// AnalyzeDlg.cpp : implementation file
//

#include "stdafx.h"
#include "HtmlHelp.h"
#include "VobBlanker.h"
#include "AnalyzeDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif



extern CVobBlankerApp theApp;

/////////////////////////////////////////////////////////////////////////////
// CAnalyzeDlg dialog


CAnalyzeDlg::CAnalyzeDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CAnalyzeDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CAnalyzeDlg)
	m_bCheckAutoScan = FALSE;
	//}}AFX_DATA_INIT
}


void CAnalyzeDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAnalyzeDlg)
	DDX_Control(pDX, IDC_PROGRESS, m_CProgress);
	DDX_Control(pDX, IDC_COMBONVOBUS, m_ComboNVOBUs);
	DDX_Check(pDX, IDC_CHECKAUTO, m_bCheckAutoScan);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CAnalyzeDlg, CDialog)
	//{{AFX_MSG_MAP(CAnalyzeDlg)
	ON_BN_CLICKED(IDABORT, OnAbort)
	ON_WM_HELPINFO()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CAnalyzeDlg message handlers

BOOL CAnalyzeDlg::OnInitDialog()
{
	int i;
	CString csAux;
	CWnd * pWnd;

	CDialog::OnInitDialog();

	m_bCheckAutoScan=	theApp.m_bCheckAutoScan;

	m_ComboNVOBUs.ResetContent();
	for (i=0;i<30;i++)
	{
		csAux.Format(_T("%d"),i+1);
		m_ComboNVOBUs.AddString(csAux);
	}
	m_ComboNVOBUs.SetCurSel(theApp.m_iScanNVOBUs);

	UpdateData(FALSE);

	CheckEnableButtons();

	if (m_bAlreadyAllScan)
	{
		pWnd = GetDlgItem(IDC_STATICSCAN);
		pWnd->SetWindowText("ALL VTS ALREADY SCANNED");
	}

	if (m_bAutoScan)
		PostMessage(WM_COMMAND, IDOK, NULL);

	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CAnalyzeDlg::CheckEnableButtons()
{
	CWnd* pWnd;
	int i;

	UpdateData(TRUE);

	m_bAlreadyAllScan=false;
	if (theApp.m_bAlreadyLoaded) 
	{
		m_bAlreadyAllScan=true;
		for (i=1; i< theApp.m_nIFOs+1 ; i++)
			if (theApp.m_bAlreadyScan[i]!=true) m_bAlreadyAllScan=false;
	}


	if (!theApp.m_bAlreadyLoaded)
	{
		pWnd = GetDlgItem(IDOK);
		pWnd->EnableWindow(FALSE);
		pWnd = GetDlgItem(IDABORT);
		pWnd->EnableWindow(FALSE);
		pWnd = GetDlgItem(IDCANCEL);
		pWnd->EnableWindow(TRUE);
	}
	else if (theApp.m_bScanInProcess)
	{
		pWnd = GetDlgItem(IDOK);
		pWnd->EnableWindow(FALSE);
		pWnd = GetDlgItem(IDABORT);
		pWnd->EnableWindow(TRUE);
		pWnd = GetDlgItem(IDCANCEL);
		pWnd->EnableWindow(FALSE);
	}
	else
	{
		pWnd = GetDlgItem(IDOK);
		pWnd->EnableWindow(TRUE);
		pWnd = GetDlgItem(IDABORT);
		pWnd->EnableWindow(FALSE);
		pWnd = GetDlgItem(IDCANCEL);
		pWnd->EnableWindow(TRUE);
	}

/*	pWnd = GetDlgItem(IDC_COMBONVOBUS);
	pWnd->EnableWindow(FALSE);
	pWnd = GetDlgItem(IDC_CHECKAUTO);
	pWnd->EnableWindow(FALSE);
	pWnd = GetDlgItem(IDC_PROGRESS);
	pWnd->EnableWindow(FALSE);
	pWnd = GetDlgItem(IDC_STATICINFO);
	pWnd->EnableWindow(FALSE);
	pWnd = GetDlgItem(IDC_STATICSCAN);
	pWnd->EnableWindow(FALSE);
	pWnd = GetDlgItem(IDC_STATICPERC);
	pWnd->EnableWindow(FALSE);
*/
}

void CAnalyzeDlg::OnOK() 
{
	// TODO: Add extra validation here
	int i,j;
	int nCells;
	CString csAux;
	CWnd * pWnd;
	int nPerc;
	int nTotalVOBUs,nVOBUsDone;
	int n,nT,nCell;

	UpdateData(TRUE);
	theApp.m_bCheckAutoScan=m_bCheckAutoScan;
	theApp.m_iScanNVOBUs=m_ComboNVOBUs.GetCurSel();
	theApp.m_bScanInProcess=true;

	CheckEnableButtons();

	for (i=1, nTotalVOBUs=0; i< theApp.m_nIFOs+1 ; i++)
		nTotalVOBUs+=theApp.GetNVOBUs(i);

	nVOBUsDone=0;

	for (i=1; i< theApp.m_nIFOs+1 && theApp.m_bScanInProcess; i++)
	{
//		if (!theApp.m_bAlreadyScan[i])
//		{
			for (j=0;j<8;j++)
				theApp.m_iAudioSectors[i][j]=0; 
			for (j=0;j<32;j++)
				theApp.m_iSubsSectors[i][j]=0;

			nCells=theApp.m_TitleCells[i].GetSize();
			for (j=0;j<nCells && theApp.m_bScanInProcess; j++)
			{
				csAux.Format(_T("Scanning VTS %d Cell %d of %d"),i, j+1 , nCells); 
				pWnd = GetDlgItem(IDC_STATICINFO);
				pWnd->SetWindowText(csAux);
				nPerc=(nVOBUsDone*100+nTotalVOBUs/2)/nTotalVOBUs;
				if (nPerc <0 ) nPerc=0;
				if (nPerc >100 ) nPerc=100;
				m_CProgress.SetPos(nPerc);
				csAux.Format(_T("%d%%"),nPerc); 
				pWnd = GetDlgItem(IDC_STATICPERC);
				pWnd->SetWindowText(csAux);
				UpdateData(FALSE);

				theApp.RunScanVobs(this, i, j);

				nVOBUsDone+=theApp.m_TitleCells[i][j].nVOBUS;

			}
			if (theApp.m_bScanInProcess) 
			{
				for (j=0;j<8;j++)
					theApp.m_iAudioSectors[i][j]*=(theApp.m_iScanNVOBUs+1); 
				for (j=0;j<32;j++)
					theApp.m_iSubsSectors[i][j]*=(theApp.m_iScanNVOBUs+1);
				theApp.m_bAlreadyScan[i]=true;
// Calculate nButtons per PGC.
				for (nT=0;nT<theApp.m_nPGCs[i];nT++)
				{
					theApp.m_nTButtons[i][nT]=0;
					for (nCell=0;nCell<theApp.m_nCells[i][nT];nCell++)
					{
						n=theApp.TitleCellGetPos(i,nT,nCell);
						theApp.m_nTButtons[i][nT]+=theApp.m_TitleCells[i][n].nButtons;
					}
				}
			}
//		}
	}

	if (theApp.m_bScanInProcess) 
	{
		theApp.m_bScanInProcess=false;
		m_CProgress.SetPos(nPerc);
		csAux.Format(_T("%d"),nPerc); 
		pWnd = GetDlgItem(IDC_STATICINFO);
		pWnd->SetWindowText("Scan completed");
		pWnd = GetDlgItem(IDC_STATICPERC);
		pWnd->SetWindowText("");
		pWnd = GetDlgItem(IDC_STATICSCAN);
		pWnd->SetWindowText("ALL VTS ALREADY SCANNED");

		if (!m_bCheckAutoScan)
		{
			MessageBox("VOB Scan Complete","Info", MB_OK|MB_ICONINFORMATION );
		}
	}
	else
	{
		pWnd = GetDlgItem(IDC_STATICINFO);
		pWnd->SetWindowText("Scan aborted");
		pWnd = GetDlgItem(IDC_STATICPERC);
		pWnd->SetWindowText("");
		pWnd = GetDlgItem(IDC_STATICSCAN);
		pWnd->SetWindowText("");

		MessageBox( "VOB Scan Aborted", "Error",  MB_OK | MB_ICONEXCLAMATION );
	}
	CheckEnableButtons();

	if (m_bAutoScan)
		CDialog::OnOK();
}

void CAnalyzeDlg::OnCancel() 
{
	// TODO: Add extra cleanup here
	
	CDialog::OnCancel();
}

void CAnalyzeDlg::OnAbort() 
{
	// TODO: Add your control notification handler code here
	theApp.m_bScanInProcess=false;
}

BOOL CAnalyzeDlg::OnHelpInfo(HELPINFO* pHelpInfo) 
{
	// TODO: Add your message handler code here and/or call default
	HtmlHelp(NULL,theApp.m_csPath+"\\VobBlanker.chm::.\\htm\\Scan_Window.htm", HH_DISPLAY_TOC, 0);
	return TRUE;
}
