// FullScanDlg.cpp : implementation file
//

#include "stdafx.h"
#include "HtmlHelp.h"
#include "ToolTipDialog.h"
#include "VobBlanker.h"
#include "FullScanDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif



extern CVobBlankerApp theApp;


/////////////////////////////////////////////////////////////////////////////
// CFullScanDlg dialog


CFullScanDlg::CFullScanDlg(CWnd* pParent /*=NULL*/)
	: CToolTipDialog(CFullScanDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CFullScanDlg)
	m_bCheckFSMenus = TRUE;
	m_bCheckFSTitles = TRUE;
	//}}AFX_DATA_INIT
}


void CFullScanDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CFullScanDlg)
	DDX_Control(pDX, IDC_PROGRESSGLB, m_CProgressGlobal);
	DDX_Control(pDX, IDC_PROGRESSTITLES, m_CProgressTitles);
	DDX_Control(pDX, IDC_PROGRESSMENUS, m_CProgressMenus);
	DDX_Check(pDX, IDC_CHECKFSMENUS, m_bCheckFSMenus);
	DDX_Check(pDX, IDC_CHECKFSTITLES, m_bCheckFSTitles);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CFullScanDlg, CDialog)
	//{{AFX_MSG_MAP(CFullScanDlg)
	ON_BN_CLICKED(IDABORT, OnAbort)
	ON_WM_HELPINFO()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CFullScanDlg message handlers
BOOL CFullScanDlg::OnInitDialog()
{
	CString csAux;
	CWnd * pWnd;

	CDialog::OnInitDialog();

	m_bCheckFSMenus = TRUE;
	m_bCheckFSTitles = TRUE;
	UpdateData(FALSE);

	pWnd = GetDlgItem(IDC_STATICSTATUS);
	pWnd->SetWindowText("Waiting...");
	pWnd = GetDlgItem(IDC_STATICTPERC);
	pWnd->SetWindowText("");
	pWnd = GetDlgItem(IDC_STATICMPERC);
	pWnd->SetWindowText("");
	pWnd = GetDlgItem(IDC_STATICGPERC);
	pWnd->SetWindowText("");

// TOOLTIPS
	c_bShowToolTips = TRUE;
	m_wndToolTip.Create(this);
	m_wndToolTip.Activate(c_bShowToolTips);

	m_wndToolTip.AddTool(GetDlgItem(IDCANCEL), "Close" );
	m_wndToolTip.AddTool(GetDlgItem(IDOK), "Run a Full Scan" );
	m_wndToolTip.AddTool(GetDlgItem(IDC_CHECKFSMENUS), "Enable Scan in MENUS domain" );
	m_wndToolTip.AddTool(GetDlgItem(IDC_CHECKFSTITLES), "Enable Scan in TITLES domain" );

	

	m_bDone=false;

	CheckEnableButtons();

	if (m_bCLIMinim)
		this->ShowWindow(SW_MINIMIZE);

	if (m_bAutoScan)
		PostMessage(WM_COMMAND, IDOK, NULL);
	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CFullScanDlg::CheckEnableButtons()
{
	CWnd* pWnd;


	if ( !theApp.m_bAlreadyLoaded)
	{
		pWnd = GetDlgItem(IDOK);
		pWnd->EnableWindow(FALSE);
		pWnd = GetDlgItem(IDABORT);
		pWnd->EnableWindow(FALSE);
		pWnd = GetDlgItem(IDCANCEL);
		pWnd->EnableWindow(TRUE);
	}
	else if (theApp.m_bScanInProcess)
	{
		pWnd = GetDlgItem(IDOK);
		pWnd->EnableWindow(FALSE);
		pWnd = GetDlgItem(IDABORT);
		pWnd->EnableWindow(TRUE);
		pWnd = GetDlgItem(IDCANCEL);
		pWnd->EnableWindow(FALSE);
	}
	else
	{
		pWnd = GetDlgItem(IDOK);
		pWnd->EnableWindow(TRUE);
		pWnd = GetDlgItem(IDABORT);
		pWnd->EnableWindow(FALSE);
		pWnd = GetDlgItem(IDCANCEL);
		pWnd->EnableWindow(TRUE);
	}

}
void CFullScanDlg::OnAbort() 
{
	// TODO: Add your control notification handler code here
	theApp.m_bScanInProcess=false;
	theApp.m_bCLIMode=theApp.m_bCLIFullScan=false;

}

void CFullScanDlg::OnCancel() 
{
	// TODO: Add extra cleanup here
	
	CDialog::OnCancel();
}

void CFullScanDlg::OnOK() 
{
	// TODO: Add extra validation here
	int nVTS;
	CString csAux;
	CWnd * pWnd;
	int iTitlesRet,iMenusRet,iRet;


	if (m_bDone)
	{
		MessageBox("VOBs have been already scanned","Info", MB_OK);
		return;
	} 

	UpdateData(TRUE);

	if (!m_bCheckFSMenus && !m_bCheckFSTitles)
	{
		MessageBox("You have to select at least one domain (TITLES and/or MENUS)","Info", MB_OK);
		return;
	}

	theApp.m_bScanInProcess=true;
	pWnd = GetDlgItem(IDC_CHECKFSTITLES);
	pWnd->EnableWindow(FALSE);
	pWnd = GetDlgItem(IDC_CHECKFSMENUS);
	pWnd->EnableWindow(FALSE);

	CheckEnableButtons();

	m_nTotalMenuSectors=m_nTotalTitleSectors=m_nTotalSectors=0;
	for (nVTS=0; nVTS< theApp.m_nIFOs+1 ; nVTS++)
	{
		m_nTotalMenuSectors+=((int)(theApp.m_i64VOBsize[nVTS][0]/2048));
		m_nTotalTitleSectors+=((int)(theApp.m_i64VOBsize[nVTS][10]/2048));
	}
	if (m_bCheckFSMenus) 
		m_nTotalSectors+=m_nTotalMenuSectors;
	if (m_bCheckFSTitles) 
		m_nTotalSectors+=m_nTotalTitleSectors;

	iTitlesRet=iMenusRet=0;
	pWnd = GetDlgItem(IDC_STATICSTATUS);
	m_nSectorsDone=0;
	for (nVTS=0; nVTS< theApp.m_nIFOs+1 && theApp.m_bScanInProcess; nVTS++)
	{
		if (m_bCheckFSMenus && theApp.m_bScanInProcess) 
		{
			if (nVTS==0)
				csAux.Format(_T("Scanning MENUS domain of VIDEO MANAGER"));
			else
				csAux.Format(_T("Scanning MENUS domain of VTS: %02d"),nVTS);
			pWnd->SetWindowText(csAux);
			iRet=theApp.FullScan(this, MENUS,nVTS);
			if (iRet <0) iTitlesRet=iRet;
			else if (iRet==1) iTitlesRet=1;
			UpdateProgress(MENUS, nVTS, 100) ;
			m_nSectorsDone+=((int)(theApp.m_i64VOBsize[nVTS][0]/2048));

		}
		if (nVTS !=0 && m_bCheckFSTitles && theApp.m_bScanInProcess) 
		{
			csAux.Format(_T("Scanning TITLES domain of VTS: %02d"),nVTS);
			pWnd->SetWindowText(csAux);
			iRet=theApp.FullScan(this, TITLES,nVTS);
			if (iRet <0) iMenusRet=iRet;
			else if (iRet==1) iMenusRet=1;
			m_nSectorsDone+=((int)(theApp.m_i64VOBsize[nVTS][10]/2048));
		}
		UpdateProgress(MENUS, nVTS, 0) ;
		UpdateProgress(TITLES, nVTS, 0) ;
	}
	pWnd->SetWindowText("Done");
	if (theApp.m_bScanInProcess)
			m_bDone=true;
	theApp.m_bScanInProcess=false;

	if (!m_bDone)
	{
		pWnd = GetDlgItem(IDC_CHECKFSTITLES);
		pWnd->EnableWindow(TRUE);
		pWnd = GetDlgItem(IDC_CHECKFSMENUS);
		pWnd->EnableWindow(TRUE);
		pWnd = GetDlgItem(IDC_STATICSTATUS);
		pWnd->SetWindowText("Waiting...");
		pWnd = GetDlgItem(IDC_STATICTPERC);
		pWnd->SetWindowText("");
		pWnd = GetDlgItem(IDC_STATICMPERC);
		pWnd->SetWindowText("");
		pWnd = GetDlgItem(IDC_STATICGPERC);
		pWnd->SetWindowText("");
	}
	CheckEnableButtons();

	if (!theApp.m_bCLIMode)
	{
		if (iMenusRet==1)
			MessageBox("Some Cells not found in Menus","Info", MB_OK);
		if (iTitlesRet==1)
			MessageBox("Some Cells not found in Titles","Info", MB_OK);
	}
	if (iMenusRet==-1)
		MessageBox("At least one critical error Scanning Menus","Error", MB_OK);	
	if (iTitlesRet==1)
		MessageBox("At least one critical error Scanning Titles","Error", MB_OK);

//Exits from CLI mode if critical error.	
	if (iMenusRet<0 || iTitlesRet<0) 
		theApp.m_bCLIMode=theApp.m_bCLIFullScan=false;

	if (m_bAutoScan)
		CDialog::OnOK();
}

void CFullScanDlg::UpdateProgress(int iDomain, int nVTS, int nPerc) 
{
	CString csAux;
	CWnd * pWnd;
	int nSectors;
	int nGlbProgress;

	if (iDomain==MENUS)
	{
		m_CProgressMenus.SetPos(nPerc);
		pWnd = GetDlgItem(IDC_STATICMPERC);
		if (nPerc==0)
			csAux="";
		else
			csAux.Format(_T("%2d %%"),nPerc);
		pWnd->SetWindowText(csAux);
		nSectors=((int)(theApp.m_i64VOBsize[nVTS][0]/2048));
		nSectors=nSectors*nPerc/100;
	}
	else
	{
		m_CProgressTitles.SetPos(nPerc);
		pWnd = GetDlgItem(IDC_STATICTPERC);
		if (nPerc==0)
			csAux="";
		else
			csAux.Format(_T("%2d %%"),nPerc);
		pWnd->SetWindowText(csAux);
		nSectors=((int)(theApp.m_i64VOBsize[nVTS][10]/2048));
		nSectors=nSectors*nPerc/100;
	}

	if (m_nTotalSectors==0)
		nGlbProgress=0;
	else
		nGlbProgress=((m_nSectorsDone+nSectors)*100)/m_nTotalSectors;

	m_CProgressGlobal.SetPos(nGlbProgress);
	pWnd = GetDlgItem(IDC_STATICGPERC);
	if (nGlbProgress==0)
		csAux="";
	else
		csAux.Format(_T("%2d %%"),nGlbProgress);
	pWnd->SetWindowText(csAux);

}
BOOL CFullScanDlg::OnHelpInfo(HELPINFO* pHelpInfo) 
{
	// TODO: Add your message handler code here and/or call default
	HtmlHelp(NULL,theApp.m_csPath+"\\VobBlanker.chm::.\\htm\\VOB_full_scan.htm", HH_DISPLAY_TOC, 0);
	return TRUE;
}
