// LogDlg.cpp : implementation file
//

#include "stdafx.h"
#include "HtmlHelp.h"
#include "VobBlanker.h"
#include "LogDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

extern CVobBlankerApp theApp;


/////////////////////////////////////////////////////////////////////////////
// LogDlg dialog


CLogDlg::CLogDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CLogDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(LogDlg)
	//}}AFX_DATA_INIT
	m_csEditLog = _T("");
}


void CLogDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(LogDlg)
	DDX_Control(pDX, IDC_RICHEDIT, m_myRich);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CLogDlg, CDialog)
	//{{AFX_MSG_MAP(LogDlg)
	ON_BN_CLICKED(IDC_SAVEAS, OnSaveas)
	ON_WM_HELPINFO()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// LogDlg message handlers


BOOL CLogDlg::OnInitDialog()
{
	CRichEditCtrl* pREdit;
	CHARFORMAT cf;
	
	m_nRlin=0;
	m_LineColor.RemoveAll();
	m_nChar.RemoveAll();
	m_nChar.SetAtGrow(0,0);

 	pREdit=(CRichEditCtrl *)GetDlgItem(IDC_RICHEDIT);
	pREdit->SetBackgroundColor(FALSE,GREY200);

// Default char format
	cf.dwMask= CFM_SIZE|CFM_FACE;
	cf.yHeight = 20*9;
	strcpy(cf.szFaceName,"Arial");
	pREdit->SetDefaultCharFormat(cf);


//	((CWnd *)pREdit)->ModifyStyle(WS_VSCROLL,0);
//	((CWnd *)pREdit)->ModifyStyleEx(ES_AUTOVSCROLL,0);

	return TRUE;  // return TRUE  unless you set the focus to a control
}


void CLogDlg::LogLine(LPCTSTR szLine, COLORREF myColor) 
{
	// TODO: Add extra validation here
	CString csAux;
	CHARFORMAT cf;
	
//	CEdit* pEdit;
	CRichEditCtrl* pREdit;


// Store all the info in m_csEditLog (To be used in SaveAs)
	csAux=szLine;
//	if (m_nRlin!=0)	csAux="\r\n"+csAux;
	if (m_nRlin!=0)	csAux="\n"+csAux;
	m_csEditLog+=csAux;

//  Add text to Control
 	pREdit=(CRichEditCtrl *)GetDlgItem(IDC_RICHEDIT);
	pREdit->SetSel(-1,-1);
	pREdit->ReplaceSel(csAux);

//  Store Line Color and Line Char indexes (Class Members do not work fine...) 
	m_LineColor.SetAtGrow(m_nRlin,myColor);
//	m_nChar.SetAtGrow(m_nRlin+1,strlen(szLine)+m_nChar[m_nRlin]+2);
	m_nChar.SetAtGrow(m_nRlin+1,strlen(szLine)+m_nChar[m_nRlin]+1);

// Change color of the just written line
	cf.dwMask= CFM_COLOR;
	cf.dwEffects= 0;
	cf.crTextColor=m_LineColor[m_nRlin];
	pREdit->SetSel(m_nChar[m_nRlin],m_nChar[m_nRlin+1]);
	pREdit->SetSelectionCharFormat(cf);

// Scroll
	pREdit->SetSel(-1,-1);
	m_nRlin++;
//	pREdit->LineScroll(m_nRlin,0); // This was the old method with UpdateData
	pREdit->LineScroll(1,0);

	return;
}

void CLogDlg::OnCancel() 
{
	// TODO: Add extra cleanup here

	theApp.m_pLog=NULL;
	DestroyWindow();
	
//	CDialog::OnCancel();
}


void CLogDlg::OnSaveas() 
{
	// TODO: Add your control notification handler code here
	CString csSavePath,csFiltro,csTitulo;
	FILE *in;

	csFiltro = "All files";
	csFiltro += " (*.*)|*.*||";
	csTitulo = "Save Project as *.txt";
	// OpenFile Dlg construction 
	CFileDialog dlgAbrir(FALSE,"txt","VobBlanker_log.txt",OFN_EXPLORER ,(const char*)csFiltro);

	dlgAbrir.m_ofn.lpstrTitle = (const char*)csTitulo;
//	dlgAbrir.m_ofn.Flags=OFN_NODEREFERENCELINKS|OFN_EXPLORER;
	dlgAbrir.m_ofn.Flags=OFN_EXPLORER;

	if (dlgAbrir.DoModal() == IDOK)
	{
		csSavePath = dlgAbrir.GetPathName(); 
		if ((in=fopen (csSavePath,"w"))==NULL)
		{
			MessageBox( "Error opening file", "Error",  MB_OK | MB_ICONSTOP );
		}
		else
		{
			if ( fprintf (in,"%s", m_csEditLog) < 0)
				MessageBox( "Error Saving Log file", "Error",  MB_OK | MB_ICONERROR );
			else
				MessageBox( "Log file Saved", "Info",  MB_OK | MB_ICONINFORMATION );
			fclose(in);
		}	
	}
}

BOOL CLogDlg::OnHelpInfo(HELPINFO* pHelpInfo) 
{
	// TODO: Add your message handler code here and/or call default
	HtmlHelp(NULL,theApp.m_csPath+"\\VobBlanker.chm::.\\htm\\Log_Window.htm", HH_DISPLAY_TOC, 0);
	
	return TRUE;
}
