// MenusDlg.cpp : implementation file
//

#include "stdafx.h"
#include "ToolTipDialog.h"
#include "HtmlHelp.h"

#include "VobBlanker.h"
#include "MenusDlg.h"
#include "PreviewDlg.h"
#include "LUSelDlg.h"
#include "CellsDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

extern CVobBlankerApp theApp;
extern CString Size_MBytes(__int64 i64size);
extern CString FormatDuration(DWORD duration);
extern CString lang_long(char * szLang);

/*
extern void MyErrorBox(LPCTSTR text);
extern void MyInfoBox(LPCTSTR text);
extern CString SelectFolder (CString csTitulo, CString csStartFolder);
extern int readbuffer(uchar* caracter, FILE *in);
extern UINT GetNbytes(int nNumber,uchar* address);
*/

/////////////////////////////////////////////////////////////////////////////
// CMenusDlg dialog


CMenusDlg::CMenusDlg(CWnd* pParent /*=NULL*/)
	: CToolTipDialog(CMenusDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CMenusDlg)
	m_csEndSize = _T("");
	m_csIniSize = _T("");
	m_bCheckBlankNoB = TRUE;
	//}}AFX_DATA_INIT
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);

}


void CMenusDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CMenusDlg)
	DDX_Control(pDX, IDC_COMBOSTILL, m_ComboStill);
	DDX_Control(pDX, IDC_LISTPGCS, m_CListPGC);
	DDX_Control(pDX, IDC_LISTLUS, m_CListLU);
	DDX_Text(pDX, IDC_EDITEND, m_csEndSize);
	DDX_Text(pDX, IDC_EDITINI, m_csIniSize);
	DDX_Check(pDX, IDC_CHECKBLANKNOBUTTONS, m_bCheckBlankNoB);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CMenusDlg, CDialog)
	//{{AFX_MSG_MAP(CMenusDlg)
	ON_BN_CLICKED(IDC_BUTTONBLANK, OnButtonblank)
	ON_BN_CLICKED(IDC_BUTTONDEL, OnButtondel)
	ON_BN_CLICKED(IDC_BUTTONKEEP, OnButtonkeep)
	ON_BN_CLICKED(IDC_BUTTONKEEPLU, OnButtonkeeplu)
	ON_BN_CLICKED(IDC_BUTTONPREV, OnButtonprev)
	ON_BN_CLICKED(IDC_BUTTONREUSE, OnButtonreuse)
	ON_BN_CLICKED(IDC_BUTTONREUSELU, OnButtonreuselu)
	ON_NOTIFY(LVN_ITEMCHANGED, IDC_LISTLUS, OnItemchangedListlus)
	ON_NOTIFY(LVN_ITEMCHANGED, IDC_LISTPGCS, OnItemchangedListpgcs)
	ON_NOTIFY(NM_RCLICK, IDC_LISTLUS, OnRclickListlus)
	ON_NOTIFY(NM_RCLICK, IDC_LISTPGCS, OnRclickListpgcs)
	ON_BN_CLICKED(IDC_BUTTONKEEPLUALL, OnButtonkeepluall)
	ON_BN_CLICKED(IDC_BUTTONCELLS, OnButtoncells)
	ON_NOTIFY(NM_DBLCLK, IDC_LISTPGCS, OnDblclkListpgcs)
	ON_BN_CLICKED(IDC_BUTTONSTILLPGC, OnButtonstillpgc)
	ON_BN_CLICKED(IDC_CHECKBLANKNOBUTTONS, OnCheckblanknobuttons)
	ON_CBN_SELCHANGE(IDC_COMBOSTILL, OnSelchangeCombostill)
	ON_WM_SIZE()
	ON_WM_HELPINFO()
	//}}AFX_MSG_MAP
	ON_COMMAND(ID__KEEPLUALL, On__keepluall)
	ON_COMMAND(ID__KEEPLU, On__keeplu)
	ON_COMMAND(ID__REUSELU, On__reuselu)
	ON_COMMAND(ID__MKEEP, On__mkeep)
	ON_COMMAND(ID__MREUSE, On__mreuse)
	ON_COMMAND(ID__MBLANK, On__mblank)
	ON_COMMAND(ID__MDELETE, On__mdelete)
	ON_COMMAND(ID__MPREV, On__mprev)
	ON_COMMAND(ID__MCELLS, On__mcells)
	ON_COMMAND(ID__MSTILLA, On__mstilla)
	ON_COMMAND(ID__MSTILLNA, On__mstillna)
	ON_COMMAND(ID__MSELALL, On__mselall)
	ON_COMMAND(ID__MSELALLB, On__mselallb)
	ON_COMMAND(ID__MSELALLNB, On__mselallnb)
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CMenusDlg message handlers


// OninitDialog
BOOL CMenusDlg::OnInitDialog()
{
	int i;
	CString csAux;


	CDialog::OnInitDialog();
	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon

	m_CListPGC.SetExtendedStyle( LVS_EX_FULLROWSELECT|LVS_EX_GRIDLINES );
	m_CListLU.SetExtendedStyle( LVS_EX_FULLROWSELECT|LVS_EX_GRIDLINES );

// m_CListLU Headers
	i=0;

	m_CListLU.InsertColumn( i, "#");
	m_CListLU.SetColumnWidth( i, 30); 
	i++;
	m_CListLU.InsertColumn( i, "Language");
	m_CListLU.SetColumnWidth( i, 80); 
	i++;
	m_CListLU.InsertColumn( i, "# PGCs");
	m_CListLU.SetColumnWidth( i, 60); 
	i++;
	m_CListLU.InsertColumn( i, "Ini Size");
	m_CListLU.SetColumnWidth( i, 80); 
	i++;
	m_CListLU.InsertColumn( i, "End Size");
	m_CListLU.SetColumnWidth( i, 80); 
	i++;

// m_CListPGC Headers
	i=0;

	m_CListPGC.InsertColumn( i, "PGC #");
	m_CListPGC.SetColumnWidth( i, 50); 
	i++;
	m_CListPGC.InsertColumn( i, "# Cells");
	m_CListPGC.SetColumnWidth( i, 50); 
	i++;
	m_CListPGC.InsertColumn( i, "1st Vid");
	m_CListPGC.SetColumnWidth( i, 50); 
	i++;
	m_CListPGC.InsertColumn( i, "Buttons");
	m_CListPGC.SetColumnWidth( i, 50); 
	i++;
	m_CListPGC.InsertColumn( i, "Duration");
	m_CListPGC.SetColumnWidth( i, 70); 
	i++;
	m_CListPGC.InsertColumn( i, "Reuse cells");
	m_CListPGC.SetColumnWidth( i, 70); 
	i++;
	m_CListPGC.InsertColumn( i, "Commands");
	m_CListPGC.SetColumnWidth( i, 110); 
	i++;
	m_CListPGC.InsertColumn( i, "Ini Size");
	m_CListPGC.SetColumnWidth( i, 60); 
	i++;
	m_CListPGC.InsertColumn( i, "End Size");
	m_CListPGC.SetColumnWidth( i, 60); 
	i++;
	m_CListPGC.InsertColumn( i, "Action");
	m_CListPGC.SetColumnWidth( i, 80); 
	i++;

		// TOOLTIPS
	c_bShowToolTips = TRUE;
	m_wndToolTip.Create(this);
	m_wndToolTip.Activate(c_bShowToolTips);

	m_wndToolTip.AddTool(GetDlgItem(IDOK), "Apply changes" );
	m_wndToolTip.AddTool(GetDlgItem(IDC_BUTTONKEEPLUALL), "Keep all LUs as they are" );
	m_wndToolTip.AddTool(GetDlgItem(IDC_BUTTONKEEPLU), "Keep LU as it is" );
	m_wndToolTip.AddTool(GetDlgItem(IDC_BUTTONREUSELU), "Reuse all PGCs from other LU" );
	m_wndToolTip.AddTool(GetDlgItem(IDC_BUTTONKEEP), "Keep PGC as it is" );
	m_wndToolTip.AddTool(GetDlgItem(IDC_BUTTONREUSE), "Reuse cells from the same PGC of other LU" );
	m_wndToolTip.AddTool(GetDlgItem(IDC_BUTTONPREV), "Preview" );
	m_wndToolTip.AddTool(GetDlgItem(IDC_BUTTONBLANK), "Blank PGC: Substitute cells by blank ones" );
	m_wndToolTip.AddTool(GetDlgItem(IDC_BUTTONDEL), "Delete playback of the selected PGC." );
	m_wndToolTip.AddTool(GetDlgItem(IDC_BUTTONCELLS), "Opens Cell list." );
	m_wndToolTip.AddTool(GetDlgItem(IDC_BUTTONSTILLPGC), "EXPERIMENTAL: Reduces all Cells in PGC to a single STILL with or without audio." );
	m_wndToolTip.AddTool(GetDlgItem(IDC_CHECKBLANKNOBUTTONS), "Blanks cells with no buttons. Recommended if audio is deleted." );
	m_wndToolTip.AddTool(GetDlgItem(IDC_COMBOSTILL), "Selection of I frame method. Auto means the largest I-Frame in the cell." );

	GetInitialCoord();

	if (m_nVTS!=0)
		csAux.Format(_T("Menu of VTS %02d"),m_nVTS);
	else
		csAux.Format(_T("Menu of VIDEO_TS"));

	SetWindowText(csAux);

	m_csIniSize= Size_MBytes(theApp.m_i64Misize[m_nVTS]);
	m_csEndSize= Size_MBytes(theApp.m_i64Mfsize[m_nVTS]);

	PintaLU();

	m_bCheckBlankNoB=theApp.m_bCheckBlankNoB;

	m_ComboStill.ResetContent();

	m_ComboStill.AddString("First");
	m_ComboStill.AddString("Middle");
	m_ComboStill.AddString("Last");
	m_ComboStill.AddString("Auto");

	m_ComboStill.SetCurSel(theApp.m_iIFrameMode);


	UpdateData(FALSE);

	CheckEnableButtons();

	return TRUE;

}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CMenusDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CMenusDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}
////////////// RESIZING CODE ///////////////

void CMenusDlg::GetInitialCoord() 
{
	CWnd* pWnd;
	CRect myRect;
	int OFFX;
	int OFFY;

	GetClientRect(&m_RectApp);
	GetWindowRect(&myRect);
	OFFX=(myRect.Width()-m_RectApp.Width())/2;    // OFFX=Border
	OFFY=myRect.Height()-m_RectApp.Height()-OFFX; // OFFY=Top border+Caption+Menu. 

	pWnd=GetDlgItem(IDC_STATIC_LUS);
	pWnd->GetWindowRect(&m_RectLUS);
	m_RectLUS.OffsetRect(-myRect.left-OFFX,-myRect.top-OFFY);

	pWnd=GetDlgItem(IDC_STATIC_PGCS);
	pWnd->GetWindowRect(&m_RectPGCS);
	m_RectPGCS.OffsetRect(-myRect.left-OFFX,-myRect.top-OFFY);

	pWnd=GetDlgItem(IDC_LISTLUS);
	pWnd->GetWindowRect(&m_RectLISTLUS);
	m_RectLISTLUS.OffsetRect(-myRect.left-OFFX,-myRect.top-OFFY);

	pWnd=GetDlgItem(IDC_LISTPGCS);
	pWnd->GetWindowRect(&m_RectLISTPGCS);
	m_RectLISTPGCS.OffsetRect(-myRect.left-OFFX,-myRect.top-OFFY);

	pWnd=GetDlgItem(IDC_BUTTONKEEPLUALL);
	pWnd->GetWindowRect(&m_RectBKEEPLUALL);
	m_RectBKEEPLUALL.OffsetRect(-myRect.left-OFFX,-myRect.top-OFFY);

	pWnd=GetDlgItem(IDC_BUTTONKEEPLU);
	pWnd->GetWindowRect(&m_RectBKEEPLU);
	m_RectBKEEPLU.OffsetRect(-myRect.left-OFFX,-myRect.top-OFFY);

	pWnd=GetDlgItem(IDC_BUTTONREUSELU);
	pWnd->GetWindowRect(&m_RectBREUSELU);
	m_RectBREUSELU.OffsetRect(-myRect.left-OFFX,-myRect.top-OFFY);

	pWnd=GetDlgItem(IDC_BUTTONKEEP);
	pWnd->GetWindowRect(&m_RectBKEEP);
	m_RectBKEEP.OffsetRect(-myRect.left-OFFX,-myRect.top-OFFY);

	pWnd=GetDlgItem(IDC_BUTTONREUSE);
	pWnd->GetWindowRect(&m_RectBREUSE);
	m_RectBREUSE.OffsetRect(-myRect.left-OFFX,-myRect.top-OFFY);

	pWnd=GetDlgItem(IDC_BUTTONPREV);
	pWnd->GetWindowRect(&m_RectBPREV);
	m_RectBPREV.OffsetRect(-myRect.left-OFFX,-myRect.top-OFFY);

	pWnd=GetDlgItem(IDC_BUTTONCELLS);
	pWnd->GetWindowRect(&m_RectBCELLS);
	m_RectBCELLS.OffsetRect(-myRect.left-OFFX,-myRect.top-OFFY);

	pWnd=GetDlgItem(IDC_BUTTONBLANK);
	pWnd->GetWindowRect(&m_RectBBLANK);
	m_RectBBLANK.OffsetRect(-myRect.left-OFFX,-myRect.top-OFFY);

	pWnd=GetDlgItem(IDC_BUTTONDEL);
	pWnd->GetWindowRect(&m_RectBDEL);
	m_RectBDEL.OffsetRect(-myRect.left-OFFX,-myRect.top-OFFY);

	pWnd=GetDlgItem(IDC_BUTTONSTILLPGC);
	pWnd->GetWindowRect(&m_RectBSTILL);
	m_RectBSTILL.OffsetRect(-myRect.left-OFFX,-myRect.top-OFFY);

	pWnd=GetDlgItem(IDOK);
	pWnd->GetWindowRect(&m_RectOK);
	m_RectOK.OffsetRect(-myRect.left-OFFX,-myRect.top-OFFY);

	pWnd=GetDlgItem(IDC_STATIC_SIZE0);
	pWnd->GetWindowRect(&m_RectSIZE0);
	m_RectSIZE0.OffsetRect(-myRect.left-OFFX,-myRect.top-OFFY);

	pWnd=GetDlgItem(IDC_STATIC_SIZE1);
	pWnd->GetWindowRect(&m_RectSIZE1);
	m_RectSIZE1.OffsetRect(-myRect.left-OFFX,-myRect.top-OFFY);

	pWnd=GetDlgItem(IDC_STATIC_SIZE2);
	pWnd->GetWindowRect(&m_RectSIZE2);
	m_RectSIZE2.OffsetRect(-myRect.left-OFFX,-myRect.top-OFFY);

	pWnd=GetDlgItem(IDC_EDITINI);
	pWnd->GetWindowRect(&m_RectEDITINI);
	m_RectEDITINI.OffsetRect(-myRect.left-OFFX,-myRect.top-OFFY);

	pWnd=GetDlgItem(IDC_EDITEND);
	pWnd->GetWindowRect(&m_RectEDITEND);
	m_RectEDITEND.OffsetRect(-myRect.left-OFFX,-myRect.top-OFFY);

	pWnd=GetDlgItem(IDC_STATIC_STILL0);
	pWnd->GetWindowRect(&m_RectSTILL0);
	m_RectSTILL0.OffsetRect(-myRect.left-OFFX,-myRect.top-OFFY);

	pWnd=GetDlgItem(IDC_STATIC_STILL1);
	pWnd->GetWindowRect(&m_RectSTILL1);
	m_RectSTILL1.OffsetRect(-myRect.left-OFFX,-myRect.top-OFFY);

	pWnd=GetDlgItem(IDC_COMBOSTILL);
	pWnd->GetWindowRect(&m_RectCOMBOSTILL);
	m_RectCOMBOSTILL.OffsetRect(-myRect.left-OFFX,-myRect.top-OFFY);

	pWnd=GetDlgItem(IDC_CHECKBLANKNOBUTTONS);
	pWnd->GetWindowRect(&m_RectBLANKNOBUTTONS);
	m_RectBLANKNOBUTTONS.OffsetRect(-myRect.left-OFFX,-myRect.top-OFFY);

}

void CMenusDlg::ReSizeLU(int IDD, CRect myRect, int cx, int cy) 
{
	int alto,ancho;
	CWnd* pWnd;


	pWnd=GetDlgItem(IDD);
	if (pWnd) 
	{
		ancho=cx-m_RectApp.right;
		ancho+=(myRect.right-myRect.left);
		if (ancho <0 ) ancho=0;
		alto=(cy-m_RectApp.bottom)/4;
		alto+=(myRect.bottom-myRect.top);
		if (alto <0 ) alto=0;
		pWnd->MoveWindow(myRect.left,myRect.top,ancho,alto);
	}
}

void CMenusDlg::ReSizeBLU(int IDD, CRect myRect, int cx, int cy) 
{
	int alto,ancho;
	CWnd* pWnd;


	pWnd=GetDlgItem(IDD);
	if (pWnd) 
	{
		ancho=(myRect.right-myRect.left);
		if (ancho <0 ) ancho=0;
		alto=(myRect.bottom-myRect.top);
		if (alto <0 ) alto=0;
		pWnd->MoveWindow(myRect.left+cx-m_RectApp.right,myRect.top,ancho,alto);
	}
}

void CMenusDlg::ReSizePGC(int IDD, CRect myRect, int cx, int cy) 
{
	int alto,ancho;
	CWnd* pWnd;


	pWnd=GetDlgItem(IDD);
	if (pWnd) 
	{
		ancho=cx-m_RectApp.right;
		ancho+=(myRect.right-myRect.left);
		if (ancho <0 ) ancho=0;
		alto=(cy-m_RectApp.bottom)*3/4;
		alto+=(myRect.bottom-myRect.top);
		if (alto <0 ) alto=0;
		pWnd->MoveWindow(myRect.left,myRect.top+(cy-m_RectApp.bottom)/4,ancho,alto);
	}
}

void CMenusDlg::ReSizeBPGC(int IDD, CRect myRect, int cx, int cy) 
{
	int alto,ancho;
	CWnd* pWnd;

	pWnd=GetDlgItem(IDD);
	if (pWnd) 
	{
		ancho=(myRect.right-myRect.left);
		if (ancho <0 ) ancho=0;
		alto=(myRect.bottom-myRect.top);
		if (alto <0 ) alto=0;
		pWnd->MoveWindow(myRect.left+cx-m_RectApp.right,myRect.top+(cy-m_RectApp.bottom)/4,ancho,alto);
	}
}


void CMenusDlg::ReSizeBottom(int IDD, CRect myRect, int cx, int cy) 
{
	int alto,ancho;
	CWnd* pWnd;


	pWnd=GetDlgItem(IDD);
	if (pWnd) 
	{
		ancho=(myRect.right-myRect.left);
		if (ancho <0 ) ancho=0;
		alto=(myRect.bottom-myRect.top);
		if (alto <0 ) alto=0;
		pWnd->MoveWindow(myRect.left+(cx-m_RectApp.right)/2,myRect.top+(cy-m_RectApp.bottom),ancho,alto);
	}
}

void CMenusDlg::ReSizeBottomB(int IDD, CRect myRect, int cx, int cy) 
{
	int alto,ancho;
	CWnd* pWnd;


	pWnd=GetDlgItem(IDD);
	if (pWnd) 
	{
		ancho=(myRect.right-myRect.left);
		if (ancho <0 ) ancho=0;
		alto=(myRect.bottom-myRect.top);
		if (alto <0 ) alto=0;
		pWnd->MoveWindow(myRect.left,myRect.top+(cy-m_RectApp.bottom),ancho,alto);
	}
}


void CMenusDlg::OnSize(UINT nType, int cx, int cy) 
{
	CDialog::OnSize(nType, cx, cy);
	// TODO: Add your message handler code here

	CRect myRect;


	if (nType==SIZE_RESTORED  )
	{
		if (cx < m_RectApp.right)
		{
			cx=m_RectApp.right-m_RectApp.left;
		}
		if (cy < m_RectApp.bottom)
		{
			cy=m_RectApp.bottom-m_RectApp.top;
		}

	}

	ReSizeLU(IDC_STATIC_LUS,m_RectLUS,cx,cy);
	ReSizeLU(IDC_LISTLUS,m_RectLISTLUS,cx,cy);
	ReSizeBLU(IDC_BUTTONKEEPLUALL,m_RectBKEEPLUALL,cx,cy);
	ReSizeBLU(IDC_BUTTONKEEPLU,m_RectBKEEPLU,cx,cy);
	ReSizeBLU(IDC_BUTTONREUSELU,m_RectBREUSELU,cx,cy);

	ReSizePGC(IDC_STATIC_PGCS,m_RectPGCS,cx,cy);
	ReSizePGC(IDC_LISTPGCS,m_RectLISTPGCS,cx,cy);
	ReSizeBPGC(IDC_BUTTONCELLS,m_RectBCELLS,cx,cy);
	ReSizeBPGC(IDC_BUTTONPREV,m_RectBPREV,cx,cy);
	ReSizeBPGC(IDC_BUTTONREUSE,m_RectBREUSE,cx,cy);
	ReSizeBPGC(IDC_BUTTONKEEP,m_RectBKEEP,cx,cy);
	ReSizeBPGC(IDC_BUTTONDEL,m_RectBDEL,cx,cy);
	ReSizeBPGC(IDC_BUTTONSTILLPGC,m_RectBSTILL,cx,cy);
	ReSizeBPGC(IDC_BUTTONBLANK,m_RectBBLANK,cx,cy);

	ReSizeBottom(IDOK,m_RectOK,cx,cy);

	ReSizeBottomB(IDC_STATIC_SIZE0,m_RectSIZE0,cx,cy);
	ReSizeBottomB(IDC_STATIC_SIZE1,m_RectSIZE1,cx,cy);
	ReSizeBottomB(IDC_STATIC_SIZE2,m_RectSIZE2,cx,cy);
	ReSizeBottomB(IDC_EDITINI,m_RectEDITINI,cx,cy);
	ReSizeBottomB(IDC_EDITEND,m_RectEDITEND,cx,cy);

	ReSizeBottomB(IDC_STATIC_STILL0,m_RectSTILL0,cx,cy);
	ReSizeBottomB(IDC_STATIC_STILL1,m_RectSTILL1,cx,cy);
	ReSizeBottomB(IDC_COMBOSTILL,m_RectCOMBOSTILL,cx,cy);
	ReSizeBottomB(IDC_CHECKBLANKNOBUTTONS,m_RectBLANKNOBUTTONS,cx,cy);

	RedrawWindow(NULL,NULL,RDW_INVALIDATE);   
}

//////// LISTCONTROLS CODE


void CMenusDlg::PintaLU()
{
	int i;
	CString csAux;

	m_CListLU.DeleteAllItems();
	m_CListPGC.DeleteAllItems();
	m_nSelectedItemLU=-1;

	for (i=0; i<theApp.m_nLUs[m_nVTS]; i++)
	{
		csAux.Format(_T("%02d"),i+1);
		m_CListLU.InsertItem( i, csAux);

		csAux=lang_long(theApp.m_szLANG_LU[m_nVTS][i]);

		m_CListLU.SetItemText(i,1, csAux );

		csAux.Format(_T("%02d"),theApp.m_nPGCinLU[m_nVTS][i]);
		m_CListLU.SetItemText(i,2, csAux);

		csAux=Size_MBytes(theApp.m_i64MLUisize[m_nVTS][i]);
		m_CListLU.SetItemText(i,3, csAux);

		csAux=Size_MBytes(theApp.m_i64MLUfsize[m_nVTS][i]);
		m_CListLU.SetItemText(i,4, csAux);

	}
//	UpdateSize();
	UpdateData(FALSE);
}

void CMenusDlg::OnItemchangedListlus(NMHDR* pNMHDR, LRESULT* pResult) 
{
	NM_LISTVIEW* pNMListView = (NM_LISTVIEW*)pNMHDR;
	// TODO: Add your control notification handler code here
	
	int nItem;
	POSITION pos;

	UpdateData(TRUE);

	pos=m_CListLU.GetFirstSelectedItemPosition();
	if (pos != NULL)
	{
		nItem=m_CListLU.GetNextSelectedItem(pos);
		if (nItem!= m_nSelectedItemLU)
		{
			m_nSelectedItemLU=nItem;
			PintaPGC();
		}
	}		
	CheckEnableButtons();
	*pResult = 0;
}


void CMenusDlg::PintaPGC()
{
	int i,j,nPGC;
	CString csAux;

	j=m_nSelectedItemLU;

	m_CListPGC.DeleteAllItems();


	for (i=0; i<theApp.m_nPGCinLU[m_nVTS][j]; i++)
	{
		nPGC=i+theApp.m_nIniPGCinLU[m_nVTS][j];

		csAux.Format(_T("%02d"),i+1);
//		if (theApp.m_bMEntry[j][i]==true) csAux+= " Entry";
		m_CListPGC.InsertItem( i, csAux);

		csAux.Format(_T("%02d"),theApp.m_nMCells[m_nVTS][nPGC]);
		m_CListPGC.SetItemText( i,1, csAux);

		csAux.Format(_T("%02d"),theApp.m_nMFirstVID[m_nVTS][nPGC]);
		m_CListPGC.SetItemText( i,2, csAux);

		csAux.Format(_T("%02d"),theApp.m_nMButtons[m_nVTS][nPGC]);
		m_CListPGC.SetItemText( i,3, csAux);

		csAux=FormatDuration(theApp.m_dwMDuration[m_nVTS][nPGC]);
		m_CListPGC.SetItemText( i,4, csAux);

		if (theApp.m_bMCellReUsed[m_nVTS][nPGC])
			m_CListPGC.SetItemText(i,5, "Yes");
		else
			m_CListPGC.SetItemText(i,5, "No");	
		
		csAux.Format(_T("Pr=%02d Po=%02d Ce=%02d"),
			theApp.m_i8MPreComm[m_nVTS][nPGC],theApp.m_i8MPostComm[m_nVTS][nPGC],theApp.m_i8MCellComm[m_nVTS][nPGC]);

		m_CListPGC.SetItemText(i,6, csAux);
	
		csAux=Size_MBytes(theApp.m_i64MPGCisize[m_nVTS][nPGC]);
		m_CListPGC.SetItemText(i,7, csAux);

		csAux=Size_MBytes(theApp.m_i64MPGCfsize[m_nVTS][nPGC]);
		m_CListPGC.SetItemText(i,8, csAux);


		if (theApp.m_iMAction[m_nVTS][nPGC]==KEEP) csAux="Keep";
		if (theApp.m_iMAction[m_nVTS][nPGC]==STILLA) csAux="Still with audio";
		if (theApp.m_iMAction[m_nVTS][nPGC]==STILLNA) csAux="Still w/o audio";
		if (theApp.m_iMAction[m_nVTS][nPGC]==BLANK) csAux="Blank";
		if (theApp.m_iMAction[m_nVTS][nPGC]==DELPBK) csAux="Delete";
		if (theApp.m_iMAction[m_nVTS][nPGC]==ZERO) csAux="----";
		if (theApp.m_iMAction[m_nVTS][nPGC]==CUT) csAux="Cut";
		if (theApp.m_iMAction[m_nVTS][nPGC]==CELLBASED) csAux="Cells";
		if (theApp.m_iMAction[m_nVTS][nPGC]==REUSE) 
		{
			csAux.Format(_T("%02d"),theApp.m_iReuseLU[m_nVTS][nPGC]+1);
			csAux="Reuse LU "+csAux;
		}

		m_CListPGC.SetItemText(i,9, csAux);
	}
//	UpdateSize();
	UpdateData(FALSE);
}

void CMenusDlg::PintaFSizes()
{
	int i,j;
	CString csAux;
	int nPGC;

	j=m_nSelectedItemLU;

	for (i=0; i<theApp.m_nLUs[m_nVTS]; i++)
	{
		csAux=Size_MBytes(theApp.m_i64MLUfsize[m_nVTS][i]);
		m_CListLU.SetItemText(i,4, csAux);
	}

	for (i=0; i<theApp.m_nPGCinLU[m_nVTS][j]; i++)
	{
		nPGC=i+theApp.m_nIniPGCinLU[m_nVTS][j];

		csAux=Size_MBytes(theApp.m_i64MPGCfsize[m_nVTS][nPGC]);
		m_CListPGC.SetItemText(i,8, csAux);
	}
}

void CMenusDlg::OnItemchangedListpgcs(NMHDR* pNMHDR, LRESULT* pResult) 
{
	NM_LISTVIEW* pNMListView = (NM_LISTVIEW*)pNMHDR;
	// TODO: Add your control notification handler code here

	CheckEnableButtons();
	
	*pResult = 0;
}

// Enabling/disabling buttons and menus

void CMenusDlg::OnRclickListlus(NMHDR* pNMHDR, LRESULT* pResult) 
{
	// TODO: Add your control notification handler code here
	
	CPoint point;
	CMenu menu;

	GetCursorPos(&point);

    VERIFY(menu.LoadMenu(IDR_MENULISTLU));
    CMenu* pPopup = menu.GetSubMenu(0);
    ASSERT(pPopup != NULL);

	CheckEnablePopupMenuLU(pPopup);
    pPopup->TrackPopupMenu(TPM_LEFTALIGN | TPM_RIGHTBUTTON, point.x,point.y , this);

	*pResult = 0;
}

void CMenusDlg::OnRclickListpgcs(NMHDR* pNMHDR, LRESULT* pResult) 
{
	// TODO: Add your control notification handler code here
	
	CPoint point;
	CMenu menu;

	GetCursorPos(&point);

    VERIFY(menu.LoadMenu(IDR_MENULISTMPGC));
    CMenu* pPopup = menu.GetSubMenu(0);
    ASSERT(pPopup != NULL);

	CheckEnablePopupMenuPGC(pPopup);
    pPopup->TrackPopupMenu(TPM_LEFTALIGN | TPM_RIGHTBUTTON, point.x,point.y , this);

	*pResult = 0;
}


void CMenusDlg::CheckEnableButtons()
{
	CWnd* pWnd;
	POSITION posLU,posPGC;
	int nItemLU, nItemPGC;
	int nPGC;
	int nSelected;

	UpdateData(TRUE);

	if (theApp.m_bInProcess==true)
	{
		pWnd = GetDlgItem(IDC_BUTTONKEEPLUALL);
		pWnd->EnableWindow(FALSE);
		pWnd = GetDlgItem(IDC_BUTTONKEEPLU);
		pWnd->EnableWindow(FALSE);
		pWnd = GetDlgItem(IDC_BUTTONREUSELU);
		pWnd->EnableWindow(FALSE);
		pWnd = GetDlgItem(IDC_BUTTONKEEP);
		pWnd->EnableWindow(FALSE);
		pWnd = GetDlgItem(IDC_BUTTONREUSE);
		pWnd->EnableWindow(FALSE);
		pWnd = GetDlgItem(IDC_BUTTONPREV);
		pWnd->EnableWindow(FALSE);
		pWnd = GetDlgItem(IDC_BUTTONCELLS);
		pWnd->EnableWindow(FALSE);
		pWnd = GetDlgItem(IDC_BUTTONBLANK);
		pWnd->EnableWindow(FALSE);
		pWnd = GetDlgItem(IDC_BUTTONDEL);
		pWnd->EnableWindow(FALSE);
		pWnd = GetDlgItem(IDC_BUTTONSTILLPGC);
		pWnd->EnableWindow(FALSE);

		pWnd = GetDlgItem(IDOK);
		pWnd->EnableWindow(FALSE);
		pWnd = GetDlgItem(IDCANCEL);
		pWnd->EnableWindow(FALSE);
	return;
	}
	else
	{
		pWnd = GetDlgItem(IDOK);
		pWnd->EnableWindow(TRUE);
	}
//LU List
	posLU=m_CListLU.GetFirstSelectedItemPosition();
	pWnd = GetDlgItem(IDC_BUTTONKEEPLUALL);
	pWnd->EnableWindow(TRUE);

	if (posLU != NULL)
	{//Enable
		pWnd = GetDlgItem(IDC_BUTTONKEEPLU);
		pWnd->EnableWindow(TRUE);
		pWnd = GetDlgItem(IDC_BUTTONREUSELU);
		if ( theApp.m_nLUs[m_nVTS] <2)
			pWnd->EnableWindow(FALSE);
		else
			pWnd->EnableWindow(TRUE);
	}
	else
	{
		pWnd = GetDlgItem(IDC_BUTTONKEEPLU);
		pWnd->EnableWindow(FALSE);
		pWnd = GetDlgItem(IDC_BUTTONREUSELU);
		pWnd->EnableWindow(FALSE);
	}


// Menu PGC List	
	posPGC=m_CListPGC.GetFirstSelectedItemPosition();
	posLU=m_CListLU.GetFirstSelectedItemPosition();
	nPGC=-1;
	nSelected=m_CListPGC.GetSelectedCount();

	if (posPGC != NULL && posLU !=NULL )
	{
		nItemLU=m_CListLU.GetNextSelectedItem(posLU);
		nItemPGC=m_CListPGC.GetNextSelectedItem(posPGC);
		nPGC=theApp.m_nIniPGCinLU[m_nVTS][nItemLU]+nItemPGC;
	}
	if (nSelected==1)
	{
		if (nPGC!=-1 && theApp.m_nMCells[m_nVTS][nPGC] !=0)
		{//Enable

			pWnd = GetDlgItem(IDC_BUTTONPREV);
			pWnd->EnableWindow(TRUE);
			pWnd = GetDlgItem(IDC_BUTTONCELLS);
			pWnd->EnableWindow(TRUE);

			pWnd = GetDlgItem(IDC_BUTTONKEEP);
			if (theApp.m_iMAction[m_nVTS][nPGC]==KEEP )
				pWnd->EnableWindow(FALSE);
			else
				pWnd->EnableWindow(TRUE);

			pWnd = GetDlgItem(IDC_BUTTONREUSE);
			if (theApp.m_iMAction[m_nVTS][nPGC]==REUSE	|| 
					theApp.m_nLUs[m_nVTS] <2			)
				pWnd->EnableWindow(FALSE);
			else
				pWnd->EnableWindow(TRUE);

			pWnd = GetDlgItem(IDC_BUTTONBLANK);
			if (theApp.m_iMAction[m_nVTS][nPGC]==BLANK)
				pWnd->EnableWindow(FALSE);
			else
				pWnd->EnableWindow(TRUE);

			pWnd = GetDlgItem(IDC_BUTTONDEL);
			if (theApp.m_iMAction[m_nVTS][nPGC]==DELPBK )
				pWnd->EnableWindow(FALSE);
			else
				pWnd->EnableWindow(TRUE);

			pWnd = GetDlgItem(IDC_BUTTONSTILLPGC);
			pWnd->EnableWindow(TRUE);

		}
		else
		{
	// disable
			pWnd = GetDlgItem(IDC_BUTTONCELLS);
			pWnd->EnableWindow(FALSE);
			pWnd = GetDlgItem(IDC_BUTTONPREV);
			pWnd->EnableWindow(FALSE);
			pWnd = GetDlgItem(IDC_BUTTONKEEP);
			pWnd->EnableWindow(FALSE);
			pWnd = GetDlgItem(IDC_BUTTONREUSE);
			pWnd->EnableWindow(FALSE);
			pWnd = GetDlgItem(IDC_BUTTONBLANK);
			pWnd->EnableWindow(FALSE);
			pWnd = GetDlgItem(IDC_BUTTONDEL);
			pWnd->EnableWindow(FALSE);
			pWnd = GetDlgItem(IDC_BUTTONSTILLPGC);
			pWnd->EnableWindow(FALSE);

		}

	}
	else
	{// More than one selected
		pWnd = GetDlgItem(IDC_BUTTONCELLS);
		pWnd->EnableWindow(FALSE);
		pWnd = GetDlgItem(IDC_BUTTONPREV);
		pWnd->EnableWindow(FALSE);
		pWnd = GetDlgItem(IDC_BUTTONREUSE);
		pWnd->EnableWindow(FALSE);
		if (nPGC!=-1 )
		{
			pWnd = GetDlgItem(IDC_BUTTONKEEP);
			pWnd->EnableWindow(TRUE);
			pWnd = GetDlgItem(IDC_BUTTONBLANK);
			pWnd->EnableWindow(TRUE);
			pWnd = GetDlgItem(IDC_BUTTONDEL);
			pWnd->EnableWindow(TRUE);
			pWnd = GetDlgItem(IDC_BUTTONSTILLPGC);
			pWnd->EnableWindow(TRUE);
		}
		else
		{
			pWnd = GetDlgItem(IDC_BUTTONKEEP);
			pWnd->EnableWindow(FALSE);
			pWnd = GetDlgItem(IDC_BUTTONBLANK);
			pWnd->EnableWindow(FALSE);
			pWnd = GetDlgItem(IDC_BUTTONDEL);
			pWnd->EnableWindow(FALSE);
			pWnd = GetDlgItem(IDC_BUTTONSTILLPGC);
			pWnd->EnableWindow(FALSE);
		}
	}
}

void CMenusDlg::CheckEnablePopupMenuLU(CMenu* pPopup)
{
	POSITION posLU;
//	int nItemLU;

	UpdateData(TRUE);

	if (theApp.m_bInProcess==true)
	{
		pPopup->EnableMenuItem(ID__KEEPLUALL, MF_BYCOMMAND | MF_DISABLED |  MF_GRAYED );
		pPopup->EnableMenuItem(ID__KEEPLU, MF_BYCOMMAND | MF_DISABLED |  MF_GRAYED );
		pPopup->EnableMenuItem(ID__REUSELU, MF_BYCOMMAND | MF_DISABLED |  MF_GRAYED );
	return;
	}

//LU List
	pPopup->EnableMenuItem(ID__KEEPLUALL, MF_BYCOMMAND | MF_ENABLED );

	posLU=m_CListLU.GetFirstSelectedItemPosition();
	if (posLU != NULL)
	{//Enable
		pPopup->EnableMenuItem(ID__KEEPLU, MF_BYCOMMAND | MF_ENABLED );
		if ( theApp.m_nLUs[m_nVTS] <2)
			pPopup->EnableMenuItem(ID__REUSELU, MF_BYCOMMAND | MF_DISABLED |  MF_GRAYED );
		else
			pPopup->EnableMenuItem(ID__REUSELU, MF_BYCOMMAND | MF_ENABLED );
	}
	else
	{
		pPopup->EnableMenuItem(ID__KEEPLU, MF_BYCOMMAND | MF_DISABLED |  MF_GRAYED );
		pPopup->EnableMenuItem(ID__REUSELU, MF_BYCOMMAND | MF_DISABLED |  MF_GRAYED );
	}
}

void CMenusDlg::CheckEnablePopupMenuPGC(CMenu* pPopup)
{

	POSITION posLU,posPGC;
	int nItemLU, nItemPGC;
	int nPGC;
	int nSelected;

	UpdateData(TRUE);

	if (theApp.m_bInProcess==true)
	{
		pPopup->EnableMenuItem(ID__MKEEP, MF_BYCOMMAND | MF_DISABLED |  MF_GRAYED );
		pPopup->EnableMenuItem(ID__MREUSE, MF_BYCOMMAND | MF_DISABLED |  MF_GRAYED );
		pPopup->EnableMenuItem(ID__MBLANK, MF_BYCOMMAND | MF_DISABLED |  MF_GRAYED );
		pPopup->EnableMenuItem(ID__MDELETE, MF_BYCOMMAND | MF_DISABLED |  MF_GRAYED );
		pPopup->EnableMenuItem(ID__MPREV, MF_BYCOMMAND | MF_DISABLED |  MF_GRAYED );
		pPopup->EnableMenuItem(ID__MCELLS, MF_BYCOMMAND | MF_DISABLED |  MF_GRAYED );
		pPopup->EnableMenuItem(ID__MSTILLA, MF_BYCOMMAND | MF_DISABLED |  MF_GRAYED );
		pPopup->EnableMenuItem(ID__MSTILLNA, MF_BYCOMMAND | MF_DISABLED |  MF_GRAYED );
		pPopup->EnableMenuItem(ID__MSELALL, MF_BYCOMMAND | MF_DISABLED |  MF_GRAYED );
		pPopup->EnableMenuItem(ID__MSELALLB, MF_BYCOMMAND | MF_DISABLED |  MF_GRAYED );
		pPopup->EnableMenuItem(ID__MSELALLNB, MF_BYCOMMAND | MF_DISABLED |  MF_GRAYED );
	return;
	}

	pPopup->EnableMenuItem(ID__MSELALL, MF_BYCOMMAND | MF_ENABLED );
	pPopup->EnableMenuItem(ID__MSELALLB, MF_BYCOMMAND | MF_ENABLED );
	pPopup->EnableMenuItem(ID__MSELALLNB, MF_BYCOMMAND | MF_ENABLED );

// Menu PGC List	
	posPGC=m_CListPGC.GetFirstSelectedItemPosition();
	posLU=m_CListLU.GetFirstSelectedItemPosition();
	nPGC=-1;
	nSelected=m_CListPGC.GetSelectedCount();

	if (posPGC != NULL && posLU !=NULL )
	{
		nItemLU=m_CListLU.GetNextSelectedItem(posLU);
		nItemPGC=m_CListPGC.GetNextSelectedItem(posPGC);
		nPGC=theApp.m_nIniPGCinLU[m_nVTS][nItemLU]+nItemPGC;
	}

	if (nSelected==1)
	{
		if (nPGC!=-1 && theApp.m_nMCells[m_nVTS][nPGC] !=0)
		{//Enable

			pPopup->EnableMenuItem(ID__MPREV, MF_BYCOMMAND | MF_ENABLED );
			pPopup->EnableMenuItem(ID__MCELLS, MF_BYCOMMAND | MF_ENABLED );
			pPopup->EnableMenuItem(ID__MSTILLA, MF_BYCOMMAND | MF_ENABLED );
			pPopup->EnableMenuItem(ID__MSTILLNA, MF_BYCOMMAND | MF_ENABLED );

			if (theApp.m_iMAction[m_nVTS][nPGC]==KEEP)
				pPopup->EnableMenuItem(ID__MKEEP, MF_BYCOMMAND | MF_DISABLED |  MF_GRAYED );
			else
				pPopup->EnableMenuItem(ID__MKEEP, MF_BYCOMMAND | MF_ENABLED );

			if (theApp.m_iMAction[m_nVTS][nPGC]==REUSE	|| 
					theApp.m_nLUs[m_nVTS] <2			)
				pPopup->EnableMenuItem(ID__MREUSE, MF_BYCOMMAND | MF_DISABLED |  MF_GRAYED );
			else
				pPopup->EnableMenuItem(ID__MREUSE, MF_BYCOMMAND | MF_ENABLED );

			if (theApp.m_iMAction[m_nVTS][nPGC]==BLANK )
				pPopup->EnableMenuItem(ID__MBLANK, MF_BYCOMMAND | MF_DISABLED |  MF_GRAYED );
			else
				pPopup->EnableMenuItem(ID__MBLANK, MF_BYCOMMAND | MF_ENABLED );

			if (theApp.m_iMAction[m_nVTS][nPGC]==DELPBK )
				pPopup->EnableMenuItem(ID__MDELETE, MF_BYCOMMAND | MF_DISABLED |  MF_GRAYED );
			else
				pPopup->EnableMenuItem(ID__MDELETE, MF_BYCOMMAND | MF_ENABLED );

		}
		else
		{
	// disable
			pPopup->EnableMenuItem(ID__MKEEP, MF_BYCOMMAND | MF_DISABLED |  MF_GRAYED );
			pPopup->EnableMenuItem(ID__MREUSE, MF_BYCOMMAND | MF_DISABLED |  MF_GRAYED );
			pPopup->EnableMenuItem(ID__MBLANK, MF_BYCOMMAND | MF_DISABLED |  MF_GRAYED );
			pPopup->EnableMenuItem(ID__MDELETE, MF_BYCOMMAND | MF_DISABLED |  MF_GRAYED );
			pPopup->EnableMenuItem(ID__MPREV, MF_BYCOMMAND | MF_DISABLED |  MF_GRAYED );
			pPopup->EnableMenuItem(ID__MCELLS, MF_BYCOMMAND | MF_DISABLED |  MF_GRAYED );
			pPopup->EnableMenuItem(ID__MSTILLA, MF_BYCOMMAND | MF_DISABLED |  MF_GRAYED );
			pPopup->EnableMenuItem(ID__MSTILLNA, MF_BYCOMMAND | MF_DISABLED |  MF_GRAYED );
		}
	}
	else
	{
		pPopup->EnableMenuItem(ID__MCELLS, MF_BYCOMMAND | MF_DISABLED |  MF_GRAYED );
		pPopup->EnableMenuItem(ID__MPREV, MF_BYCOMMAND | MF_DISABLED |  MF_GRAYED );
		pPopup->EnableMenuItem(ID__MREUSE, MF_BYCOMMAND | MF_DISABLED |  MF_GRAYED );

		if (nPGC!=-1)
		{
			pPopup->EnableMenuItem(ID__MBLANK,  MF_BYCOMMAND | MF_ENABLED );
			pPopup->EnableMenuItem(ID__MDELETE,  MF_BYCOMMAND | MF_ENABLED );
			pPopup->EnableMenuItem(ID__MKEEP,  MF_BYCOMMAND | MF_ENABLED );
			pPopup->EnableMenuItem(ID__MSTILLA,  MF_BYCOMMAND | MF_ENABLED );
			pPopup->EnableMenuItem(ID__MSTILLNA,  MF_BYCOMMAND | MF_ENABLED );
		}
		else
		{
			pPopup->EnableMenuItem(ID__MBLANK, MF_BYCOMMAND | MF_DISABLED |  MF_GRAYED );
			pPopup->EnableMenuItem(ID__MDELETE, MF_BYCOMMAND | MF_DISABLED |  MF_GRAYED );
			pPopup->EnableMenuItem(ID__MKEEP, MF_BYCOMMAND | MF_DISABLED |  MF_GRAYED );
			pPopup->EnableMenuItem(ID__MSTILLA, MF_BYCOMMAND | MF_DISABLED |  MF_GRAYED );
			pPopup->EnableMenuItem(ID__MSTILLNA, MF_BYCOMMAND | MF_DISABLED |  MF_GRAYED );
		}
	}
}

/// Menus Code
void CMenusDlg::On__keepluall() 
{
	OnButtonkeepluall();
}
void CMenusDlg::On__keeplu() 
{
	OnButtonkeeplu();
}
void CMenusDlg::On__reuselu() 
{
	OnButtonreuselu();
}
void CMenusDlg::On__mprev() 
{
	OnButtonprev();
}
void CMenusDlg::On__mcells() 
{
	OnButtoncells();
}
void CMenusDlg::On__mblank() 
{
	OnButtonblank();
}
void CMenusDlg::On__mdelete() 
{
	OnButtondel();
}
void CMenusDlg::On__mkeep() 
{
	OnButtonkeep();
}
void CMenusDlg::On__mreuse() 
{
	OnButtonreuse();
}
void CMenusDlg::On__mstilla() 
{
	m_bPreserveAudio=true;
	OnButtonstillpgc2();
}
void CMenusDlg::On__mstillna() 
{
	m_bPreserveAudio=false;
	OnButtonstillpgc2();
}
void CMenusDlg::On__mselall() 
{
	int nPGC,nPGCs;

	nPGCs=m_CListPGC.GetItemCount();	

	for (nPGC=0;nPGC<nPGCs;nPGC++)
		m_CListPGC.SetItemState(nPGC,LVIS_SELECTED,LVIS_SELECTED);

}
void CMenusDlg::On__mselallb() 
{
	POSITION posLU;
	int nItemLU;
	int nPGC,nPGCs,nItem;

	nPGCs=m_CListPGC.GetItemCount();	

	posLU=m_CListLU.GetFirstSelectedItemPosition();

	if (posLU != NULL)
	{
		nItemLU=m_CListLU.GetNextSelectedItem(posLU);
		for (nItem=0; nItem< nPGCs; nItem++)
		{
			nPGC=nItem+theApp.m_nIniPGCinLU[m_nVTS][nItemLU];
			if (theApp.m_nMButtons[m_nVTS][nPGC]!=0)
				m_CListPGC.SetItemState(nPGC,LVIS_SELECTED,LVIS_SELECTED);
			else
				m_CListPGC.SetItemState(nPGC,0,LVIS_SELECTED);
		}
	}
}
void CMenusDlg::On__mselallnb() 
{
	POSITION posLU;
	int nItemLU;
	int nPGC,nPGCs,nItem;

	nPGCs=m_CListPGC.GetItemCount();	

	posLU=m_CListLU.GetFirstSelectedItemPosition();

	if (posLU != NULL)
	{
		nItemLU=m_CListLU.GetNextSelectedItem(posLU);
		for (nItem=0; nItem< nPGCs; nItem++)
		{
			nPGC=nItem+theApp.m_nIniPGCinLU[m_nVTS][nItemLU];
			if (theApp.m_nMButtons[m_nVTS][nPGC]==0)
				m_CListPGC.SetItemState(nPGC,LVIS_SELECTED,LVIS_SELECTED);
			else
				m_CListPGC.SetItemState(nPGC,0,LVIS_SELECTED);
		}
	}
}

//////// BUTTONS CODE
void CMenusDlg::OnButtonkeepluall() 
{
	// TODO: Add your control notification handler code here
	int nItemLU,nItemPGC;

	for (nItemLU=0; nItemLU<theApp.m_nLUs[m_nVTS]; nItemLU++)
	{
		for (nItemPGC=0;nItemPGC<theApp.m_nPGCinLU[m_nVTS][nItemLU] ; nItemPGC++)
				Buttonkeep(nItemLU,nItemPGC);

	}	
	PintaFSizes();
	m_csEndSize= Size_MBytes(theApp.m_i64Mfsize[m_nVTS]);
	UpdateData(FALSE);

	CheckEnableButtons();	
}
void CMenusDlg::OnButtonkeeplu() 
{
	// TODO: Add your control notification handler code here
	POSITION posLU;
	int nItemLU,nItemPGC;

	posLU=m_CListLU.GetFirstSelectedItemPosition();

	if ( posLU !=NULL)
	{
		nItemLU=m_CListLU.GetNextSelectedItem(posLU);

		for (nItemPGC=0;nItemPGC<theApp.m_nPGCinLU[m_nVTS][nItemLU] ; nItemPGC++)
				Buttonkeep(nItemLU,nItemPGC);
		PintaFSizes();
		m_csEndSize= Size_MBytes(theApp.m_i64Mfsize[m_nVTS]);
		UpdateData(FALSE);
	}	

	CheckEnableButtons();
}

void CMenusDlg::OnButtonreuselu() 
{
	// TODO: Add your control notification handler code here
	POSITION posLU;
	int nItemLU,nItemPGC;
	int nResponse;
	CLUSelDlg dlg;

	posLU=m_CListLU.GetFirstSelectedItemPosition();

	if ( posLU !=NULL)
	{
		nItemLU=m_CListLU.GetNextSelectedItem(posLU);

		dlg.m_nVTS=m_nVTS;
		dlg.m_nLU=nItemLU;

		nResponse = dlg.DoModal();

		if (nResponse == IDOK)
		{
			for (nItemPGC=0;nItemPGC<theApp.m_nPGCinLU[m_nVTS][nItemLU] ; nItemPGC++)
				Buttonreuse(nItemLU,nItemPGC,dlg.m_nSelectedLU);
			PintaFSizes();
			m_csEndSize= Size_MBytes(theApp.m_i64Mfsize[m_nVTS]);
			UpdateData(FALSE);
		}
	}	

	CheckEnableButtons();

}

void CMenusDlg::OnButtonblank() 
{
	// TODO: Add your control notification handler code here
	POSITION posLU,posPGC;
	int nItemLU, nItemPGC;
	int nPGC;
	int iRet;
	CString csAux;

	posPGC=m_CListPGC.GetFirstSelectedItemPosition();
	posLU=m_CListLU.GetFirstSelectedItemPosition();
	if (posLU != NULL) nItemLU=m_CListLU.GetNextSelectedItem(posLU);
	else return;

	while (posPGC)
	{
		
		nItemPGC=m_CListPGC.GetNextSelectedItem(posPGC);
		nPGC=theApp.m_nIniPGCinLU[m_nVTS][nItemLU]+nItemPGC;

		if (theApp.m_iMAction[m_nVTS][nPGC]!=ZERO)
		{
			iRet=IDYES;
			if ((theApp.m_i8MCellComm[m_nVTS][nPGC]!=0 && theApp.m_b8MCellComm[m_nVTS][nPGC] ) ||
				 theApp.m_nMButtons[m_nVTS][nPGC]!=0)
			{
				csAux.Format(_T("The selected PGC %d has Cell Commands and/or Cell Buttons.\n"), nItemPGC+1);
				iRet=AfxMessageBox (csAux + "Blanking may produce a non-working menu.\nDo you really want to blank it?", MB_YESNO|MB_ICONQUESTION );
			}

			if (iRet==IDYES)
			{

				theApp.m_iMAction[m_nVTS][nPGC]=BLANK;
				theApp.GetMenuEndSize();

				CleanCellBased(m_nVTS,nPGC);

				csAux="Blank";
				m_CListPGC.SetItemText(nItemPGC,9, csAux);

				PintaFSizes();

				m_csEndSize= Size_MBytes(theApp.m_i64Mfsize[m_nVTS]);
				UpdateData(FALSE);
			}
		}
	}	

	CheckEnableButtons();
}

void CMenusDlg::OnButtondel() 
{
	// TODO: Add your control notification handler code here
	// TODO: Add your control notification handler code here
	POSITION posLU,posPGC;
	int nItemLU, nItemPGC;
	int nPGC;
	int iRet;
	CString csAux;

	posPGC=m_CListPGC.GetFirstSelectedItemPosition();
	posLU=m_CListLU.GetFirstSelectedItemPosition();
	if (posLU != NULL) nItemLU=m_CListLU.GetNextSelectedItem(posLU);
	else return;


	while (posPGC)
	{
		nItemPGC=m_CListPGC.GetNextSelectedItem(posPGC);
		nPGC=theApp.m_nIniPGCinLU[m_nVTS][nItemLU]+nItemPGC;

		if (theApp.m_iMAction[m_nVTS][nPGC]!=ZERO)
		{
			iRet=IDYES;
			if ((theApp.m_i8MCellComm[m_nVTS][nPGC]!=0 && theApp.m_b8MCellComm[m_nVTS][nPGC] ) ||
				 theApp.m_nMButtons[m_nVTS][nPGC]!=0)
			{
				csAux.Format(_T("The selected PGC %d has Cell Commands and/or Cell Buttons.\n"), nItemPGC+1);
				iRet=AfxMessageBox (csAux + "Deleting PBK may produce a non-working menu.\nDo you really want to delete playback?", MB_YESNO|MB_ICONQUESTION );
			}
		
			if (iRet==IDYES)
			{
				theApp.m_iMAction[m_nVTS][nPGC]=DELPBK;
				theApp.GetMenuEndSize();
	
				CleanCellBased(m_nVTS,nPGC);

				csAux="Delete";
				m_CListPGC.SetItemText(nItemPGC,9, csAux);

				PintaFSizes();

				m_csEndSize= Size_MBytes(theApp.m_i64Mfsize[m_nVTS]);
				UpdateData(FALSE);
			}
		}
	}	

	CheckEnableButtons();	
}

void CMenusDlg::OnButtonkeep() 
{
	// TODO: Add your control notification handler code here
	POSITION posLU,posPGC;
	int nItemLU, nItemPGC;

	posPGC=m_CListPGC.GetFirstSelectedItemPosition();
	posLU=m_CListLU.GetFirstSelectedItemPosition();
	if (posLU != NULL) nItemLU=m_CListLU.GetNextSelectedItem(posLU);
	else return;

	while (posPGC )
	{
		nItemPGC=m_CListPGC.GetNextSelectedItem(posPGC);

		Buttonkeep(nItemLU,nItemPGC);

		PintaFSizes();

		m_csEndSize= Size_MBytes(theApp.m_i64Mfsize[m_nVTS]);
		UpdateData(FALSE);
	}	

	CheckEnableButtons();

}


void CMenusDlg::OnButtonreuse() 
{
	// TODO: Add your control notification handler code here
	POSITION posLU,posPGC;
	int nItemLU, nItemPGC;
	int nPGC;
	int nResponse;
	CLUSelDlg dlg;

	posPGC=m_CListPGC.GetFirstSelectedItemPosition();
	posLU=m_CListLU.GetFirstSelectedItemPosition();

	if (posPGC != NULL && posLU !=NULL)
	{
		nItemLU=m_CListLU.GetNextSelectedItem(posLU);
		nItemPGC=m_CListPGC.GetNextSelectedItem(posPGC);
		nPGC=theApp.m_nIniPGCinLU[m_nVTS][nItemLU]+nItemPGC;

		dlg.m_nVTS=m_nVTS;
		dlg.m_nLU=nItemLU;

		nResponse = dlg.DoModal();

		if (nResponse == IDOK)
		{
			Buttonreuse(nItemLU,nItemPGC,dlg.m_nSelectedLU);

			CleanCellBased(m_nVTS,nPGC);

			PintaFSizes();
			m_csEndSize= Size_MBytes(theApp.m_i64Mfsize[m_nVTS]);
			UpdateData(FALSE);
		}
	}	

	CheckEnableButtons();


}

void CMenusDlg::Buttonkeep(int nItemLU, int nItemPGC) 
{
	// TODO: Add your control notification handler code here
	int nPGC;
	CString csAux;

	nPGC=theApp.m_nIniPGCinLU[m_nVTS][nItemLU]+nItemPGC;

	if (theApp.m_iMAction[m_nVTS][nPGC]==ZERO) return;

	theApp.m_iMAction[m_nVTS][nPGC]=KEEP;
	theApp.GetMenuEndSize();

	csAux="Keep";
	m_CListPGC.SetItemText(nItemPGC,9, csAux);

	CleanCellBased(m_nVTS,nPGC);

}	

void CMenusDlg::Buttonreuse(int nItemLU, int nItemPGC, int nSelectedLU) 
{
	// TODO: Add your control notification handler code here
	int nPGC;
	CString csAux;

	nPGC=theApp.m_nIniPGCinLU[m_nVTS][nItemLU]+nItemPGC;
	if (theApp.m_iMAction[m_nVTS][nPGC]==ZERO) return;

	theApp.m_iMAction[m_nVTS][nPGC]=REUSE;
	theApp.m_iReuseLU[m_nVTS][nPGC]=nSelectedLU;

	theApp.GetMenuEndSize();

	csAux.Format(_T("%02d"),theApp.m_iReuseLU[m_nVTS][nPGC]+1);
	csAux="Reuse LU "+csAux;
	m_CListPGC.SetItemText(nItemPGC,9, csAux);

	CleanCellBased(m_nVTS,nPGC);

}


void CMenusDlg::OnButtonprev() 
{
	// TODO: Add your control notification handler code here
	int nItemPGC,nItemLU,nPGC;
	POSITION posPGC, posLU;
	CPreviewDlg dlgPreview;


	posPGC=m_CListPGC.GetFirstSelectedItemPosition();
	posLU=m_CListLU.GetFirstSelectedItemPosition();


	if (posPGC != NULL && posLU !=NULL)
	{
		nItemPGC=m_CListPGC.GetNextSelectedItem(posPGC);	
		nItemLU=m_CListLU.GetNextSelectedItem(posLU);
		nPGC=theApp.m_nIniPGCinLU[m_nVTS][nItemLU]+nItemPGC;
	
		dlgPreview.m_BEnableCut=FALSE;
		dlgPreview.m_iModePrev=PGCPREV;
		dlgPreview.m_nCell=0;
		dlgPreview.m_nT=nPGC;
		dlgPreview.m_nVTS=m_nVTS;
		dlgPreview.m_iDomain=MENUS;

		dlgPreview.DoModal();	

	}

	ShowWindow(SW_RESTORE);


}	

void CMenusDlg::OnButtoncells() 
{
	// TODO: Add your control notification handler code here
	CString csAux;
	CCellsDlg dlg;
	int nResponse;
	int nCell,nCells;
	bool bAllCellsKeep;

	int nItemPGC,nItemLU,nPGC;
	POSITION posPGC, posLU;

	UpdateData(TRUE);

	posPGC=m_CListPGC.GetFirstSelectedItemPosition();
	posLU=m_CListLU.GetFirstSelectedItemPosition();

	if (posPGC != NULL && posLU !=NULL)
	{
		nItemPGC=m_CListPGC.GetNextSelectedItem(posPGC);	
		nItemLU=m_CListLU.GetNextSelectedItem(posLU);
		nPGC=theApp.m_nIniPGCinLU[m_nVTS][nItemLU]+nItemPGC;

		dlg.m_nVTS=m_nVTS;
		dlg.m_nT=nPGC;
		dlg.m_nLU=nItemLU;
		dlg.m_iDomain=MENUS;

		nResponse = dlg.DoModal();

		if (nResponse == IDOK)
		{
			nCells=theApp.m_nMCells[m_nVTS][nPGC];

			for (nCell=0, bAllCellsKeep=true; nCell<nCells &&  bAllCellsKeep ;nCell++)
			{
				if (theApp.m_csMCellBased[m_nVTS][nPGC][nCell] != 'K' ) bAllCellsKeep=false;
			}
			if (bAllCellsKeep) 
			{
				OnButtonkeep();
				return;
			}

			theApp.m_iMAction[m_nVTS][nPGC]=CELLBASED;
			m_CListPGC.SetItemText(nItemPGC,9, "Cells");
			UpdateData(FALSE);
		}
	
	theApp.GetMenuEndSize();
	PintaFSizes();
	m_csEndSize= Size_MBytes(theApp.m_i64Mfsize[m_nVTS]);
	UpdateData(FALSE);
	}
}

void CMenusDlg::OnOK() 
{
	// TODO: Add extra validation here

	UpdateData(TRUE);

	theApp.GetMenuEndSize();
	theApp.m_bCheckBlankNoB=m_bCheckBlankNoB;
	theApp.m_iIFrameMode=m_ComboStill.GetCurSel();

	
	CDialog::OnOK();
}



void CMenusDlg::OnDblclkListpgcs(NMHDR* pNMHDR, LRESULT* pResult) 
{
	// TODO: Add your control notification handler code here
	OnButtoncells();
	*pResult = 0;
}

void CMenusDlg::CleanCellBased(int nVTS, int nT)
{
	int nCell,nCells;
	int nCellR,nArrayCells;
	char mychar;

	nCells=theApp.m_nMCells[nVTS][nT];

	mychar='K';

	for (nCell=0; nCell<nCells ;nCell++)
	   theApp.m_csMCellBased[nVTS][nT].SetAt(nCell,mychar);

// REMOVE ONLY CELLS OF MY TITLE ....
// REPLACED CELLS

	nArrayCells=theApp.m_ACell_replace.GetSize();
	for (nCellR=nArrayCells-1; nCellR>=0 ;nCellR--)
	{
		for (nCell=0;nCell<nCells;nCell++)
		{
			if (nT==    theApp.m_ACell_replace[nCellR].nT    &&
			    nCell== theApp.m_ACell_replace[nCellR].nCell &&
				m_nVTS==theApp.m_ACell_replace[nCellR].nVTS  &&
				MENUS== theApp.m_ACell_replace[nCellR].iDomain)
			{
				theApp.m_ACell_replace.RemoveAt(nCellR,1);
				nCell=nCells;  //exit loop
			}
		}
	}

// MOTION2STILL CELLS
	nArrayCells=theApp.m_ACellStillinfo.GetSize();
	for (nCellR=nArrayCells-1; nCellR>=0 ;nCellR--)
	{
		for (nCell=0;nCell<nCells;nCell++)
		{
			if (theApp.m_ACellStillinfo[nCellR].nT ==nT &&
			    theApp.m_ACellStillinfo[nCellR].nCell == nCell &&
			    theApp.m_ACellStillinfo[nCellR].nVTS==nVTS &&
				theApp.m_ACellStillinfo[nCellR].iDomain==MENUS)
			{
				theApp.m_ACellStillinfo.RemoveAt(nCellR,1);
				nCell=nCells;  //exit loop
			}
		}
	}
//SPLIT CELLS
	nArrayCells=theApp.m_ACellSplitinfo.GetSize();
	for (nCellR=nArrayCells-1; nCellR>=0 ;nCellR--)
	{
		for (nCell=0;nCell<nCells;nCell++)
		{
			if (theApp.m_ACellSplitinfo[nCellR].nT ==nT &&
			    theApp.m_ACellSplitinfo[nCellR].nCell == nCell &&
			    theApp.m_ACellSplitinfo[nCellR].nVTS==nVTS &&
				theApp.m_ACellSplitinfo[nCellR].iDomain==MENUS)
			{
				theApp.m_ACellSplitinfo.RemoveAt(nCellR,1);
				nCell=nCells;  //exit loop
			}
		}
	}

//CUT CELLS
	nArrayCells=theApp.m_ACellCutinfo.GetSize();
	for (nCellR=nArrayCells-1; nCellR>=0 ;nCellR--)
	{
		for (nCell=0;nCell<nCells;nCell++)
		{
			if (theApp.m_ACellCutinfo[nCellR].nT ==nT &&
			    theApp.m_ACellCutinfo[nCellR].nCell == nCell &&
			    theApp.m_ACellCutinfo[nCellR].nVTS==nVTS &&
				theApp.m_ACellCutinfo[nCellR].iDomain==MENUS)
			{
				theApp.m_ACellCutinfo.RemoveAt(nCellR,1);
				nCell=nCells;  //exit loop
			}
		}
	}

}

void CMenusDlg::OnButtonstillpgc() 
{
	// TODO: Add your control notification handler code here
	int iRet;

	iRet=AfxMessageBox ("Selected pgc/s will be converted to a single I-Frame per Cell.\nDo you want to keep the audio?", MB_YESNO|MB_ICONQUESTION );

	if (iRet==IDYES)
		m_bPreserveAudio=true;
	else
		m_bPreserveAudio=false;

	OnButtonstillpgc2();
	
}

void CMenusDlg::OnButtonstillpgc2() 
{
	POSITION posLU,posPGC;
	int nItemLU, nItemPGC;

	posPGC=m_CListPGC.GetFirstSelectedItemPosition();
	posLU=m_CListLU.GetFirstSelectedItemPosition();
	if (posLU != NULL) nItemLU=m_CListLU.GetNextSelectedItem(posLU);
	else return;

	while (posPGC )
	{
		nItemPGC=m_CListPGC.GetNextSelectedItem(posPGC);

		ButtonStill(nItemLU,nItemPGC);

		PintaFSizes();

		m_csEndSize= Size_MBytes(theApp.m_i64Mfsize[m_nVTS]);
		UpdateData(FALSE);
	}	

	CheckEnableButtons();
}

void CMenusDlg::ButtonStill(int nItemLU, int nItemPGC) 
{
	// TODO: Add your control notification handler code here
	int nPGC;
	CString csAux;

	nPGC=theApp.m_nIniPGCinLU[m_nVTS][nItemLU]+nItemPGC;

	if (theApp.m_iMAction[m_nVTS][nPGC]==ZERO) return;

	if (m_bPreserveAudio)
		theApp.m_iMAction[m_nVTS][nPGC]=STILLA;
	else
		theApp.m_iMAction[m_nVTS][nPGC]=STILLNA;

	theApp.GetMenuEndSize();

	if (m_bPreserveAudio)
		csAux="Still with audio";
	else
		csAux="Still w/o audio";
	
	m_CListPGC.SetItemText(nItemPGC,9, csAux);

	CleanCellBased(m_nVTS,nPGC);

}	


void CMenusDlg::OnCheckblanknobuttons() 
{
	// TODO: Add your control notification handler code here
	UpdateData(TRUE);
	theApp.m_bCheckBlankNoB=m_bCheckBlankNoB;
	theApp.GetMenuEndSize();

	PintaFSizes();
	m_csEndSize= Size_MBytes(theApp.m_i64Mfsize[m_nVTS]);
	UpdateData(FALSE);
	
}

void CMenusDlg::OnSelchangeCombostill() 
{
	// TODO: Add your control notification handler code here
	UpdateData(TRUE);
	theApp.m_iIFrameMode=m_ComboStill.GetCurSel();

}

BOOL CMenusDlg::OnHelpInfo(HELPINFO* pHelpInfo) 
{
	// TODO: Add your message handler code here and/or call default
	
	HtmlHelp(NULL,theApp.m_csPath+"\\VobBlanker.chm::.\\htm\\Menus_Main_Dialog.htm", HH_DISPLAY_TOC, 0);
	return TRUE;
}
