// PreviewDlg.cpp : implementation file
//

#include "stdafx.h"
#include "direct.h"
#include "process.h"
#include "HtmlHelp.h"
#include "ToolTipDialog.h"
#include "VobBlanker.h"
#include "PreviewDlg.h"

#include "sys/types.h"
#include "sys/stat.h"
#include "io.h"


#define TRACK_HEIGHT	30

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

extern CVobBlankerApp theApp;
extern void MyInfoBox(LPCTSTR text);
extern void MyErrorBox(LPCTSTR text);
//extern "C" int Coded_Picture_Width, Coded_Picture_Height;	// Size of picture.
extern bool MyDeleteFile(const char *szFilename);


#define TIMEOUT   150

#define ID_USERPOSITION   0
#define ID_USERINISECTOR  1
#define ID_USERENDSECTOR  2

#define ID_LEFT_BUTTON                  1
#define ID_LEFT_ARROW                   2
#define ID_RIGHT_ARROW                  3
#define ID_RIGHT_BUTTON                 4
#define ID_TRACKBAR                     5

#define IDM_PREVIEW                     32775
#define IDM_PAUSE                       32777
#define IDM_STOP                        32778
#define IDM_PLAY                        32862
#define IDM_INFO                        32786



/////////////////////////////////////////////////////////////////////////////
// CPreviewDlg dialog


CPreviewDlg::CPreviewDlg(CWnd* pParent /*=NULL*/)
	: CToolTipDialog(CPreviewDlg::IDD, pParent)


{
	//{{AFX_DATA_INIT(CPreviewDlg)
	m_csSector = _T("");
	m_csIniSector = _T("");
	m_csIniCell = _T("");
	m_csEndSector = _T("");
	m_csEndCell = _T("");
	m_bCheckDar = TRUE;
	m_bCheckFps = TRUE;
	m_csFileStill = _T("");
	m_bCheckChapter = FALSE;
	m_bCheckProgram = FALSE;
	//}}AFX_DATA_INIT
	m_nACell=-1;
	m_hIcon = AfxGetApp()->LoadIcon(IDI_MYMOVIE);

}


void CPreviewDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CPreviewDlg)
	DDX_Control(pDX, IDC_SLIDER1, m_CSlider);
	DDX_Control(pDX, IDC_COMBOIFRAME, m_ComboIFrame);
	DDX_Control(pDX, IDC_COMBOCELL, m_ComboCell);
	DDX_Text(pDX, IDC_SECTOR, m_csSector);
	DDX_Text(pDX, IDC_INISECTOR, m_csIniSector);
	DDX_Text(pDX, IDC_INICELL, m_csIniCell);
	DDX_Text(pDX, IDC_ENDSECTOR, m_csEndSector);
	DDX_Text(pDX, IDC_ENDCELL, m_csEndCell);
	DDX_Radio(pDX, IDC_RADIO1, m_iRadio);
	DDX_Check(pDX, IDC_CHECKDAR, m_bCheckDar);
	DDX_Check(pDX, IDC_CHECKFPS, m_bCheckFps);
	DDX_Check(pDX, IDC_CHECKAUDIO, m_bCheckAudio);
	DDX_Text(pDX, IDC_EDITFILE, m_csFileStill);
	DDX_Check(pDX, IDC_CHECKCHAPTER, m_bCheckChapter);
	DDX_Check(pDX, IDC_CHECKPROGRAM, m_bCheckProgram);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CPreviewDlg, CDialog)
	//{{AFX_MSG_MAP(CPreviewDlg)
	ON_BN_CLICKED(IDC_STOP, OnStop)
	ON_BN_CLICKED(IDC_PLAY, OnPlay)
	ON_BN_CLICKED(IDC_PREV, OnPrev)
	ON_BN_CLICKED(IDC_NEXT, OnNext)
	ON_BN_CLICKED(IDC_INIMARK, OnInimark)
	ON_BN_CLICKED(IDC_ENDMARK, OnEndmark)
	ON_BN_CLICKED(IDC_INICLEAR, OnIniclear)
	ON_BN_CLICKED(IDC_ENDCLEAR, OnEndclear)
	ON_CBN_SELENDOK(IDC_COMBOCELL, OnSelendokCombocell)
	ON_BN_CLICKED(IDC_BUTTONINFO, OnInfo)
	ON_BN_CLICKED(IDC_CHECKDAR, OnCheckdar)
	ON_BN_CLICKED(IDC_CHECKFPS, OnCheckfps)
	ON_WM_HELPINFO()
	ON_BN_CLICKED(IDC_BUTTONBMP, OnButtonbmp)
	ON_BN_CLICKED(IDC_BUTTONFILE, OnButtonfile)
	ON_CBN_SELENDOK(IDC_COMBOIFRAME, OnSelendokComboiframe)
	ON_WM_SIZE()
	ON_WM_MOVE()
	ON_MESSAGE(WM_USER,OnUser)
	ON_BN_CLICKED(IDC_CHECKPROGRAM, OnCheckprogram)
	//}}AFX_MSG_MAP
	ON_WM_HSCROLL ()
    ON_WM_DROPFILES()
	
END_MESSAGE_MAP()

BOOL CPreviewDlg::OnInitDialog()
{
	CString csPar,csPath,csError,csAux;
	int i,n;
	CRect myRect;
	int iOFFX;
	int iOFFY;
	CWnd *pWnd;
	int iPos;


	CDialog::OnInitDialog();

	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon

// TOO MUCH DIRTY DIRTY....., but solves the disappearing buttons problem..
	pWnd=GetParent();
	pWnd->GetWindowRect(myRect);
	pWnd->MoveWindow(myRect.left,myRect.top,myRect.Width()-1,myRect.Height());
	pWnd->MoveWindow(myRect.left,myRect.top,myRect.Width(),myRect.Height());


	if (m_iModePrev==MOTION2STILL && m_iDomain==MENUS)
		csAux.Format(_T("MOTION2STILL in MENUS: VTS=%02d PGC=%02d nCell= %02d"), m_nVTS, m_nT+1, m_nCell+1 );
	if (m_iModePrev==MOTION2STILL && m_iDomain==TITLES)
		csAux.Format(_T("MOTION2STILL in TITLES: VTS=%02d PGC=%02d nCell= %02d"), m_nVTS, m_nT+1, m_nCell+1 );
	if (m_iModePrev==CELLSPLIT)
		csAux.Format(_T("CELL SPLIT MODE: VTS=%02d PGC=%02d nCell= %02d"), m_nVTS, m_nT+1, m_nCell+1 );
	if (m_iModePrev==CELLPREV)
		csAux.Format(_T("CELL PREVIEW/CUT MODE: VTS=%02d PGC=%02d nCell= %02d"), m_nVTS, m_nT+1, m_nCell+1 );
	if (m_iModePrev==PGCPREV)
		csAux.Format(_T("PGC PREVIEW/CUT MODE: VTS=%02d PGC=%02d"), m_nVTS, m_nT+1 );

	SetWindowText(csAux);


	m_ComboCell.ResetContent();
	m_ComboIFrame.ResetContent();

	m_ComboIFrame.AddString("Custom");

	m_CSlider.SetRange(0, 1000 );

	if (m_iModePrev==MOTION2STILL)
	{
		m_ComboIFrame.AddString("First");
		m_ComboIFrame.AddString("Middle");
		m_ComboIFrame.AddString("Last");
		m_ComboIFrame.AddString("Auto");
		m_ComboIFrame.AddString("Default");
		m_ComboIFrame.AddString("File");
	}
	if (m_i64IFrame <0)
	{
		m_iIFrameSel=(int)(m_i64IFrame)*(-1);
		m_i64IFrame=0;
	}
	else m_iIFrameSel=0;
	if (m_iIFrameSel > 6) m_iIFrameSel =5;
	m_ComboIFrame.SetCurSel(m_iIFrameSel);


	if (m_iDomain==TITLES)
	{
		for (i=0; i<theApp.m_nCells[m_nVTS][m_nT] ; i++)
		{
			csAux.Format(_T("%d"),i+1);
			m_ComboCell.AddString(csAux);
		}
	}
	else
	{
		for (i=0; i<theApp.m_nMCells[m_nVTS][m_nT] ; i++)
		{
			csAux.Format(_T("%d"),i+1);
			m_ComboCell.AddString(csAux);
		}
	}

	m_ComboCell.SetCurSel(m_nCell);

	m_nCellSectors= (int) theApp.PR_CellSectors(m_iDomain, m_nVTS,m_nT,m_nCell);
	iSector=0;
	m_csSector="0";

	m_bIsPlaying=false;

	if (m_iDomain==TITLES  && m_iModePrev==PGCPREV)
	{
		iIniCell=	theApp.m_CutInfo[m_nVTS][m_nT].iIniCell;
		iIniSector= theApp.m_CutInfo[m_nVTS][m_nT].iIniLba;
		iIniIsClosed= theApp.m_CutInfo[m_nVTS][m_nT].iIniIsClosed;
		iEndCell=	theApp.m_CutInfo[m_nVTS][m_nT].iEndCell;
		iEndSector=	theApp.m_CutInfo[m_nVTS][m_nT].iEndLba;
		iEndIsClosed= theApp.m_CutInfo[m_nVTS][m_nT].iEndIsClosed;
		m_iRadio=	theApp.m_CutInfo[m_nVTS][m_nT].iAction;
	}
	if (m_iModePrev==CELLPREV)
	{
		m_nACell=-1;
		n=theApp.m_ACellCutinfo.GetSize()-1;
		for(n=theApp.m_ACellCutinfo.GetSize()-1; n>=0;n--)
		{
			if (theApp.m_ACellCutinfo[n].nT== m_nT &&
				theApp.m_ACellCutinfo[n].nCell== m_nCell &&
				theApp.m_ACellCutinfo[n].iDomain== m_iDomain &&
				theApp.m_ACellCutinfo[n].nVTS==m_nVTS)
					m_nACell=n;
		}
		iIniCell=	m_nCell;
		iEndCell=	m_nCell;
		iEndSector=	  -1;
		iEndIsClosed= 0;
		iIniSector=   -1;
		iIniIsClosed= 0;
		m_iRadio=	  0;
		if (m_nACell>=0)
		{
			iIniSector=		theApp.m_ACellCutinfo[m_nACell].iIniSector;
			iEndSector=		theApp.m_ACellCutinfo[m_nACell].iEndSector;
			iEndIsClosed=	theApp.m_ACellCutinfo[m_nACell].iEndIsClosed;
			iIniIsClosed=	theApp.m_ACellCutinfo[m_nACell].iIniIsClosed;
			m_iRadio=		theApp.m_ACellCutinfo[m_nACell].iAction;
		}
	}

	if (m_iModePrev==MOTION2STILL || m_iModePrev==CELLSPLIT)
	{
		iIniSector=(int)m_i64IFrame;
		iSector=iIniSector;
		m_csSector.Format(_T("%d"),iSector);
	}

	// TOOLTIPS
	c_bShowToolTips = TRUE;
	m_wndToolTip.Create(this);
	m_wndToolTip.Activate(c_bShowToolTips);

	m_wndToolTip.AddTool(GetDlgItem(IDOK), "Exit" );
	m_wndToolTip.AddTool(GetDlgItem(IDC_SLIDER1), "Move cursor inside the Cell" );
	m_wndToolTip.AddTool(GetDlgItem(IDC_COMBOCELL), "Change Cell" );
	m_wndToolTip.AddTool(GetDlgItem(IDC_NEXT), "Move cursor to next VOBU" );
	m_wndToolTip.AddTool(GetDlgItem(IDC_PREV), "Move cursor to previous VOBU" );

	if (m_iModePrev==MOTION2STILL || m_iModePrev==CELLSPLIT)
	{
		m_wndToolTip.AddTool(GetDlgItem(IDC_INISECTOR), "Mark to select the I-Frame" );
		m_wndToolTip.AddTool(GetDlgItem(IDC_INIMARK), "Mark to select the I-Frame" );
	}
	else
	{
		m_wndToolTip.AddTool(GetDlgItem(IDC_INISECTOR), "Mark for cut PGC: Initial point" );
		m_wndToolTip.AddTool(GetDlgItem(IDC_INIMARK), "Mark for cut PGC: Initial point" );
	}
	m_wndToolTip.AddTool(GetDlgItem(IDC_INICLEAR), "Clear mark" );
	m_wndToolTip.AddTool(GetDlgItem(IDC_ENDMARK), "Mark for cut PGC: End point" );
	m_wndToolTip.AddTool(GetDlgItem(IDC_ENDCLEAR), "Clear mark" );
	m_wndToolTip.AddTool(GetDlgItem(IDC_PLAY), "Play the selected Cell." );
	m_wndToolTip.AddTool(GetDlgItem(IDC_STOP), "Stop playing." );
	m_wndToolTip.AddTool(GetDlgItem(IDC_INICELL), "Mark for cut PGC: Initial point" );
	m_wndToolTip.AddTool(GetDlgItem(IDC_ENDCELL), "Mark for cut PGC: End point" );


	m_wndToolTip.AddTool(GetDlgItem(IDC_ENDSECTOR), "Mark for cut PGC: End point" );
	m_wndToolTip.AddTool(GetDlgItem(IDC_BUTTONINFO), "Toggle DVD2AVI info window" );
	m_wndToolTip.AddTool(GetDlgItem(IDC_RADIO1), "Keep movie between marks. Discard before initial mark and after end mark" );
	m_wndToolTip.AddTool(GetDlgItem(IDC_RADIO2), "Discard movie between marks. Keep before initial mark and after end mark" );
	m_wndToolTip.AddTool(GetDlgItem(IDC_CHECKDAR), "Keep Display Aspect Ratio when resizing. If not checked, fill the window completely" );
	m_wndToolTip.AddTool(GetDlgItem(IDC_CHECKFPS), "Insert delays between frames to get the actual frame rate." );
	m_wndToolTip.AddTool(GetDlgItem(IDC_COMBOIFRAME), "I Frame selection mode. Auto means the largest. Default means the global default mode." );

	m_wndToolTip.AddTool(GetDlgItem(IDC_EDITFILE), "File to get an external the I frame." );
	m_wndToolTip.AddTool(GetDlgItem(IDC_BUTTONFILE), "Search a VOB file to get an external the I frame." );

	UpdateCsEdit();

	UpdateData(FALSE);

	GetClientRect(&m_RectDlg);
	GetWindowRect(&myRect);
	iOFFX=(myRect.Width()-m_RectDlg.Width())/2;    // OFFX=Border
	iOFFY=myRect.Height()-m_RectDlg.Height()-iOFFX; // OFFY=Top border+Caption+Menu. 

	pWnd=GetDlgItem(IDC_STATICPREV);
	pWnd->GetWindowRect(&m_RectPrev);

	m_RectPrev.OffsetRect(-myRect.left-iOFFX,-myRect.top-iOFFY);

	m_PreviewHWnd = m_VideoPreview.InitPreview(m_hWnd,.5,.5,m_RectPrev.left,m_RectPrev.top,
		SW_SHOW,0,WS_CHILD|WS_DLGFRAME, theApp.m_bCheckNoOverlay);

// Load the VOB file or the still


	if (m_iIFrameSel!= 6 )
		LoadMyVOB();
	else
		LoadVOBFile( m_csFileStill);

	long handle;

	if (m_iModePrev==MOTION2STILL)
		DragAcceptFiles(TRUE);

	if ((m_iModePrev==MOTION2STILL && m_iIFrameSel!= 6 ) ||
		 m_iModePrev==CELLSPLIT)
	{
		iIniSector=(int)m_i64IFrame;
		iSector=iIniSector;
		m_csSector.Format(_T("%d"),iSector);
		iPos=(int) ((((__int64)iSector) *(__int64)1000)/m_nCellSectors);
		m_CSlider.SetPos(iPos);
		UpdateData(FALSE);
		SendPosition( ID_USERPOSITION, true );
// Dirty trick... why do I need this delay?. Without it, in some PCs does not work...
		_sleep (100);
	}
	else
	{
		handle= (long)::GetDlgItem(m_hWnd, IDC_PLAY);
		if (theApp.m_bCheckAutoPlay)
			PostMessage(WM_COMMAND, (BN_CLICKED<<16)+IDC_PLAY,handle);
	}

	ReSize(m_RectDlg.Width(),m_RectDlg.Height());

	return TRUE;  // return TRUE  unless you set the focus to a control

}
/////////////////////////////////////////////////////////////////////////////
// CPreviewDlg message handlers


void CPreviewDlg::OnHScroll( UINT nSBCode, UINT nPos, CScrollBar* pScrollBar )
{
	int i, iVID,iCID;
	__int64	i64DestSector;
	int iSector_old;
	CWnd *pWnd;

//	if (nSBCode!=TB_THUMBTRACK) return;

	pWnd=GetDlgItem(IDC_SLIDER1);

	if (pScrollBar!=pWnd) return;

	UpdateData(TRUE);

	iSector_old=iSector;
	i= m_CSlider.GetPos();
	iSector=(int)(  ((__int64)(m_nCellSectors-1)) * ((__int64)i)/(__int64)1000);

	if (m_iDomain==TITLES)
	{
		iVID=theApp.CellVID(m_nVTS,m_nT,m_nCell);
		iCID=theApp.CellCID(m_nVTS,m_nT,m_nCell);
	}
	else
	{
		iVID=theApp.CellMVID(m_nVTS,m_nT,m_nCell);
		iCID=theApp.CellMCID(m_nVTS,m_nT,m_nCell);
	}

	i64DestSector= theApp.PR_CellIniSector(m_iDomain,m_nVTS,m_nT,m_nCell) + iSector;
	i64DestSector=theApp.PR_LocateNavSector(m_iDomain,m_nVTS, iVID, iCID, i64DestSector, true);
	if (i64DestSector >= 0 ) 
		i64DestSector-=theApp.PR_CellIniSector(m_iDomain,m_nVTS,m_nT,m_nCell);
	else
		i64DestSector=iSector_old;
	iSector= (int) i64DestSector;
	m_csSector.Format(_T("%d"),iSector);

	UpdateData(FALSE);

	SendPosition( ID_USERPOSITION, true );
}

void CPreviewDlg::OnOK() 
{
	// TODO: Add extra cleanup here
	int iSel;
	CELLCUTINFO myCellCutInfo;


	UpdateData(TRUE);

	if (m_iDomain==TITLES && m_iModePrev==PGCPREV)
	{
		theApp.m_CutInfo[m_nVTS][m_nT].iIniCell=iIniCell;
		theApp.m_CutInfo[m_nVTS][m_nT].iIniLba=iIniSector;
		theApp.m_CutInfo[m_nVTS][m_nT].iIniIsClosed=iIniIsClosed;
		theApp.m_CutInfo[m_nVTS][m_nT].iEndCell=iEndCell;
		theApp.m_CutInfo[m_nVTS][m_nT].iEndLba=iEndSector;
		theApp.m_CutInfo[m_nVTS][m_nT].iEndIsClosed=iEndIsClosed;
		theApp.m_CutInfo[m_nVTS][m_nT].iAction=m_iRadio;
	}
	if (m_iModePrev==CELLPREV)
	{
		if (m_nACell>=0)
		{
			theApp.m_ACellCutinfo[m_nACell].iIniSector	=iIniSector;
			theApp.m_ACellCutinfo[m_nACell].iEndSector	=iEndSector;
			theApp.m_ACellCutinfo[m_nACell].iEndIsClosed=iEndIsClosed;
			theApp.m_ACellCutinfo[m_nACell].iIniIsClosed=iIniIsClosed;
			theApp.m_ACellCutinfo[m_nACell].iAction		=m_iRadio;
		}
		else
		{
			myCellCutInfo.iDomain	=m_iDomain;
			myCellCutInfo.nVTS		=m_nVTS;
			myCellCutInfo.nT		=m_nT;
			myCellCutInfo.nCell		=m_nCell;

			myCellCutInfo.iIniSector	=iIniSector;
			myCellCutInfo.iEndSector	=iEndSector;
			myCellCutInfo.iEndIsClosed	=iEndIsClosed;
			myCellCutInfo.iIniIsClosed	=iIniIsClosed;
			myCellCutInfo.iAction		=m_iRadio;
			theApp.m_ACellCutinfo.Add(myCellCutInfo);
		}
	}
	if (m_iModePrev==MOTION2STILL)
	{
		iSel=m_ComboIFrame.GetCurSel();

		if (iSel ==6 )
		{
			if( (_access( m_csFileStill , 04 )) != 0 )
			{
				MyErrorBox ("File mode selected, but file is not accessible");
				return;
			}

		}
		if ( iIniSector==-1) iIniSector=0;
		if (iSel ==0 || iSel==6)
			m_i64IFrame=iIniSector;
		if (iSel >0)
			m_i64IFrame=(-1)*iSel;
	}

	if (m_iModePrev==CELLSPLIT)
	{
		if ( iIniSector==-1) iIniSector=0;
		m_i64IFrame=iIniSector;
//		theApp.m_CutInfo[m_nVTS][m_nT].iIniIsClosed=iIniIsClosed;
	}

	if (m_bIsPlaying)  OnStop();

	m_VideoPreview.CloseFile();
	m_VideoPreview.WaitForThread();
	m_VideoPreview.QuickRelease();
	m_VideoPreview.WaitForThread();
	m_VideoPreview.DestroyPreview(m_PreviewHWnd);

	CDialog::OnOK();
}


void CPreviewDlg::OnCancel() 
{
	if (m_bIsPlaying)  OnStop();

	m_VideoPreview.CloseFile();
	m_VideoPreview.WaitForThread();
	m_VideoPreview.QuickRelease();
	m_VideoPreview.WaitForThread();
	m_VideoPreview.DestroyPreview(m_PreviewHWnd);

	CDialog::OnCancel();
}

void CPreviewDlg::OnStop() 
{
	// TODO: Add your control notification handler code here
	long iDestSector;
	int iVID,iCID;
	
	m_VideoPreview.Stop();
	m_VideoPreview.WaitForThread();

	m_VideoPreview.SetStopSector(-1);
	m_VideoPreview.WaitForThread();

	iDestSector=m_VideoPreview.GetCurrentSector();
	if (iDestSector <0) iDestSector=0;

	if (m_iDomain==TITLES)
	{
		iVID=theApp.CellVID(m_nVTS,m_nT,m_nCell);
		iCID=theApp.CellCID(m_nVTS,m_nT,m_nCell);
	}
	else
	{
		iVID=theApp.CellMVID(m_nVTS,m_nT,m_nCell);
		iCID=theApp.CellMCID(m_nVTS,m_nT,m_nCell);
	}

	iDestSector= (int)theApp.PR_LocateNavSector(m_iDomain,m_nVTS, iVID, iCID, iDestSector, true);

	if (iDestSector >= 0 ) 
		iDestSector-= (int)theApp.PR_CellIniSector(m_iDomain,m_nVTS,m_nT,m_nCell);
	else
		iDestSector=0;

	iSector= (int) iDestSector;
	m_CSlider.SetPos((int) ((((__int64)iSector) *(__int64)1000)/m_nCellSectors));
	m_csSector.Format(_T("%d"),iSector);
	UpdateData(FALSE);

	SendPosition( ID_USERPOSITION, true );

	m_bIsPlaying=false;
	EnableButtons();

}

void CPreviewDlg::OnPlay() 
{
	// TODO: Add your control notification handler code here
	int iVobId, iCellId;
	DWORD dwDuration;
	__int64 i64Size;
	int nButtons;
	bool bReused;
	uchar CellCat0;
	int iDestSector;

	if (m_bIsPlaying) return;

	theApp.GetCellInfo(m_iDomain, m_nVTS,m_nT,m_nCell, 
		&iVobId, &iCellId, &dwDuration, &i64Size, &bReused, &CellCat0 , &nButtons);

	if (CellCat0 & 0x04)
	{
		MyInfoBox("This cell is a interleaved one.\nPlayback will not be correct.");
	}
	m_bIsPlaying=true;
	EnableButtons();

	iDestSector=(int) (theApp.PR_CellIniSector(m_iDomain,m_nVTS,m_nT,m_nCell)+
		               theApp.PR_CellSectors(m_iDomain,m_nVTS,m_nT,m_nCell))-1;

	m_VideoPreview.SetStopSector(iDestSector);
	m_VideoPreview.WaitForThread();

	m_VideoPreview.Play();

}

void CPreviewDlg::OnPrev() 
{
	// TODO: Add your control notification handler code here
	__int64 i64DestSector;
	int iVID,iCID;
	bool bDecrCell;

	// TODO: Add your control notification handler code here
	UpdateData(TRUE);

	i64DestSector= theApp.PR_CellIniSector(m_iDomain,m_nVTS,m_nT,m_nCell) + iSector;
	if (m_iDomain==TITLES)
	{
		iVID=theApp.CellVID(m_nVTS,m_nT,m_nCell);
		iCID=theApp.CellCID(m_nVTS,m_nT,m_nCell);
	}
	else
	{
		iVID=theApp.CellMVID(m_nVTS,m_nT,m_nCell);
		iCID=theApp.CellMCID(m_nVTS,m_nT,m_nCell);
	}

	bDecrCell=false;
	if (iSector > 0)
	{
		i64DestSector=theApp.PR_LocateNavSector(m_iDomain, m_nVTS, iVID, iCID, i64DestSector-1, false);
		if (i64DestSector >= 0 )
		{
			i64DestSector-=theApp.PR_CellIniSector(m_iDomain,m_nVTS,m_nT,m_nCell);
			iSector= (int) i64DestSector;
		}
		else bDecrCell=true;
	}
	else bDecrCell=true;

	if (bDecrCell && m_iModePrev==PGCPREV)
	{
		if (m_nCell >0)
		{
			m_nCell--;
			m_ComboCell.SetCurSel(m_nCell);
			if (m_iDomain==TITLES)
			{
				iVID=theApp.CellVID(m_nVTS,m_nT,m_nCell);
				iCID=theApp.CellCID(m_nVTS,m_nT,m_nCell);
			}
			else
			{
				iVID=theApp.CellMVID(m_nVTS,m_nT,m_nCell);
				iCID=theApp.CellMCID(m_nVTS,m_nT,m_nCell);
			}
			m_nCellSectors= (int) theApp.PR_CellSectors(m_iDomain,m_nVTS,m_nT,m_nCell);
			iSector=m_nCellSectors;

			i64DestSector= theApp.PR_CellIniSector(m_iDomain,m_nVTS,m_nT,m_nCell) + iSector;
			i64DestSector= theApp.PR_LocateNavSector(m_iDomain, m_nVTS,iVID, iCID, i64DestSector-1, false);
			if (i64DestSector >= 0 )
				i64DestSector-=theApp.PR_CellIniSector(m_iDomain,m_nVTS,m_nT,m_nCell);
			iSector= (int) i64DestSector;

		}
		
	}

	m_csSector.Format(_T("%d"),iSector);
	m_CSlider.SetPos((int) ((((__int64)iSector) *(__int64)1000)/m_nCellSectors));

	UpdateData(FALSE);

	SendPosition( ID_USERPOSITION, true );

}

void CPreviewDlg::OnNext() 
{

	__int64 i64DestSector;
	int iCID,iVID,nCells;

	// TODO: Add your control notification handler code here
	UpdateData(TRUE);

	i64DestSector= theApp.PR_CellIniSector(m_iDomain,m_nVTS,m_nT,m_nCell) + iSector;
	if (m_iDomain==TITLES)
	{
		iVID=theApp.CellVID(m_nVTS,m_nT,m_nCell);
		iCID=theApp.CellCID(m_nVTS,m_nT,m_nCell);
		nCells=theApp.m_nCells[m_nVTS][m_nT] ;
	}
	else
	{
		iVID=theApp.CellMVID(m_nVTS,m_nT,m_nCell);
		iCID=theApp.CellMCID(m_nVTS,m_nT,m_nCell);
		nCells=theApp.m_nMCells[m_nVTS][m_nT] ;
	}

	if (iSector < m_nCellSectors-1)
	{
		i64DestSector=theApp.PR_LocateNavSector(m_iDomain, m_nVTS,iVID, iCID,i64DestSector+1, true);
		if (i64DestSector >= 0)
		{
			i64DestSector-=theApp.PR_CellIniSector(m_iDomain,m_nVTS,m_nT,m_nCell);
			iSector= (int) i64DestSector;
		}
		else 
		{
			if (m_nCell < nCells-1  && m_iModePrev==PGCPREV)
			{
				iSector=0;
				m_nCell++;
				m_ComboCell.SetCurSel(m_nCell);
				m_nCellSectors= (int) theApp.PR_CellSectors(m_iDomain,m_nVTS,m_nT,m_nCell);
			}
		}
	}
	else
	{
		if (m_nCell < nCells -1 && m_iModePrev==PGCPREV)
		{
			iSector=0;
			m_nCell++;
			m_ComboCell.SetCurSel(m_nCell);
			m_nCellSectors= (int) theApp.PR_CellSectors(m_iDomain,m_nVTS,m_nT,m_nCell);
		}
	}

	m_csSector.Format(_T("%d"),iSector);
	m_CSlider.SetPos((int) ((((__int64)iSector) *(__int64)1000)/m_nCellSectors));

	UpdateData(FALSE);

	SendPosition(ID_USERPOSITION, true );

}

void CPreviewDlg::ShowButtons() 
{

	CWnd *pWnd;

	if (m_iModePrev==MOTION2STILL || m_iModePrev==CELLSPLIT)
	{
		pWnd = GetDlgItem(IDC_STATIC1);
		pWnd->ShowWindow(SW_HIDE);
		pWnd = GetDlgItem(IDC_STATIC2);
		pWnd->ShowWindow(SW_HIDE);
		pWnd = GetDlgItem(IDC_STATIC3);
		pWnd->ShowWindow(SW_SHOW);
		pWnd = GetDlgItem(IDC_STATIC4);
		pWnd->ShowWindow(SW_HIDE);
		if (m_iModePrev==MOTION2STILL)
		{
			pWnd = GetDlgItem(IDC_STATIC50);
			pWnd->ShowWindow(SW_HIDE);
			pWnd = GetDlgItem(IDC_STATIC51);
			pWnd->ShowWindow(SW_SHOW);
			pWnd->SetWindowText("I Frame Selection");
		}
		else
		{
			pWnd = GetDlgItem(IDC_STATIC51);
			pWnd->ShowWindow(SW_HIDE);
			pWnd = GetDlgItem(IDC_STATIC50);
			pWnd->ShowWindow(SW_SHOW);
			pWnd->SetWindowText("Split point selection");
		}
		pWnd->ShowWindow(SW_SHOW);
		pWnd = GetDlgItem(IDC_STATIC6);
		pWnd->ShowWindow(SW_HIDE);
		pWnd = GetDlgItem(IDC_STATIC7);
		pWnd->ShowWindow(SW_HIDE);
		pWnd = GetDlgItem(IDC_RADIO1);
		pWnd->ShowWindow(SW_HIDE);
		pWnd = GetDlgItem(IDC_RADIO2);
		pWnd->ShowWindow(SW_HIDE);
		pWnd = GetDlgItem(IDC_ENDCELL);
		pWnd->ShowWindow(SW_HIDE);
		pWnd = GetDlgItem(IDC_ENDSECTOR);
		pWnd->ShowWindow(SW_HIDE);
		pWnd = GetDlgItem(IDC_INICELL);
		pWnd->ShowWindow(SW_HIDE);
		pWnd = GetDlgItem(IDC_INISECTOR);
		pWnd->ShowWindow(SW_SHOW);
		pWnd = GetDlgItem(IDC_COMBOIFRAME);
		pWnd->ShowWindow(SW_SHOW);
		if (m_iDomain==TITLES)
			pWnd->EnableWindow(FALSE);
		else
			pWnd->EnableWindow(TRUE);
		pWnd = GetDlgItem(IDC_ENDMARK);
		pWnd->ShowWindow(SW_HIDE);
		pWnd = GetDlgItem(IDC_ENDCLEAR);
		pWnd->ShowWindow(SW_HIDE);
		if (m_iModePrev==MOTION2STILL)
		{
			pWnd = GetDlgItem(IDC_BUTTONFILE);
			pWnd->ShowWindow(SW_SHOW);
			pWnd = GetDlgItem(IDC_EDITFILE);
			pWnd->ShowWindow(SW_SHOW);
			pWnd = GetDlgItem(IDC_CHECKAUDIO);
			pWnd->ShowWindow(SW_SHOW);
			pWnd = GetDlgItem(IDC_CHECKPROGRAM);
			pWnd->ShowWindow(SW_HIDE);
			pWnd = GetDlgItem(IDC_CHECKCHAPTER);
			pWnd->ShowWindow(SW_HIDE);
			pWnd = GetDlgItem(IDC_CHAPTERWARNING);
			pWnd->ShowWindow(SW_HIDE);
		}
		else
		{
			pWnd = GetDlgItem(IDC_BUTTONFILE);
			pWnd->ShowWindow(SW_HIDE);
			pWnd = GetDlgItem(IDC_EDITFILE);
			pWnd->ShowWindow(SW_HIDE);
			pWnd = GetDlgItem(IDC_CHECKAUDIO);
			pWnd->ShowWindow(SW_HIDE);
			pWnd = GetDlgItem(IDC_CHECKPROGRAM);
			pWnd->ShowWindow(SW_SHOW);
			pWnd = GetDlgItem(IDC_CHECKCHAPTER);
			pWnd->ShowWindow(SW_SHOW);
			pWnd = GetDlgItem(IDC_CHAPTERWARNING);
			pWnd->ShowWindow(SW_SHOW);
		}
	}
	else
	{
		pWnd = GetDlgItem(IDC_STATIC1);
		pWnd->ShowWindow(SW_SHOW);
		pWnd = GetDlgItem(IDC_STATIC2);
		pWnd->ShowWindow(SW_SHOW);
		pWnd = GetDlgItem(IDC_STATIC3);
		pWnd->ShowWindow(SW_SHOW);
		pWnd = GetDlgItem(IDC_STATIC4);
		pWnd->ShowWindow(SW_SHOW);
		pWnd = GetDlgItem(IDC_STATIC50);
		pWnd->SetWindowText("Intial Mark");
		pWnd->ShowWindow(SW_SHOW);
		pWnd = GetDlgItem(IDC_STATIC51);
		pWnd->ShowWindow(SW_HIDE);
		pWnd = GetDlgItem(IDC_STATIC6);
		pWnd->ShowWindow(SW_SHOW);
		pWnd = GetDlgItem(IDC_STATIC7);
		pWnd->ShowWindow(SW_SHOW);
		pWnd = GetDlgItem(IDC_RADIO1);
		pWnd->ShowWindow(SW_SHOW);
		pWnd = GetDlgItem(IDC_RADIO2);
		pWnd->ShowWindow(SW_SHOW);
		pWnd = GetDlgItem(IDC_ENDCELL);
		pWnd->ShowWindow(SW_SHOW);
		pWnd = GetDlgItem(IDC_ENDSECTOR);
		pWnd->ShowWindow(SW_SHOW);
		pWnd = GetDlgItem(IDC_INICELL);
		pWnd->ShowWindow(SW_SHOW);
		pWnd = GetDlgItem(IDC_INISECTOR);
		pWnd->ShowWindow(SW_SHOW);
		pWnd = GetDlgItem(IDC_COMBOIFRAME);
		pWnd->ShowWindow(SW_HIDE);
		pWnd = GetDlgItem(IDC_CHECKAUDIO);
		pWnd->ShowWindow(SW_HIDE);
		pWnd = GetDlgItem(IDC_ENDMARK);
		pWnd->ShowWindow(SW_SHOW);
		pWnd = GetDlgItem(IDC_ENDCLEAR);
		pWnd->ShowWindow(SW_SHOW);
		pWnd = GetDlgItem(IDC_BUTTONFILE);
		pWnd->ShowWindow(SW_HIDE);
		pWnd = GetDlgItem(IDC_EDITFILE);
		pWnd->ShowWindow(SW_HIDE);
		pWnd = GetDlgItem(IDC_CHECKPROGRAM);
		pWnd->ShowWindow(SW_HIDE);
		pWnd = GetDlgItem(IDC_CHECKCHAPTER);
		pWnd->ShowWindow(SW_HIDE);
		pWnd = GetDlgItem(IDC_CHAPTERWARNING);
		pWnd->ShowWindow(SW_HIDE);
	}
}

void CPreviewDlg::EnableButtons() 
{

	CWnd *pWnd;
	int iSel;


	iSel=m_ComboIFrame.GetCurSel();


	if (m_bIsPlaying)
	{
		pWnd = GetDlgItem(IDC_SLIDER1);
		pWnd->EnableWindow(FALSE);
		pWnd = GetDlgItem(IDC_COMBOCELL);
		pWnd->EnableWindow(FALSE);
		pWnd = GetDlgItem(IDC_NEXT);
		pWnd->EnableWindow(FALSE);
		pWnd = GetDlgItem(IDC_PREV);
		pWnd->EnableWindow(FALSE);
		pWnd = GetDlgItem(IDC_INIMARK);
		pWnd->EnableWindow(FALSE);
		pWnd = GetDlgItem(IDC_ENDMARK);
		pWnd->EnableWindow(FALSE);
		pWnd = GetDlgItem(IDC_INICLEAR);
		pWnd->EnableWindow(FALSE);
		pWnd = GetDlgItem(IDC_ENDCLEAR);
		pWnd->EnableWindow(FALSE);
		pWnd = GetDlgItem(IDC_PLAY);
		pWnd->EnableWindow(FALSE);
		pWnd = GetDlgItem(IDC_BUTTONFILE);
		pWnd->EnableWindow(FALSE);
	}
	else
	{
		pWnd = GetDlgItem(IDC_INIMARK);
		pWnd->EnableWindow(TRUE);
		pWnd = GetDlgItem(IDC_ENDMARK);
		pWnd->EnableWindow(TRUE);
		pWnd = GetDlgItem(IDC_INICLEAR);
		pWnd->EnableWindow(TRUE);
		pWnd = GetDlgItem(IDC_ENDCLEAR);
		pWnd->EnableWindow(TRUE);
		if (m_iModePrev!=MOTION2STILL || iSel!=6)
		{
			pWnd = GetDlgItem(IDC_SLIDER1);
			pWnd->EnableWindow(TRUE);
			pWnd = GetDlgItem(IDC_COMBOCELL);
			if (m_iModePrev!=PGCPREV)
				pWnd->EnableWindow(FALSE);
			else
				pWnd->EnableWindow(TRUE);
			pWnd = GetDlgItem(IDC_NEXT);
			pWnd->EnableWindow(TRUE);
			pWnd = GetDlgItem(IDC_PREV);
			pWnd->EnableWindow(TRUE);
			pWnd = GetDlgItem(IDC_PLAY);
			pWnd->EnableWindow(TRUE);
		}
		else
		{
			pWnd = GetDlgItem(IDC_SLIDER1);
			pWnd->EnableWindow(FALSE);
			pWnd = GetDlgItem(IDC_COMBOCELL);
			pWnd->EnableWindow(FALSE);
			pWnd = GetDlgItem(IDC_NEXT);
			pWnd->EnableWindow(FALSE);
			pWnd = GetDlgItem(IDC_PREV);
			pWnd->EnableWindow(FALSE);
			pWnd = GetDlgItem(IDC_PLAY);
			pWnd->EnableWindow(FALSE);
			pWnd = GetDlgItem(IDC_STOP);
			pWnd->EnableWindow(FALSE);

		}

		if (m_iDomain==TITLES && m_iModePrev==PGCPREV)
		{
			pWnd = GetDlgItem(IDC_INIMARK);

			pWnd->EnableWindow(m_BEnableCut);
			pWnd = GetDlgItem(IDC_ENDMARK);
			pWnd->EnableWindow(m_BEnableCut);
			pWnd = GetDlgItem(IDC_INICLEAR);
			pWnd->EnableWindow(m_BEnableCut);
			pWnd = GetDlgItem(IDC_ENDCLEAR);
			pWnd->EnableWindow(m_BEnableCut);
		}
		if ((m_iDomain==MENUS && m_iModePrev==PGCPREV))
		{
			pWnd = GetDlgItem(IDC_INIMARK);
			pWnd->EnableWindow(FALSE);
			pWnd = GetDlgItem(IDC_ENDMARK);
			pWnd->EnableWindow(FALSE);
			pWnd = GetDlgItem(IDC_INICLEAR);
			pWnd->EnableWindow(FALSE);
			pWnd = GetDlgItem(IDC_ENDCLEAR);
			pWnd->EnableWindow(FALSE);
		}
		if (m_iModePrev==CELLPREV)
		{
			pWnd = GetDlgItem(IDC_INIMARK);
			pWnd->EnableWindow(m_BEnableCut);
			pWnd = GetDlgItem(IDC_ENDMARK);
			pWnd->EnableWindow(m_BEnableCut);
			pWnd = GetDlgItem(IDC_INICLEAR);
			pWnd->EnableWindow(m_BEnableCut);
			pWnd = GetDlgItem(IDC_ENDCLEAR);
			pWnd->EnableWindow(m_BEnableCut);
		}
		if (m_iModePrev==MOTION2STILL)
		{
			if (iSel==0)
			{
				pWnd = GetDlgItem(IDC_INIMARK);
				pWnd->EnableWindow(TRUE);
				pWnd = GetDlgItem(IDC_INICLEAR);
				pWnd->EnableWindow(TRUE);
		
			}
			else
			{
				pWnd = GetDlgItem(IDC_INIMARK);
				pWnd->EnableWindow(FALSE);
				pWnd = GetDlgItem(IDC_INICLEAR);
				pWnd->EnableWindow(FALSE);
			}
			pWnd = GetDlgItem(IDC_ENDMARK);
			pWnd->EnableWindow(FALSE);
			pWnd = GetDlgItem(IDC_ENDCLEAR);
			pWnd->EnableWindow(FALSE);
		}

	}
	if (m_iDomain==TITLES && m_iModePrev==PGCPREV)
	{
		pWnd = GetDlgItem(IDC_STATIC1);
		pWnd->EnableWindow(TRUE);
		pWnd = GetDlgItem(IDC_STATIC2);
		pWnd->EnableWindow(TRUE);
		pWnd = GetDlgItem(IDC_STATIC3);
		pWnd->EnableWindow(TRUE);
		pWnd = GetDlgItem(IDC_STATIC4);
		pWnd->EnableWindow(TRUE);
		pWnd = GetDlgItem(IDC_STATIC50);
		pWnd->EnableWindow(TRUE);
		pWnd = GetDlgItem(IDC_STATIC6);
		pWnd->EnableWindow(TRUE);
		pWnd = GetDlgItem(IDC_STATIC7);
		pWnd->EnableWindow(TRUE);
		pWnd = GetDlgItem(IDC_RADIO1);
		pWnd->EnableWindow(TRUE);
		pWnd = GetDlgItem(IDC_RADIO2);
		pWnd->EnableWindow(TRUE);
	}
	if (m_iModePrev==CELLPREV)
	{
		pWnd = GetDlgItem(IDC_STATIC1);
		pWnd->EnableWindow(TRUE);
		pWnd = GetDlgItem(IDC_STATIC2);
		pWnd->EnableWindow(TRUE);
		pWnd = GetDlgItem(IDC_STATIC3);
		pWnd->EnableWindow(TRUE);
		pWnd = GetDlgItem(IDC_STATIC4);
		pWnd->EnableWindow(TRUE);
		pWnd = GetDlgItem(IDC_STATIC50);
		pWnd->EnableWindow(TRUE);
		pWnd = GetDlgItem(IDC_STATIC6);
		pWnd->EnableWindow(TRUE);
		pWnd = GetDlgItem(IDC_STATIC7);
		pWnd->EnableWindow(TRUE);
		pWnd = GetDlgItem(IDC_RADIO1);
		pWnd->EnableWindow(TRUE);
		pWnd = GetDlgItem(IDC_RADIO2);
		pWnd->EnableWindow(TRUE);
	}
	if ((m_iDomain==MENUS && m_iModePrev==PGCPREV))
	{
		pWnd = GetDlgItem(IDC_STATIC1);
		pWnd->EnableWindow(FALSE);
		pWnd = GetDlgItem(IDC_STATIC2);
		pWnd->EnableWindow(FALSE);
		pWnd = GetDlgItem(IDC_STATIC3);
		pWnd->EnableWindow(FALSE);
		pWnd = GetDlgItem(IDC_STATIC4);
		pWnd->EnableWindow(FALSE);
		pWnd = GetDlgItem(IDC_STATIC50);
		pWnd->EnableWindow(FALSE);
		pWnd = GetDlgItem(IDC_STATIC6);
		pWnd->EnableWindow(FALSE);
		pWnd = GetDlgItem(IDC_STATIC7);
		pWnd->EnableWindow(FALSE);
		pWnd = GetDlgItem(IDC_RADIO1);
		pWnd->EnableWindow(FALSE);
		pWnd = GetDlgItem(IDC_RADIO2);
		pWnd->EnableWindow(FALSE);
		pWnd = GetDlgItem(IDC_ENDCELL);
		pWnd->EnableWindow(FALSE);
		pWnd = GetDlgItem(IDC_ENDSECTOR);
		pWnd->EnableWindow(FALSE);
		pWnd = GetDlgItem(IDC_INICELL);
		pWnd->EnableWindow(FALSE);
		pWnd = GetDlgItem(IDC_INISECTOR);
		pWnd->EnableWindow(FALSE);
	}
	if (m_iModePrev==MOTION2STILL || m_iModePrev==CELLSPLIT) 
	{
		pWnd = GetDlgItem(IDC_STATIC1);
		pWnd->EnableWindow(FALSE);
		pWnd = GetDlgItem(IDC_STATIC2);
		pWnd->EnableWindow(FALSE);
		pWnd = GetDlgItem(IDC_STATIC3);
		pWnd->EnableWindow(TRUE);
		pWnd = GetDlgItem(IDC_STATIC4);
		pWnd->EnableWindow(FALSE);
		pWnd = GetDlgItem(IDC_STATIC6);
		pWnd->EnableWindow(FALSE);
		pWnd = GetDlgItem(IDC_STATIC7);
		pWnd->EnableWindow(FALSE);
		pWnd = GetDlgItem(IDC_RADIO1);
		pWnd->EnableWindow(FALSE);
		pWnd = GetDlgItem(IDC_RADIO2);
		pWnd->EnableWindow(FALSE);
		pWnd = GetDlgItem(IDC_ENDCELL);
		pWnd->EnableWindow(FALSE);
		pWnd = GetDlgItem(IDC_ENDSECTOR);
		pWnd->EnableWindow(FALSE);
		pWnd = GetDlgItem(IDC_INICELL);
		pWnd->EnableWindow(FALSE);
		if (iSel==0)
		{
			pWnd = GetDlgItem(IDC_INISECTOR);
			pWnd->EnableWindow(TRUE);
		}
		else
		{
			pWnd = GetDlgItem(IDC_INISECTOR);
			pWnd->EnableWindow(FALSE);
		}
		if (iSel==6)
		{
			pWnd = GetDlgItem(IDC_BUTTONFILE);
			pWnd->EnableWindow(TRUE);
			pWnd = GetDlgItem(IDC_EDITFILE);
			pWnd->EnableWindow(TRUE);
		}
		else
		{
			pWnd = GetDlgItem(IDC_BUTTONFILE);
			pWnd->EnableWindow(FALSE);
			pWnd = GetDlgItem(IDC_EDITFILE);
			pWnd->EnableWindow(FALSE);

		}
	}
	if (m_iModePrev==MOTION2STILL)
	{
		pWnd = GetDlgItem(IDC_COMBOIFRAME);
		pWnd->EnableWindow(TRUE);
		pWnd = GetDlgItem(IDC_STATIC51);
		pWnd->EnableWindow(TRUE);
	}
	else	
	{
		pWnd = GetDlgItem(IDC_COMBOIFRAME);
		pWnd->EnableWindow(FALSE);
	}

	if (m_iModePrev==MOTION2STILL && m_iDomain==MENUS)
	{
		pWnd = GetDlgItem(IDC_CHECKAUDIO);
		pWnd->EnableWindow(TRUE);
	}
	else	
	{
		pWnd = GetDlgItem(IDC_CHECKAUDIO);
		pWnd->EnableWindow(FALSE);
	}
	if ( m_iModePrev==CELLSPLIT) 
	{
		pWnd = GetDlgItem(IDC_CHECKCHAPTER);
		if (m_bCheckProgram)
			pWnd->EnableWindow(TRUE);
		else
		{
			pWnd->EnableWindow(FALSE);
			m_bCheckChapter=FALSE;
		}
		pWnd = GetDlgItem(IDC_STATIC50);
		pWnd->EnableWindow(TRUE);
	}
}

void CPreviewDlg::OnIniclear() 
{
	// TODO: Add your control notification handler code here
	UpdateData(TRUE);

	iIniIsClosed=-1;

	if (m_iModePrev==PGCPREV)
	{
		iIniCell=-1;
		m_csIniCell="Start";
	}

	iIniSector=-1;
	m_csIniSector="Start";

	UpdateData(FALSE);

}

void CPreviewDlg::OnEndclear() 
{
	// TODO: Add your control notification handler code here
	UpdateData(TRUE);

	iEndIsClosed=-1;
	iEndSector=-1;

	if (m_iModePrev==PGCPREV)
	{
		m_csEndCell="Last";
		iEndCell=-1;
	}
	m_csEndSector="Last";

	UpdateData(FALSE);

}

void CPreviewDlg::OnInimark() 
{
	// TODO: Add your control notification handler code here
	int iret,iGOP;

	UpdateData(TRUE);

	if 	(m_iModePrev != MOTION2STILL )
	{
		iGOP=theApp.PR_IsClosedGOP(m_iDomain,m_nVTS,m_nT,m_nCell, iSector);
		if (iGOP == 0)
		{
//			iret=AfxMessageBox ("The selected GOP is an open one,\nso if this mark is the init of the playback,\nthe first picture can not be properly decoded,\nso VobBlanker will mark it as a broken GOP\nDo you want to continue?", MB_YESNO|MB_ICONQUESTION );
//			if (iret!=IDYES) return;
			AfxMessageBox ("The selected GOP is an open one, so if this mark is the init of the playback,\nVobBlanker will mark it as a broken GOP to allow to be properly decoded.", MB_OK);

		}
		if (theApp.PR_AreOrphanSubsInVOBU()) 
		{
			iret=AfxMessageBox ("The selected VOBU has subpictures w/o PTS\nso this will produce orphan subs packs\nVobBlanker will NOT fix them\nDo you want to continue?", MB_YESNO|MB_ICONQUESTION );
			if (iret!=IDYES) return;
		}
/*
		if (iGOP == 1)
			MessageBox("The selected GOP is a closed one","GOP info", MB_OK|MB_ICONINFORMATION );
		if (iGOP == 2)
			MessageBox("The selected GOP is a self-contained one","GOP info", MB_OK|MB_ICONINFORMATION );
		if (iGOP == 3)
			MessageBox("The selected GOP is an unknown one","GOP info", MB_OK|MB_ICONINFORMATION );
*/
	}

	iIniIsClosed=iGOP;
	iIniSector=iSector;
	iIniCell=m_nCell;

	m_csIniCell.Format(_T("%d"),iIniCell+1);
	m_csIniSector.Format(_T("%d"),iIniSector);


	if (iEndSector >=0 )
		if (iEndCell < iIniCell || 
			 ( iEndCell==iIniCell && iEndSector < iIniSector))
		{
			iEndSector=iIniSector;
			iEndCell=iIniCell;

			m_csEndCell=m_csIniCell;
			m_csEndSector=m_csIniSector;

		}

	UpdateData(FALSE);

}
void CPreviewDlg::UpdateCsEdit()
{ 

	if ((m_iDomain==TITLES && m_iModePrev==PGCPREV) || (m_iModePrev==CELLPREV))
	{
		if (iIniCell ==-1)
			m_csIniCell="Start";
		else
			m_csIniCell.Format(_T("%d"),iIniCell+1);
		if (iIniSector ==-1)
			m_csIniSector="Start";
		else
			m_csIniSector.Format(_T("%d"),iIniSector);
		if (iEndCell ==-1)
			m_csEndCell="Last";
		else
			m_csEndCell.Format(_T("%d"),iEndCell+1);
		if (iEndSector ==-1)
			m_csEndSector="Last";
		else
			m_csEndSector.Format(_T("%d"),iEndSector);
	}
	if ((m_iDomain==MENUS && m_iModePrev==PGCPREV) )
	{
		m_csIniCell="Start";
		m_csIniSector="Start";
		m_csEndCell="Last";
		m_csEndSector="Last";
	}
	if (m_iModePrev==MOTION2STILL || m_iModePrev==CELLSPLIT )
	{
		if (iIniSector ==-1)
			m_csIniSector="Start";
		else
			m_csIniSector.Format(_T("%d"),iIniSector);

	}


}

void CPreviewDlg::OnEndmark() 
{
	// TODO: Add your control notification handler code here
	int iret,iGOP;

	UpdateData(TRUE);

	iGOP=theApp.PR_IsClosedGOP(m_iDomain,m_nVTS,m_nT,m_nCell, iSector);

	if (iGOP == 0)
	{
//		iret=AfxMessageBox ("The selected GOP is an open one,\nso if this mark is the init of the playback,\nthe first picture can not be properly decoded,\nso VobBlanker will mark it as a broken GOP\nDo you want to continue?", MB_YESNO|MB_ICONQUESTION );
//		if (iret!=IDYES) return;
		AfxMessageBox ("The selected GOP is an open one, so if this mark is the init of the playback,\nVobBlanker will mark it as a broken GOP to allow to be properly decoded.", MB_OK);
	}
	if (theApp.PR_AreOrphanSubsInVOBU()) 
	{
		iret=AfxMessageBox ("The selected VOBU has subpictures w/o PTS\nso this will produce orphan subs packs\nVobBlanker will NOT fix them\nDo you want to continue?", MB_YESNO|MB_ICONQUESTION );
		if (iret!=IDYES) return;
	}

/*	if (iGOP == 1)
		MessageBox("The selected GOP is a closed one","GOP info", MB_OK|MB_ICONINFORMATION );
	if (iGOP == 2)
		MessageBox("The selected GOP is a self-contained one","GOP info", MB_OK|MB_ICONINFORMATION );
	if (iGOP == 3)
		MessageBox("The selected GOP is an unknown one","GOP info", MB_OK|MB_ICONINFORMATION );
*/
	iEndIsClosed=iGOP;
	iEndSector=iSector;
	iEndCell=m_nCell;

	m_csEndCell.Format(_T("%d"),iEndCell+1);
	m_csEndSector.Format(_T("%d"),iEndSector);


	if (iEndCell < iIniCell || 
		 ( iEndCell==iIniCell && iEndSector < iIniSector))
	{
		iEndSector=iIniSector;
		iEndCell=iIniCell;
		m_csEndCell=m_csIniCell;
		m_csEndSector=m_csIniSector;

	}
	UpdateData(FALSE);	
}

void CPreviewDlg::OnSelendokCombocell() 
{
	// TODO: Add your control notification handler code here
	UpdateData(TRUE);
	m_nCell=m_ComboCell.GetCurSel();
	m_nCellSectors= (int) theApp.PR_CellSectors(m_iDomain,m_nVTS,m_nT,m_nCell);
	iSector=0;
	m_csSector="0";
	m_CSlider.SetPos(0);
	UpdateData(FALSE);

	SendPosition( ID_USERENDSECTOR, false );
	SendPosition( ID_USERINISECTOR, true );
	SendPosition( ID_USERPOSITION, true );
}

void CPreviewDlg::SendPosition(LONG wParam, bool bCheck) 
{
	static int iDestSector_old=-1;
	int iDestSector;

	switch (wParam)
	{
		case ID_USERPOSITION:
			iDestSector=(int) theApp.PR_CellIniSector(m_iDomain,m_nVTS,m_nT,m_nCell) + iSector;
			if (bCheck && iDestSector==iDestSector_old) return;
			iDestSector_old=iDestSector;

			m_VideoPreview.GoToSector(iDestSector,1);
			m_VideoPreview.WaitForThread();

		break;

		case ID_USERINISECTOR:
			iDestSector=(int) theApp.PR_CellIniSector(m_iDomain,m_nVTS,m_nT,m_nCell);

			m_VideoPreview.HandleMessage(WM_USER,ID_USERINISECTOR,iDestSector);
			m_VideoPreview.WaitForThread();
//			m_VideoPreview.HandleMessage(WM_COMMAND,ID_LEFT_ARROW,0);
//			m_VideoPreview.WaitForThread();
			m_VideoPreview.HandleMessage(WM_COMMAND,ID_LEFT_BUTTON,0);
			m_VideoPreview.WaitForThread();
		break;

		case ID_USERENDSECTOR:
			iDestSector=(int) (theApp.PR_CellIniSector(m_iDomain,m_nVTS,m_nT,m_nCell)+
			               theApp.PR_CellSectors(m_iDomain,m_nVTS,m_nT,m_nCell))-1;

			m_VideoPreview.HandleMessage(WM_USER,ID_USERINISECTOR,0);
			m_VideoPreview.WaitForThread();
			m_VideoPreview.HandleMessage(WM_COMMAND,ID_LEFT_BUTTON,0);
			m_VideoPreview.WaitForThread();
			m_VideoPreview.HandleMessage(WM_USER,ID_USERENDSECTOR,iDestSector);
			m_VideoPreview.WaitForThread();
//			m_VideoPreview.HandleMessage(WM_COMMAND,ID_RIGHT_ARROW,0);
//			m_VideoPreview.WaitForThread();
			m_VideoPreview.HandleMessage(WM_COMMAND,ID_RIGHT_BUTTON,0);
			m_VideoPreview.WaitForThread();
		break;
	}
}


void CPreviewDlg::OnInfo() 
{
	static bool ShowIt = false;

	ShowIt = !ShowIt;
	m_VideoPreview.ShowInfo(ShowIt);
}


void CPreviewDlg::OnMove(int x, int y) 
{
	CDialog::OnMove(x, y);
	// This is necessary, so when you move the preview window, the video moves with it!
	// Only necessary when using the video overlay mixer.
	m_VideoPreview.HandleMessage(WM_MOVE,0,0);

}


void CPreviewDlg::OnSize(UINT nType, int cx, int cy) 
{
	CDialog::OnSize(nType, cx, cy);
/*	if (nType==SIZE_RESTORED  )
	{
		if (cx < m_RectDlg.right)
		{
			cx=m_RectDlg.right-m_RectDlg.left;
		}
		if (cy < m_RectDlg.bottom)
		{
			cy=m_RectDlg.bottom-m_RectDlg.top;
		}

	}
*/
	ReSize(cx, cy);
}

void CPreviewDlg::ReSize(int cx, int cy) 
{

	// TODO: Add your message handler code here
	float fscale_x, fscale_y;
	int iDar,iVideoAttr;
	int iIniX,iIniY;

	CRect myRect;
	int imaxhoriz,imaxvert;
	int iResHoriz,iResVert;
	int ihorizDar,ivertDar;
	
	if (m_iDomain==TITLES)
		iVideoAttr=theApp.m_iVideoAttr[m_nVTS];
	else
		iVideoAttr=theApp.m_pIFO[m_nVTS][0x100]*256+theApp.m_pIFO[m_nVTS][0x101];

	iDar=0;
	if ((iVideoAttr & 0x0C00) != 0)  
		iDar=1;
	
//	iResHoriz=Coded_Picture_Width;
//	iResVert=Coded_Picture_Height;
//	iResVert=Vert_Display_Size;
	iResHoriz=m_VideoPreview.GetCodedPictureWidth();
	iResVert=m_VideoPreview.GetCodedPictureHeight();

	if (iResHoriz==0 || iResVert==0) return;

	imaxhoriz=cx-(m_RectDlg.Width()-m_RectPrev.Width());
	imaxvert=cy-(m_RectDlg.Height()-m_RectPrev.Height())-TRACK_HEIGHT;

	iIniX=m_RectPrev.left;
	iIniY=m_RectPrev.top;

	if (!m_bCheckDar)
	{
		fscale_x=(float)imaxhoriz/(float)iResHoriz;
		fscale_y=(float)imaxvert/(float)iResVert;
	}
	else
	{
		if (iDar==0)
		{
			ihorizDar=imaxvert*4/3;
			ivertDar=imaxhoriz*3/4;
		}
		else
		{
			ihorizDar=imaxvert*16/9;
			ivertDar=imaxhoriz*9/16;
		}
		if (ihorizDar > imaxhoriz)
		{
			ihorizDar = imaxhoriz;
			fscale_x=(float)imaxhoriz/(float)iResHoriz;
			fscale_y=(float)ivertDar/(float)iResVert;
			iIniY+=((imaxvert-ivertDar)/2);
		}
		else
		{
			ivertDar=imaxvert;
			fscale_x=(float)ihorizDar/(float)iResHoriz;
			fscale_y=(float)imaxvert/(float)iResVert;
			iIniX+=((imaxhoriz-ihorizDar)/2);

		}


	}
	m_VideoPreview.SetVideoScaling(fscale_x,fscale_y);
	::SetWindowPos(m_PreviewHWnd,HWND_TOP,iIniX,iIniY,0,0,SWP_NOSIZE|SWP_NOZORDER);
	m_VideoPreview.SetVideoPosition(iIniX,iIniY);
}

void CPreviewDlg::OnCheckdar() 
{
	// TODO: Add your control notification handler code here
	UpdateData(TRUE);

	CRect myRect;

	GetClientRect(&myRect);

	ReSize(myRect.Width(),myRect.Height());

}

void CPreviewDlg::OnUser(WPARAM wParam, LPARAM lParam)
{
	// Here, we handle messages sent by DVD2AVI.
	int iDestSector;

	if(wParam == ID_THREAD_STOPPED)
	{
	}
	else if(wParam == ID_SECTOR_HIT)
	{
	// We're here because playback hit a sector limit.
//		m_bIsPlaying=false;
		if ( m_iModePrev==PGCPREV)
		{
			if (m_nCell+1 < m_ComboCell.GetCount() )
			{
				m_nCell++;
				m_ComboCell.SetCurSel(m_nCell);
				m_nCell=m_ComboCell.GetCurSel();
				m_nCellSectors= (int) theApp.PR_CellSectors(m_iDomain,m_nVTS,m_nT,m_nCell);
				iSector=0;
				m_csSector="0";
				m_CSlider.SetPos(0);
				UpdateData(FALSE);
//	SendPosition( ID_USERENDSECTOR, false );
//	SendPosition( ID_USERINISECTOR, true );
//	SendPosition( ID_USERPOSITION, true );

				iDestSector=(int) (theApp.PR_CellIniSector(m_iDomain,m_nVTS,m_nT,m_nCell)+
					                m_nCellSectors)-1;

				m_VideoPreview.SetStopSector(iDestSector);
				m_VideoPreview.WaitForThread();

				m_VideoPreview.Play();

			}
			else
				OnStop();
		}
		else
			OnStop();
/*
		m_bIsPlaying=false;
		EnableButtons();
		m_VideoPreview.SetStopSector(-1);
		m_VideoPreview.WaitForThread();
*/
	}
}

void CPreviewDlg::OnCheckfps() 
{
	// TODO: Add your control notification handler code here
	UpdateData(TRUE);
	m_VideoPreview.PlaybackActualRate(m_bCheckFps);
	
}


BOOL CPreviewDlg::OnHelpInfo(HELPINFO* pHelpInfo) 
{
	// TODO: Add your message handler code here and/or call default

	if (m_iModePrev==MOTION2STILL)
		HtmlHelp(NULL,theApp.m_csPath+"\\VobBlanker.chm::.\\htm\\Cell_still.htm", HH_DISPLAY_TOC, 0);
	else if (m_iModePrev==CELLSPLIT)
		HtmlHelp(NULL,theApp.m_csPath+"\\VobBlanker.chm::.\\htm\\Cell_split.htm", HH_DISPLAY_TOC, 0);
	else if (m_iModePrev==CELLPREV ) 
		HtmlHelp(NULL,theApp.m_csPath+"\\VobBlanker.chm::.\\htm\\Cell_cut.htm", HH_DISPLAY_TOC, 0);
	else /*if (m_iModePrev==PGCPREV ) */
		HtmlHelp(NULL,theApp.m_csPath+"\\VobBlanker.chm::.\\htm\\Preview_and_Cut.htm", HH_DISPLAY_TOC, 0);

	return TRUE;
}

void CPreviewDlg::OnButtonbmp() 
{
	// TODO: Add your control notification handler code here
//	PreviewSaveToBMPFile(char* VideoFileName, int Sector, float Xfactor, float Yfactor, char* BMPFileName);
	m_VideoPreview.SaveBMPFile(NULL, 1.0, 1.0, 0);
}


void CPreviewDlg::OnButtonfile() 
{
	CString csFiltro, csTitulo;

	iIniSector =0;
	UpdateCsEdit();

	csFiltro = "All supported files (*.VOB; *.bmp)|*.VOB;*.bmp|";
	csFiltro +="Vob files (*.VOB)|*.VOB|";
	csFiltro +="Bitmap files (*.bmp)|*.bmp|";
	csFiltro +="All files (*.*)|*.*|";
	csFiltro +="|";
	csTitulo = "Select Still file";
	// OpenFile Dlg construction 
	CFileDialog dlgAbrir(TRUE,"","",OFN_EXPLORER|OFN_FILEMUSTEXIST ,(const char*)csFiltro);

	dlgAbrir.m_ofn.lpstrTitle = (const char*)csTitulo;
	dlgAbrir.m_ofn.Flags=OFN_EXPLORER|OFN_FILEMUSTEXIST;

	if (dlgAbrir.DoModal() == IDOK)
	{
		m_csFileStill= dlgAbrir.GetPathName();
		UpdateData (FALSE);
	}
	else
	{
//		m_csFileStill="";
//		UpdateData (FALSE);
		return;
	}

	OpenStillFile();
}

void CPreviewDlg::OpenStillFile() 
{
	// TODO: Add your control notification handler code here
	CString csBmpFile, csAux, csOutputFolder, csProjectName, csLogFile;
	int iRet;


// Check name: Must end in .VOB
	csAux=m_csFileStill;
	csAux=csAux.Right(4);
	csAux.MakeUpper();
	if (csAux == ".VOB") 
	{
		LoadVOBFile(m_csFileStill);
		return;
	}
	if (csAux != ".BMP") 
	{
		MyErrorBox("Please select a VOB or a Bitmap: Filename must be *.VOB or *.bmp");
		m_csFileStill="";
		UpdateData (FALSE);
		return;
	}

// Now, file is a bitmap, check if MuxMan paths exist
	if ( theApp.m_csMuxManPath.IsEmpty() ||
		 theApp.m_csWorkingPath.IsEmpty() ||
		 _access (theApp.m_csMuxManPath, 04)!=0 ||
		 _access (theApp.m_csWorkingPath, 0)!=0) 
 	{
		MyErrorBox("Please check MuxMan and Working folder Paths in Tools Menu");
		m_csFileStill="";
		UpdateData (FALSE);
		return;
	}

	m_VideoPreview.CloseFile();
	m_VideoPreview.WaitForThread();

	csBmpFile=m_csFileStill;
	
	csAux.Format(_T("\\STILL%1d_%02d_%03d_%03d"),
					m_iDomain, m_nVTS, m_nT, m_nCell);
	csOutputFolder= theApp.m_csWorkingPath + csAux ;

	CreateDirectory(csOutputFolder,NULL);
	
	m_csFileStill=csOutputFolder + "\\VIDEO_TS\\VTS_01_1.VOB";
	csProjectName=csOutputFolder+"\\mxp.mxp";

	MyDeleteFile(csOutputFolder+"\\VIDEO_TS\\*.*");
	MyDeleteFile(csOutputFolder+"\\*.*");

	if ( Create_mxp_file (csBmpFile, csOutputFolder, csProjectName) ==false)
	{
		m_csFileStill="";
		UpdateData (FALSE);
		return;
	}

// Launch MuxMan
	csProjectName="\""+csProjectName+"\"";

    iRet=_spawnl( _P_WAIT, theApp.m_csMuxManPath, "\""+theApp.m_csMuxManPath+"\"", 
		            csProjectName, " -d ", "\""+csOutputFolder + "\\VIDEO_TS"+"\"",
					" -l " , "\""+csOutputFolder +"\\mxp_log.txt"+"\"", " -run" , NULL );

//	csAux.Format(_T("MuxMan returned %d"),iRet);
//	MyErrorBox(csAux);

	if	( _access (m_csFileStill, 04)!=0 ) 
 	{
		MyErrorBox("Unknown error running MuxMan. Please see log file\n" + csOutputFolder +"\\mxp_log.txt");
		m_csFileStill="";
		UpdateData (FALSE);
		return;
	}


	UpdateData (FALSE);
	LoadVOBFile(m_csFileStill);

}

void CPreviewDlg::LoadVOBFile(CString csVOBFile) 
{
	char szFile[1024];
	__int64 i64size;
	struct _stati64 statbuf;

	m_ComboIFrame.SetCurSel(6);
	m_iIFrameSel=m_ComboIFrame.GetCurSel();

	sprintf( szFile,"%s",csVOBFile );

	m_VideoPreview.CloseFile();
	m_VideoPreview.WaitForThread();

	m_VideoPreview.LoadFile(szFile,false, true);
	m_VideoPreview.WaitForThread();
	m_VideoPreview.PlaybackActualRate(m_bCheckFps);

	ShowButtons();
	EnableButtons();

	i64size=0;
	if (_stati64 ( csVOBFile, &statbuf)==0)
		i64size= statbuf.st_size;

	m_nCellSectors= (int)(i64size/2048);

	if (m_nCellSectors==0) m_nCellSectors=1;

	m_VideoPreview.GoToSector(0,1);
	m_VideoPreview.WaitForThread();

	ReSize(m_RectDlg.Width(),m_RectDlg.Height());
}

void CPreviewDlg::LoadMyVOB() 
{
	bool bLoadMany;
	char szFile[1024];


	if (m_iDomain==TITLES)
	{
		sprintf( szFile,"%s\\VTS_%02d_1.VOB",theApp.m_csInputPath, m_nVTS);
		bLoadMany=true;
	}
	else
	{
		bLoadMany=false;
		if (m_nVTS ==0 )
			sprintf( szFile,"%s\\VIDEO_TS.VOB",theApp.m_csInputPath);
		else
			sprintf( szFile,"%s\\VTS_%02d_0.VOB",theApp.m_csInputPath, m_nVTS);
	}

	m_VideoPreview.CloseFile();
	m_VideoPreview.WaitForThread();

	m_VideoPreview.LoadFile(szFile,bLoadMany, true);
	m_VideoPreview.WaitForThread();
	m_VideoPreview.PlaybackActualRate(m_bCheckFps);

	ShowButtons();
	EnableButtons();
	m_nCellSectors= (int) theApp.PR_CellSectors(m_iDomain,m_nVTS,m_nT,m_nCell);
	OnSelendokCombocell();

	ReSize(m_RectDlg.Width(),m_RectDlg.Height());

}

void CPreviewDlg::OnSelendokComboiframe() 
{
	// TODO: Add your control notification handler code here
	int iSel0;

	if (m_iModePrev !=MOTION2STILL) return;

	iSel0=m_iIFrameSel;
	m_iIFrameSel=m_ComboIFrame.GetCurSel();


	if (iSel0==6 && m_iIFrameSel!= 6 )
		LoadMyVOB();

	if (iSel0!=6 && m_iIFrameSel== 6 )
		OnButtonfile();

	UpdateData(TRUE);
	EnableButtons();
}

bool CPreviewDlg::Create_mxp_file (CString csBmpFile, CString csOutputFolder, CString csProjectName)
{
	CString csAux,csRes,csDar, csFormat;
	FILE *out;
	int iVideoAttr,iFormat;


	if (m_iDomain==TITLES)
		iVideoAttr=theApp.m_iVideoAttr[m_nVTS];
	else
		iVideoAttr=theApp.m_pIFO[m_nVTS][0x100]*256+theApp.m_pIFO[m_nVTS][0x101];

	iFormat=(iVideoAttr & 0x1000)>>12;

/*	if ( iFormat == PAL )
	{
		if ((iVideoAttr & 0x18) == 0 )   
			csRes="720x576";
		if ((iVideoAttr & 0x18) == 0x08 ) 
			csRes="704x576";
		if ((iVideoAttr & 0x18) == 0x10 ) 
			csRes="352x576";
		if ((iVideoAttr & 0x18) == 0x18 ) 
			csRes="352x288";
	}
	else
	{
		if ((iVideoAttr & 0x18) == 0 )   
			csRes="720x480";
		if ((iVideoAttr & 0x18) == 0x08 ) 
			csRes="704x480";
		if ((iVideoAttr & 0x18) == 0x10 ) 
			csRes="352x480";
		if ((iVideoAttr & 0x18) == 0x18 ) 
			csRes="352x240";
	}
*/

	if ( iFormat == PAL )
		csRes="720x576";
	else
		csRes="720x480";

	if (iFormat==NTSC)
		csFormat="NTSC";
	else
		csFormat="PAL";

	csDar="4:3";
	if ((iVideoAttr & 0x0C00) != 0)  
		csDar="P/S and LB";

	csAux=  "Section=Content\n";
	csAux+= "{\n";
	csAux+= "  Item=Segment\n";
	csAux+= "  {\n";
	csAux+= "    Name=Segment_1\n";

	csAux+=("    Display Mode="+csDar+"\n");

	csAux+=("    Resolution=" + csRes+ "\n");

	csAux+= "    Force=No\n";
	csAux+= "    Item=Video Stream\n";
	csAux+= "    {\n";
	csAux+= "      Coding Mode=Mpeg-2\n";

	csAux+=("      Standard=" + csFormat +"\n");

	csAux+= "      CC Field 1=No\n";
	csAux+= "      CC Field 2=No\n";
	csAux+= "      Item=Video Play\n";
	csAux+= "      {\n";

	csAux+=("        File="+ csBmpFile +"\n");

	csAux+= "        Size=0\n";
	csAux+= "        Duration=Default\n";
	csAux+= "      }\n";
	csAux+= "    }\n";
	csAux+= "    Item=Scene List\n";
	csAux+= "    {\n";
	csAux+= "      Item=Scene\n";
	csAux+= "      {\n";
	csAux+= "        Name=Segment_1_scn1\n";
	csAux+= "        Scene Time=00:00:00:00\n";
	csAux+= "        Uop=00000000\n";
	csAux+= "      }\n";
	csAux+= "    }\n";
	csAux+= "  }\n";
	csAux+= "}\n";
	

	if ((out=fopen (csProjectName,"w"))==NULL)
	{
		MyErrorBox("Unable to create Muxman project file: " + csProjectName);
		return false;
	}

	fprintf (out,"%s",csAux);
	fclose (out);
	return true;
}


void CPreviewDlg::OnDropFiles( HDROP hDropInfo)
{
	UINT nFiles;
	CWinApp* pApp;
	TCHAR szFileName[_MAX_PATH];


	SetActiveWindow();      // activate us first !
	POINT ThePoint;

	DragQueryPoint(hDropInfo,&ThePoint);

	nFiles = ::DragQueryFile(hDropInfo, (UINT)-1, NULL, 0);
	pApp = AfxGetApp();
	ASSERT(pApp != NULL);
	if(nFiles> 1)
	{
		MessageBox( "Only one file at a time!.", "Error",  MB_OK | MB_ICONSTOP );
	}
	else if(nFiles== 1)
	{
		::DragQueryFile(hDropInfo, 0, szFileName, _MAX_PATH);
		m_csFileStill= szFileName;
		UpdateData (FALSE);
		OpenStillFile();
	}
}

void CPreviewDlg::OnCheckprogram() 
{
	// TODO: Add your control notification handler code here

	CWnd * pWnd;

	UpdateData(TRUE);
	if ( m_iModePrev==CELLSPLIT) 
	{
		pWnd = GetDlgItem(IDC_CHECKCHAPTER);
		if (m_bCheckProgram)
			pWnd->EnableWindow(TRUE);
		else
		{
			pWnd->EnableWindow(FALSE);
			m_bCheckChapter=FALSE;
			UpdateData(FALSE);
		}
		
	}
}
