// Tools.cpp : implementation file
//

#include "stdafx.h"
#include "HtmlHelp.h"
#include "ToolTipDialog.h"
#include "VobBlanker.h"
#include "Tools.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif


extern CVobBlankerApp theApp;
extern CString SelectFolder (CString csTitulo, CString csStartFolder);

/////////////////////////////////////////////////////////////////////////////
// CToolsDlg dialog


CToolsDlg::CToolsDlg(CWnd* pParent /*=NULL*/)
	: CToolTipDialog(CToolsDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CToolsDlg)
	m_csMuxMan = _T("");
	m_csWorking = _T("");
	//}}AFX_DATA_INIT
}


void CToolsDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CTools)
	DDX_Text(pDX, IDC_EDITMUXMAN, m_csMuxMan);
	DDX_Text(pDX, IDC_EDITWORKING, m_csWorking);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CToolsDlg, CDialog)
	//{{AFX_MSG_MAP(CToolsDlg)
	ON_BN_CLICKED(IDC_BUTTONSAVE, OnButtonsave)
	ON_BN_CLICKED(IDC_BUTTONMUXMAN, OnButtonmuxman)
	ON_BN_CLICKED(IDC_BUTTONWORKING, OnButtonworking)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CTools message handlers

BOOL CToolsDlg::OnInitDialog()
{

	CDialog::OnInitDialog();

	m_csMuxMan = theApp.m_csMuxManPath;
	m_csWorking = theApp.m_csWorkingPath;

	UpdateData (FALSE);
	// TOOLTIPS
	c_bShowToolTips = TRUE;
	m_wndToolTip.Create(this);
	m_wndToolTip.Activate(c_bShowToolTips);

	m_wndToolTip.AddTool(GetDlgItem(IDC_BUTTONMUXMAN), "Path to MuxMan exe" );
	m_wndToolTip.AddTool(GetDlgItem(IDC_BUTTONWORKING), "Path to a working Folder to store temporary files" );
	m_wndToolTip.AddTool(GetDlgItem(IDOK), "Apply, save paths in Registry and exit" );
	m_wndToolTip.AddTool(GetDlgItem(IDCANCEL), "Quit" );


	return TRUE;  // return TRUE  unless you set the focus to a control

}


void CToolsDlg::OnButtonsave() 
{
	// TODO: Add your control notification handler code here
	
}

void CToolsDlg::OnButtonmuxman() 
{
	// TODO: Add your control notification handler code here
	CString	csFiltro,csTitulo;
	CString csAux;

	// String del filtro de ficheros y del titulo
	UpdateData (TRUE);

	csFiltro = "MuxMan exe";
	csFiltro += " (MuxMan.exe)|MuxMan.exe||";
	csTitulo = "Select MuxMan executable";
	// OpenFile Dlg construction 
	CFileDialog dlgAbrir(TRUE,"exe","MuxMan.exe",OFN_EXPLORER|OFN_FILEMUSTEXIST ,(const char*)csFiltro);

	dlgAbrir.m_ofn.lpstrTitle = (const char*)csTitulo;
	dlgAbrir.m_ofn.Flags=OFN_EXPLORER|OFN_FILEMUSTEXIST;

	if (dlgAbrir.DoModal() == IDOK)
	{
		m_csMuxMan = dlgAbrir.GetPathName(); 
		//TODO: Check name

		UpdateData (FALSE);
	}			
}

void CToolsDlg::OnCancel() 
{
	// TODO: Add extra cleanup here
	
	CDialog::OnCancel();
}



void CToolsDlg::OnButtonworking() 
{
	// TODO: Add your control notification handler code here

	CString	csPath;
	
	UpdateData (TRUE);

	if (m_csWorking.IsEmpty())
	{
		csPath=SelectFolder ("Select Working (temporal) Folder","C:\\");
	}
	else
		csPath=SelectFolder ("Select Working (temporal) Folder",m_csWorking);
	if (! csPath.IsEmpty())
	{
		m_csWorking= csPath;
//		m_csOutput.MakeUpper();
	}
	UpdateData (FALSE);
	
}

void CToolsDlg::OnOK() 
{
	// TODO: Add extra validation here

	theApp.m_csMuxManPath = m_csMuxMan;
	theApp.m_csWorkingPath= m_csWorking;
	theApp.WriteProfileString("Paths",   "WorkingFolder" ,	m_csWorking);	
	theApp.WriteProfileString("Paths",   "MuxManPath" ,		m_csMuxMan);	

	CDialog::OnOK();
}
