// VobBlanker.h : main header file for the VOBBLANKER application
//

#if !defined(AFX_VOBBLANKER_H__D9C5F094_96B1_4541_8EB0_320F4C91A546__INCLUDED_)
#define AFX_VOBBLANKER_H__D9C5F094_96B1_4541_8EB0_320F4C91A546__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#ifndef __AFXWIN_H__
	#error include 'stdafx.h' before including this file for PCH
#endif

#include "resource.h"		// main symbols

#include <afxtempl.h>


#define RED     RGB(255,0,0)
#define BLUE    RGB(0,0,255)
#define GREEN15 RGB(0,150,0)
#define GREEN   RGB(0,255,0)
#define GREY200 RGB(200,200,200)
#define GREY100 RGB(100,100,100)
#define YELLOW  RGB(255,200,0)
#define MAGEN	RGB(255,0,255)
#define CIAN	RGB(0,255,255)
#define CIAN15	RGB(0,150,255)
#define WHITE	RGB(255,255,255)
#define BLACK	RGB(0,0,0)
#define ORANGE  RGB(255,100,0)

#define VB_VERSION  "2.1.1.0"
//TODO: number of subs and audio copying in replacing...

#define MAXPACKSPERVOBU 800
#define MAXVOBUSECSLENGTH 8
#define MAXLOOKFORAUDIO 10000
#define MAXLOOKFORAUDIOINMENUS 10000
#define MAXLOOKFORAUDIOREPLACING 10000
#define MAXSUBCOMMANDSIZE 200
#define MAXSCRDIFF  135000  // Maxima diferencia entre el ultimo scr de una celula y el primero de la siguiente.
/*
#define INI_AUDIO  0x204
#define INI_SUBS   0x256
#define INI_VIDEO  0x200
#define HEADLENGTH 0x3D8
*/
#define KEEP		0
#define BLANK		1
#define REPLACE		2
#define STRIP		3
#define CUT			4
#define CELLBASED	5
#define SKIP		6
#define PROCESS		7
#define REUSE		8
#define ZERO		9
#define DELPBK		10
#define STILLA		11
#define STILLNA		12
#define UNREF		13

// different cut types 
#define CUT1		21
#define CUT2		22
#define CUT3		23
#define CUT4		24


// Used in Audio dialog
#define ATTRIB		31
#define AUDINFO     32

// Used in Stream Attributes dialogs
#define PGCATTRIB	0
#define VTSATTRIB   1
#define PGCSTRIP	2


//Logs combined with m_bLog
#define LOGNAV			1
#define LOGTMAPTI		0
#define LOGSTRIP		0
#define LOGSUBS			0

// Update Module
#define MODUPDATEVOBU	10
#define MODUPDATEPACK	10
#define MODUPDATE		1000
#define MODUPDATESCAN	4

// MaxIFOlength 
#define MAX_VTS  100
#define MAXLENGTH  10240*1024   //Absolute maximum size of an IFO: 10MB
#define MAX_NEWIFOSECTORS_END  64   //Free space for IFO growing (ADT/ADMAP).
#define MAX_NEWIFOSECTORS_INITIAL  16   //Free space for IFO growing (in place).
#define MAX_MPGC 32768
#define MAX_PGC  32768
//#define MAX_VTS  35

#define MAX_MLUS 25

#define PAL 1
#define NTSC 0

// Domains
#define TITLES 0
#define MENUS 1

typedef unsigned char uchar;
typedef unsigned long ulong;
typedef unsigned __int64 uint64;


typedef struct NAVINFO
{
    __int64 LBA,LastLBA;
	__int64 originalLBA;
	unsigned __int64 ui64iniscr,ui64lastscr;
    int VID,CID;
	int frames,seconds;
	int iPTS0,iPTS1;
	DWORD dwDuration;
	bool hasvideo;
} NAVINFO;

typedef struct AUDIOINFO
{
    __int64 LBA;
    int VID,CID;
//	uchar streamID; 
	int iPTS;
} AUDIOINFO;

typedef struct SUBSINFO
{
    __int64 LBA;
    int VID,CID;
//	uchar streamID; 
	int iPTS0,iPTS1;
} SUBSINFO;

typedef struct SUBSCOMMANDS
{
    uchar buffer[MAXSUBCOMMANDSIZE];
	int nIndex, nIndexCommands;
	int nAlready,nSize;
	bool bStarted;
//	uchar streamID; 
} SUBSCOMMANDS;

typedef struct TITLE_CELL_LIST
{
    int VID,CID;	// Original VCIDs
	  int iPart;	    // part of the Cell. From 0 to n-1. Used in split mode 
    int NVID,NCID; // VCIDs after renumbering. The outputted ones
    __int64 i64FirstLBAFirstVOBU, i64FirstLBALastVOBU, i64LastLBALastVOBU;
	__int64 i64size;
	__int64 i64IniSecCell,i64EndSecCell;
	__int64 i64IniSecVOB,i64EndSecVOB; // Positions extracted from VOB
// Pointers used to Cutting Cells and to Replacing Cells.
	__int64 i64IniSecAux,i64EndSecAux; 
//	__int64 i64PreButtons;
	__int64 i64IniButtons,i64EndButtons,i64MidButtons,i64MaxButtons;
	__int64 i64IniIFSize,i64EndIFSize,i64MidIFSize,i64MaxIFSize;
	__int64 i64IFrame;
	int indexReplace;  // index to Replaced Cell (m_ACell_replace) in CellBased Mode, 
	int indexStill;  // index to StillInfo (m_ACellStillinfo) in CellBased Mode, 
	unsigned __int64 ui64iniscr,ui64lastscr;
	int nButtons,nVOBUS,iIniVOBU;
	int nT;	// Pointer to PGC Used in STRIP and Replace
  	int iFirstIsClosedGOP; // Used in CUT and SPLIT modes
	int iMode,iCutMode;
	int nNavs;
	DWORD dwDuration;
	int iSplitMode;
	uchar chMode;
	uchar uCellStatus;		// Stores the cell status of Replacing titles. Not used.
	bool bFixPointers; 
	bool bToBeDeleted;
} TITLE_CELL_LIST;

typedef struct MENU_CELL_LIST
{
    int VID,CID;	// Original VCIDs
    int NVID,NCID; // VCIDs after renumbering. The outputted ones
    __int64 i64FirstLBAFirstVOBU, i64FirstLBALastVOBU, i64LastLBALastVOBU;
	__int64 i64size;
	__int64 i64IniSecCell,i64EndSecCell;
	__int64 i64IniSecVOB,i64EndSecVOB; // Positions extracted from VOB
// Pointers used to Cutting Cells.
	__int64 i64IniSecAux,i64EndSecAux; 
	__int64 i64PreButtons,i64PrePreButtons;
	__int64 i64IniButtons,i64EndButtons,i64MidButtons,i64MaxButtons;
	__int64 i64IniIFSize,i64EndIFSize,i64MidIFSize,i64MaxIFSize;
	__int64 i64IFrame;
	int indexReplace;  // index to Replaced Cell (m_ACell_replace) in CellBased Mode, 
	int indexStill;  // index to StillInfo (m_ACellStillinfo) in CellBased Mode, 
	unsigned __int64 ui64iniscr,ui64lastscr;
	int nButtons,nVOBUS,iIniVOBU;
	int nPreSubs, nPostSubs;
  	int iFirstIsClosedGOP; // Used in CUT  modes
	int iMode,iCutMode;
	int nNavs;
	DWORD dwDuration;
	uchar chMode;
	bool bFixPointers; 
	bool bAlreadySize;
	bool bToBeDeleted;
} MENU_CELL_LIST;

typedef struct CUTINFO
{
    int iIniCell,iIniLba;
    int iEndCell,iEndLba;
	int iAction;
	int iIniIsClosed,iEndIsClosed;
} CUTINFO;

typedef struct CELL_REPLACE
{
	int iDomain,nVTS;
	int nT,nCell;
	CString csPath;
} CELL_REPLACE;

typedef struct CELLSTILLINFO
{
	int nVTS,iDomain;
	__int64 i64IFrame; // Pointer to Nav of selected I frame
	int nT, nCell;
	CString csFileStill;
} CELLSTILLINFO;

typedef struct CELLSPLITINFO
{
	int nVTS,iDomain;
	__int64 i64IFrame; // Pointer to Nav of selected I frame
	int nT, nCell;
	int iSplitMode,iIniIsClosed;
} CELLSPLITINFO;

typedef struct CELLCUTINFO
{
	int nVTS,iDomain;
	int nT, nCell;
    int iIniSector,iEndSector; // Pointer to Nav of selected cut points
	int iAction; // Action: Keep(0)/Cut(1) movie in between
	int	iIniIsClosed,iEndIsClosed;
} CELLCUTINFO;

/////////////////////////////////////////////////////////////////////////////
// CVobBlankerApp:
// See VobBlanker.cpp for the implementation of this class
//

class CVobBlankerApp : public CWinApp
{
public:
	CVobBlankerApp();

	bool	m_bCLIMode, m_bCLIFullScan;
	bool	m_bLog;

	bool	m_bAlreadyRun, m_bAlreadyLoaded;
	bool	m_bAlreadyRunInInput;
	bool	m_bAlreadyScan[MAX_VTS];

	bool	m_bTitleNeedScan[MAX_VTS];
	bool	m_bMenuNeedScan[MAX_VTS];
	bool	m_bNeedScan;

	bool	m_bInProcess, m_bAborted, m_bScanInProcess;

	BOOL	m_bCheckTitle;
	BOOL	m_bCheckMenu;

	BOOL	m_bCheckFolder;
	BOOL	m_bCheckVobPuops;
	BOOL	m_bCheckIfoPuops;
	BOOL	m_bCheckFixTitlePointers;
	BOOL	m_bCheckFixMenuPointers;

	BOOL	m_bCheckPostPre;
	BOOL	m_bCheckPostPreForced;

	BOOL	m_bCheckNoOverlay, m_bCheckAutoPlay, m_bCheckDisTinyPrev, m_bInitDisTinyPrev;
	BOOL	m_bCheckAutoPlayTiny,m_bCheckTinyGoto10,m_bCheckTinyMenus;

	BOOL	m_bCheckBlankNoB,m_bCheckOneSecStill;

	int		m_iIFrameMode;
	int		m_iIMaxStill,m_iIMinStill;

	BOOL	m_bCheckNextMenu,m_bCheckNextTitle;
	BOOL	m_bCheckPrevMenu,m_bCheckPrevTitle;
	BOOL	m_bCheckAttrMenu,m_bCheckAttrTitle;
	BOOL	m_bCheckVobFill,m_bCheckVobOrder,m_bCheckVobMUnref,m_bCheckVobLUnref,m_bCheckVobRenumber,m_bCheckClockDisc;

	BOOL	m_bCheckBckVts,m_bCheckBckMul;

	BOOL	m_bCheckElapsed, m_bCheckFixVobsReplacing,m_bCheckCopyAttrib,m_bCheckCopyPalette,m_bCheckCopyStatus, m_bCheckSubsAR;

	BOOL	m_bCheckAutoScan;
	int		m_iScanNVOBUs;

	CString	m_csWorkingPath,m_csMuxManPath;
	
	uchar	m_buffer[2048*MAXPACKSPERVOBU];
	CString m_csPath;
	CString m_csLoadedProject;
	CDialog *m_pLog;
	int		m_nWarnings, m_nErrors;
	bool	m_bFixVobs;
	int		m_nPostPre,m_nActualPostPre;
	bool	m_bBadOffset;

	FILE *m_Fin, *m_Fout;
	CString m_csFout,m_csFin;

private:
	__int64 m_i64OutputLBA, m_i64TotalLBA;
	                                   // 10: 1..9 cummulated (Titles size)
	int m_nVobout,m_nVobin ;

	int m_nAudioStream[8],m_nSubsStream[32];
	int m_nNavsInCell;
	int m_nAudioInCell[8],m_nSubsInCell[32];
	SUBSCOMMANDS  m_SubsCommands[32];
	CArray<NAVINFO,NAVINFO> m_ANavinfo;
	CArray<NAVINFO,NAVINFO> m_CellNavinfo;
	CArray<AUDIOINFO,AUDIOINFO> m_AAudioinfo[8];
	CArray<AUDIOINFO,AUDIOINFO> m_CellAudioinfo[8];
	CArray<SUBSINFO,SUBSINFO> m_ASubsinfo[32];
	CArray<SUBSINFO,SUBSINFO> m_CellSubsinfo[32];

public:
	CArray<MENU_CELL_LIST,MENU_CELL_LIST> m_MenuCells[MAX_VTS];
	CArray<TITLE_CELL_LIST,TITLE_CELL_LIST> m_TitleCells[MAX_VTS];
	CArray<CELLSTILLINFO,CELLSTILLINFO> m_ACellStillinfo;
	CArray<CELLSPLITINFO,CELLSPLITINFO> m_ACellSplitinfo;
	CArray<CELLCUTINFO,CELLCUTINFO> m_ACellCutinfo;
	CArray<CELL_REPLACE,CELL_REPLACE> m_ACell_replace;

	__int64 m_i64GranTotalMax, m_i64GranTotalCurr;
	uchar SimpleVob[2048*5];

////////// Members used to read Titles
	uchar* m_pIFO[MAX_VTS];        
	__int64 m_i64IFOlen[MAX_VTS];
	__int64 m_i64NewIFOlen[MAX_VTS];
	int m_nIFOs,m_nTotalTitles;
	CString m_csInputPath;
	CString	m_csOutputPath;
	
	CString m_csError;

	bool m_bAngleAll;
	bool m_bILVAll;

	int m_ticsperframe;

	int  m_iFixDuration; 
//Substracts from elapsed time the time stored in m_iFixDuration
#define FIXOFFDURATION 1
//Get duration as new offset, reset elapsed time and change state  to FIXOFFDURATION
#define GETOFFDURATION 2
//Save elapsed time in m_iFixDuration. Do not correct elapsed time.
#define SAVEOFFDURATION 3
//calculate m_iFixDuration, fix elapsed time and change state to FIXOFFSETDURATION
#define CALCULATE_FIXOFFDURATION 4
//calculate ADDOFFDURATION: Related with Replace Title
#define ADDOFFDURATION 5


	DWORD m_dwOffDuration;

	bool	m_bZeroMenu[MAX_VTS];
	bool	m_bZMenu;

////////// Members for info required in VTS ClistView
	CString m_csVTSname[MAX_VTS];
	__int64 m_i64VTSisize[MAX_VTS];
	__int64 m_i64Misize[MAX_VTS];
	__int64 m_i64VTSfsize[MAX_VTS];
	__int64 m_i64VOBsize[MAX_VTS][11]; // VOB files sizes: 0: menu; 1..9 titles;
	int m_nPGCs[MAX_VTS],m_TT_SRPT;
	int	m_VTS_PTT_SRPT[MAX_VTS];
	int m_VTS_PGCI[MAX_VTS];
	int m_VTS_TMAPTI[MAX_VTS];
	int m_VTS_C_ADT[MAX_VTS];
	int	m_VTS_VOBU_ADMAP[MAX_VTS];
	int m_iVideoAttrBK[MAX_VTS];
	int m_iVideoAttr[MAX_VTS];
	int m_iAudioAttr[MAX_VTS][8];
	int m_iAudioAttrBK[MAX_VTS][8];
	int m_iStreamUsedInAudio[MAX_VTS][8];   // Used streams in each track (bool as position in integer)
	int m_iAddIdAudio[MAX_VTS][8]; // Audio stream AddIds. Offset to add to each index (0..7) to get the stream number
	int m_iActionVTS[MAX_VTS];
	int m_nAudio[MAX_VTS];
	int m_nSubs[MAX_VTS];
//	int m_iBRAudio[MAX_VTS][8]; // Bitrate (initial) 
	int m_iAudioSectors[MAX_VTS][8]; // Size (in sectors) after scan 
	int m_iSubsSectors[MAX_VTS][32]; // Size (in sectors) after scan 
	int m_nMenuAudio[MAX_VTS];
	int m_iMenuAddIdAudio[MAX_VTS][8]; // Audio stream AddIds. Offset to add to each index (0..7) to get the stream number
//	int m_iMenuBRAudio[MAX_VTS][8]; // Bitrate (initial)
	bool m_bAngleVTS[MAX_VTS];
	bool m_bILVVTS[MAX_VTS];
	int	 m_nTVOBIDs[MAX_VTS];		// Num of VOBid In Titles
	int	 m_nMVOBIDs[MAX_VTS];		// Num of VOBid In Menus
	int	 m_nTMaxVOBIDs[MAX_VTS];		// Max VOBid In Titles
	int	 m_nMMaxVOBIDs[MAX_VTS];		// Max VOBid In Menus
	int	 m_nVOBIDsInProcess;
	DWORD m_dwVOBAudDuration[MAX_VTS][8] ;  // Stores the total duration of an audio stream in a VOB
	DWORD m_dwVOBSubDuration[MAX_VTS][32] ; // Stores the total duration of a subs stream in a VOB

// Used in IFO processing, to allow IFOs resizing	
	int m_nIniADTSectors,  m_nIniMADTSectors;   // Stores the original number of sectors used by ADT tables
	int m_nIniADMAPSectors,m_nIniMADMAPSectors; // Stores the original number of sectors used by ADMAP tables
	int m_nNewADTSectors,  m_nNewMADTSectors;   // Stores the New number of sectors used by ADT tables
	int m_nNewADMAPSectors,m_nNewMADMAPSectors; // Stores the New number of sectors used by ADMAP tables
	int m_nStartCellsTable;  // Stores a pointer to the start of MADT/MADMAP/ADT/ADMAP tables

////////// Pointers to Members for info required in Title ClistView
// All MUST be allocated with new and deallocated with delete in
// NewMemoryVTSTitle and DeleteMemoryVTSTitle

	int * m_nTitle[MAX_VTS];
	bool * m_bEntry[MAX_VTS] ;
	int * m_nTitleInVTS[MAX_VTS] ;
	bool * m_bILVU[MAX_VTS] ;
	int * m_nAngles[MAX_VTS] ;
	int * m_nChaptersAdded[MAX_VTS] ;
	bool * m_bCellReUsed[MAX_VTS] ;
	int * m_nCells[MAX_VTS] ;
	int * m_nFirstVID[MAX_VTS] ;
	DWORD * m_dwDuration[MAX_VTS] ;
	DWORD * m_dwDurationOwn[MAX_VTS] ; //Duration of PGC, but only not reused cells.
	__int64 * m_i64Tisize[MAX_VTS] ;
	__int64 * m_i64Rsize[MAX_VTS] ;
	int * m_iAction[MAX_VTS] ;
	int * m_VTS_PGC[MAX_VTS] ;
	int * m_C_PBKT[MAX_VTS] ;
	int * m_C_POST[MAX_VTS] ;
	int * m_PGC_COMM[MAX_VTS] ;
	int * m_nTButtons[MAX_VTS];
	int * m_iIdTAudio[MAX_VTS][8] ;      // Used Audio stream Ids. May be different per Title.
//	int * m_iBRTAudio[MAX_VTS][8] ;      // BitRate per stream Ids. May be different per Title.
	int * m_iIdTAudioStrip[MAX_VTS][8] ; // Bool to discard stream or not.
	int * m_iIdTSubsStrip[MAX_VTS][32] ; // Bool to discard stream or not.
	uchar * m_i8CellComm[MAX_VTS] ;
	uchar * m_i8PreComm[MAX_VTS] ;
	uchar * m_i8PostComm[MAX_VTS] ;
	CUTINFO * m_CutInfo[MAX_VTS] ;
	CString * m_csReplace[MAX_VTS] ;
	CString * m_csCellBased[MAX_VTS];
	

////////// Members for info required in Menus

	__int64 m_i64Mfsize[MAX_VTS];
	int m_nLUs[MAX_VTS];
	int m_nMPGCs[MAX_VTS];
// Pointers in IFOs
	int m_VTSM_PGCI[MAX_VTS];
	int m_VTSM_C_ADT[MAX_VTS];
	int	m_VTSM_VOBU_ADMAP[MAX_VTS];

// Pointers in IFOs (LUs)
	int m_VTSM_LU[MAX_VTS][MAX_MLUS];

// Others (LUs)
	int m_nPGCinLU[MAX_VTS][MAX_MLUS];
	char m_szLANG_LU[MAX_VTS][MAX_MLUS][3];
	int m_nIniPGCinLU[MAX_VTS][MAX_MLUS];
	__int64 m_i64MLUisize[MAX_VTS][MAX_MLUS];
	__int64 m_i64MLUfsize[MAX_VTS][MAX_MLUS];

// Pointers in IFOs (MPGCs)
	int * m_MENU_PGC[MAX_VTS];
	int * m_M_C_PBKT[MAX_VTS];
	int * m_M_C_POST[MAX_VTS];
	int * m_M_PGC_COMM[MAX_VTS];

// Others (Menu PGCs)
	int * m_nLU_MPGC[MAX_VTS];
	int * m_iMAction[MAX_VTS];
	__int64 * m_i64MPGCisize[MAX_VTS];
	__int64 * m_i64MPGCfsize[MAX_VTS];
	int * m_nMCells[MAX_VTS];
	int * m_nMFirstVID[MAX_VTS];
	DWORD * m_dwMDuration[MAX_VTS];
	bool * m_bMCellReUsed[MAX_VTS];
	bool * m_b8MCellComm[MAX_VTS];  // true if there is a comand different of LinkTailPGC
	uchar * m_i8MCellComm[MAX_VTS];
	uchar * m_i8MPreComm[MAX_VTS];
	uchar * m_i8MPostComm[MAX_VTS];
	int * m_iReuseLU[MAX_VTS];
	int * m_nMButtons[MAX_VTS];
	CString * m_csMCellBased[MAX_VTS];
	
	uchar * m_IFrame;

	bool m_bMaxIframeScan[MAX_VTS];

///////////////////////////////////////////
////////// Members for IFO copy processing 
	uchar * m_pIFO_00;        

	__int64 m_i64IFOlen_00;
	int m_nPGCs_00;
	int	m_VTS_PTT_SRPT_00;
	int m_VTS_PGCI_00;
	int m_VTS_TMAPTI_00;
	int m_VTS_C_ADT_00;
	int	m_VTS_VOBU_ADMAP_00;

	int * m_VTS_PGC_00 ;
	int * m_C_PBKT_00 ;
	int * m_C_POST_00 ;
	int * m_C_PROG_00 ;
	int * m_PGC_COMM_00;
	int * m_nCells_00;

	int m_VTSM_C_ADT_00;
	int m_VTSM_PGCI_00;
	int m_VTSM_VOBU_ADMAP_00;
	int m_nMPGCs_00;
	int m_nLUs_00;

	int m_VTSM_LU_00[MAX_MLUS];
	int m_nPGCinLU_00[MAX_MLUS];
	int m_nIniPGCinLU_00[MAX_MLUS];

	int * m_nLU_MPGC_00 ;
	int * m_MENU_PGC_00 ;
	int * m_M_C_PBKT_00 ;
	int * m_M_C_POST_00 ;
	int * m_M_PGC_COMM_00;
	int * m_nMCells_00;
	
//	MAX_PGC
//	MAX_MPGC

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CVobBlankerApp)
	public:
	virtual BOOL InitInstance();
	//}}AFX_VIRTUAL

// Main methods
	virtual void MemoryDeleteAll();
	virtual void MemoryDeleteVTSTitle(int nVTS);
	virtual int  MemoryNewVTSTitle(int nVTS, int nPGCs);
	virtual void MemoryDeleteVTSMenu(int nVTS);
	virtual int  MemoryNewVTSMenu(int nVTS, int nPGCs);
	virtual void MemoryDeleteVTSTitle_00();
	virtual int  MemoryNewVTSTitle_00(int nPGCs);
	virtual void MemoryDeleteVTSMenu_00();
	virtual int  MemoryNewVTSMenu_00(int nPGCs);
	virtual int  ReadIFOs(CString csVideo_TS);
	virtual int  ReadIFO_Copy(int nVTS);
	virtual int  InsertCellInPGC(int nT, int nCell, int iChapterMode);
	virtual int	 FillTitleCellInfo(int nVTS);
	virtual int  FillTitleVobHoles(int nVTS);
	virtual void FillTitleOutputVCIDs(int nVTS);
	virtual int	 FillMenuCellInfo(int nVTS);
	virtual int  FillMenuVobHoles(int nVTS);
	virtual void FillMenuOutputVCIDs(int nVTS);
	virtual int  GetCellTitlesData();
	virtual void GetSubsData();
	virtual void GetAudioData();
	virtual void GetMenuAudioData();
	virtual int  GetMenuData();
	virtual void GetMaxIFrameData(int nVTS);
	virtual int  GetButtonsData();
	virtual void GetMenuIniSize();
	virtual void GetMenuEndSize();
	virtual int  ExitInstance();
	virtual void ProcessMenu(int nVTS, CWnd* pDlg);
	virtual void ProcessVob(int nVTS, CWnd* pDlg);
	virtual void ProcessIfoClearAttrib(int nVTS, int iDomain);
	virtual void ProcessIfoVTSPrepare(int nVTS, CWnd* pDlg);
	virtual void ProcessIfoVTSTitle(int nVTS, CWnd* pDlg);
	virtual void ProcessIfoVTSMenu(int nVTS, CWnd* pDlg);
	virtual void ProcessIfoVTSEnd(int nVTS, CWnd* pDlg);
	virtual void ProcessIfoMGR(CWnd* pDlg);
	virtual void ProcessIfoVTSCopyTables(int nVTS, int iDomain);

	virtual void TitleKeep(int nVTS,int nT);
	virtual void TitleCut(int nVTS,int nT);
	virtual void TitleStrip(int nVTS,int nT);
	virtual void TitleReplace(int nVTS,int nT);
	virtual void TitleBlank(int nVTS,int nT);
	virtual void TitleBasedCell(int nVTS,int nT);

	virtual int  TitleCellGetPos(int nVTS,int nT,int nCell);
	virtual int  TitleCellGetPosByVCID(int nVTS,int VobId,int CellId);
	virtual void TitleCellKeep(int nVTS,int nCell, CWnd* pDlg);
	virtual void TitleCellCut(int nVTS,int nCell, CWnd* pDlg);
	virtual void TitleCellStrip(int nVTS,int nCell, CWnd* pDlg);
	virtual void TitleCellReplace(int nVTS,int nCell, CWnd* pDlg);
	virtual void TitleCellBlank(int nVTS,int nCell, CWnd* pDlg);
	virtual void TitleCellUnref(int nVTS,int nCell, CWnd* pDlg);
	virtual void TitleCellBasedCell(int nVTS,int nCell, CWnd* pDlg);
	virtual void TitleCellStill(int nVTS, int nCell, bool bAudio, __int64 i64Sector, CWnd* pDlg);
	virtual void TitleCellSplit(int nVTS,int nCell,__int64 i64Sector, CWnd* pDlg);
	virtual int  ExtractTitleIFrame(int nVTS, int nCell, int nVobin);
	virtual void TitleCellExplore(int nVTS, int nCell);

	virtual void MenuKeep(int nVTS,int nT);
	virtual void MenuBlank(int nVTS,int nT);
	virtual void MenuDelpbk(int nVTS,int nT);
	virtual void MenuZero(int nVTS,int nT);
	virtual void MenuReuse(int nVTS,int nT);
	virtual void MenuBasedCell(int nVTS,int nT);
	virtual void MenuStill(int nVTS,int nT,bool bAudio);

	virtual int  MenuCellGetPos(int nVTS,int nT,int nCell);
	virtual int  MenuCellGetPosByVCID(int nVTS,int VobId,int CellId);
	virtual void MenuCellKeep (int nVTS, int nCell, CWnd* pDlg);
	virtual void MenuCellBlank(int nVTS,int nCell, CWnd* pDlg);
	virtual void MenuCellUnref(int nVTS,int nCell, CWnd* pDlg);
	virtual void MenuCellBasedCell(int nVTS,int nCell, CWnd* pDlg);
	virtual void MenuCellStill(int nVTS, int nCell, bool bAudio, __int64 i64Sector, CWnd* pDlg);
	virtual void MenuCellCut(int nVTS,int nCell, CWnd* pDlg);
	virtual int  ExtractMenuIFrame(int nVTS, int nCell, __int64 i64Sector);
	virtual int  ExtractExternalIFrame(__int64 i64Sector);

	virtual void WritePack(uchar* buffer,int nVTS);
	virtual void DecodeSubsCommands(uchar* buffer, int nbytes, int nIndexOffset, int * nStartTics, int * nStopTics);
	virtual bool LoadProject(CString FilePath);
	virtual bool SaveProject(CString FilePath);
	virtual void SettingsClear();
	virtual void SettingsSave();

	virtual int  AdjustSectors(CString csPath);


//Aux methods
	virtual void CalculateCutSize(int nVTS, int nT);
	virtual void UpdateVideoAttr(int nVTS);
	virtual void UpdateAudioAttr(int nVTS, int nA);
	virtual void LogEnd();
	virtual void OutputBlankCell(int nVTS,int VobId,int CellId);
	virtual void UpdateProgress( CWnd* pDlg, int nPerc, bool bTotal);
	virtual void UpdateProgressCell( CWnd* pDlg, int nPerc);
	virtual int  CellVID(int nVTS,int nT,int nCell); 
	virtual int  CellCID(int nVTS,int nT,int nCell);
	virtual int  CellMVID(int nVTS,int nT,int nCell); 
	virtual int  CellMCID(int nVTS,int nT,int nCell);
	virtual	bool IsReused(int iDomain, int nVTS,int nT,int nCell);
	virtual int  ChangePostIntoPre(int iDomain, int nVTS, int nT);
	virtual void MyErrorLog_Box(LPCTSTR text, COLORREF myColor=RED);
	virtual void MyLog(LPCTSTR text, COLORREF myColor=BLUE);
	virtual void ClearPartialProgress();
	virtual BOOL GetInfoReplacingIFO(CString csPath,  int * nPGCs,  int * nCells, uchar * uVTSAttr, uchar * uPalette, uchar * uStatus);
	virtual BOOL CVobBlankerApp::GetIFOVTSAttr(CString csPath, uchar * uVTSAttr);
	virtual int  GetMenuNVobId(int nVTS);
	virtual int  GetMenuMaxVobId(int nVTS);
	virtual int  GetTitleNVobId(int nVTS);
	virtual int  GetTitleMaxVobId(int nVTS);


//methods called from Streams attrib and Strip dlg 
	virtual uchar ST_GetAudioStatus(int nVTS, int nT, int nA);
	virtual void  ST_GetAudioDelayAndRate(int nVTS, int nT, int nA, int * iDelay, int * iRate);

//methods related with TMAPTI
	virtual void ProcessTmapti(int nT);
	virtual int  Findidxlba (int sec, int nT, int * discontinuity);

//methods called from Preview dlg 
	virtual	__int64 PR_CellIniSector(int m_iDomain,int nVTS, int nT, int nCell);
	virtual __int64 PR_CellSectors(int iDomain, int nVTS, int nT, int nCell);
	virtual __int64 PR_LocateNavSector(int m_iDomain, int nVTS, int iVID, int iCID, __int64 i64sector, bool iNext);
	virtual int     PR_IsClosedGOP(int iDomain, int nVTS,int nT,int nCell, int iSector);
	virtual int     PR_AreOrphanSubsInVOBU();

//methods related with Cells dlg 
	virtual void GetCellInfo(int iDomain, int nVTS,int nT,int nCell, 
			     int * VobId, int * CellId, DWORD * dwDuration,__int64 * i64Size,bool * bReused, uchar * CellCat0, int * nButtons);
	virtual void ExtractCell(int iDomain,int nVTS,int nT, int nCell, CWnd* pDlg);
	virtual __int64 CalculateCellBasedSize(int nVTS, int nT);
	virtual __int64 CalculateMenuCellBasedSize(int nVTS, int nT);
	virtual int GetProgram(int iDomain, int nVTS, int nT, int nCell);
	virtual int GetChapter(int nVTS, int nT, int nCell);
	virtual __int64 CalculateStillMenuCellSize(int nVTS,int nT, int nCell, bool bAudio, __int64 i64Sector);
    virtual __int64 CalculateStillTitleCellSize(int nVTS,int nT, int nCell,  bool bAudio, __int64 i64Sector);

// methods related with pointer adjustments
	virtual void FV_FixVob(int n, CWnd* pDlg);
	virtual void FV_FixMenu(int n, CWnd* pDlg);
	virtual void FV_FixNavPack(int n);
	virtual int  FV_FindVobu(int pts,int l,int h);
	virtual unsigned int FV_GetSect(int curvobnum,int jumpvobnum,int skip,unsigned notfound);
	virtual int  FV_FindNextVideo(int cur, int dir);
	virtual __int64 FV_FindAudSect(int aind,int pts0,int pts1);
	virtual __int64 FV_FindSubSect(int sind,int pts0,int pts1);

// methods related with VOB Scan
	virtual int ReadTitleVOBU(int nVTS, int iSector);
	virtual int GetVOBUSector(int nVTS, int nCell, int nVOBU);
	virtual int GetNVOBUs(int nVTS);
	virtual int RunScanVobs(CWnd* pDlg, int nVTS, int nCell);
	virtual int FullScan(CWnd* pDlg, int iDomain, int nVTS);
	virtual void UpdateProgressFullScan(CWnd* pDlg, int iDomain, int nVTS, int nPerc);

// Implementation

	//{{AFX_MSG(CVobBlankerApp)
		// NOTE - the ClassWizard will add and remove member functions here.
		//    DO NOT EDIT what you see in these blocks of generated code !
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};


/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_VOBBLANKER_H__D9C5F094_96B1_4541_8EB0_320F4C91A546__INCLUDED_)
