// VobBlanker.cpp : Defines the class behaviors for the application.
//

#include "stdafx.h"
#include "direct.h"
#include "sys/types.h"
#include "sys/stat.h"
#include "io.h"
#include "Winbase.h"
#include "ToolTipDialog.h"
#include "VobBlanker.h"
#include "VobBlankerDlg.h"
#include "LogDlg.h"
#include "InfoDlg.h"
#include "CellsDlg.h"
#include "FullScanDlg.h"
#include "Externs.h"


#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif



/////////////////////////////////////////////////////////////////////////////
// CVobBlankerApp

BEGIN_MESSAGE_MAP(CVobBlankerApp, CWinApp)
	//{{AFX_MSG_MAP(CVobBlankerApp)
		// NOTE - the ClassWizard will add and remove mapping macros here.
		//    DO NOT EDIT what you see in these blocks of generated code!
	//}}AFX_MSG
	ON_COMMAND(ID_HELP, CWinApp::OnHelp)
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CVobBlankerApp construction

CVobBlankerApp::CVobBlankerApp()
{
	// TODO: add construction code here,
	// Place all significant initialization in InitInstance
}

/////////////////////////////////////////////////////////////////////////////
// The one and only CVobBlankerApp object

CVobBlankerApp theApp;

void CVobBlankerApp::MyErrorLog_Box(LPCTSTR text, COLORREF myColor)
{
	if (theApp.m_pLog) ((CLogDlg *)(theApp.m_pLog))->LogLine(text, myColor);
	MyErrorBox(text);
	theApp.m_nErrors++;
}

void CVobBlankerApp::MyLog(LPCTSTR text,  COLORREF myColor)
{
	if (theApp.m_pLog) ((CLogDlg *)(theApp.m_pLog))->LogLine(text, myColor);
}
/////////////////////////////////////////////////////////////////////////////
// CVobBlankerApp initialization

BOOL CVobBlankerApp::InitInstance()
{
	AfxEnableControlContainer();

	// Standard initialization
	// If you are not using these features and wish to reduce the size
	//  of your final executable, you should remove from the following
	//  the specific initialization routines you do not need.

#ifdef _AFXDLL
	Enable3dControls();			// Call this when using MFC in a shared DLL
#else
	Enable3dControlsStatic();	// Call this when linking to MFC statically
#endif

	char szPath[_MAX_PATH];
	CString csAux;


	for (int i=0; i<MAX_VTS; i++)
	{
		m_pIFO[i]=NULL;
		m_nPGCs[i]=0;
		m_nMPGCs[i]=0;
	}

	try
	{
		m_ANavinfo.SetSize(10000,5000);

		for (i=0;i<8;i++)
		{
			m_AAudioinfo[i].RemoveAll();
			m_AAudioinfo[i].SetSize(200000,100000);
		}
		for (i=0;i<32;i++)
		{
			m_ASubsinfo[i].RemoveAll();
			m_AAudioinfo[i].SetSize(5000,1000);
		}
	}
	catch (...)
	{
		csAux.Format("Caught exception trying to allocate memory in internal arrays\n" );
		AfxMessageBox(csAux,  MB_OK);
		throw;
	}



	m_bInProcess=false;
	m_bLog=false;
	m_nIFOs=0;
	m_pLog=NULL;
	m_csLoadedProject="";

	SetRegistryKey( "jsoto's tools" );

//	Old Keys deletion
    RegDelnode (HKEY_CURRENT_USER, "Software\\jsoto's tools\\VobBlanker\\Checkboxes");

/*		CheckFolder CheckTitle CheckMenu
		CheckVobPuops CheckIfoPuops
		CheckFixPointers 
		CheckPostPre
		CheckPostPreForced
		CheckAttrMenu CheckAttrTitle
		CheckNextTitle CheckPrevMenu
		CheckPrevTitle CheckNextMenu

*/

	GetModuleFileName( NULL, szPath , _MAX_PATH);
	m_csPath.Format(_T("%s"),szPath);
	m_csPath=m_csPath.Left(m_csPath.ReverseFind('\\'));

	WriteProfileString("General",   "VobBlankerVersion" , VB_VERSION );

	m_bCheckFolder=		GetProfileInt("General", "CheckFolder" ,FALSE);
	m_bCheckTitle=		GetProfileInt("General", "CheckTitle" ,TRUE);
	m_bCheckMenu=		GetProfileInt("General", "CheckMenu" ,TRUE);

	m_bCheckVobPuops=	GetProfileInt("General", "CheckVobPuops" ,TRUE);
	m_bCheckIfoPuops=	GetProfileInt("General", "CheckIfoPuops" ,TRUE);
	m_bCheckFixTitlePointers=GetProfileInt("FixVOBPointers", "CheckFixTitlePointers" ,FALSE);
	m_bCheckFixMenuPointers=GetProfileInt("FixVOBPointers", "CheckFixMenuPointers" ,FALSE);

	m_bCheckPostPre=	GetProfileInt("PGC options", "CheckPostPre" ,TRUE);
	m_bCheckPostPreForced=GetProfileInt("PGC options", "CheckPostPreForced" ,FALSE);

	m_bCheckElapsed=	GetProfileInt("Replace", "CheckElapsed" ,FALSE);
	m_bCheckFixVobsReplacing=	GetProfileInt("Replace", "CheckFixVobsReplacing" ,FALSE);
	m_bCheckCopyPalette=	GetProfileInt("Replace", "CheckCopyPalette" ,FALSE);
	m_bCheckCopyAttrib=	GetProfileInt("Replace", "CheckCopyAttrib" ,FALSE);
	m_bCheckCopyStatus=	GetProfileInt("Replace", "CheckCopyStatus" ,FALSE);
	m_bCheckSubsAR=	    GetProfileInt("Replace", "CheckSubsAR" ,TRUE);
	
	m_bCheckAutoScan=	GetProfileInt("ScanVOBUs", "CheckAutoScan" ,FALSE);
	m_iScanNVOBUs=		GetProfileInt("ScanVOBUs", "ScanNVOBUs" ,4);

	m_bCheckDisTinyPrev=GetProfileInt("Preview", "CheckDisTinyPrev" ,FALSE);
// This is the bool to be used. The one read at startup
	m_bInitDisTinyPrev= m_bCheckDisTinyPrev;
	m_bCheckNoOverlay=	GetProfileInt("Preview", "CheckNoOverlay" ,FALSE);
	m_bCheckAutoPlay=	GetProfileInt("Preview", "CheckAutoPlay" ,FALSE);
	m_bCheckAutoPlayTiny=	GetProfileInt("Preview", "CheckAutoPlayTiny" ,TRUE);
	m_bCheckTinyGoto10=	GetProfileInt("Preview", "CheckTinyGoto10" ,TRUE);
	m_bCheckTinyMenus=	GetProfileInt("Preview", "CheckTinyMenus" ,TRUE);

	m_bCheckBlankNoB=	GetProfileInt("Motion2Still", "CheckBlankNoB" ,TRUE);
	m_iIFrameMode=		GetProfileInt("Motion2Still", "IFrameMode" ,1);
	m_iIMaxStill=		GetProfileInt("Motion2Still", "MaxStillTime" ,4);
	m_iIMinStill=		GetProfileInt("Motion2Still", "MinStillTime" ,9);
	m_bCheckOneSecStill=GetProfileInt("Motion2Still", "CheckOneSecStill",TRUE);

	m_bCheckAttrMenu=	GetProfileInt("PGC options", "CheckAttrMenu" ,TRUE);
	m_bCheckAttrTitle=	GetProfileInt("PGC options", "CheckAttrTitle" ,FALSE);
	m_bCheckNextMenu=	GetProfileInt("PGC options", "CheckNextMenu" ,TRUE);
	m_bCheckNextTitle=	GetProfileInt("PGC options", "CheckNextTitle" ,TRUE);
	m_bCheckPrevMenu=	GetProfileInt("PGC options", "CheckPrevMenu" ,TRUE);
	m_bCheckPrevTitle=	GetProfileInt("PGC options", "CheckPrevTitle" ,TRUE);
	m_bCheckVobFill=	GetProfileInt("VobLayout", "CheckVobFill" ,FALSE);
	m_bCheckVobOrder=	GetProfileInt("VobLayout", "CheckVobOrder" ,FALSE);
	m_bCheckVobMUnref=	GetProfileInt("VobLayout", "CheckVobMUnref" ,FALSE);
	m_bCheckVobLUnref=	GetProfileInt("VobLayout", "CheckVobLUnref" ,FALSE);
	m_bCheckVobRenumber=GetProfileInt("VobLayout", "CheckVobRenumber" ,TRUE);
	m_bCheckClockDisc=	GetProfileInt("VobLayout", "CheckClockDisc" ,TRUE);

	m_bCheckBckMul=		GetProfileInt("Backup", "CheckBckMul" ,FALSE);
	m_bCheckBckVts=		GetProfileInt("Backup", "CheckBckVts" ,FALSE);

	m_csWorkingPath=	GetProfileString("Paths", "WorkingFolder" ,"");
	m_csMuxManPath=		GetProfileString("Paths", "MuxManPath" ,"");

	m_csOutputPath=		GetProfileString("Paths", "OutputFolder" ,"");
	if (m_csOutputPath != "" &&  _access(m_csOutputPath + "\\" , 06 ) !=0)
	{
		m_csOutputPath="";
		WriteProfileString("Paths",   "OutputFolder", "");
	}

	AfxInitRichEdit();


 	CVobBlankerDlg dlg;
	m_pMainWnd = &dlg;
	int nResponse = dlg.DoModal();
	if (nResponse == IDOK)
	{
		// TODO: Place code here to handle when the dialog is
		//  dismissed with OK
	}
	else if (nResponse == IDCANCEL)
	{
		// TODO: Place code here to handle when the dialog is
		//  dismissed with Cancel
	}

	// Since the dialog has been closed, return FALSE so that we exit the
	//  application, rather than start the application's message pump.
	return FALSE;
}

void CVobBlankerApp::ClearPartialProgress()
{
	((CVobBlankerDlg *)m_pMainWnd)->m_csProgress= "Waiting..";
	((CVobBlankerDlg *)m_pMainWnd)->m_csPcProgress="";
	((CVobBlankerDlg *)m_pMainWnd)->m_CProgress.SetPos(0);
	((CVobBlankerDlg *)m_pMainWnd)->UpdateData(FALSE);
}

int CVobBlankerApp::ReadIFO_Copy(int nVTS)
{
	int k;
	int nLU,nAbsPGC,nPGC;
	CString csAux;


	if (m_nPGCs_00) MemoryDeleteVTSTitle_00(); m_nPGCs_00=0;
	if (m_nMPGCs_00) MemoryDeleteVTSMenu_00(); m_nMPGCs_00=0;

// Fill Titles data	
	if (nVTS!=0)
	{
		m_VTS_PTT_SRPT_00=	2048*GetNbytes(4,&m_pIFO_00[0xC8]);
		m_VTS_PGCI_00=		2048*GetNbytes(4,&m_pIFO_00[0xCC]);
		m_VTS_C_ADT_00=		2048*GetNbytes(4,&m_pIFO_00[0xE0]);
		m_VTS_VOBU_ADMAP_00=2048*GetNbytes(4,&m_pIFO_00[0xE4]);
		m_VTS_TMAPTI_00=	2048*GetNbytes(4,&m_pIFO_00[0xD4]);
		m_nPGCs_00=			GetNbytes(2,&m_pIFO_00[m_VTS_PGCI_00]);
	}
	else
	{
		m_VTS_PTT_SRPT_00=	0;
		m_VTS_PGCI_00=		0;
		m_VTS_C_ADT_00=		0;
		m_VTS_VOBU_ADMAP_00=0;
		m_VTS_TMAPTI_00=	0;
		m_nPGCs_00=			0;
	}
	if (m_nPGCs_00)
		if (!MemoryNewVTSTitle_00(m_nPGCs_00))
		{
			MyErrorBox("ERROR: Memory allocation failed!");
			return -1;
		}

// Loop PGCs ---> PGC index: "k"
	for (k=0 ; k<m_nPGCs_00 ; k++)
	{

	// locate the PGC
		m_VTS_PGC_00[k]=	GetNbytes(4,&m_pIFO_00[m_VTS_PGCI_00+0x04+(k+1)*8])+m_VTS_PGCI_00;

		m_C_PBKT_00[k]=		GetNbytes(2,&m_pIFO_00[m_VTS_PGC_00[k]+0xE8]);
		if (m_C_PBKT_00[k]!=0  ) m_C_PBKT_00[k]+=m_VTS_PGC_00[k];
		m_C_POST_00[k]=		GetNbytes(2,&m_pIFO_00[m_VTS_PGC_00[k]+0xEA]);
		if (m_C_POST_00[k]!=0  ) m_C_POST_00[k]+=m_VTS_PGC_00[k];
		m_C_PROG_00[k]=		GetNbytes(2,&m_pIFO_00[m_VTS_PGC_00[k]+0xE6]);
		if (m_C_PROG_00[k]!=0  ) m_C_PROG_00[k]+=m_VTS_PGC_00[k];
		m_PGC_COMM_00[k]=	GetNbytes(2,&m_pIFO_00[m_VTS_PGC_00[k]+0xE4]);
		if (m_PGC_COMM_00[k]!=0) m_PGC_COMM_00[k]+=m_VTS_PGC_00[k];

		if (m_nCells[nVTS][k] == 0) 
			m_nCells_00[k]=0;
		else
			m_nCells_00[k]=		m_pIFO_00[m_VTS_PGC_00[k]+3];
		if ((m_C_POST_00[k]==0 || m_C_PBKT_00[k]==0 ) && m_nCells_00[k]!=0)
				// Seems something is wrong so reset the number of cells.....
		{
			m_nCells_00[k]=0;
			csAux.Format(_T("ERROR: There is something wrong in number of cells in Title PGC %02d."),k);
			MyErrorBox (csAux);
			return -1;
		}

	}

////////////////////////	
/////////MENU

	if (nVTS==0)
		m_VTSM_PGCI_00=2048*GetNbytes(4,&m_pIFO_00[0xc8]);
	else
		m_VTSM_PGCI_00=2048*GetNbytes(4,&m_pIFO_00[0xD0]);
	m_VTSM_C_ADT_00=2048*GetNbytes(4,&m_pIFO_00[0xD8]);
	m_VTSM_VOBU_ADMAP_00=2048*GetNbytes(4,&m_pIFO_00[0xDC]);

// Fill LU data
	if (m_VTSM_PGCI_00==0)
		m_nLUs_00=0;
	else
		m_nLUs_00=GetNbytes(2,&m_pIFO_00[m_VTSM_PGCI_00]);

	m_nMPGCs_00=0;
	for (nLU=0; nLU <m_nLUs_00; nLU++)
	{
		m_VTSM_LU_00[nLU]=   GetNbytes(4,&m_pIFO_00[m_VTSM_PGCI_00+0x04+(nLU+1)*8])+m_VTSM_PGCI_00;
		m_nPGCinLU_00[nLU]=  GetNbytes(2,&m_pIFO_00[m_VTSM_LU_00[nLU]]);
		m_nIniPGCinLU_00[nLU]= m_nMPGCs_00;
		m_nMPGCs_00+=m_nPGCinLU_00[nLU];
	} // For LUs

	if (m_nMPGCs_00)
		if (!MemoryNewVTSMenu_00 (m_nMPGCs_00 ))
		{
			MyErrorBox("ERROR: Memory allocation failed!");
			return -1;
		}
		for (nLU=0; nLU <m_nLUs_00; nLU++)
	{
		for (nPGC=0; nPGC < m_nPGCinLU_00[nLU]; nPGC++)
		{
			nAbsPGC=nPGC+m_nIniPGCinLU_00[nLU];
			m_nLU_MPGC_00[nAbsPGC]=nLU;
		    m_MENU_PGC_00[nAbsPGC]= GetNbytes(4,&m_pIFO_00[m_VTSM_LU_00[nLU]+0x04+(nPGC+1)*8])+m_VTSM_LU_00[nLU];
			m_M_C_PBKT_00[nAbsPGC]  =GetNbytes(2,&m_pIFO_00[m_MENU_PGC_00[nAbsPGC]+0xE8]);
			if (m_M_C_PBKT_00[nAbsPGC] !=0) m_M_C_PBKT_00[nAbsPGC] += m_MENU_PGC_00[nAbsPGC];
			m_M_C_POST_00[nAbsPGC]  =GetNbytes(2,&m_pIFO_00[m_MENU_PGC_00[nAbsPGC]+0xEA]);
			if (m_M_C_POST_00[nAbsPGC] !=0) m_M_C_POST_00[nAbsPGC] +=m_MENU_PGC_00[nAbsPGC];
				m_M_PGC_COMM_00[nAbsPGC]=GetNbytes(2,&m_pIFO_00[m_MENU_PGC_00[nAbsPGC]+0xE4]);
			if (m_M_PGC_COMM_00[nAbsPGC] !=0) m_M_PGC_COMM_00[nAbsPGC] +=m_MENU_PGC_00[nAbsPGC];

			if (m_nMCells[nVTS][nAbsPGC] == 0) 
				m_nMCells_00[nAbsPGC]=0;
			else
				m_nMCells_00[nAbsPGC]=m_pIFO_00[m_MENU_PGC_00[nAbsPGC]+3];

			if ( (m_M_C_PBKT_00[nAbsPGC]==0 || m_M_C_POST_00[nAbsPGC] ==0) &&  m_nMCells_00[nAbsPGC]!=0)
				// There is something wrong...
			{
				m_nMCells_00[nAbsPGC]=0;
				csAux.Format(_T("ERROR: There is something wrong in number of cells in Menu PGC %02d."),nAbsPGC);
				MyErrorBox (csAux);
				return -1;
			}
		} // For PGCs
	} // For LUs

// Inisectors

	if (m_VTSM_C_ADT_00==0)
//   VTSM_C_ADT table did not exist;
		m_nIniMADTSectors=0;
	else
	{
		m_nIniMADTSectors=GetNbytes(4,&m_pIFO_00[m_VTSM_C_ADT_00+4]);
		m_nIniMADTSectors=m_nIniMADTSectors/2048+1;
	}

	if (m_VTSM_VOBU_ADMAP_00==0)
//   VTSM_VOBU_ADMAP table did not exist;
		m_nIniMADMAPSectors=0;
	else
	{
		m_nIniMADMAPSectors=GetNbytes(4,&m_pIFO_00[m_VTSM_VOBU_ADMAP_00]);
		m_nIniMADMAPSectors=m_nIniMADMAPSectors/2048+1;
	}
	if (m_VTS_C_ADT_00==0)
//   VTS_C_ADT table did not exist;
		m_nIniADTSectors=0;
	else
	{
		m_nIniADTSectors=GetNbytes(4,&m_pIFO_00[m_VTS_C_ADT_00+4]);
		m_nIniADTSectors=m_nIniADTSectors/2048+1;
	}

	if (m_VTS_VOBU_ADMAP_00==0)
//   VTSM_VOBU_ADMAP table did not exist;
		m_nIniADMAPSectors=0;
	else
	{
		m_nIniADMAPSectors=GetNbytes(4,&m_pIFO_00[m_VTS_VOBU_ADMAP_00]);
		m_nIniADMAPSectors=m_nIniADMAPSectors/2048+1;
	}

	if (m_VTSM_C_ADT_00!=0)  
		m_nStartCellsTable=m_VTSM_C_ADT_00;
	else if (m_VTSM_VOBU_ADMAP_00!=0)
		m_nStartCellsTable=m_VTSM_VOBU_ADMAP_00;
	else if (nVTS!=0 && m_VTS_C_ADT_00!=0)
		m_nStartCellsTable=m_VTS_C_ADT_00;
	else if (nVTS!=0 && m_VTS_VOBU_ADMAP_00!=0)
		m_nStartCellsTable=m_VTS_VOBU_ADMAP_00;
	else
		m_nStartCellsTable= (int)((m_i64IFOlen_00/2048)*2048);

	return 0;
}


int CVobBlankerApp::ReadIFOs(CString csVideo_TS)
{
	__int64 i;
	FILE *in;
	int j,k,l;
	int kk,ll;
	int n;
	CString csAux,csAux2;
	struct  _stati64 statbuf;
	int VIDa, same;
	int nADTCells;
	__int64 i64Newlen;
	int nIFOs;
	int iret;
	int myAngle, iCat0, nC;

	((CVobBlankerDlg *)m_pMainWnd)->m_csProgress= "Reading IFOs..";
	UpdateProgress(m_pMainWnd,0,false);
	m_pMainWnd->UpdateData(FALSE);

	MemoryDeleteAll();
	m_bZMenu=false;
	m_bBadOffset=false;

//	csVideo_TS.MakeUpper();
	m_csVTSname[0]="VIDEO_TS.VOB";
	m_csInputPath=csVideo_TS.Left(csVideo_TS.ReverseFind('\\'));

	if (_stati64 ( csVideo_TS, &statbuf)==0)
		i64Newlen= statbuf.st_size;
	else
	{
		MyErrorLog_Box("Error: Unable to stat " + csVideo_TS );
		return false;
	}

	if (i64Newlen > MAXLENGTH )
	{
		csAux2.Format(_T(". Size %I64d"),i64Newlen);
		MyErrorBox ("ERROR: Ifo file too big"+ csAux2+"\r\n"+ csVideo_TS);
		return -1;
	}

	i64Newlen=i64Newlen+MAX_NEWIFOSECTORS_INITIAL*2048; // Allow MAX_NEWSECTORS additional sectors

	m_pIFO[0]= new uchar[(int)i64Newlen];

// Read VIDEO_TS.IFO
	if ((in=fopen(csVideo_TS,"rb"))==NULL)
	{
		MyErrorBox ("Unable to open input file: "+csVideo_TS);
		return -1;
	}

	for (i=0;!feof(in) && i< i64Newlen ;i++)
		m_pIFO[0][i]=fgetc(in);
	m_i64IFOlen[0]=i-1;
	
	if (in!=NULL) fclose(in);

	m_nIFOs=m_pIFO[0][0x3E]*256+m_pIFO[0][0x3F];

// Check existence of nIFOs
	for (j=1; j<MAX_VTS ;j++)
	{
		csAux2.Format(_T("VTS_%02d_0.IFO"), j);
		csAux=m_csInputPath+'\\'+csAux2;

		if (_access ( csAux, 0)== -1)
		{
			nIFOs=j-1;
			j=MAX_VTS;
		}

	}

// In CLI Mode assume the IFOs in folder silently..
	if (m_nIFOs > nIFOs && !m_bCLIMode)
	{
		csAux.Format(_T("ERROR: Number of IFOs mismatch: There are %d IFO files but %d are referenced in VIEO_TS.IFO\nDo you want to continue (VobBlanker will use the actual number of files)?"),
			nIFOs, m_nIFOs);
		iret=AfxMessageBox (csAux, MB_YESNO|MB_ICONQUESTION );
		if (iret!=IDYES) return -1;
	}
	m_nIFOs=nIFOs;
	Put2bytes (nIFOs, &m_pIFO[0][0x3E]);


	if ( (m_nIFOs+1) > MAX_VTS)
	{
		csAux.Format(_T("ERROR: Max VTS limit (%d) has been reached."),MAX_VTS-1);
		MyErrorBox (csAux);
		return -1;
	}

	m_TT_SRPT=2048*GetNbytes(4,&m_pIFO[0][0xC4]);
	m_nTotalTitles=GetNbytes(2,&m_pIFO[0][m_TT_SRPT]);
	m_iActionVTS[0]=PROCESS;

	m_ACell_replace.RemoveAll();
	m_ACellStillinfo.RemoveAll();
	m_ACellSplitinfo.RemoveAll();
	m_ACellCutinfo.RemoveAll();

	m_i64VTSisize[0]=m_i64VOBsize[0][0]=0;
	m_bZeroMenu[0]=false;
	csAux=m_csInputPath+'\\'+"VIDEO_TS.VOB";
	if (_stati64 ( csAux, &statbuf)==0)
	{
		m_i64VTSisize[0]= m_i64VOBsize[0][0]=statbuf.st_size;
		// zero bytes menu
		if (m_i64VTSisize[0]==0)
		{ 
			m_bZeroMenu[0]=true;
			m_bZMenu=true;
		}
	}
	m_i64VTSfsize[0]=m_i64Mfsize[0]=m_i64Misize[0]=m_i64VTSisize[0];

	m_bAngleAll=m_bILVAll=false;
// Read all VTS IFOs ---> VTS index:"j"
	SetCursor(AfxGetApp()->LoadStandardCursor(IDC_WAIT));
	for (j=1; j<m_nIFOs+1 ;j++)
	{
		UpdateProgress(m_pMainWnd,(j-1)*100/m_nIFOs,false);

		m_csVTSname[j].Format(_T("VTS_%02d_*.VOB"), j);
		csAux2.Format(_T("VTS_%02d_0.IFO"), j);
		csAux=m_csInputPath+'\\'+csAux2;

		if (_stati64 ( csAux, &statbuf)==0)
			i64Newlen= statbuf.st_size;
		else
		{
			MyErrorLog_Box("Error: Unable to stat " + csAux);
			return false;
		}

		if (i64Newlen > MAXLENGTH )
		{
			SetCursor(AfxGetApp()->LoadStandardCursor(IDC_ARROW));
			csAux2.Format(_T(". Size %I64d"),i64Newlen);
			MyErrorBox ("ERROR: Ifo file too big"+ csAux2+"\r\n"+ csAux);
			return -1;
		}
		i64Newlen=i64Newlen+MAX_NEWIFOSECTORS_INITIAL*2048; // Allow MAX_NEWSECTORS additional sectors

		m_pIFO[j]= new uchar[(int)i64Newlen];

		// Read IFO
		if ((in=fopen(csAux,"rb"))==NULL)
		{
			SetCursor(AfxGetApp()->LoadStandardCursor(IDC_ARROW));
			MyErrorBox ("Unable to open input file: "+csAux);
			return -1;
		}
		for (i=0;!feof(in) && i< i64Newlen ;i++)
			m_pIFO[j][i]=fgetc(in);
		m_i64IFOlen[j]=i-1;
	
		if (in!=NULL) fclose(in);

		m_i64VTSisize[j]=m_i64Misize[j]=m_i64VOBsize[j][0]=0;
		m_bZeroMenu[j]=false;
		csAux2.Format(_T("VTS_%02d_0.VOB"), j);
		csAux=m_csInputPath+'\\'+csAux2;
		if (_stati64 ( csAux, &statbuf)==0)
		{
			m_i64VOBsize[j][0]=m_i64VTSisize[j]=m_i64Misize[j]= statbuf.st_size;
			if (m_i64VTSisize[j]==0) 
			{
				m_bZeroMenu[j]=true;
				m_bZMenu=true;
			}
		}
		m_i64Mfsize[j]=m_i64Misize[j];

		for (k=1; k<11; k++)
			m_i64VOBsize[j][k]=0;

		for (k=1; k<10; k++)
		{
			csAux2.Format(_T("VTS_%02d_%d.VOB"), j,k);
			csAux=m_csInputPath+'\\'+csAux2;
			if (_stati64 ( csAux, &statbuf)==0)
			{
				m_i64VOBsize[j][k]=statbuf.st_size;
				m_i64VTSisize[j]+= m_i64VOBsize[j][k];
			}
			else 
				if (k!=0) k=20;
		}
		m_i64VTSfsize[j]=m_i64VTSisize[j];
		for (k=1; k<10; k++)
			m_i64VOBsize[j][10]+=m_i64VOBsize[j][k];


// Fill Titles data	
		m_VTS_PTT_SRPT[j]=2048*GetNbytes(4,&m_pIFO[j][0xC8]);
		if ( m_VTS_PTT_SRPT[j] >= m_i64IFOlen[j])
		{
			m_VTS_PTT_SRPT[j]=0;
			Put4bytes(0,&m_pIFO[j][0xC8]);
			m_bBadOffset=true;
		}

		m_VTS_PGCI[j]=2048*GetNbytes(4,&m_pIFO[j][0xCC]);
		if ( m_VTS_PGCI[j] >= m_i64IFOlen[j])
		{
			m_VTS_PGCI[j]=0;
			Put4bytes(0,&m_pIFO[j][0xCC]);
			m_bBadOffset=true;
		}
		m_VTS_C_ADT[j]=2048*GetNbytes(4,&m_pIFO[j][0xE0]);
		if ( m_VTS_C_ADT[j] >= m_i64IFOlen[j])
		{
			m_VTS_C_ADT[j]=0;
			Put4bytes(0,&m_pIFO[j][0xE0]);
			m_bBadOffset=true;
		}

		m_VTS_VOBU_ADMAP[j]=2048*GetNbytes(4,&m_pIFO[j][0xE4]);
		if ( m_VTS_VOBU_ADMAP[j] >= m_i64IFOlen[j])
		{
			m_VTS_VOBU_ADMAP[j]=0;
			Put4bytes(0,&m_pIFO[j][0xE4]);
			m_bBadOffset=true;
		}

		m_VTS_TMAPTI[j]=2048*GetNbytes(4,&m_pIFO[j][0xD4]);
		if ( m_VTS_TMAPTI[j] >= m_i64IFOlen[j])
		{
			m_VTS_TMAPTI[j]=0;
			Put4bytes(0,&m_pIFO[j][0xD4]);
			m_bBadOffset=true;
		}

		if (m_VTS_PGCI[j]==0)
			m_nPGCs[j]=0;
		else
			m_nPGCs[j]=GetNbytes(2,&m_pIFO[j][m_VTS_PGCI[j]]);

		if ( m_nPGCs[j] > MAX_PGC)
		{
			csAux.Format(_T("ERROR: Max PGC limit (%d) has been reached."),MAX_PGC);
			MyErrorBox (csAux);
			return -1;
		}
		if (m_nPGCs[j])
			if (!MemoryNewVTSTitle(j, m_nPGCs[j] ))
			{
				MyErrorBox("ERROR: Memory allocation failed!");
				return -1;
			}

		m_iVideoAttr[j]=m_pIFO[j][0x200]*256+m_pIFO[j][0x201];
		m_iVideoAttrBK[j]=m_iVideoAttr[j];

		m_bAngleVTS[j]=false;

// Compute m_nTVOBIDs
		same=0;
		if (m_VTS_C_ADT[j]==0)
			nADTCells=0;
		else
			nADTCells=(GetNbytes(4,&m_pIFO[j][m_VTS_C_ADT[j]+4])-7)/12;

		for( kk=0, m_nTVOBIDs[j]=m_nTMaxVOBIDs[j]=0; kk< nADTCells ; kk++)
		{
			VIDa=GetNbytes(2, &m_pIFO[j][m_VTS_C_ADT[j]+8+12*kk]);
			for (ll=0,same=0; ll< kk; ll++)
			{
				if (VIDa==(int)GetNbytes(2, &m_pIFO[j][m_VTS_C_ADT[j]+8+12*ll]))
				same=1;
			}
			if (same==0) m_nTVOBIDs[j]++;
			if (VIDa > m_nTMaxVOBIDs[j]) m_nTMaxVOBIDs[j]=VIDa;
		}

// Loop PGCs ---> VTS index:"j"; PGC index: "k"
		for (k=0 ; k<m_nPGCs[j] ; k++)
		{
			m_nChaptersAdded[j][k]=0;
			m_CutInfo[j][k].iIniCell=-1;
			m_CutInfo[j][k].iIniLba=-1;
			m_CutInfo[j][k].iEndCell=-1;
			m_CutInfo[j][k].iEndLba=-1;
			m_CutInfo[j][k].iAction=0;
			m_CutInfo[j][k].iIniIsClosed=-1;
			m_CutInfo[j][k].iEndIsClosed=-1;

			m_nTitleInVTS[j][k]=m_pIFO[j][m_VTS_PGCI[j]+0x08+k*8] & 0x7f;
			if (m_pIFO[j][m_VTS_PGCI[j]+0x08+k*8] & 0x80 )
				m_bEntry[j][k]=true;
			else
				m_bEntry[j][k]=false;

			m_nTitle[j][k]=0;
			m_nAngles[j][k]=0;

			for (l=0; l<m_nTotalTitles;l++)
			{
				if (m_pIFO[0][m_TT_SRPT+8+12*l+6]==(UINT)j &&
					m_pIFO[0][m_TT_SRPT+8+12*l+7]== (int)m_nTitleInVTS[j][k])
				{
					m_nTitle[j][k]=l+1;
//					m_nAngles[j][k]= m_pIFO[0][m_TT_SRPT+8+12*l+1];
				}
			}

			m_iAction[j][k]=KEEP;

		// locate the PGC
			m_VTS_PGC[j][k]=GetNbytes(4,&m_pIFO[j][m_VTS_PGCI[j]+0x04+(k+1)*8])+m_VTS_PGCI[j];
			m_dwDuration[j][k]=(DWORD)GetNbytes(4,&m_pIFO[j][m_VTS_PGC[j][k]+4]);
			m_dwDurationOwn[j][k]=0;

			m_C_PBKT[j][k]=GetNbytes(2,&m_pIFO[j][m_VTS_PGC[j][k]+0xE8]);
			if (m_C_PBKT[j][k]!=0  ) m_C_PBKT[j][k]+=m_VTS_PGC[j][k];

			m_C_POST[j][k]=GetNbytes(2,&m_pIFO[j][m_VTS_PGC[j][k]+0xEA]);
			if (m_C_POST[j][k]!=0  ) m_C_POST[j][k]+=m_VTS_PGC[j][k];

			m_PGC_COMM[j][k]=GetNbytes(2,&m_pIFO[j][m_VTS_PGC[j][k]+0xE4]);
			if (m_PGC_COMM[j][k]!=0) m_PGC_COMM[j][k]+=m_VTS_PGC[j][k];

			m_nCells[j][k]=m_pIFO[j][m_VTS_PGC[j][k]+3];
			if ((m_C_POST[j][k]==0 || m_C_PBKT[j][k]==0 ) && m_nCells[j][k]!=0)
				// Seems something is wrong so reset the number of cells.....
			{
				m_nCells[j][k]=0;
				if ( !m_bCLIMode )
				{
					csAux.Format(_T("ERROR: There is something wrong in number of cells in VTS %02d, Title PGC %02d.\nChanging to zero the number of cells"),j,k);
					MyErrorBox (csAux);
				}
			}
			m_nFirstVID[j][k]=0;
			m_i8CellComm[j][k]=m_i8PreComm[j][k]=m_i8PostComm[j][k]=0;
			if (m_nCells[j][k]!=0)
				m_nFirstVID[j][k]=GetNbytes(2,&m_pIFO[j][m_C_POST[j][k]]);
			if (m_PGC_COMM[j][k]!=0)
			{
				m_i8CellComm[j][k]=GetNbytes(2,&m_pIFO[j][m_PGC_COMM[j][k]+4]);
				m_i8PreComm[j][k]=GetNbytes(2,&m_pIFO[j][m_PGC_COMM[j][k]]);
				m_i8PostComm[j][k]=GetNbytes(2,&m_pIFO[j][m_PGC_COMM[j][k]+2]);
			}

			// Calculate # of angles
			m_nAngles[j][k]=1;
			myAngle=0;
			for (nC=0 ; nC<m_nCells[j][k] ; nC++)
			{
				iCat0=m_pIFO[j][m_C_PBKT[j][k]+nC*24];
				if ( (iCat0 & 0x0F0 ) == 0x50 ) myAngle=0;
				if ( (iCat0 & 0x030 ) == 0x00 ) myAngle=0;
				if ( (iCat0 & 0x030) != 0 )  myAngle++;
				if ( (iCat0 & 0x0F0) == 0x0d0 )
				{
					if (m_nAngles[j][k]==1)
						m_nAngles[j][k]=myAngle;
					else if (m_nAngles[j][k]!=myAngle)
						m_nAngles[j][k]=-1;
				}
			}

// Do a minimal check
			if (m_nAngles[j][k] ==-1 )
			{
				m_nAngles[j][k]=1;
				csAux.Format(_T("ERROR: There is something wrong in number of angles in VTS %02d, Title PGC %02d.\nChanging to one the number of angles"),j,k);
				MyErrorBox (csAux);
			}

			if (m_nAngles[j][k]> 1)
			{
				m_bAngleAll=true;
				m_bAngleVTS[j]=true;
			}	
		} // For PGCs
	}// For VTSs

//////////// CELLS IN TITLES //////////////	
	GetCellTitlesData();

	for (j=1; j<m_nIFOs+1 ;j++)
	{
// Loop PGCs ---> VTS index:"j"; PGC index: "k"
		for (k=0 ; k<m_nPGCs[j] ; k++)
		{
			m_i64Tisize[j][k]=0;
			m_bCellReUsed[j][k]=false;

//			m_bILVU[j][k]=false;
//			m_bILVU is filled in GetCellTitlesData
			m_nTButtons[j][k]=-1;
            m_csCellBased[j][k].Empty();
// Loop Cells ---> VTS index:"j"; PGC index: "k"; Cell index: "l"
			for ( l=0; l< m_nCells[j][k]; l++)
			{
				m_csCellBased[j][k]+='K'; // Keep

				n=TitleCellGetPos( j, k, l);
				if (n <0) 
				{
					MyErrorLog_Box("Error: Cell not found");
					return -1;
				}

				if (IsReused(TITLES,j,k,l))	m_bCellReUsed[j][k]=true;
				else
				{
					m_i64Tisize[j][k]+= m_TitleCells[j][n].i64size;
					m_dwDurationOwn[j][k] = AddDuration (m_dwDurationOwn[j][k],
						               GetNbytes(4,&m_pIFO[j][m_C_PBKT[j][k]+24*l+4]) );
				}
			}
		}
		if (m_bILVVTS[j] || m_bAngleVTS[j] || m_bCheckFolder)
		{
			for (k=0 ; k<m_nPGCs[j] ; k++)
			{
				m_iAction[j][k]=SKIP;
			}
			m_iActionVTS[j]=SKIP;
			m_i64VTSfsize[j]=0;
		}
		else
			m_iActionVTS[j]=PROCESS;
	}
	if (m_bCheckFolder) m_iActionVTS[0]=SKIP;

	GetSubsData();

	ClearPartialProgress();
//// Audio Data
	((CVobBlankerDlg *)m_pMainWnd)->m_csProgress= "Getting Audio Data..";
	UpdateProgress(m_pMainWnd,0,false);
	m_pMainWnd->UpdateData(FALSE);
	GetAudioData();
	ClearPartialProgress();

/// Menu data
	((CVobBlankerDlg *)m_pMainWnd)->m_csProgress= "Getting Menu Data..";
	UpdateProgress(m_pMainWnd,0,false);
	m_pMainWnd->UpdateData(FALSE);

	if ( GetMenuData()!=0 )
	{
		ClearPartialProgress();
		SetCursor(AfxGetApp()->LoadStandardCursor(IDC_ARROW));
		return -1;
	}
	ClearPartialProgress();

// Menu Audio Data
	((CVobBlankerDlg *)m_pMainWnd)->m_csProgress= "Getting Audio Menu Data..";
	UpdateProgress(m_pMainWnd,0,false);
	m_pMainWnd->UpdateData(FALSE);
	GetMenuAudioData();
	ClearPartialProgress();

// Buttons data
	((CVobBlankerDlg *)m_pMainWnd)->m_csProgress= "Getting Buttons Menu Data..";
	UpdateProgress(m_pMainWnd,0,false);
	m_pMainWnd->UpdateData(FALSE);
	GetButtonsData();
	ClearPartialProgress();

// Menu sizes
	((CVobBlankerDlg *)m_pMainWnd)->m_csProgress= "Getting Menu Sizes..";
	m_pMainWnd->UpdateData(FALSE);
	GetMenuIniSize();
	GetMenuEndSize();
	ClearPartialProgress();

	SetCursor(AfxGetApp()->LoadStandardCursor(IDC_ARROW));

	m_bAlreadyLoaded=TRUE;
	return j;
}

int CVobBlankerApp::GetCellTitlesData()
{
	int j,k,l;
	int	nEntries;
	int VIDa, VIDb, CIDa, CIDb;
	int n,nn,nnn;
	int nArray;
	bool bAlready;
	TITLE_CELL_LIST myCell;
	__int64 i64Cellsize, i64IniSecCell,i64EndSecCell;
	CString csAux,csAux2;
	int i,ii;
	bool bIsHigher;
	int nCells, EndADMAPSector;
	__int64 i64IniSec,i64EndSec;
	int nVOBUS, VOBUSector;
	int	nSuspect,nSuspectPointers;
	int i64IniSecCell_PBK,i64EndSecCell_PBK;
	bool bBadCellPointers;

	m_bILVAll=false;
	for (j=1; j<m_nIFOs+1 ;j++)
	{
		m_bILVVTS[j]=false;
		m_TitleCells[j].RemoveAll();

		if (m_VTS_C_ADT[j]==0)
			nEntries=0;
		else
		{
			nEntries=GetNbytes(4,&m_pIFO[j][m_VTS_C_ADT[j]+4]);
			nEntries=(nEntries-7)/12;
		}
		if (nEntries <0 )  nEntries=0;

		for (n=0;n < nEntries ; n++)
		{
			VIDa=GetNbytes(2,&m_pIFO[j][m_VTS_C_ADT[j]+8+12*n]);
			CIDa=m_pIFO[j][m_VTS_C_ADT[j]+8+2+12*n];
			nArray=m_TitleCells[j].GetSize();
			for (nn=0,bAlready=false;nn < nArray  && bAlready==false; nn++)
			{
				VIDb=m_TitleCells[j][nn].VID;
				CIDb=m_TitleCells[j][nn].CID;
				if (VIDa==VIDb && CIDa==CIDb)
				{
					bAlready=true;
					nnn=nn;
				}
			}
			i64IniSecCell=GetNbytes(4,&m_pIFO[j][m_VTS_C_ADT[j]+8+12*n+4]);
			i64EndSecCell=GetNbytes(4,&m_pIFO[j][m_VTS_C_ADT[j]+8+12*n+8]);
			i64Cellsize=(i64EndSecCell-i64IniSecCell+1)*2048;

			if (bAlready)
			{
				if (i64IniSecCell<m_TitleCells[j][nnn].i64IniSecCell)
					 m_TitleCells[j][nnn].i64IniSecCell=i64IniSecCell;
				if (i64EndSecCell>m_TitleCells[j][nnn].i64EndSecCell)
					 m_TitleCells[j][nnn].i64EndSecCell=i64EndSecCell;
				m_TitleCells[j][nnn].i64size+=i64Cellsize;
			}
			else
			{
				myCell.VID=VIDa;
				myCell.CID=CIDa;
				myCell.iPart=0;
				myCell.i64size=i64Cellsize;
				myCell.i64IniSecCell=i64IniSecCell;
				myCell.i64EndSecCell=i64EndSecCell;
				myCell.iMode=UNREF;
				myCell.nButtons=-1;

				ii=nArray;
				if (m_bCheckVobOrder)
				{
					for (i=0,bIsHigher=true; i<nArray && bIsHigher ; i++)
					{
						if (myCell.VID < m_TitleCells[j][i].VID )	   {ii=i; bIsHigher=false;}
						else if (myCell.VID > m_TitleCells[j][i].VID )  bIsHigher=true;
						else
						{
							if (myCell.CID < m_TitleCells[j][i].CID )   {ii=i; bIsHigher=false;}
							else if (myCell.CID > m_TitleCells[j][i].CID )  bIsHigher=true;
						}
					}
				}
				m_TitleCells[j].InsertAt(ii,myCell);
			}
		} // For Entries


// Check ILV flag in IFOs

		for (k=0 ; k<m_nPGCs[j] ; k++)
		{
			m_bILVU[j][k]=false;
			for ( l=0; l< m_nCells[j][k]; l++)
			{
				if (m_pIFO[j][m_C_PBKT[j][k]+24*l] & 0x04 )
				{
					m_bILVAll=true;
					m_bILVVTS[j]=true;
					m_bILVU[j][k]=true;
				}
			}
		}
//////////////////////////////////////////////////////////
/// Review the PGCs: Look for unreferenced cells
		nSuspect=nSuspectPointers=0;
		for (k=0 ; k<m_nPGCs[j] ; k++)
		{
// Loop Cells ---> VTS index:"j"; PGC index: "k"; Cell index: "n"
///////////////////   nn --> Cell index in m_TitleCells[j]
			for ( n=0; n< m_nCells[j][k]; n++)
			{
				i64IniSecCell_PBK=GetNbytes(4,&m_pIFO[j][m_C_PBKT[j][k]+24*n+8]) ;
				i64EndSecCell_PBK=GetNbytes(4,&m_pIFO[j][m_C_PBKT[j][k]+24*n+0x14]) ;
				i64Cellsize=(i64EndSecCell_PBK-i64IniSecCell_PBK+1)*2048;
				nn=TitleCellGetPos( j, k, n);
				if (nn <0) 
				{
					nSuspect++;
/////////////////////////////////////////////////////////////////////////////////
/////////////////////Found a cell not referenced in C_ADT!! Using PGC pointers
					nArray=m_TitleCells[j].GetSize();
					myCell.VID=GetNbytes(2,&m_pIFO[j][m_C_POST[j][k]+n*4]);
					myCell.CID=m_pIFO[j][m_C_POST[j][k]+n*4+3];
					myCell.iPart=0;
					myCell.i64size=i64Cellsize;
					myCell.i64IniSecCell=i64IniSecCell_PBK;
					myCell.i64EndSecCell=i64EndSecCell_PBK;
					myCell.iMode=UNREF;
					myCell.nButtons=-1;

					ii=nArray;
//					if (m_bCheckVobOrder)
//					{
						for (i=0,bIsHigher=true; i<nArray && bIsHigher ; i++)
						{
							if (myCell.VID < m_TitleCells[j][i].VID )	   {ii=i; bIsHigher=false;}
							else if (myCell.VID > m_TitleCells[j][i].VID )  bIsHigher=true;
							else
							{
								if (myCell.CID < m_TitleCells[j][i].CID )   {ii=i; bIsHigher=false;}
								else if (myCell.CID > m_TitleCells[j][i].CID )  bIsHigher=true;
							}
						}
//					}
					m_TitleCells[j].InsertAt(ii,myCell);				
				}
				else
// Check inisectors TODO: Decide what to be used if not match....
				{
					if (i64IniSecCell_PBK != m_TitleCells[j][nn].i64IniSecCell ||
						i64EndSecCell_PBK != m_TitleCells[j][nn].i64EndSecCell)
						nSuspectPointers++;
				}
			}
		}
         	
		if (nSuspect && !m_bCLIFullScan)
		{
			csAux.Format(_T("VTS %02d:  Detected %d cells in PGCs not referenced in C_ADT\nUsing PGC initial and ending pointers...\n\nA FullScan is recommended."),
				j,nSuspect);
			MyInfoBox(csAux);
		}
		if (nSuspectPointers && !m_bCLIFullScan)
		{
			csAux.Format(_T("VTS %02d:  Detected %d cells with pointers mismatch between VTS_C_ADT and PGC_PBK tables\n"),
				j,nSuspectPointers);
			csAux+=_T("Using VTSM_C_ADT initial and ending pointers...\n\n");
			csAux+=_T("This is quite usual in ILV/multiangle VTSs, but VobBlanker does not support them,\nexcept in skip mode.");
			if (m_bILVVTS[j])
				csAux+=_T("\n\nNote: This is an InterLeaVed VTS");
			else
				csAux+=_T("\n\nNote: This is NOT an InterLeaVed VTS");
			MyInfoBox(csAux);
		}

///////////////Check if pointers out of VOB File/////////
		nArray=m_TitleCells[j].GetSize();
		bBadCellPointers=false;
		for ( n=0; n<nArray; n++)
		{
			if (m_TitleCells[j][n].i64IniSecCell <0 ||
				m_TitleCells[j][n].i64IniSecCell >m_i64VOBsize[j][10]/2048)
			{
				m_TitleCells[j][n].i64IniSecCell=0;
				bBadCellPointers=true;
			}

			if (m_TitleCells[j][n].i64EndSecCell <0 ||
				m_TitleCells[j][n].i64EndSecCell >m_i64VOBsize[j][10]/2048)
			{
				m_TitleCells[j][n].i64EndSecCell=m_TitleCells[j][n].i64IniSecCell;
				bBadCellPointers=true;
			}
		}
		if (bBadCellPointers)
			m_bTitleNeedScan[j]=true;
		else
			m_bTitleNeedScan[j]=false;

///////////////Continuing with VOBUs///////////
		if (m_VTS_VOBU_ADMAP[j]==0)
			EndADMAPSector=0;
		else
		{
			EndADMAPSector=GetNbytes(4,&m_pIFO[j][m_VTS_VOBU_ADMAP[j]]);
			EndADMAPSector=((EndADMAPSector+1)/4)-1;
		}

		nCells=m_TitleCells[j].GetSize();

		for (n=0;n<nCells;n++)
		{
			m_TitleCells[j][n].i64IniIFSize=0;
			m_TitleCells[j][n].i64MidIFSize=0;
			m_TitleCells[j][n].i64EndIFSize=0;

			i64IniSec=m_TitleCells[j][n].i64IniSecCell;
			i64EndSec=m_TitleCells[j][n].i64EndSecCell;

			m_TitleCells[j][n].i64MaxButtons=i64IniSec*2048;
			m_TitleCells[j][n].i64IniButtons=i64IniSec*2048;
			m_TitleCells[j][n].i64MidButtons=i64IniSec*2048;
			m_TitleCells[j][n].i64EndButtons=i64IniSec*2048;

			for (i=0,nVOBUS=0; i<EndADMAPSector;i++)
			{
				VOBUSector=GetNbytes(4,&m_pIFO[j][m_VTS_VOBU_ADMAP[j] + 4 +4*i]);
				if ( VOBUSector == i64IniSec ) m_TitleCells[j][n].iIniVOBU=i;
				if ( VOBUSector >= i64IniSec && VOBUSector <= i64EndSec )
					nVOBUS++;
			}
			m_TitleCells[j][n].nVOBUS=nVOBUS;
		}
	} // nVTS

	for (j=1,bBadCellPointers=false; j<m_nIFOs+1 ;j++)
	{
		if (m_bTitleNeedScan[j])
			bBadCellPointers=true;
	}
	if (bBadCellPointers && !m_bCLIFullScan)
	{
		csAux.Format(_T("Detected ini/end cell pointers out of range in TITLES domain\nAffected titlesets are:\n\n"));
		for (i=1; i< m_nIFOs+1 ;i++)
		{
			if (m_bTitleNeedScan[i])
			{
				csAux2.Format(_T("VTS_%02d_0.IFO\n"),i);
				csAux+=csAux2;
			}
		}
		csAux+=(_T("\nA FullScan is required: See Menu->File->FullScan..."));
		MyErrorBox(csAux);
	}

	return 0;
}


//// CODE USED DURING VOB SCAN ////////////
int CVobBlankerApp::GetNVOBUs(int nVTS)
{
	int EndADMAPSector;

	EndADMAPSector=GetNbytes(4,&m_pIFO[nVTS][m_VTS_VOBU_ADMAP[nVTS]]);
	EndADMAPSector=((EndADMAPSector+1)/4)-1;
	return EndADMAPSector;
}

int CVobBlankerApp::GetVOBUSector(int nVTS, int nCell, int nVOBU)
{
	int VOBUSector;
	int i;

	if (nCell > m_TitleCells[nVTS].GetSize()) return -1; 
	if (nVOBU > m_TitleCells[nVTS][nCell].nVOBUS) nVOBU=m_TitleCells[nVTS][nCell].nVOBUS;

	i=m_TitleCells[nVTS][nCell].iIniVOBU+nVOBU;

	VOBUSector=GetNbytes(4,&m_pIFO[nVTS][m_VTS_VOBU_ADMAP[nVTS] + 4 +4*i]);

	return VOBUSector;
}

int CVobBlankerApp::ReadTitleVOBU(int nVTS, int iSector)
{
	CString csAux;
	int j,k,nVobin;
	__int64 i64sectors;
	int ilastpack;

//	theApp.m_i64VTSisize[nVTS]-theApp.m_i64Misize[nVTS];
	i64sectors=0;
	for (k=1,nVobin=1;k<10;k++)
	{
		i64sectors+=(m_i64VOBsize[nVTS][k]/2048);
		if (iSector<i64sectors)
		{
			i64sectors-=(m_i64VOBsize[nVTS][k]/2048);
			nVobin=k;
			k=20;
		}
	}

	csAux.Format(_T("VTS_%02d_%d.VOB"), nVTS, nVobin);
	csAux=m_csInputPath+ '\\' +csAux;

	if (m_Fin==NULL)
	{
		m_csFin=csAux;
		m_Fin=fopen(m_csFin,"rb");
	}
	if (m_Fin!=NULL && m_csFin!=csAux)
	{
		// close file and open the right one
		fclose(m_Fin);

		m_csFin=csAux;
		m_Fin=fopen(m_csFin,"rb");
	}

	if (m_Fin==NULL) 
		return -1;

// Read first pack (Nav)
	fseek(m_Fin, (long) ((iSector-i64sectors)*2048), SEEK_SET);

	if (readbuffer(m_buffer,m_Fin)!=2048)
	{
		if (m_Fin!=NULL) fclose (m_Fin);
		nVobin++;
		csAux.Format(_T("VTS_%02d_%d.VOB"), nVTS, nVobin);
		m_csFin=m_csInputPath+ '\\' +csAux;
		m_Fin=fopen(m_csFin,"rb");
		if (readbuffer(m_buffer,m_Fin)!=2048)
		{
			MyErrorLog_Box("Input error: Reached end of VOB too early");
			return -1;
		}
	}
	if (IsSynch(m_buffer) != true)
	{
//		MyErrorLog_Box("Error reading input VOB: Unsynchronized");
//		return -1;
		return 0;
	}
	if (!IsNav(m_buffer))
	{
//		MyErrorLog_Box("Input error: Not found a nav pack where it should be");
//		return -1;
		return 0;
	}

	ilastpack= GetNbytes(4,&m_buffer[0x40f]);
	if (ilastpack >= MAXPACKSPERVOBU-1 )
	{
		MyErrorLog_Box("Input error: VOBU too large");
		return -1;
	}

	for (j=1 ; j<ilastpack+1 && m_bScanInProcess; j++)
	{
		if (readbuffer(&m_buffer[2048*j],m_Fin)!=2048)
		{
			if (m_Fin!=NULL) fclose (m_Fin);
			nVobin++;
			csAux.Format(_T("VTS_%02d_%d.VOB"), nVTS, nVobin);
			m_csFin=m_csInputPath+ '\\' +csAux;
			m_Fin=fopen(m_csFin,"rb");
			if (readbuffer(&m_buffer[2048*j],m_Fin)!=2048)
			{
				MyErrorLog_Box("Input error: Reached end of VOB too early");
				return -1;
			}
			if (IsSynch(&m_buffer[2048*j]) != true)
			{
				MyErrorLog_Box("Error reading input VOB: Unsynchronized");
				return -1;
			}
		}
	}
	return ilastpack+1;
}

int CVobBlankerApp::FullScan(CWnd* pDlg, int iDomain, int nVTS)
{
// Scans the VOB files completely, sector by sectro.
// Calculates the Audio and Subs size in Titles
// Calculates ini/end pointers of each cell
// Return values:
//  0 : Everything went OK
// -1:  Critical error. No changes in Cell arrays
//  1:  Some Cells not found in VOBs

	int nVobin;
	__int64 i64sector,i64;
	__int64 i64IniSector,i64EndSector;
	int CID,VID,CIDa,VIDa;
	FILE * in;
	CString csAux;
	int nCells;
	int i;
	int nButtons;
	int nT, nCell;
	int iRet;




	if (iDomain==TITLES)
	{
		m_bAlreadyScan[nVTS]=false;
		for (i=0;i<8;i++)
			theApp.m_iAudioSectors[nVTS][i]=0; 
		for (i=0;i<32;i++)
			theApp.m_iSubsSectors[nVTS][i]=0;

		nCells=m_TitleCells[nVTS].GetSize();
		for (i=0; i<nCells;i++)
		{
			m_TitleCells[nVTS][i].i64IniSecVOB=-1;
			m_TitleCells[nVTS][i].i64EndSecVOB=-1;
			m_TitleCells[nVTS][i].nButtons=-1;
		}
		i64sector=i64IniSector=0;
		VIDa=CIDa=-1;
		for (nVobin=1; nVobin<10 && m_bScanInProcess; nVobin++)
		{
			if (m_i64VOBsize[nVTS][nVobin] !=0)
			{
				csAux.Format(_T("VTS_%02d_%d.VOB"), nVTS, nVobin);
				csAux=m_csInputPath+ '\\' +csAux;
				in=fopen(csAux,"rb");
				if (in==NULL) return -1;
				for (i64=0;i64<m_i64VOBsize[nVTS][nVobin]/2048 && m_bScanInProcess;i64++,i64sector++)
				{
					if ((i64%MODUPDATE) == 0) UpdateProgressFullScan(pDlg,iDomain,nVTS, (int)(i64sector*100/(m_i64VOBsize[nVTS][10]/2048)));
					if (readbuffer(m_buffer,in)!=2048)
					{
						fclose(in);
						return -1;
					}
					if (IsNav(m_buffer))
					{
						CID=m_buffer[0x422];
						VID=m_buffer[0x41F]*256+m_buffer[0x420];
						if (VID!=VIDa || CID!=CIDa) 
						{
							i=TitleCellGetPosByVCID(nVTS,VIDa,CIDa);
							if (VIDa !=-1 && CIDa !=-1)
							{
								i64EndSector=i64sector-1;
								if (i>=0)
								{
									if (m_TitleCells[nVTS][i].i64IniSecVOB==-1)
										m_TitleCells[nVTS][i].i64IniSecVOB=i64IniSector;
									if (m_TitleCells[nVTS][i].i64EndSecVOB==-1)
										m_TitleCells[nVTS][i].i64EndSecVOB=i64EndSector;
									else
										m_TitleCells[nVTS][i].i64EndSecVOB=i64EndSector;
								}
							}
							VIDa=VID;
							CIDa=CID;
							i64IniSector=i64sector;
						}
						i=TitleCellGetPosByVCID(nVTS,VID,CID);
						nButtons=m_buffer[0x9E];
						if (i>=0 && m_TitleCells[nVTS][i].nButtons <0 )
							m_TitleCells[nVTS][i].nButtons =0;
						if (i>=0 && nButtons >0 && m_TitleCells[nVTS][i].nButtons <=0 )
							m_TitleCells[nVTS][i].nButtons=nButtons;

					}
					else if (IsSubs(m_buffer))
						m_iSubsSectors[nVTS][getSubId (m_buffer) & 0x1F]++;
					else if (IsAudio(m_buffer))
						m_iAudioSectors[nVTS][getAudId (m_buffer) & 0x07]++;
				}
				fclose(in);
			}
		} // nVobin
		if (VIDa !=-1 && CIDa !=-1 && m_bScanInProcess)
		{
			i64EndSector=i64sector-1;
			i=TitleCellGetPosByVCID(nVTS,VIDa,CIDa);
			if (i>=0)
			{
				if (m_TitleCells[nVTS][i].i64IniSecVOB==-1)
					m_TitleCells[nVTS][i].i64IniSecVOB=i64IniSector;
				if (m_TitleCells[nVTS][i].i64EndSecVOB==-1)
					m_TitleCells[nVTS][i].i64EndSecVOB=i64EndSector;
				else
					m_TitleCells[nVTS][i].i64EndSecVOB=i64EndSector;
			}
		}

		iRet=0;
		for (i=0; i<nCells && m_bScanInProcess ;i++)
		{
			if (m_TitleCells[nVTS][i].i64IniSecCell!=m_TitleCells[nVTS][i].i64IniSecVOB ||
			    m_TitleCells[nVTS][i].i64EndSecCell!=m_TitleCells[nVTS][i].i64EndSecVOB)
			{
			if (m_TitleCells[nVTS][i].i64IniSecVOB!=-1)
				m_TitleCells[nVTS][i].i64IniSecCell=m_TitleCells[nVTS][i].i64IniSecVOB;
			if (m_TitleCells[nVTS][i].i64EndSecVOB!=-1)
				m_TitleCells[nVTS][i].i64EndSecCell=m_TitleCells[nVTS][i].i64EndSecVOB;
			if (m_TitleCells[nVTS][i].i64EndSecVOB==-1 || m_TitleCells[nVTS][i].i64IniSecVOB==-1)
				iRet=1;
			}
		}
		if (m_bScanInProcess) 
		{
			m_bAlreadyScan[nVTS]=true;
// Calculate nButtons per PGC.
			for (nT=0;nT<m_nPGCs[nVTS];nT++)
			{
				m_nTButtons[nVTS][nT]=0;
				for (nCell=0;nCell<m_nCells[nVTS][nT];nCell++)
				{
					i=TitleCellGetPos(nVTS,nT,nCell);
					nButtons=m_TitleCells[nVTS][i].nButtons;
					m_nTButtons[nVTS][nT]+=m_TitleCells[nVTS][i].nButtons;
				}
			}
		}
		return iRet;
	}
///////////////////////////////////////////////
/////////////////MENUS ////////////////////////

	if (iDomain==MENUS)
	{
		nCells=m_MenuCells[nVTS].GetSize();
		for (i=0; i<nCells;i++)
		{
			m_MenuCells[nVTS][i].i64IniSecVOB=-1;
			m_MenuCells[nVTS][i].i64EndSecVOB=-1;
		}
		i64sector=i64IniSector=0;
		VIDa=CIDa=-1;
		if (m_i64VOBsize[nVTS][0] !=0)
		{
			csAux.Format(_T("VTS_%02d_0.VOB"), nVTS);
			csAux=m_csInputPath+ '\\' +csAux;
			in=fopen(csAux,"rb");
			if (in==NULL) return -1;
			for (i64=0;i64<m_i64VOBsize[nVTS][0]/2048 && m_bScanInProcess;i64++,i64sector++)
			{
				if ((i64%MODUPDATE) == 0) UpdateProgressFullScan(pDlg,iDomain,nVTS, (int)(i64sector*100/(m_i64VOBsize[nVTS][0]/2048)));
				if (readbuffer(m_buffer,in)!=2048)
				{
					fclose(in);
					return -1;
				}
				if (IsNav(m_buffer))
				{
					CID=m_buffer[0x422];
					VID=m_buffer[0x41F]*256+m_buffer[0x420];
					if (VID!=VIDa || CID!=CIDa) 
					{
						if (VIDa !=-1 && CIDa !=-1)
						{
							i64EndSector=i64sector-1;
							i=MenuCellGetPosByVCID(nVTS,VIDa,CIDa);
							if (i>=0)
							{
								if (m_MenuCells[nVTS][i].i64IniSecVOB==-1)
									m_MenuCells[nVTS][i].i64IniSecVOB=i64IniSector;
								if (m_MenuCells[nVTS][i].i64EndSecVOB==-1)
									m_MenuCells[nVTS][i].i64EndSecVOB=i64EndSector;
								else
									m_MenuCells[nVTS][i].i64EndSecVOB=i64EndSector;
							}
						}
						VIDa=VID;
						CIDa=CID;
						i64IniSector=i64sector;
					}
				}
			}
			fclose(in);
		}
		if (VIDa !=-1 && CIDa !=-1)
		{
			i64EndSector=i64sector-1;
			i=MenuCellGetPosByVCID(nVTS,VIDa,CIDa);
			if (i>=0)
			{
				if (m_MenuCells[nVTS][i].i64IniSecVOB==-1)
					m_MenuCells[nVTS][i].i64IniSecVOB=i64IniSector;
				if (m_MenuCells[nVTS][i].i64EndSecVOB==-1)
					m_MenuCells[nVTS][i].i64EndSecVOB=i64EndSector;
				else
					m_MenuCells[nVTS][i].i64EndSecVOB=i64EndSector;
			}
		}

		iRet=0;
		for (i=0; i<nCells && m_bScanInProcess ;i++)
		{
			if (m_MenuCells[nVTS][i].i64IniSecCell!=m_MenuCells[nVTS][i].i64IniSecVOB ||
			    m_MenuCells[nVTS][i].i64EndSecCell!=m_MenuCells[nVTS][i].i64EndSecVOB)
			{
			if (m_MenuCells[nVTS][i].i64IniSecVOB!=-1)
				m_MenuCells[nVTS][i].i64IniSecCell=m_MenuCells[nVTS][i].i64IniSecVOB;
			if (m_MenuCells[nVTS][i].i64EndSecVOB!=-1)
				m_MenuCells[nVTS][i].i64EndSecCell=m_MenuCells[nVTS][i].i64EndSecVOB;

			if (m_MenuCells[nVTS][i].i64EndSecVOB!=-1 || m_MenuCells[nVTS][i].i64IniSecVOB!=-1)
				iRet=1;

			}
		}
		return iRet;
	}

return 0;
}

int CVobBlankerApp::RunScanVobs(CWnd* pDlg, int nVTS, int nCell)
{

	int i,j,k;
	int iSector,nSectors;
	MSG msg;
	int nButtons;


	if (m_Fin!=NULL) fclose (m_Fin);
	m_Fin=NULL;


	for (i=j=0; i< m_TitleCells[nVTS][nCell].nVOBUS && m_bScanInProcess; i+=(m_iScanNVOBUs+1), j++)
	{
		iSector=GetVOBUSector(nVTS,nCell, i);
		if (iSector <0) 
		{
			m_bScanInProcess=false;
			if (m_Fin!=NULL) fclose (m_Fin);
			m_Fin=NULL;
			return -1;
		}
		nSectors= ReadTitleVOBU (nVTS,iSector);
		if (nSectors <0) 
		{
			m_bScanInProcess=false;
			if (m_Fin!=NULL) fclose (m_Fin);
			m_Fin=NULL;
			return -1;
		}
		for (k=0; k<nSectors; k++)
		{
			if (IsSubs(&m_buffer[2048*k]))
				m_iSubsSectors[nVTS][getSubId (&m_buffer[2048*k]) & 0x1F]++;
			if (IsAudio(&m_buffer[2048*k]))
				m_iAudioSectors[nVTS][getAudId (&m_buffer[2048*k]) & 0x07]++;
		}
		if (nSectors!=0)
		{
			nButtons=m_buffer[0x9E];
			if (m_TitleCells[nVTS][nCell].nButtons <=0)
				m_TitleCells[nVTS][nCell].nButtons=nButtons;
//			else if (nButtons>0 && m_TitleCells[nVTS][nCell].nButtons >0 && 
//			     nButtons !=m_TitleCells[nVTS][nCell].nButtons )
//			{
// More than 
//			}
		}

		if ( pDlg && !(j%MODUPDATESCAN) )
		{
			while (PeekMessage(&msg, NULL, 0, 0, PM_REMOVE))
			{
				TranslateMessage(&msg);
				DispatchMessage(&msg);
			}
		}
	}
	if (m_Fin!=NULL) fclose (m_Fin);
	m_Fin=NULL;
	return 0;
}


int CVobBlankerApp::GetMenuData()
{
	int j,l,nLU,nPGC,nAbsPGC;
	int	nEntries;
	int VIDa, VIDb, CIDa, CIDb;
	int n,nn,nnn;
	int nArray;
	bool bAlready;
	MENU_CELL_LIST myCell;
	__int64 i64Cellsize, i64IniSecCell,i64EndSecCell;
	__int64 i64IniSecCell_PBK,i64EndSecCell_PBK;
	CString csAux,csAux2;
	int same,nADTCells;
	int kk,ll;
	uchar *pCommand;
	int i,ii;
	bool bIsHigher;
	int nSuspect,nSuspectPointers;
	int k;
	bool bBadCellPointers;


	for (j=0; j<m_nIFOs+1 ;j++)
	{
		UpdateProgress(m_pMainWnd, (j*100)/(m_nIFOs+1),false);
		m_bMaxIframeScan[j]=false;

		if (j==0)
			m_VTSM_PGCI[j]=2048*GetNbytes(4,&m_pIFO[j][0xc8]);
		else
			m_VTSM_PGCI[j]=2048*GetNbytes(4,&m_pIFO[j][0xD0]);
		if ( m_VTSM_PGCI[j] >= m_i64IFOlen[j])
		{
			m_VTSM_PGCI[j]=0;
			if (j==0)
				Put4bytes(0,&m_pIFO[j][0xc8]);
			else
				Put4bytes(0,&m_pIFO[j][0xD0]);
			m_bBadOffset=true;
		}

		m_VTSM_C_ADT[j]=2048*GetNbytes(4,&m_pIFO[j][0xD8]);
		if ( m_VTSM_C_ADT[j] >= m_i64IFOlen[j])
		{
			m_VTSM_C_ADT[j]=0;
			Put4bytes(0,&m_pIFO[j][0xD8]);
			m_bBadOffset=true;
		}

		m_VTSM_VOBU_ADMAP[j]=2048*GetNbytes(4,&m_pIFO[j][0xDC]);
		if ( m_VTSM_VOBU_ADMAP[j] >= m_i64IFOlen[j])
		{
			m_VTSM_VOBU_ADMAP[j]=0;
			Put4bytes(0,&m_pIFO[j][0xDC]);
			m_bBadOffset=true;
		}

// Fill LU data
		if (m_VTSM_PGCI[j]==0)
			m_nLUs[j]=0;
		else
			m_nLUs[j]=GetNbytes(2,&m_pIFO[j][m_VTSM_PGCI[j]]);

		if ( m_nLUs[j] > MAX_MLUS)
		{
			csAux.Format(_T("ERROR: Max LU limit (%d) has been reached."),MAX_MLUS);
			MyErrorBox (csAux);
			return -1;
		}
		
// Compute m_nMVOBIDs
		same=0;

		if (m_VTSM_C_ADT[j]==0)
			nADTCells=0;
		else
			nADTCells=(GetNbytes(4,&m_pIFO[j][m_VTSM_C_ADT[j]+4])-7)/12;

		for( kk=0, m_nMVOBIDs[j]=m_nMMaxVOBIDs[j]=0; kk< nADTCells ; kk++)
		{
			VIDa=GetNbytes(2, &m_pIFO[j][m_VTSM_C_ADT[j]+8+12*kk]);
			for (ll=0,same=0; ll< kk; ll++)
			{
				if (VIDa==(int)GetNbytes(2, &m_pIFO[j][m_VTSM_C_ADT[j]+8+12*ll]))
				same=1;
			}
			if (same==0) m_nMVOBIDs[j]++;
			if (VIDa > m_nMMaxVOBIDs[j]) m_nMMaxVOBIDs[j]=VIDa;
		}

		m_nMPGCs[j]=0;
		for (nLU=0; nLU <m_nLUs[j]; nLU++)
		{
			m_VTSM_LU[j][nLU]=   GetNbytes(4,&m_pIFO[j][m_VTSM_PGCI[j]+0x04+(nLU+1)*8])+m_VTSM_PGCI[j];
			m_szLANG_LU[j][nLU][0]= m_pIFO[j][m_VTSM_PGCI[j]+0x00+(nLU+1)*8];
			m_szLANG_LU[j][nLU][1]= m_pIFO[j][m_VTSM_PGCI[j]+0x01+(nLU+1)*8];
			m_szLANG_LU[j][nLU][2]= 0;
			m_nPGCinLU[j][nLU]=  GetNbytes(2,&m_pIFO[j][m_VTSM_LU[j][nLU]]);
			m_nIniPGCinLU[j][nLU]= m_nMPGCs[j];
			if ((m_nMPGCs[j] + m_nPGCinLU[j][nLU]) > MAX_MPGC)
			{
				csAux.Format(_T("ERROR: Max MPGCs limit (%d) has been reached."),MAX_MPGC);
				MyErrorBox (csAux);
				return -1;
			}
			m_nMPGCs[j]+=m_nPGCinLU[j][nLU];
		} // For LUs

		if (m_nMPGCs[j])
			if (!MemoryNewVTSMenu (j, m_nMPGCs[j] ))
			{
				MyErrorBox("ERROR: Memory allocation failed!");
				return -1;
			}

		for (nLU=0; nLU <m_nLUs[j]; nLU++)
		{
			for (nPGC=0; nPGC < m_nPGCinLU[j][nLU]; nPGC++)
			{
				nAbsPGC=nPGC+m_nIniPGCinLU[j][nLU];
				m_nLU_MPGC[j][nAbsPGC]=nLU;
				m_iMAction[j][nAbsPGC]=KEEP;
			    m_MENU_PGC[j][nAbsPGC]= GetNbytes(4,&m_pIFO[j][m_VTSM_LU[j][nLU]+0x04+(nPGC+1)*8])+m_VTSM_LU[j][nLU];

				m_M_C_PBKT[j][nAbsPGC]  =GetNbytes(2,&m_pIFO[j][m_MENU_PGC[j][nAbsPGC]+0xE8]);
				if (m_M_C_PBKT[j][nAbsPGC] !=0) m_M_C_PBKT[j][nAbsPGC] += m_MENU_PGC[j][nAbsPGC];
				m_M_C_POST[j][nAbsPGC]  =GetNbytes(2,&m_pIFO[j][m_MENU_PGC[j][nAbsPGC]+0xEA]);
				if (m_M_C_POST[j][nAbsPGC] !=0) m_M_C_POST[j][nAbsPGC] +=m_MENU_PGC[j][nAbsPGC];
				m_M_PGC_COMM[j][nAbsPGC]=GetNbytes(2,&m_pIFO[j][m_MENU_PGC[j][nAbsPGC]+0xE4]);
				if (m_M_PGC_COMM[j][nAbsPGC] !=0) m_M_PGC_COMM[j][nAbsPGC] +=m_MENU_PGC[j][nAbsPGC];

				m_nMCells[j][nAbsPGC]=m_pIFO[j][m_MENU_PGC[j][nAbsPGC]+3];

				if ( (m_M_C_PBKT[j][nAbsPGC]==0 || m_M_C_POST[j][nAbsPGC] ==0) &&  m_nMCells[j][nAbsPGC]!=0)
					// There is something wrong...
				{
					m_nMCells[j][nAbsPGC]=0;
					csAux.Format(_T("ERROR: There is something wrong in number of cells in VTS %02d, Menu PGC %02d."),j,nAbsPGC);
					MyErrorBox (csAux);
					return -1;
				}
				if (m_nMCells[j][nAbsPGC]==0)
				{
					m_iMAction[j][nAbsPGC]=ZERO;
					m_nMFirstVID[j][nAbsPGC]=0;
				}
				else
				{
					m_nMFirstVID[j][nAbsPGC]=GetNbytes(2,&m_pIFO[j][m_M_C_POST[j][nAbsPGC]]);
				}
				m_i8MCellComm[j][nAbsPGC]=m_i8MPreComm[j][nAbsPGC]=m_i8MPostComm[j][nAbsPGC]=0;
				m_b8MCellComm[j][nAbsPGC]=false;
				if (m_M_PGC_COMM[j][nAbsPGC]!=0) 
				{
						m_i8MPreComm[j][nAbsPGC]=GetNbytes(2,&m_pIFO[j][m_M_PGC_COMM[j][nAbsPGC]]);
						m_i8MPostComm[j][nAbsPGC]=GetNbytes(2,&m_pIFO[j][m_M_PGC_COMM[j][nAbsPGC]+2]);
						m_i8MCellComm[j][nAbsPGC]=GetNbytes(2,&m_pIFO[j][m_M_PGC_COMM[j][nAbsPGC]+4]);
						for (l=0;l<m_i8MCellComm[j][nAbsPGC];l++)
						{
							pCommand=&m_pIFO[j][m_M_PGC_COMM[j][nAbsPGC]+8+8*(l+m_i8MPostComm[j][nAbsPGC]+m_i8MPreComm[j][nAbsPGC])];
							if (! ( (pCommand[0] & 0xF0)==0x20 && (pCommand[1] == 0x81 || pCommand[1] == 01) &&
								    (pCommand[7] & 0x1F)==0x0d ) )
								// if Cell Command != LinkTailPGC
								m_b8MCellComm[j][nAbsPGC]=true;
						}

				}
				m_dwMDuration[j][nAbsPGC]=(DWORD)GetNbytes(4,&m_pIFO[j][m_MENU_PGC[j][nAbsPGC]+4]);
				m_bMCellReUsed[j][nAbsPGC]=false;
				m_i64MPGCisize[j][nAbsPGC]=0;
	            m_csMCellBased[j][nAbsPGC].Empty();
				for ( l=0; l< m_nMCells[j][nAbsPGC]; l++)
				{
						m_csMCellBased[j][nAbsPGC]+='K'; // Keep
				}

			} // For PGCs
//			m_nMPGCs[j]+=m_nPGCinLU[j][nLU];

		} // For LUs

		m_MenuCells[j].RemoveAll();

		if (m_VTSM_C_ADT[j]==0)
			nEntries=0;
		else
		{
			nEntries=GetNbytes(4,&m_pIFO[j][m_VTSM_C_ADT[j]+4]);
			nEntries=(nEntries-7)/12;
		}
		if (nEntries <0 )  nEntries=0;

		for (n=0;n < nEntries ; n++)
		{
			VIDa=GetNbytes(2,&m_pIFO[j][m_VTSM_C_ADT[j]+8+12*n]);
			CIDa=m_pIFO[j][m_VTSM_C_ADT[j]+8+2+12*n];
			nArray=m_MenuCells[j].GetSize();
			for (nn=0,bAlready=false;nn < nArray  && bAlready==false; nn++)
			{
				VIDb=m_MenuCells[j][nn].VID;
				CIDb=m_MenuCells[j][nn].CID;
				if (VIDa==VIDb && CIDa==CIDb)
				{
					bAlready=true;
					nnn=nn;
				}
			}
			i64IniSecCell=GetNbytes(4,&m_pIFO[j][m_VTSM_C_ADT[j]+8+12*n+4]);
			i64EndSecCell=GetNbytes(4,&m_pIFO[j][m_VTSM_C_ADT[j]+8+12*n+8]);
			i64Cellsize=(i64EndSecCell-i64IniSecCell+1)*2048;

			if (bAlready)
			{
				if (i64IniSecCell<m_MenuCells[j][nnn].i64IniSecCell)
					 m_MenuCells[j][nnn].i64IniSecCell=i64IniSecCell;
				if (i64EndSecCell>m_MenuCells[j][nnn].i64EndSecCell)
					 m_MenuCells[j][nnn].i64EndSecCell=i64EndSecCell;
				m_MenuCells[j][nnn].i64size+=i64Cellsize;
			}
			else
			{
				myCell.VID=VIDa;
				myCell.CID=CIDa;
				myCell.i64size=i64Cellsize;
				myCell.i64IniSecCell=i64IniSecCell;
				myCell.i64EndSecCell=i64EndSecCell;
				myCell.iMode=UNREF;
				myCell.nButtons=-1;

				ii=nArray;
				if (m_bCheckVobOrder)
				{
					for (i=0,bIsHigher=true; i<nArray && bIsHigher ; i++)
					{
						if (myCell.VID < m_MenuCells[j][i].VID )	   {ii=i; bIsHigher=false;}
						else if (myCell.VID > m_MenuCells[j][i].VID )  bIsHigher=true;
						else
						{
							if (myCell.CID < m_MenuCells[j][i].CID )   {ii=i; bIsHigher=false;}
							else if (myCell.CID > m_MenuCells[j][i].CID )  bIsHigher=true;
						}
					}
				}
				m_MenuCells[j].InsertAt(ii,myCell);
			}
		} // For Entries

		if (nEntries)
		{
			if (m_i64Misize[j] <=0)
			{
				if (j==0)
					csAux.Format(_T("ERROR: Referenced Menu empty or does not exist in VIDEO_TS"));
				else
					csAux.Format(_T("ERROR: Referenced Menu empty or does not exist in VTS %02d"),j);
				MyErrorBox (csAux);
//				return 0;
			}
		}

//////////////////////////////////////////////////////////
/// Review the PGCs: Look for unreferenced cells
		nSuspect=nSuspectPointers=0;
		for (k=0 ; k<m_nMPGCs[j] ; k++)
		{
// Loop Cells ---> VTS index:"j"; PGC index: "k"; Cell index: "n"
///////////////////   nn --> Cell index in m_MenuCells[j]
			for ( n=0; n< m_nMCells[j][k]; n++)
			{
				i64IniSecCell_PBK=GetNbytes(4,&m_pIFO[j][m_M_C_PBKT[j][k]+24*n+8]) ;
				i64EndSecCell_PBK=GetNbytes(4,&m_pIFO[j][m_M_C_PBKT[j][k]+24*n+0x14]) ;
				i64Cellsize=(i64EndSecCell_PBK-i64IniSecCell_PBK+1)*2048;
				nn=MenuCellGetPos( j, k, n);
				if (nn <0) 
				{
					nSuspect++;
/////////////////////////////////////////////////////////////////////////////////
/////////////////////Found a cell not referenced in VTSM_C_ADT!! Using PGC pointers
					nArray=m_MenuCells[j].GetSize();
					myCell.VID=GetNbytes(2,&m_pIFO[j][m_M_C_POST[j][k]+n*4]);
					myCell.CID=m_pIFO[j][m_M_C_POST[j][k]+n*4+3];
					myCell.i64size=i64Cellsize;
					myCell.i64IniSecCell=i64IniSecCell_PBK;
					myCell.i64EndSecCell=i64EndSecCell_PBK;
					myCell.iMode=UNREF;
					myCell.nButtons=-1;

					ii=nArray;
//					if (m_bCheckVobOrder)
//					{
						for (i=0,bIsHigher=true; i<nArray && bIsHigher ; i++)
						{
							if (myCell.VID < m_MenuCells[j][i].VID )	   {ii=i; bIsHigher=false;}
							else if (myCell.VID > m_MenuCells[j][i].VID )  bIsHigher=true;
							else
							{
								if (myCell.CID < m_MenuCells[j][i].CID )   {ii=i; bIsHigher=false;}
								else if (myCell.CID > m_MenuCells[j][i].CID )  bIsHigher=true;
							}
						}
//					}
					m_MenuCells[j].InsertAt(ii,myCell);				
				}
				else
// Check inisectors TODO: Decide what to be used if not match....
				{
					if (i64IniSecCell_PBK != m_MenuCells[j][nn].i64IniSecCell ||
						i64EndSecCell_PBK != m_MenuCells[j][nn].i64EndSecCell)
					nSuspectPointers++;
				}
			}
		}

		if (j==0)
			csAux2.Format(_T("VIDEO_TS Menu: "));
		else
			csAux2.Format(_T("VTS_%02d   Menu: "),j);
		
		if (nSuspect && !m_bCLIFullScan)
		{
			csAux.Format(_T("Detected %d cells in PGCs not referenced in VTSM_C_ADT\nUsing PGC initial and ending pointers..."),
				nSuspect);
			MyInfoBox(csAux2+csAux);
		}
		if (nSuspectPointers && !m_bCLIFullScan)
		{
			csAux.Format(_T("Detected %d cells with pointers mismatch between VTSM_C_ADT and PGC_PBK tables\n"),
				nSuspectPointers);
			csAux+=_T("Using VTSM_C_ADT initial and ending pointers...\n\n");
			csAux+=_T("This is not usual in menus, so a FullScan in menus is recommended.\n\n");

			MyInfoBox(csAux2+csAux);
		}
	///////////////Check if pointers out of VOB File/////////
		nArray=m_MenuCells[j].GetSize();
		bBadCellPointers=false;
		for ( n=0; n<nArray; n++)
		{
			if (m_MenuCells[j][n].i64IniSecCell <0 ||
				m_MenuCells[j][n].i64IniSecCell >m_i64VOBsize[j][0]/2048)
			{
				m_MenuCells[j][n].i64IniSecCell=0;
				bBadCellPointers=true;
			}

			if (m_MenuCells[j][n].i64EndSecCell <0 ||
				m_MenuCells[j][n].i64EndSecCell >m_i64VOBsize[j][0]/2048)
			{
				m_MenuCells[j][n].i64EndSecCell=m_MenuCells[j][n].i64IniSecCell;
				bBadCellPointers=true;
			}
		}
		if (bBadCellPointers)
			m_bMenuNeedScan[j]=true;
		else
			m_bMenuNeedScan[j]=false;

	}  // For VTSs
	for (j=0, bBadCellPointers=false; j<m_nIFOs+1 ;j++)
	{
		if (m_bMenuNeedScan[j])
			bBadCellPointers=true;
	}
	if (bBadCellPointers && !m_bCLIFullScan)
	{

		csAux.Format(_T("Detected ini/end cell pointers out of range in MENUS domain\nAffected titlesets are:\n\n"));
		if (m_bMenuNeedScan[0])
		{
			csAux2.Format(_T("VIDEO_TS.IFO\n"));
			csAux+=csAux2;
		}

		for (i=1; i< m_nIFOs+1 ;i++)
		{
			if (m_bMenuNeedScan[i])
			{
				csAux2.Format(_T("VTS_%02d_0.IFO\n"),i);
				csAux+=csAux2;
			}
		}
		csAux+=(_T("\nA FullScan is required: See Menu->File->FullScan..."));
		MyErrorBox(csAux);

	}

	return 0;
}

int CVobBlankerApp::GetButtonsData()
{
	int nVTS,n,nCells,k,nPGC;
	FILE *in;
	CString csAux;
	__int64 i64;
	int VID,CID;
	int EndADMAPSector,VOBUSector,iIniVOBU,iIniButtonsVOBU, i;
	int nButtons,nVOBUS;
	__int64 i64IniSec,i64EndSec;
	int nSubsP,nSubsPP,nSubsPo;


	for (nVTS=0; nVTS<m_nIFOs+1 ;nVTS++)
	{
		for (nPGC=0; nPGC < m_nMPGCs[nVTS]; nPGC++)
			m_nMButtons[nVTS][nPGC]=-1;
	}

	for (nVTS=0; nVTS<m_nIFOs+1 ;nVTS++)
	{
		if (nVTS)
			csAux.Format(_T("Scan for buttons VTS_%02d_0.VOB"),nVTS);
		else
			csAux.Format(_T("Scan for buttons VIDEO_TS.VOB"));
		((CVobBlankerDlg *)m_pMainWnd)->m_csProgress= csAux;
		UpdateProgress(m_pMainWnd,0,false);
		m_pMainWnd->UpdateData(FALSE);

		if (m_VTSM_VOBU_ADMAP[nVTS]==0)
			EndADMAPSector=0;
		else
		{
			EndADMAPSector=GetNbytes(4,&m_pIFO[nVTS][m_VTSM_VOBU_ADMAP[nVTS]]);
			EndADMAPSector=((EndADMAPSector+1)/4)-1;
		}

		if (nVTS==0)
			csAux="VIDEO_TS.VOB";
		else
			csAux.Format(_T("VTS_%02d_0.VOB"), nVTS);
		csAux=m_csInputPath+'\\'+csAux;
		
		if ( (in=fopen (csAux,"rb"))!=NULL) 
		{
			nCells=m_MenuCells[nVTS].GetSize();

			for (n=0;n<nCells;n++)
			{
				UpdateProgress(m_pMainWnd,n*100/nCells,false);
				nButtons=0;
				m_MenuCells[nVTS][n].i64IniIFSize=0;
				m_MenuCells[nVTS][n].i64MidIFSize=0;
				m_MenuCells[nVTS][n].i64EndIFSize=0;
				m_MenuCells[nVTS][n].nButtons=0;

				i64IniSec=m_MenuCells[nVTS][n].i64IniSecCell;
				i64EndSec=m_MenuCells[nVTS][n].i64EndSecCell;

				m_MenuCells[nVTS][n].i64PrePreButtons=i64IniSec*2048;
				m_MenuCells[nVTS][n].i64PreButtons=i64IniSec*2048;
				m_MenuCells[nVTS][n].i64IniButtons=i64IniSec*2048;
				m_MenuCells[nVTS][n].i64MidButtons=i64IniSec*2048;
				m_MenuCells[nVTS][n].i64EndButtons=i64IniSec*2048;

				for (i=0,nVOBUS=0; i<EndADMAPSector;i++)
				{
					VOBUSector=GetNbytes(4,&m_pIFO[nVTS][m_VTSM_VOBU_ADMAP[nVTS] + 4 +4*i]);
					if ( VOBUSector >= i64IniSec && VOBUSector <= i64EndSec ) 	nVOBUS++;
					if ( VOBUSector==i64IniSec) iIniVOBU=iIniButtonsVOBU=i;
					if ( nButtons==0 && VOBUSector >= i64IniSec && VOBUSector <= i64EndSec )
					{
						i64=VOBUSector*2048;
						fseek (in,(long)i64,SEEK_SET);
						if (readbuffer(m_buffer,in)==2048)
						{
							if (IsNav(m_buffer))
							{
								if (VOBUSector==i64IniSec)
								{
									m_MenuCells[nVTS][n].i64IniIFSize=m_MenuCells[nVTS][n].i64EndIFSize=GetNbytes(4,&m_buffer[0x413]);
								}
								nButtons=m_buffer[0x9E];
								if (nButtons!=0)
								{
									m_MenuCells[nVTS][n].nButtons=nButtons;
									m_MenuCells[nVTS][n].i64IniIFSize=GetNbytes(4,&m_buffer[0x413])*2048;
									m_MenuCells[nVTS][n].i64EndIFSize=m_MenuCells[nVTS][n].i64IniIFSize;
									m_MenuCells[nVTS][n].i64IniButtons=i64;
									m_MenuCells[nVTS][n].i64EndButtons=i64;
									iIniButtonsVOBU=i;
								}
								else
								{
									m_MenuCells[nVTS][n].i64PrePreButtons=m_MenuCells[nVTS][n].i64PreButtons;
									m_MenuCells[nVTS][n].i64PreButtons=i64;
								}
							}
						}
					}
				}
				m_MenuCells[nVTS][n].nVOBUS=nVOBUS;
				m_MenuCells[nVTS][n].iIniVOBU=iIniVOBU;
// Check last VOBU, and if the number of buttons is the same store its data
				if (nVOBUS>0)
				{
					VOBUSector=GetNbytes(4, &m_pIFO[nVTS][m_VTSM_VOBU_ADMAP[nVTS] + 4 +4*(iIniVOBU+nVOBUS-1)]);
					i64=VOBUSector*2048;
					fseek (in,(long)i64,SEEK_SET);
					if (readbuffer(m_buffer,in)==2048)
					{
						if (IsNav(m_buffer))
						{
							nButtons=m_buffer[0x9E];
							if (nButtons==m_MenuCells[nVTS][n].nButtons)
							{
								m_MenuCells[nVTS][n].i64EndIFSize=GetNbytes(4,&m_buffer[0x413])*2048;
								m_MenuCells[nVTS][n].i64EndButtons=i64;
							}
						}
					}
				}
// Check Mid VOBU, and if the number of buttons is the same store its data
				if (nVOBUS>1)
				{
					VOBUSector=GetNbytes(4, &m_pIFO[nVTS][m_VTSM_VOBU_ADMAP[nVTS] + 4 +4*(iIniVOBU+nVOBUS/2-1)]);
					i64=VOBUSector*2048;
					fseek (in,(long)i64,SEEK_SET);
					if (readbuffer(m_buffer,in)==2048)
					{
						if (IsNav(m_buffer))
						{
							nButtons=m_buffer[0x9E];
							if (nButtons==m_MenuCells[nVTS][n].nButtons)
							{
								m_MenuCells[nVTS][n].i64MidIFSize=GetNbytes(4,&m_buffer[0x413])*2048;
								m_MenuCells[nVTS][n].i64MidButtons=i64;
							}
						}
					}
				}
// Check Next VOBU, and store the number of subs
				m_MenuCells[nVTS][n].nPostSubs=0;
				if (nVOBUS>1)
				{
					VOBUSector=GetNbytes(4, &m_pIFO[nVTS][m_VTSM_VOBU_ADMAP[nVTS] + 4 +4*(iIniButtonsVOBU+1)]);
					i64=VOBUSector*2048;
					fseek (in,(long)i64,SEEK_SET);
					nSubsPo=0;

					if (readbuffer(m_buffer,in)==2048)
					{
						if (IsNav(m_buffer) && m_buffer[0x422] == m_MenuCells[nVTS][n].CID &&
							GetNbytes(2,&m_buffer[0x41F]) == (UINT) m_MenuCells[nVTS][n].VID )
							while (readbuffer(m_buffer,in)==2048 && !IsNav(m_buffer))
								if ( IsSubs(m_buffer) ) nSubsPo++;
					}
					m_MenuCells[nVTS][n].nPostSubs=nSubsPo;
				} 
// Check Prev Prev VOBU
				nSubsPP=0;
				if ( nVOBUS>2 && m_MenuCells[nVTS][n].i64IniButtons != m_MenuCells[nVTS][n].i64PrePreButtons
					&& m_MenuCells[nVTS][n].i64PreButtons != m_MenuCells[nVTS][n].i64PrePreButtons)
				{
					i64=m_MenuCells[nVTS][n].i64PrePreButtons;
					fseek (in,(long)i64,SEEK_SET);
					if (readbuffer(m_buffer,in)==2048)
					{
						if (IsNav(m_buffer))
							while (readbuffer(m_buffer,in)==2048 && !IsNav(m_buffer))
								if ( IsSubs(m_buffer) ) nSubsPP++;
					}
/*
					if (nSubsPP) 
					{
						m_MenuCells[nVTS][n].i64PreButtons=i64;
						m_MenuCells[nVTS][n].nPreSubs=nSubs;
					}
					else
					{
						m_MenuCells[nVTS][n].i64PreButtons=m_MenuCells[nVTS][n].i64IniButtons;
						m_MenuCells[nVTS][n].nPreSubs=0;
					}
*/
				}

// Check Prev VOBU, and if it has not subs, modify the Pre pointer to Ini
				nSubsP=0;
				if ( nVOBUS>1 && m_MenuCells[nVTS][n].i64IniButtons != m_MenuCells[nVTS][n].i64PreButtons)
				{
					i64=m_MenuCells[nVTS][n].i64PreButtons;
					fseek (in,(long)i64,SEEK_SET);
					if (readbuffer(m_buffer,in)==2048)
					{
						if (IsNav(m_buffer))
							while (readbuffer(m_buffer,in)==2048 && !IsNav(m_buffer))
								if ( IsSubs(m_buffer) ) nSubsP++;
					}
/*					if (nSubs) 
					{
						m_MenuCells[nVTS][n].i64PreButtons=i64;
						m_MenuCells[nVTS][n].nPreSubs=nSubs;
					}
					else
					{
						m_MenuCells[nVTS][n].i64PreButtons=m_MenuCells[nVTS][n].i64IniButtons;
						m_MenuCells[nVTS][n].nPreSubs=0;
					}
*/				}

				m_MenuCells[nVTS][n].nPreSubs=nSubsP+nSubsPP;
				if (nSubsPP)
				{
					m_MenuCells[nVTS][n].i64PreButtons=m_MenuCells[nVTS][n].i64PrePreButtons;
				}
				else if (nSubsP)
				{
					m_MenuCells[nVTS][n].i64PreButtons=m_MenuCells[nVTS][n].i64PreButtons;
				}
				else
				{
					m_MenuCells[nVTS][n].i64PreButtons=m_MenuCells[nVTS][n].i64IniButtons;
//					m_MenuCells[nVTS][n].nPreSubs=0;
				}
			} // For of nCells
			fclose (in);
		} /* if file opened */
	}
	for (nVTS=0; nVTS<m_nIFOs+1 ;nVTS++)
	{
		for (nPGC=0; nPGC < m_nMPGCs[nVTS]; nPGC++)
		{
			m_nMButtons[nVTS][nPGC]=0;
			for (k=0;k<m_nMCells[nVTS][nPGC] && m_nMButtons[nVTS][nPGC] >=0;k++)
			{
				VID=GetNbytes(2,&m_pIFO[nVTS][m_M_C_POST[nVTS][nPGC]+4*k]);
				CID=m_pIFO[nVTS][m_M_C_POST[nVTS][nPGC]+3+4*k];

				nCells=m_MenuCells[nVTS].GetSize();

				for (n=0;n<nCells;n++)
				{
					if (m_MenuCells[nVTS][n].VID==VID && m_MenuCells[nVTS][n].CID==CID)
					{
						if (m_MenuCells[nVTS][n].nButtons==-1)
							m_nMButtons[nVTS][nPGC]=-1;
						else
							m_nMButtons[nVTS][nPGC]+=m_MenuCells[nVTS][n].nButtons;
					}
				}
			}
		}
	} /* For VTS */
	return 0;
}

void CVobBlankerApp::GetMaxIFrameData(int nVTS)
{
	int n,nCells;
	CString csAux;
	__int64 i64, i64IFSize;
//	int VID,CID;
	int EndADMAPSector,VOBUSector, i;
	__int64 i64IniSec,i64EndSec;

// Open menu file	
	if (nVTS==0)
		csAux="VIDEO_TS.VOB";
	else
		csAux.Format(_T("VTS_%02d_0.VOB"), nVTS);
	m_csFin=m_csInputPath+ '\\' +csAux;
	m_Fin=fopen(m_csFin,"rb");
	if (m_Fin ==NULL)
	{
		MyErrorLog_Box("Error opening input VOB: "+m_csFin);
		m_bInProcess=false;
		return;
	}

	EndADMAPSector=GetNbytes(4,&m_pIFO[nVTS][m_VTSM_VOBU_ADMAP[nVTS]]);
	EndADMAPSector=((EndADMAPSector+1)/4)-1;


	nCells=m_MenuCells[nVTS].GetSize();

	for (n=0;n<nCells;n++)
	{
		m_MenuCells[nVTS][n].i64MaxButtons=m_MenuCells[nVTS][n].i64IniButtons;
		m_MenuCells[nVTS][n].i64MaxIFSize=m_MenuCells[nVTS][n].i64IniIFSize;

		i64IniSec=m_MenuCells[nVTS][n].i64IniSecCell;
		i64EndSec=m_MenuCells[nVTS][n].i64EndSecCell;

		for (i=0; i<EndADMAPSector;i++)
		{
			VOBUSector=GetNbytes(4,&m_pIFO[nVTS][m_VTSM_VOBU_ADMAP[nVTS] + 4 +4*i]);
			if ( VOBUSector >= i64IniSec && VOBUSector <= i64EndSec )
			{
				i64=VOBUSector*2048;
				fseek (m_Fin,(long)i64,SEEK_SET);
				if (readbuffer(m_buffer,m_Fin)==2048)
				{
					if (IsNav(m_buffer))
					{
						if (m_MenuCells[nVTS][n].nButtons==m_buffer[0x9E])
						{
							i64IFSize=GetNbytes(4,&m_buffer[0x413]);
							if (i64IFSize > m_MenuCells[nVTS][n].i64MaxIFSize)
							{
								m_MenuCells[nVTS][n].i64MaxIFSize=i64IFSize;
								m_MenuCells[nVTS][n].i64MaxButtons=i64;
							}
						}
					}
				}
			}
		}
	}
	fclose(m_Fin);
	m_Fin=NULL;
}




void CVobBlankerApp::GetMenuIniSize()
{
// Fills:
//	m_i64MPGCisize[MAX_VTS][MAX_MPGC]
//	m_i64MLUisize[MAX_VTS][MAX_LUS]
//  m_bMCellReUsed[MAX_VTS][MAX_MPGC]

	int j;
	int nArray,nACell,nCell,nPGC,nLU;
	int VIDa, CIDa;
	int VIDb, CIDb;

	for (j=0; j<m_nIFOs+1 ;j++)
	{
		nArray=m_MenuCells[j].GetSize();
		for (nCell=0; nCell<nArray; nCell++)
			m_MenuCells[j][nCell].bAlreadySize=false;

		for (nPGC=0; nPGC <m_nMPGCs[j]; nPGC++)
		{
			m_i64MPGCisize[j][nPGC]=0;
			m_bMCellReUsed[j][nPGC]=false;

			for (nCell=0; nCell <m_nMCells[j][nPGC]; nCell++)
			{
				VIDa=GetNbytes(2,&m_pIFO[j][m_M_C_POST[j][nPGC] +4*nCell]);
				CIDa=m_pIFO[j][m_M_C_POST[j][nPGC] +4*nCell +3];
				for (nACell=0; nACell<nArray; nACell++)
				{
					VIDb=m_MenuCells[j][nACell].VID;
					CIDb=m_MenuCells[j][nACell].CID;
					if (VIDa==VIDb && CIDa==CIDb)
					{
						if 	(m_MenuCells[j][nACell].bAlreadySize)
							m_bMCellReUsed[j][nPGC]=true;
						else
						{
							m_i64MPGCisize[j][nPGC]+=m_MenuCells[j][nACell].i64size;
							m_MenuCells[j][nACell].bAlreadySize=true;
						}
					}
				}
			}
		} // For PGCs

		for (nLU=0; nLU <m_nLUs[j]; nLU++)
		{
			m_i64MLUisize[j][nLU]=0;
			for (nPGC=0; nPGC <m_nPGCinLU[j][nLU]; nPGC++)
				m_i64MLUisize[j][nLU]+=m_i64MPGCisize[j][nPGC+m_nIniPGCinLU[j][nLU]];

		}  // For LUs
	}// For VTSs
}


void CVobBlankerApp::GetMenuEndSize()
{
// Fills:
//	m_i64MPGCfsize[MAX_VTS][MAX_MPGC]
//  m_i64Mfsize[MAX_VTS]
//	m_i64MLUfsize[MAX_VTS][MAX_MLUS]

	int j;
	int nArray,nACell,nCell,nPGC,nnPGC,nLU;
	int VIDa, CIDa;
	int VIDb, CIDb;
	bool bAudio;

	for (j=0; j<m_nIFOs+1 ;j++)
	{
		nArray=m_MenuCells[j].GetSize();
		for (nCell=0; nCell<nArray; nCell++)
			m_MenuCells[j][nCell].bAlreadySize=false;

		for (nPGC=0; nPGC <m_nMPGCs[j]; nPGC++)
		{
			m_i64MPGCfsize[j][nPGC]=0;
//			if (m_iMAction[j][nPGC] ==BLANK) m_i64MPGCfsize[j][nPGC]=5*2048*m_nMCells[j][nPGC];
			if (m_iMAction[j][nPGC] ==DELPBK) m_i64MPGCfsize[j][nPGC]=0;
			if (m_iMAction[j][nPGC] ==CELLBASED)
				m_i64MPGCfsize[j][nPGC]=CalculateMenuCellBasedSize(j,nPGC);

			nnPGC=nPGC;
			if (m_iMAction[j][nPGC] ==REUSE)
			{
				nnPGC=nPGC-m_nIniPGCinLU[j][m_nLU_MPGC[j][nPGC]];
				nnPGC=nnPGC+m_nIniPGCinLU[j][m_iReuseLU[j][nPGC]];
			}

// CHECKREUSE
//			if (m_iMAction[j][nPGC] ==REUSE || m_iMAction[j][nPGC] ==KEEP)
			if (m_iMAction[j][nPGC] ==KEEP || m_iMAction[j][nPGC] == BLANK)
			{
				for (nCell=0; nCell <m_nMCells[j][nnPGC]; nCell++)
				{
					VIDa=GetNbytes(2,&m_pIFO[j][m_M_C_POST[j][nnPGC] +4*nCell]);
					CIDa=m_pIFO[j][m_M_C_POST[j][nnPGC] +4*nCell +3];
					for (nACell=0; nACell<nArray; nACell++)
					{
						VIDb=m_MenuCells[j][nACell].VID;
						CIDb=m_MenuCells[j][nACell].CID;
						if (VIDa==VIDb && CIDa==CIDb)
						{
							if 	(!m_MenuCells[j][nACell].bAlreadySize)
							{
								if (m_iMAction[j][nPGC] ==KEEP)
									m_i64MPGCfsize[j][nPGC]+=m_MenuCells[j][nACell].i64size;
								if (m_iMAction[j][nPGC] ==BLANK)
									m_i64MPGCfsize[j][nPGC]+=5*2048;

								m_MenuCells[j][nACell].bAlreadySize=true;
							}
						}
					}
				}
			}
			if (m_iMAction[j][nPGC] ==STILLA || m_iMAction[j][nPGC] ==STILLNA)
			{
				if (m_iMAction[j][nPGC] ==STILLA) bAudio=true;
				else  bAudio=false;
		 
				for (nCell=0; nCell <m_nMCells[j][nPGC]; nCell++)
				{
					VIDa=GetNbytes(2,&m_pIFO[j][m_M_C_POST[j][nPGC] +4*nCell]);
					CIDa=m_pIFO[j][m_M_C_POST[j][nPGC] +4*nCell +3];
					for (nACell=0; nACell<nArray; nACell++)
					{
						VIDb=m_MenuCells[j][nACell].VID;
						CIDb=m_MenuCells[j][nACell].CID;
						if (VIDa==VIDb && CIDa==CIDb)
						{
							if 	(!m_MenuCells[j][nACell].bAlreadySize)
							{
								m_i64MPGCfsize[j][nPGC]+= (2048*theApp.CalculateStillMenuCellSize(j,nPGC,nCell,bAudio,0));
								m_MenuCells[j][nACell].bAlreadySize=true;
							}
						}
					}
				}
			}
		} // For PGCs

		m_i64Mfsize[j]=0;
		for (nLU=0; nLU <m_nLUs[j]; nLU++)
		{
			m_i64MLUfsize[j][nLU]=0;
			for (nPGC=0; nPGC <m_nPGCinLU[j][nLU]; nPGC++)
				m_i64MLUfsize[j][nLU]+=m_i64MPGCfsize[j][nPGC+m_nIniPGCinLU[j][nLU]];

			m_i64Mfsize[j]+=m_i64MLUfsize[j][nLU];
		}  // For LUs
	}// For VTSs
}

void CVobBlankerApp::GetMenuAudioData()
{
	int nVTS,nA,nCode,nId;
	CString csAux,csAux2;
//	FILE *in;
//	int i;


	for (nVTS=0; nVTS<m_nIFOs+1 ;nVTS++)
	{
// Fill Pointers

		m_nMenuAudio[nVTS]=GetNbytes(2,&m_pIFO[nVTS][0x102]);
		for (nA=0; nA<8; nA++)
		{
			m_iMenuAddIdAudio[nVTS][nA]=-1;
//			m_iMenuBRAudio[nVTS][nA]=0;
		}

		for (nA=0; nA<m_nMenuAudio[nVTS]; nA++)
		{
			UpdateProgress(m_pMainWnd, ((nVTS)*8+nA)*100/(m_nIFOs*8),false);
			nCode=m_pIFO[nVTS][0x104+8*nA] >> 5;
			if (nCode==0) nId= 0x80;
			if (nCode==1) nId= 0x80;
			if (nCode==2) nId= 0xC0;
			if (nCode==3) nId= 0xC8;
			if (nCode==4) nId= 0xA0;
			if (nCode==5) nId= 0x80;
			if (nCode==6) nId= 0x88;
			if (nCode==7) nId= 0x80;

			m_iMenuAddIdAudio[nVTS][nA]=nId;

/*			if (nId != -1 && ((nId<=0x8f && nId>=0x80) || 
				              (nId<=0xa7 && nId>=0xa0) ||
							  (nId<=0xc7 && nId>=0xc0) ))
			{
				if (nVTS==0)
					csAux2="VIDEO_TS.VOB";
				else
					csAux2.Format(_T("VTS_%02d_0.VOB"), nVTS);

				csAux=m_csInputPath+'\\'+csAux2;

				in=fopen (csAux,"rb");
				if (in !=NULL)
				{
// Look for a Audio pack, but only in a few packs...
					for (i=0;i<MAXLOOKFORAUDIOINMENUS && m_iMenuBRAudio[nVTS][nA]==0; i++ )
					{
						if (readbuffer(m_buffer,in)!=2048)
						{
							if (in !=NULL) fclose (in);
							i=MAXLOOKFORAUDIOINMENUS;
						}
						else
						{
							if (IsAudio(m_buffer)  && getAudId(m_buffer)== nId)
							{
								if (nId >=0x80 && nId <=0x87)
									m_iMenuBRAudio[nVTS][nA]=getac3rate(m_buffer);
								else if (nId >=0x88 && nId <=0x8f)
									m_iMenuBRAudio[nVTS][nA]=getdtsrate(m_buffer);
								else if (nId >=0xa0 && nId <=0xa7)
									m_iMenuBRAudio[nVTS][nA]=getpcmrate(m_buffer);
								else if (nId >=0xc0 && nId <=0xc7)
									m_iMenuBRAudio[nVTS][nA]=getmpgrate(m_buffer);
							}
						}
					}
				}
				if (in!=NULL) fclose (in);
			}// If nId
*/
		}  // For nA
	}// for VTS
}


void CVobBlankerApp::GetSubsData()
{
	int nVTS,nT;
	int nS,nSS;
	uchar SubStatus0, SubStatus1,SubStatus2,SubStatus3;
	bool b43,bWI,bLB,bPS;


	for (nVTS=1; nVTS<m_nIFOs+1 ;nVTS++)
	{
		m_nSubs[nVTS]=GetNbytes(2,&m_pIFO[nVTS][0x254]);
		if (m_nSubs[nVTS] >32 ) m_nSubs[nVTS]=32;

		for (nSS=0; nSS<32; nSS++)
			m_dwVOBSubDuration[nVTS][nSS]=0;

		for (nS=0; nS<32; nS++)
		{
			for (nT=0 ; nT<m_nPGCs[nVTS] ; nT++)
			{
				m_iIdTSubsStrip[nVTS][nS][nT]=0;
/// Calculate the total duration of each sub stream
 				SubStatus0=m_pIFO[nVTS][m_VTS_PGC[nVTS][nT]+nS*4+0x1c+0];
				SubStatus1=m_pIFO[nVTS][m_VTS_PGC[nVTS][nT]+nS*4+0x1c+1];
				SubStatus2=m_pIFO[nVTS][m_VTS_PGC[nVTS][nT]+nS*4+0x1c+2];
				SubStatus3=m_pIFO[nVTS][m_VTS_PGC[nVTS][nT]+nS*4+0x1c+3];
				b43=true; bWI=false;
				if (m_iVideoAttr[nVTS] & 0x400)	{b43=false; bWI=true;}
				bLB=false; bPS=false;
				if (bWI && !(m_iVideoAttr[nVTS] & 0x100)) bLB=true;
				if (bWI && !(m_iVideoAttr[nVTS] & 0x200)) bPS=true;
				if (SubStatus0 & 0x80)
				{
					nSS=SubStatus0 & 0x1F;
					if (b43) 
						m_dwVOBSubDuration[nVTS][nSS]=
							AddDuration(m_dwDurationOwn[nVTS][nT],m_dwVOBSubDuration[nVTS][nSS]);
					nSS=SubStatus1 & 0x1F;
					if (bWI) 
						m_dwVOBSubDuration[nVTS][nSS]=
							AddDuration(m_dwDurationOwn[nVTS][nT],m_dwVOBSubDuration[nVTS][nSS]);
					nSS=SubStatus2 & 0x1F;
					if (bLB) 
						m_dwVOBSubDuration[nVTS][nSS]=
							AddDuration(m_dwDurationOwn[nVTS][nT],m_dwVOBSubDuration[nVTS][nSS]);
					nSS=SubStatus3 & 0x1F;
					if (bPS) 
						m_dwVOBSubDuration[nVTS][nSS]=
							AddDuration(m_dwDurationOwn[nVTS][nT],m_dwVOBSubDuration[nVTS][nSS]);
				}
			}
		}
	}
}

void CVobBlankerApp::GetAudioData()
{
//	int i,k,kk,nCell;
	int nVTS,nT;
	int nA,nCode;
	int nAA;
	CString csAux,csAux2;
//	FILE *in;
//	__int64 i64IniSec, i64AccSec;
//	struct  _stati64 statbuf;
//	uchar AudStatus;
	int AddId;
//	bool bEnd;
//	int layer;


	for (nVTS=1; nVTS<m_nIFOs+1 ;nVTS++)
	{
// Fill Pointers
		m_nAudio[nVTS]=GetNbytes(2,&m_pIFO[nVTS][0x202]);
// nA= # stream.
		for (nA=0; nA<8; nA++)
		{
			m_dwVOBAudDuration[nVTS][nA]=0;
			m_iAddIdAudio[nVTS][nA]=-1;
//			m_iBRAudio[nVTS][nA]=0;
			m_iAudioAttr[nVTS][nA]=-1;
			m_iAudioAttrBK[nVTS][nA]=-1;
			m_iStreamUsedInAudio[nVTS][nA]=0;
		}

		for (nT=0 ; nT<m_nPGCs[nVTS] ; nT++)
		{
// nA= track number; nAA :stream number
			for (nA=0; nA<8; nA++)
			{
				m_iIdTAudio[nVTS][nA][nT]=-1;
				m_iIdTAudioStrip[nVTS][nA][nT]=0;
				for (nAA=0; nAA<8; nAA++)
				{
					if (m_pIFO[nVTS][m_VTS_PGC[nVTS][nT]+nA*2+0x0c] & 0x80 &&
						(m_pIFO[nVTS][m_VTS_PGC[nVTS][nT]+nA*2+0x0c] & 0x07)==nAA)
					{
						m_dwVOBAudDuration[nVTS][nAA]=AddDuration(m_dwDurationOwn[nVTS][nT],m_dwVOBAudDuration[nVTS][nA]);
						m_iIdTAudio[nVTS][nA][nT]=nAA;
						m_iStreamUsedInAudio[nVTS][nA]+= (1<<nAA);
					}
				}
			}
		}

		for (nA=0; nA<m_nAudio[nVTS]; nA++)
		{
			UpdateProgress(m_pMainWnd, ((nVTS-1)*8+nA)*100/(m_nIFOs*8),false);
			m_iAudioAttr[nVTS][nA]=GetNbytes(2,&m_pIFO[nVTS][0x204+8*nA]);
			m_iAudioAttrBK[nVTS][nA]=m_iAudioAttr[nVTS][nA];
			nCode=m_pIFO[nVTS][0x204+8*nA] >> 5;
			if (nCode==0) { AddId=0x80; csAux="ac3";}
			if (nCode==1) { AddId=0x80; csAux="???";}
			if (nCode==2) { AddId=0xC0; csAux="Mpeg1";}
			if (nCode==3) { AddId=0xC8; csAux="Mpeg2";}
			if (nCode==4) { AddId=0xA0; csAux="LPCM";}
			if (nCode==5) { AddId=0x80; csAux="???";}
			if (nCode==6) { AddId=0x88; csAux="DTS";}
			if (nCode==7) { AddId=0x80; csAux="???";}

// stream id: The stream number is indicated in the PGC
			m_iAddIdAudio[nVTS][nA]=AddId;
		}	

/*
// Explore VOB to detect bitrate (assuming constant bitrate in a stream)
//			nId=m_iIdAudio[nVTS][nA];

//			for (nT=0;nT<m_nPGCs[nVTS] && m_iBRAudio[nVTS][nA]==0 &&
			for (nT=0;nT<m_nPGCs[nVTS] &&
				 (m_pIFO[nVTS][m_VTS_PGC[nVTS][nT]+nA*2+0x0c] & 0x80);nT++)
			{
				nId=m_pIFO[nVTS][m_VTS_PGC[nVTS][nT]+nA*2+0x0c] & 0x7;
				nId+=m_iAddIdAudio[nVTS][nA];
				if (nId != -1 && ((nId<=0x8f && nId>=0x80) || 
					              (nId<=0xa7 && nId>=0xa0) ||
								  (nId<=0xc7 && nId>=0xc0) ) 
							   && m_iBRAudio[nVTS][nId&0x7] ==0 )
				{
					for ( nCell=0; nCell<2 && nCell < m_nCells[nVTS][nT] &&  m_iBRAudio[nVTS][nId&0x07]==0;nCell++)
					{
					i64IniSec=GetNbytes(4,&m_pIFO[nVTS][m_C_PBKT[nVTS][nT]+24*nCell+8])+1;
					i64AccSec=0;
						for (k=1; k<10; k++)
						{
							csAux2.Format(_T("VTS_%02d_%d.VOB"), nVTS,k);
							kk=k;
							csAux=m_csInputPath+'\\'+csAux2;
							if (_stati64 ( csAux, &statbuf)==0)
								{
								i64AccSec+= (statbuf.st_size/2048);
								if (i64AccSec > i64IniSec)
								{
									k=10;
									i64AccSec-= (statbuf.st_size/2048);
								}
							}
							else 
								k=20;
						}

						if (k==11)
						{
							in=fopen (csAux,"rb");
							if (in!=NULL) 
							{
								fseek(in, (int)( (i64IniSec-i64AccSec )*2048) ,SEEK_SET);

// Look for a Audio pack, but only in a few packs...
								for (i=0,bEnd=false;i<MAXLOOKFORAUDIO && m_iBRAudio[nVTS][nA]==0 && bEnd==false; i++ )
								{
									if (readbuffer(m_buffer,in)!=2048)
									{
										if (in !=NULL) fclose (in);
										kk++;
										csAux2.Format(_T("VTS_%02d_%d.VOB"), nVTS, kk);
										csAux=m_csInputPath+ '\\' +csAux2;
										in=fopen(csAux,"rb");
										if (readbuffer(m_buffer,in)!=2048)
										{
//											MyErrorBox("Error: Reached end of VOB too early");
											if (in !=NULL) fclose (in);
											bEnd=true;
										}
									}
									if (IsAudio(m_buffer)  && getAudId(m_buffer)== nId)
									{
										if (nId >=0x80 && nId <=0x87)
											m_iBRAudio[nVTS][nId&0x7]=getac3rate(m_buffer);
										else if (nId >=0x88 && nId <=0x8f)
											m_iBRAudio[nVTS][nA]=getdtsrate(m_buffer);
										else if (nId >=0xa0 && nId <=0xa7)
											m_iBRAudio[nVTS][nA]=getpcmrate(m_buffer);
										else if (nId >=0xc0 && nId <=0xc7)
										{
//											layer=getmpglayer(m_buffer);
//											csAux2.Format(_T(" L %d"),layer);
//											csAux=csAux+csAux2;
											m_iBRAudio[nVTS][nA]=getmpgrate(m_buffer);
										}
									}
								}
							}
							if (in !=NULL) fclose(in);
						}
					}
				}  // If nId
			} // For NT
		} // For NA
*/
	} // For VTS
}

uchar CVobBlankerApp::ST_GetAudioStatus(int nVTS, int nT, int nA)
{
	uchar AudStatus;

	AudStatus=m_pIFO[nVTS][m_VTS_PGC[nVTS][nT]+nA*2+0x0c];

	return AudStatus;
}

void CVobBlankerApp::ST_GetAudioDelayAndRate(int nVTS, int nT, int nA, int * iDelay, int * iRate)
{
// iRate= returns value if found, 0 if unknown 
// iDelay= returns value if found, 0x7fffffff if unknown 
	int nId,nCell;
	__int64 i64AccSec,i64IniSec,i64EndSec;
	int k,kk,i;
	bool bFirstVideo,bFirstAudio;
	CString csAux, csAux2;
	FILE *in;
	struct  _stati64 statbuf;
	int iAudPTS,iVidPTS;
	int AudDelay,AudioStatus;
	

	*iRate=0;
	*iDelay=0x7fffffff;
	AudioStatus=ST_GetAudioStatus(nVTS, nT, nA);
	if ((AudioStatus & 0x80)==0) return;

	nId=m_iIdTAudio[nVTS][nA][nT];
	if (nId< 0) return;
// nA is the track number
	nId=m_iIdTAudio[nVTS][nA][nT]+m_iAddIdAudio[nVTS][nA];

//	nId=m_iAddIdAudio[nVTS][m_iIdTAudio[nVTS][nA][nT]]+nA;

	bFirstVideo=false;
	bFirstAudio=false;
	for ( nCell=0; nCell<2 && nCell < m_nCells[nVTS][nT] && (bFirstVideo==false || bFirstAudio==false ) ;nCell++)
	{
		i64IniSec=GetNbytes(4,&m_pIFO[nVTS][m_C_PBKT[nVTS][nT]+24*nCell+8]);
		i64EndSec=GetNbytes(4,&m_pIFO[nVTS][m_C_PBKT[nVTS][nT]+24*nCell+0x14])+1;
		i64AccSec=0;
		for (k=1; k<10; k++)
		{
			csAux2.Format(_T("VTS_%02d_%d.VOB"), nVTS,k);
			kk=k;
			csAux=m_csInputPath+'\\'+csAux2;
			if (_stati64 ( csAux, &statbuf)==0)
			{
				i64AccSec+= (statbuf.st_size/2048);
				if (i64AccSec > i64IniSec)
				{
					k=10;
					i64AccSec-= (statbuf.st_size/2048);
				}
			}
			else 
				k=20;
		}
		if (k==11)
		{
			in=fopen (csAux,"rb");
			fseek(in, (int)( (i64IniSec-i64AccSec )*2048) ,SEEK_SET);
// Look for a Video and Audio pack, but only in a few packs...
			for (i=0;i<MAXLOOKFORAUDIO && i<(i64EndSec-i64AccSec ) && 
				       (bFirstVideo==false || bFirstAudio==false ); i++ )
			{
				if (readbuffer(m_buffer,in)!=2048)
				{
					if (in !=NULL) fclose (in);
					kk++;
					csAux2.Format(_T("VTS_%02d_%d.VOB"), nVTS, kk);
					csAux=m_csInputPath+ '\\' +csAux2;
					in=fopen(csAux,"rb");
					if (readbuffer(m_buffer,in)!=2048)
					{
//						MyErrorBox("Error: Reached end of VOB too early");
						if (in !=NULL)  fclose (in);
						i=MAXLOOKFORAUDIO;
					}
				}
				if (bFirstAudio==false && IsAudio(m_buffer) && 
					getAudId (m_buffer)==nId )
				{
					if (m_buffer[0x15] & 0x80) 
					{
						bFirstAudio=true;
						iAudPTS= (int)readpts(&m_buffer[0x17]);
/// Get bitrate here, can be different per PGC!!
						if (nId >=0x80 && nId <=0x87)
							*iRate=getac3rate(m_buffer);
						else if (nId >=0x88 && nId <=0x8f)
							*iRate=getdtsrate(m_buffer);
						else if (nId >=0xa0 && nId <=0xa7)
							*iRate=getpcmrate(m_buffer);
						else if (nId >=0xc0 && nId <=0xc7)
						{
//							layer=getmpglayer(m_buffer);
//							csAux2.Format(_T(" L %d"),layer);
//							csAux=csAux+csAux2;
							*iRate=getmpgrate(m_buffer);
						}
					}
				}
				if (bFirstVideo==false && IsNav(m_buffer) && i==0 )
				{
/*					if (m_buffer[0x15] & 0x80) 
					{
						bFirstVideo=true;
						iVidPTS= (int)readpts(&m_buffer[0x17]);
					}*/
					iVidPTS= GetNbytes(4,&m_buffer[0x39]);
					bFirstVideo=true;
				}
			}
			if (in !=NULL) fclose(in);
		} // If k==1

	} // For nCell

	if (!bFirstAudio || !bFirstVideo)
		*iDelay=0x7fffffff;
	else
	{
		AudDelay=iAudPTS-iVidPTS;
		if (AudDelay <0)
			AudDelay-=44;
		else
			AudDelay+=44;
		AudDelay/=90;

		*iDelay=AudDelay;
	}

}


	// Exit Value
int CVobBlankerApp::ExitInstance()
{
	int ret;

	MemoryDeleteAll();
	
	ret= CWinApp::ExitInstance();
	return ret;

}

void CVobBlankerApp::UpdateProgress( CWnd* pDlg, int nPerc, bool bTotal)
{
	MSG msg;
	static int oldPerc=-1;

	
	if ( pDlg )
	{
		while (PeekMessage(&msg, NULL, 0, 0, PM_REMOVE))
		{
			TranslateMessage(&msg);
			DispatchMessage(&msg);
		}
		if (oldPerc!=nPerc)
		{
			oldPerc=nPerc;
			((CVobBlankerDlg *)pDlg)->UpdateProgress(nPerc, bTotal);
		}
	}
}

void CVobBlankerApp::UpdateProgressCell( CWnd* pDlg, int nPerc)
{
	MSG msg;
	static int oldPerc=-1;

	
	if ( pDlg )
	{
		while (PeekMessage(&msg, NULL, 0, 0, PM_REMOVE))
		{
			TranslateMessage(&msg);
			DispatchMessage(&msg);
		}
		if (oldPerc!=nPerc)
		{
			oldPerc=nPerc;
			((CCellsDlg *)pDlg)->UpdateProgress(nPerc);
		}
	}
}

void CVobBlankerApp::UpdateProgressFullScan(CWnd* pDlg, int iDomain, int nVTS, int nPerc)
{
	MSG msg;
	static int oldPerc=-1;

	
	if ( pDlg )
	{
		while (PeekMessage(&msg, NULL, 0, 0, PM_REMOVE))
		{
			TranslateMessage(&msg);
			DispatchMessage(&msg);
		}
		if (oldPerc!=nPerc)
		{
			oldPerc=nPerc;
			((CFullScanDlg *)pDlg)->UpdateProgress(iDomain,nVTS,nPerc);
		}
	}
}

void CVobBlankerApp::FV_FixMenu(int n, CWnd* pDlg)
{

	int nCells,nNavs;
	int	Vobid,Cellid;
	int i,j,k,kk;
	__int64 iPack, iTotalPacks;
	int nCellsToBeCorrected;
	CString csAux,csAux2;


	MyLog("--------------MENU VOB FIXING POINTERS STARTED-",GREEN15);
	
	nCells=m_MenuCells[n].GetSize();
	nNavs=m_ANavinfo.GetSize();
	nCellsToBeCorrected=0;

// Calculate Total number of Nav Packs to be corrected.
	iTotalPacks=0;
	for (i=0; i<nCells; i++)
	{
		if (m_MenuCells[n][i].bFixPointers || m_bCheckFixMenuPointers)
		{
			nCellsToBeCorrected++;
			iTotalPacks+=m_MenuCells[n][i].nNavs;
		}
	}
	csAux.Format(_T("VTS %02d: Fixing Menu VOB pointers in %d Cells of %d"),
		          n, nCellsToBeCorrected, nCells);
	MyLog(csAux);


// DO THE JOB
	m_Fout=NULL;

	if (n==0)
		csAux="VIDEO_TS.VOB";
	else
		csAux.Format(_T("VTS_%02d_0.VOB"), n);
	m_csFout=m_csOutputPath+ '\\' +csAux;
	m_Fout=fopen(m_csFout,"r+b");

	for (i=0,iPack=0; i<nCells; i++)
	{
		if (m_MenuCells[n][i].bFixPointers || m_bCheckFixMenuPointers)
		{
			Vobid=m_MenuCells[n][i].NVID;
			Cellid=m_MenuCells[n][i].NCID;
			csAux.Format(_T("     Fixing Cell # %d, VID=%d  CID=%d"),i+1,Vobid,Cellid);
			MyLog(csAux);

//	Copy the Navinfo of the Cell
			m_CellNavinfo.RemoveAll();

			for ( k=0,kk=0 ; k< nNavs ; k++)
			{
				if (Cellid == m_ANavinfo[k].CID &&
						Vobid  == m_ANavinfo[k].VID )
				{
					m_CellNavinfo.SetAtGrow (kk, m_ANavinfo[k]);
					kk++;
				}
			}
			m_nNavsInCell=m_CellNavinfo.GetSize();

// Copy Audio & Subs in Cell info 
			for (j=0;j<8;j++)
			{
  				m_nAudioStream[j]=m_AAudioinfo[j].GetSize();
				m_CellAudioinfo[j].RemoveAll();

				for ( k=0,kk=0 ; k< m_nAudioStream[j] ; k++)
				{
					if (Cellid == m_AAudioinfo[j][k].CID &&
							Vobid  == m_AAudioinfo[j][k].VID )
					{
						m_CellAudioinfo[j].SetAtGrow (kk, m_AAudioinfo[j][k]);
						kk++;
					}
				}
				m_nAudioInCell[j]=m_CellAudioinfo[j].GetSize();
			}

			for (j=0;j<32;j++)
			{
  				m_nSubsStream[j]=m_ASubsinfo[j].GetSize();
				m_CellSubsinfo[j].RemoveAll();

				for ( k=0,kk=0 ; k< m_nSubsStream[j] ; k++)
				{
					if (Cellid == m_ASubsinfo[j][k].CID &&
							Vobid  == m_ASubsinfo[j][k].VID )
					{
						m_CellSubsinfo[j].SetAtGrow (kk, m_ASubsinfo[j][k]);
						kk++;
					}
				}
				m_nSubsInCell[j]=m_CellSubsinfo[j].GetSize();

			}

			for (k=0; k<m_nNavsInCell; k++)
			{
				if ((iPack%MODUPDATEPACK) == 0) UpdateProgress(pDlg, (int)((100*iPack)/iTotalPacks), true);
				iPack++;
// Locate the Pack in the File
				fseek(m_Fout, (long) ((m_CellNavinfo[k].LBA)*2048), SEEK_SET);
				if (readbuffer(m_buffer,m_Fout)!=2048)
				{
					csAux.Format(_T("    ERROR: Unable to read sector of VOB!!"));
					if (m_Fout !=NULL) {fclose(m_Fout); m_Fout=NULL;}
					MyErrorLog_Box(csAux);
					m_bInProcess=false;
					return;
				}
// Rewind.
				fseek(m_Fout, (long) ((m_CellNavinfo[k].LBA)*2048), SEEK_SET);
// Fix Pack if Nav and belongs to the cell
				if (!IsNav(m_buffer) ||
					m_buffer[0x420]!=(uchar)(Vobid%256) ||
					m_buffer[0x41F]!=(uchar)(Vobid/256) ||
					m_buffer[0x422]!= (uchar) Cellid     )
				{
					csAux.Format(_T("     WARNING: NavPack not found LBA= %I64d"),m_CellNavinfo[k].LBA);
					MyLog (csAux,ORANGE);
					m_nWarnings++;
				}
				else
				{
					FV_FixNavPack(k);
					writebuffer(m_buffer,m_Fout);
				}
			} /* For k (PAcksinCell) */		
		} /* if FixPointers */
	} /* For i (Cells) */

//	Free Audio  & Subs memory (Navs and Cells are used in ProcessIFO)
	for (k=0;k<8 ;k++)
	{
		m_AAudioinfo[k].RemoveAll();
		m_CellAudioinfo[k].RemoveAll();
	}
	for (k=0;k<32 ;k++)
	{
		m_ASubsinfo[k].RemoveAll();
		m_CellSubsinfo[k].RemoveAll();
	}

	if (m_Fout !=NULL) {fclose(m_Fout); m_Fout=NULL;}

	MyLog("--------------MENU VOB FIXING POINTERS FINISHED-",GREEN15);


}
void CVobBlankerApp::FV_FixVob(int n, CWnd* pDlg)
{
	int nCells,nNavs;
	int	Vobid,Cellid;
	int i,j,k,kk;
	__int64 iPack, iTotalPacks;
	int nCellsToBeCorrected;
	CString csAux,csAux2;
	__int64 nSectVobout[10];
	int nVobout, newVobout,nFiles;
	struct  _stati64 statbuf;
	__int64 i64sectors;


	MyLog("--------------TITLE VOB FIXING POINTERS STARTED-",GREEN15);
	for (k=1; k<10; k++)
	{
		csAux2.Format(_T("VTS_%02d_%d.VOB"), n,k);
		csAux=m_csOutputPath+'\\'+csAux2;
		if (_stati64 ( csAux, &statbuf)==0)
			nSectVobout[k]= statbuf.st_size/2048;
		else 
		{
			nFiles=k-1;
			k=20;
		}
	}

	
	nCells=m_TitleCells[n].GetSize();
	nNavs=m_ANavinfo.GetSize();
	nCellsToBeCorrected=0;

// Calculate Total number of Nav Packs to be corrected.
	iTotalPacks=0;
	for (i=0; i<nCells; i++)
	{
		if (m_TitleCells[n][i].bFixPointers || m_bCheckFixTitlePointers)
		{
			nCellsToBeCorrected++;
			iTotalPacks+=m_TitleCells[n][i].nNavs;
		}
	}
	csAux.Format(_T("VTS %02d: Fixing VOB pointers in %d Cells of %d"),
		          n, nCellsToBeCorrected, nCells);
	MyLog(csAux);


// DO THE JOB
	m_Fout=NULL;
	nVobout=0;

	for (i=0,iPack=0; i<nCells; i++)
	{
		if (m_TitleCells[n][i].bFixPointers || m_bCheckFixTitlePointers)
		{
			Vobid=m_TitleCells[n][i].NVID;
			Cellid=m_TitleCells[n][i].NCID;
			csAux.Format(_T("     Fixing Cell # %d, VID=%d  CID=%d"),i+1,Vobid,Cellid);
			MyLog(csAux);

//	Copy the Navinfo of the Cell
			m_CellNavinfo.RemoveAll();

			for ( k=0,kk=0 ; k< nNavs ; k++)
			{
				if (Cellid == m_ANavinfo[k].CID &&
						Vobid  == m_ANavinfo[k].VID )
				{
					m_CellNavinfo.SetAtGrow (kk, m_ANavinfo[k]);
					kk++;
				}
			}
			m_nNavsInCell=m_CellNavinfo.GetSize();

// Copy Audio & Subs in Cell info 
			for (j=0;j<8;j++)
			{
  				m_nAudioStream[j]=m_AAudioinfo[j].GetSize();
				m_CellAudioinfo[j].RemoveAll();

				for ( k=0,kk=0 ; k< m_nAudioStream[j] ; k++)
				{
					if (Cellid == m_AAudioinfo[j][k].CID &&
						Vobid  == m_AAudioinfo[j][k].VID )
					{
						m_CellAudioinfo[j].SetAtGrow (kk, m_AAudioinfo[j][k]);
						kk++;
					}
				}
				m_nAudioInCell[j]=m_CellAudioinfo[j].GetSize();
			}

			for (j=0;j<32;j++)
			{
  				m_nSubsStream[j]=m_ASubsinfo[j].GetSize();
				m_CellSubsinfo[j].RemoveAll();

				for ( k=0,kk=0 ; k< m_nSubsStream[j] ; k++)
				{
					if (Cellid == m_ASubsinfo[j][k].CID &&
						Vobid  == m_ASubsinfo[j][k].VID )
					{
						m_CellSubsinfo[j].SetAtGrow (kk, m_ASubsinfo[j][k]);
						kk++;
					}
				}
				m_nSubsInCell[j]=m_CellSubsinfo[j].GetSize();

			}

			for (k=0; k<m_nNavsInCell; k++)
			{
				if ((iPack%MODUPDATEPACK) == 0) UpdateProgress(pDlg, (int)((100*iPack)/iTotalPacks), true);
				iPack++;

				for (j=1, i64sectors=0; j<=nFiles;j++)
				{
					i64sectors+=nSectVobout[j];
					if (m_CellNavinfo[k].LBA < i64sectors)
					{
						i64sectors=i64sectors-nSectVobout[j];
						newVobout=j;
						j=20;
					}
					else
						if (j==nFiles)
						{
							csAux.Format(_T("    ERROR: NavPack out of VOB!!"));
							if (m_Fout !=NULL) {fclose(m_Fout); m_Fout=NULL;}
							MyErrorLog_Box(csAux);
							m_bInProcess=false;
							return;
						}

				}
				if (newVobout !=nVobout)
				{
					nVobout=newVobout;
					if (m_Fout !=NULL) {fclose(m_Fout); m_Fout=NULL;}
					csAux.Format(_T("VTS_%02d_%d.VOB"), n, nVobout);
					m_csFout=m_csOutputPath+ '\\' +csAux;
					m_Fout=fopen(m_csFout,"r+b");
				}
// Locate the Pack in the File
				fseek(m_Fout, (long) ((m_CellNavinfo[k].LBA-i64sectors)*2048), SEEK_SET);
				if (readbuffer(m_buffer,m_Fout)!=2048)
				{
					csAux.Format(_T("    ERROR: Unable to read sector of VOB!!"));
					if (m_Fout !=NULL) {fclose(m_Fout); m_Fout=NULL;}
					MyErrorLog_Box(csAux);
					m_bInProcess=false;
					return;
				}
				fseek(m_Fout, (long) ((m_CellNavinfo[k].LBA-i64sectors)*2048), SEEK_SET);
				if (!IsNav(m_buffer) ||
					m_buffer[0x420]!=(uchar)(Vobid%256) ||
					m_buffer[0x41F]!=(uchar)(Vobid/256) ||
					m_buffer[0x422]!= (uchar) Cellid     )
				{
					csAux.Format(_T("     WARNING: NavPack not found LBA= %I64d"),m_CellNavinfo[k].LBA);
					MyLog (csAux,ORANGE);
					m_nWarnings++;
				}
				else
				{
					FV_FixNavPack(k);
					writebuffer(m_buffer,m_Fout);
				}
			} /* For k (PAcksinCell) */		
		} /* if FixPointers */
	} /* For i (Cells) */

//	Free Audio  & Subs memory (Navs and Cells are used in ProcessIFO)
	for (k=0;k<8 ;k++)
	{
		m_AAudioinfo[k].RemoveAll();
		m_CellAudioinfo[k].RemoveAll();
	}
	for (k=0;k<32 ;k++)
	{
		m_ASubsinfo[k].RemoveAll();
		m_CellSubsinfo[k].RemoveAll();
	}

	if (m_Fout !=NULL) {fclose(m_Fout); m_Fout=NULL;}

	MyLog("--------------TITLE VOB FIXING POINTERS FINISHED-",GREEN15);

}

void CVobBlankerApp::FV_FixNavPack(int n)
{

/*
NavPack is in m_buffer;
n is the index of m_CellNavinfo;
m_CellNavinfo has all required NavInfo of the Cell

*/

	int j,nff,nrew;
	int vff, vrew;
	int myPTS0,myPTS1;
	static int timeline[19]={1,2,3,4,5,6,7,8,9,10,11,12,13,14,15,
                         20,60,120,240};
	__int64 s,ss,CurrentValue;
	CString csAux;
//	int nn,nnn;

//	int id;


// DSI Navigational pointers
	myPTS0= (int) GetNbytes(4,&m_buffer[0x39]);
	myPTS1= (int) GetNbytes(4,&m_buffer[0x3d]);
//  VOBU_SRI 
	Put4bytes(FV_GetSect(n,FV_FindNextVideo(n,1),0,0xbfffffff), &m_buffer[0x4f1]);
	Put4bytes(FV_GetSect(n,n+1,0,0x3fffffff), &m_buffer[0x541]);
	Put4bytes(FV_GetSect(n,n-1,0,0x3fffffff), &m_buffer[0x545]);
	Put4bytes(FV_GetSect(n,FV_FindNextVideo(n,-1),0,0xbfffffff), &m_buffer[0x595]);

	vff=n;
	vrew=n;
	for( j=0; j<19; j++ )
	{
		nff=FV_FindVobu(myPTS0+timeline[j]*45000, 0,m_nNavsInCell-1);
// a hack -- the last vobu in the cell shouldn't have any forward ptrs
		if( n==(m_nNavsInCell-1))
			nff=n+1;
		nrew=FV_FindVobu(myPTS0-timeline[j]*45000,0,m_nNavsInCell-1);

		Put4bytes(FV_GetSect(n,nff,j>=15 && nff>vff+1,0x3fffffff), &m_buffer[0x53d-j*4]);
		Put4bytes(FV_GetSect(n,nrew,j>=15 && nrew<vrew-1,0x3fffffff), &m_buffer[0x549+j*4]);
		vff=nff;
		vrew=nrew;
	}

// SYNCI Audio pointers
	
	for( j=0; j<8; j++ )
	{
		CurrentValue=GetNbytes(2,&m_buffer[0x599+j*2]);
		if (CurrentValue == 0 )
			s=0;
//		else if (CurrentValue == 0x3fff)
//			s=0x3fff;
		else if (m_nAudioStream[j]==0)
			s=0;
		else
		{
			ss=FV_FindAudSect(j,myPTS0,myPTS1);

			if( ss>=0 )
			{
				s=ss-m_CellNavinfo[n].LBA;
				if( s > 0x1fff || s < -(0x1fff))
				{
					csAux.Format(_T("     WARNING: audio sector out of range: %I64d (LBA #%I64d, pts %d)"),
						             ss,m_CellNavinfo[n].LBA,myPTS0);
					MyLog (csAux,ORANGE);
					m_nWarnings++;
					s=0;
				}
				if( s < 0 )
					s=(-s)|0x8000;
			}
			else
				s=0x3fff;
		}
		Put2bytes(s, &m_buffer[0x599+j*2]);
	}


// SYNCI Subs pointers. These pointers should point to a Nav Pack, not to  a sub pack
// The Nav pack identifies the VOBU where the sub is located.
// Subs have a duration from subpts0 to subpts1. VOBU has a duraion from pts0 to pts1
// Subs duration usually is higher than a VOBU, so:
// Find a Sub which overlaps this VOBU (  subpts0 <= pts1 && subpts1 >= pts0 )
//    - If does not exist--> point to this VOBU (0x7fffffff)
//    - If exist, point to the VOBU containing the Sub (if this, point to 07fffffff)


	for( j=0; j<32 ; j++ )
	{
		CurrentValue=GetNbytes(4,&m_buffer[0x5a9+j*4]);
		if (m_nSubsStream[j] == 0 )
		{
			if (CurrentValue == 0 )
				s=0;
			else
			    s= 0x7fffffff;
		}
		else
		{
			ss=FV_FindSubSect(j,myPTS0,myPTS1);
			if( ss>=0 )
			{
				s=ss-m_CellNavinfo[n].LBA;
				if( s > 0x1fffffff || s < -(0x1fffffff))
				{
					csAux.Format(_T("     WARNING: sub sector out of range: %I64d (LBA #%I64d, pts %d)"),
						             ss,m_CellNavinfo[n].LBA,myPTS0);
					MyLog (csAux,ORANGE);
					m_nWarnings++;
					s=0;
				}
				if( s < 0 )
					s=(-s)|0x80000000;
				if (s==0) s=0x7fffffff;
			}
			else
//This case was confused with 0x3fffffff, but must be 0x7fffffff;
				s=0x7fffffff;
		}
		Put4bytes(s, &m_buffer[0x5a9+j*4]);
	}
	// Other pointers
	Put4bytes( m_CellNavinfo[n].LastLBA-m_CellNavinfo[n].LBA, &m_buffer[0x40f]);

}

int CVobBlankerApp::FV_FindVobu(int pts,int l,int h)
{
	int m;

    if( h<l )
        return l-1;
    if( pts<   m_CellNavinfo[l].iPTS0 )
        return l-1;
    if( pts>=  m_CellNavinfo[h].iPTS1 )
        return h+1;
    while(l<h) 
	{
// binary search!
        m=(l+h+1)/2;
        if( pts < m_CellNavinfo[m].iPTS0 )
            h=m-1;
        else
            l=m;
    }
    return l;
}

unsigned int CVobBlankerApp::FV_GetSect(int curvobnum,int jumpvobnum,int skip,unsigned notfound)
{

    int l,h,i;

    if( skip )
	{

        // only set skip bit if one of the VOBU's from here to there contain video
        if( curvobnum<jumpvobnum )
		{
            l=curvobnum+1;
            h=jumpvobnum-1;
        }
		else
		{
            l=jumpvobnum+1;
            h=curvobnum-1;
        }
        for( i=l; i<=h; i++ )
            if( m_CellNavinfo[i].hasvideo )
                break;
        if( i<=h )
            skip=0x40000000;
        else
            skip=0;
    }
    if( jumpvobnum < 0 || jumpvobnum >= m_nNavsInCell )
        return notfound|skip;

    return abs((int)( m_CellNavinfo[jumpvobnum].LBA-m_CellNavinfo[curvobnum].LBA))
        |(m_CellNavinfo[jumpvobnum].hasvideo?0x80000000:0)
        |skip;
}

int CVobBlankerApp::FV_FindNextVideo(int cur, int dir)
{
// find next (dir=1) or previous(dir=-1) vobu with video
    int i;
  
    switch(dir)
	{
    case 1:  // forward
        for(i = cur+1; i < m_nNavsInCell; i++) if(m_CellNavinfo[i].hasvideo) return i;
        return -1;
    case -1: // backward
        for(i = cur-1; i > -1; i--) if(m_CellNavinfo[i].hasvideo) return i;
        return -1;
    default:
        // ??
        return -1;
    }
}

__int64 CVobBlankerApp::FV_FindAudSect(int aind, int pts0, int pts1)
{
    int l,h,m;
	int audpts;

	l=0;
	h=m_nAudioInCell[aind]-1;

	if( h<l )
		return -1;
	while(h>l)
	{
		m=(l+h+1)/2;
		audpts=m_CellAudioinfo[aind][m].iPTS;
		if( pts0 < audpts)
			h=m-1;
		else
			l=m;
	}
// Check next one (binary search can point one less...)	
	if ((l+1)< m_nAudioInCell[aind])
	{
		audpts=m_CellAudioinfo[aind][l+1].iPTS;
		if (audpts < pts1)
			l++;
	}
// Final check to be sure ...
	audpts=m_CellAudioinfo[aind][l].iPTS;
	if( audpts > pts1 )
		return -1;
	return m_CellAudioinfo[aind][l].LBA;
}


__int64 CVobBlankerApp::FV_FindSubSect(int sind, int pts0, int pts1)
{
    int l,h,m;
	int subpts0,subpts1;

	l=0;
	h=m_nSubsInCell[sind]-1;

	if( h<l )
		return -1;
// binary search!
	while(h>l)
	{
		m=(l+h+1)/2;
		subpts0=m_CellSubsinfo[sind][m].iPTS0;
		if( pts1 < subpts0 )
			h=m-1;
		else
			l=m;
	}

// Check if previous sub also overlaps. If yes, point to it

	if (l>0)
	{
		subpts0=m_CellSubsinfo[sind][l-1].iPTS0;
		subpts1=m_CellSubsinfo[sind][l-1].iPTS1;
		if ( subpts0 <= pts1 && subpts1 >= pts0 )
			l--;
	}

	subpts0=m_CellSubsinfo[sind][l].iPTS0;
	subpts1=m_CellSubsinfo[sind][l].iPTS1;
// Final test to verify the sub overlaps the VOBU
	if ( subpts0 <= pts1 && subpts1 >= pts0 )
		return  m_CellSubsinfo[sind][l].LBA;
	else
		return -1;


/* Simple and safe way, but not speed optimized
	for (m=0; m<h+1; m++)
	{
		subpts0=m_CellSubsinfo[sind][m].iPTS0;
		subpts1=m_CellSubsinfo[sind][m].iPTS1;
		if ( subpts0 <= pts1 && subpts1 >= pts0 )
		{
			return  m_CellSubsinfo[sind][m].LBA;
		}
	}
	return -1;
*/
}


void CVobBlankerApp::OutputBlankCell(int nVTS,int VobId,int CellId)
{
	int i,j;
	
	for (i=0;i<5; i++)
	{
		for (j=0; j< 2048; j++)
		{
			m_buffer[j]=SimpleVob[i*2048+j];
		}
		if (m_bInProcess==true)
		{
			if (IsNav(m_buffer))
			{
				ModifyCID (m_buffer,VobId, CellId);
			}
			WritePack(m_buffer,nVTS);
		}
	}
}




void CVobBlankerApp::WritePack(uchar* buffer,int nVTS)
{
	CString csAux;
	NAVINFO myNavinfo;
	AUDIOINFO myAudioinfo;
	SUBSINFO mySubsinfo;
//	int hh,mm,ss,ff,hor,min,sec,fra,fps;
	int iArraysize;
	static int VobId=0;
	static int CellId=0;
	int streamID,nS;
	DWORD dwVOBUDuration;
	int iSubsStart,nIniCommandArea, nbytes;
	int k,j;
	int nStartTics,nStopTics;

	if (m_bInProcess==true)
	{
		if (m_i64OutputLBA!=0 && ((m_i64OutputLBA)%(512*1024-1))==0 && nVTS!=0)
		{
			if (m_Fout!=NULL) fclose(m_Fout);
			m_nVobout++;
			csAux.Format(_T("VTS_%02d_%d.VOB"), nVTS, m_nVobout);
			m_csFout=m_csOutputPath+ '\\' +csAux;
			m_Fout=fopen(m_csFout,"wb");
		}

		if (IsNav(buffer)) 
		{
			myNavinfo.LastLBA=m_i64OutputLBA;
			myNavinfo.LBA=m_i64OutputLBA;
			myNavinfo.CID=buffer[0x422];
			myNavinfo.VID=buffer[0x41F]*256+buffer[0x420];
			myNavinfo.dwDuration=GetNbytes(4,&buffer[0x45]);
			myNavinfo.hasvideo=false;
			myNavinfo.iPTS0= (int) GetNbytes(4,&buffer[0x39]);
			myNavinfo.iPTS1= (int) GetNbytes(4,&buffer[0x3d]);
			myNavinfo.ui64iniscr=myNavinfo.ui64lastscr=readscr(buffer);
			myNavinfo.originalLBA=(__int64)GetNbytes (4,&buffer[0x2D]);
			ModifyLBA (buffer, m_i64OutputLBA);
	
			VobId=myNavinfo.VID;
			CellId=myNavinfo.CID;

// CODE RELATED WITH REPLACING TITLES: FIXING ELAPSED TIME
			if (m_iFixDuration==ADDOFFDURATION)
				myNavinfo.dwDuration=AddDuration(myNavinfo.dwDuration,m_dwOffDuration);

// CODE RELATED WITH CUTING TITLES: FIXING ELAPSED TIME
			if (m_iFixDuration==FIXOFFDURATION)
				myNavinfo.dwDuration=SubDuration(myNavinfo.dwDuration,m_dwOffDuration);

			if (m_iFixDuration==GETOFFDURATION)
			{
				m_dwOffDuration=myNavinfo.dwDuration;
				myNavinfo.dwDuration=myNavinfo.dwDuration & 0xc0;
				m_iFixDuration=FIXOFFDURATION;
			}
			if (m_iFixDuration==SAVEOFFDURATION)
			{
				m_dwOffDuration=myNavinfo.dwDuration;
				dwVOBUDuration=(myNavinfo.iPTS1-myNavinfo.iPTS0)/(m_ticsperframe);
				dwVOBUDuration=Dec2BCD(dwVOBUDuration);
				dwVOBUDuration=dwVOBUDuration|(m_dwOffDuration & 0xc0);
				m_dwOffDuration=AddDuration(m_dwOffDuration,dwVOBUDuration);
			}

			if (m_iFixDuration==CALCULATE_FIXOFFDURATION)
			{
				m_dwOffDuration=SubDuration(myNavinfo.dwDuration,m_dwOffDuration);
				myNavinfo.dwDuration=SubDuration(myNavinfo.dwDuration,m_dwOffDuration);
				m_iFixDuration=FIXOFFDURATION;
			}

//////////////////////////////////

			myNavinfo.frames=DurationInFrames(myNavinfo.dwDuration);
			myNavinfo.seconds=DurationInSecs(myNavinfo.dwDuration);

			iArraysize=m_ANavinfo.GetSize();
			try
			{
				m_ANavinfo.SetAtGrow(iArraysize,myNavinfo);
			}
			catch (...)
			{
				csAux.Format("Caught exception trying to allocate NavInfo # %d\n", iArraysize );
				AfxMessageBox(csAux,  MB_OK);
				throw;
			}

			if (m_bCheckVobPuops) ModifyPUOPS(buffer);	
			if (m_iFixDuration) 
			{
				Put4bytes(myNavinfo.dwDuration,&buffer[0x45]);
				Put4bytes(myNavinfo.dwDuration,&buffer[0x423]);
			}
		}

		if (IsAudio(buffer)) 
		{
			myAudioinfo.LBA=m_i64OutputLBA;
			myAudioinfo.CID=CellId;
			myAudioinfo.VID=VobId;
			streamID=getAudId(buffer);
			if (buffer[0x15] & 0x80) 
			{
				myAudioinfo.iPTS= (int)readpts(&buffer[0x17]);
				iArraysize=m_AAudioinfo[streamID & 0x07].GetSize();
				try
				{
					m_AAudioinfo[streamID & 0x07].SetAtGrow(iArraysize,myAudioinfo);
				}
				catch (...)
				{
					csAux.Format("Caught exception trying to allocate AudioInfo # %d\n", iArraysize );
					AfxMessageBox(csAux,  MB_OK);
					throw;
				}
			}
//			else
//				myAudioinfo.iPTS=0;
		}

		if (IsSubs(buffer)) 
		{
//			mySubsinfo.LBA=m_i64OutputLBA;
// Pointer to Subs must point to the NAv pack, so storing the nav pack LBA... 
			iArraysize=m_ANavinfo.GetSize();
			if (iArraysize >0) 
				mySubsinfo.LBA=m_ANavinfo[iArraysize-1].LBA;
			else
				mySubsinfo.LBA=0;
			mySubsinfo.CID=CellId;
			mySubsinfo.VID=VobId;
			nS=getSubId(buffer) & 0x1F;
			if (buffer[0x15]&0x80) 
			{
				mySubsinfo.iPTS0= (int)readpts(&buffer[0x17]);
				mySubsinfo.iPTS1= mySubsinfo.iPTS0;
				iArraysize=m_ASubsinfo[nS].GetSize();
				try
				{
					m_ASubsinfo[nS].SetAtGrow(iArraysize,mySubsinfo);
				}
				catch (...)
				{
					csAux.Format("Caught exception trying to allocate SubsInfo # %d\n", iArraysize );
					AfxMessageBox(csAux,  MB_OK);
					throw;
				}
			}
//			else
//				mySubsinfo.iPTS0=0;
// Decode Subs to detect their duration
// First step: Store all (but only) the sub commands 
			iSubsStart=0x17+buffer[0x16]+1;
			nbytes=buffer[0x12]*256+buffer[0x13]+0x14;
			nbytes=nbytes-iSubsStart;
			if (buffer[0x15]&0x80) 
			{
				m_SubsCommands[nS].bStarted=true;
				m_SubsCommands[nS].nAlready=0;
				m_SubsCommands[nS].nIndex=0;
				m_SubsCommands[nS].nSize=buffer[iSubsStart+0]*256+buffer[iSubsStart+1];
				m_SubsCommands[nS].nIndexCommands=buffer[iSubsStart+2]*256+buffer[iSubsStart+3];
				if (m_SubsCommands[nS].nSize-m_SubsCommands[nS].nIndexCommands > MAXSUBCOMMANDSIZE-2)
					m_SubsCommands[nS].bStarted=false;
			}
			if (m_SubsCommands[nS].bStarted)
			{
				if ((nbytes+m_SubsCommands[nS].nAlready) > m_SubsCommands[nS].nIndexCommands)
				{
					nIniCommandArea=m_SubsCommands[nS].nIndexCommands-m_SubsCommands[nS].nAlready;
// Check if commands start in previous pack. If yes, copy from byte #0 until nbytes-1
					if (nIniCommandArea<0) nIniCommandArea=0;
					j=m_SubsCommands[nS].nIndex;
					for (k=nIniCommandArea; k<nbytes; k++)
					{
						m_SubsCommands[nS].buffer[j+k-nIniCommandArea]= buffer[iSubsStart+k];
					}
					m_SubsCommands[nS].nIndex+=(nbytes-nIniCommandArea);
				}
				m_SubsCommands[nS].nAlready+=nbytes;

				if (m_SubsCommands[nS].nSize == m_SubsCommands[nS].nAlready)
				{
					m_SubsCommands[nS].bStarted=false;
/// All commands are in. Starting the decoding process and apply the results to the subinfo PTSs
					DecodeSubsCommands(m_SubsCommands[nS].buffer,m_SubsCommands[nS].nIndex,
						       m_SubsCommands[nS].nIndexCommands, &nStartTics, &nStopTics);
					iArraysize=m_ASubsinfo[nS & 0x1F].GetSize();
					m_ASubsinfo[nS][iArraysize-1].iPTS0+=nStartTics;
					m_ASubsinfo[nS][iArraysize-1].iPTS1+=nStopTics;
				}
			}
		}

		iArraysize=m_ANavinfo.GetSize();
		if (iArraysize >0) 
		{
			m_ANavinfo[iArraysize-1].LastLBA=m_i64OutputLBA;
			m_ANavinfo[iArraysize-1].ui64lastscr=readscr(buffer);
		}
		if (IsVideo(buffer))
			m_ANavinfo[iArraysize-1].hasvideo=true;
		if ( writebuffer(buffer,m_Fout) != 2048)
		{
			MyErrorLog_Box("Error writting output file. Check disk space");
			m_bInProcess=false;
		}
		m_i64OutputLBA++;
		m_i64GranTotalCurr++;
	}

}

//uchar debugbuffer[MAXSUBCOMMANDSIZE];	

void CVobBlankerApp::DecodeSubsCommands(uchar* buffer, int nbytes, int nIndexOffset, int * nStartTics, int * nStopTics)
{
	int nStart, nStop, nTics;
	int k,kk;
	int nIndex, nNewIndex,nIniBlock,nEndBlock;
	int nBlocks;

	int i,j;
	FILE * log;

	if (LOGSUBS && m_bLog)
	{
		log=fopen ("C:\\Subs_commands.log","a");
		fprintf (log,"New subs: Size %d\n", nbytes);
		for (i=0;i<nbytes;)
		{
			for (j=0; j<8 && i<nbytes; j++,i++)
			{
				fprintf (log," %02X", buffer[i]);
			}
			fprintf (log,"\n");
		}
		fclose (log);
	}

	nStart=nStop=-1;
	*nStartTics=0;
	*nStopTics=0;


//	for (k=0;k<nbytes; k++)
//		debugbuffer[k]=buffer[k];

	nBlocks=0;
	nIndex=-1;
	nNewIndex=0;

	while (nNewIndex > nIndex && nNewIndex >=0)
//	while (nNewIndex != nIndex && nNewIndex >=0)
	{
		nIndex=nNewIndex;
		nNewIndex=buffer[nIndex+2]*256+buffer[nIndex+3]-nIndexOffset;
		if (nNewIndex > nbytes-4  )
		{
//			csAux.Format(_T("     WARNING: Something was wrong decoding subs..."));
//			MyLog(csAux,ORANGE);
//			m_nWarnings++;
			return;	
		}
		nBlocks++;
		nIniBlock=nIndex;
		if (nNewIndex==nIndex)
			nEndBlock=nbytes;
		else
			nEndBlock=nNewIndex;
/// Decoding block
		nTics=buffer[nIniBlock+0]*256+buffer[nIniBlock+1];
		for (k=nIniBlock+4; k< nEndBlock;)
		{
			if (buffer[k] == 0)        { nStart=nTics; k++;} // Forced start
			else if (buffer[k] == 1)   { nStart=nTics; k++;} // start
			else if (buffer[k] == 2)   { nStop=nTics; k++;} // stop
			else if (buffer[k] == 3)   k+=3; // set_color
			else if (buffer[k] == 4)   k+=3; // set_contr
			else if (buffer[k] == 5)   k+=7; // SET_DAREA 
			else if (buffer[k] == 6)   k+=5; // SET_DSPXA 
			else if (buffer[k] == 7)  // CHG_COLCON  
			{ 
				kk=buffer[k+1]*256+buffer[k+2];
				k+=(kk+1);
			} 
			else if (buffer[k] == 0xFF)  k=nEndBlock; // CMD_END
			else k=nEndBlock; // Something wrong
		}
	}

	if (nStart <0 ) nStart=0;
	if (nStop <0 ) nStop=0;
	if (nStart > nStop) nStop=nStart;

	*nStartTics=nStart*1024;
	*nStopTics=nStop*1024;
}

//////////////////////////////////////////////////////////////////
///CODE RELATED WITH IFO PROCESSING
// uchar* pIFO;

void CVobBlankerApp::ProcessIfoVTSPrepare(int nVTS, CWnd* pDlg)
{
	CString csAux;
	int i;

	if (nVTS==0)
		csAux.Format(_T("VIDEO_TS: Opening IFO"),nVTS);
	else
		csAux.Format(_T("VTS %02d: Opening IFO"),nVTS);
	MyLog(csAux);

	m_pIFO_00= new uchar[MAXLENGTH+MAX_NEWIFOSECTORS_INITIAL*2048];

	for (i=0;i<m_i64IFOlen[nVTS];i++)
		m_pIFO_00[i]=m_pIFO[nVTS][i];

	m_i64IFOlen_00=m_i64IFOlen[nVTS];

// Process IFO copy to grow PGCs if needed
	ReadIFO_Copy(nVTS);
/*

	if (m_VTSM_C_ADT_00==0)
//   VTSM_C_ADT table did not exist;
		m_nIniMADTSectors=0;
	else
	{
		m_nIniMADTSectors=GetNbytes(4,&m_pIFO_00[m_VTSM_C_ADT_00+4]);
		m_nIniMADTSectors=m_nIniMADTSectors/2048+1;
	}

	if (m_VTSM_VOBU_ADMAP_00==0)
//   VTSM_VOBU_ADMAP table did not exist;
		m_nIniMADMAPSectors=0;
	else
	{
		m_nIniMADMAPSectors=GetNbytes(4,&m_pIFO_00[m_VTSM_VOBU_ADMAP_00]);
		m_nIniMADMAPSectors=m_nIniMADMAPSectors/2048+1;
	}
	if (m_VTS_C_ADT_00==0)
//   VTS_C_ADT table did not exist;
		m_nIniADTSectors=0;
	else
	{
		m_nIniADTSectors=GetNbytes(4,&m_pIFO_00[m_VTS_C_ADT_00+4]);
		m_nIniADTSectors=m_nIniADTSectors/2048+1;
	}

	if (m_VTS_VOBU_ADMAP_00==0)
//   VTSM_VOBU_ADMAP table did not exist;
		m_nIniADMAPSectors=0;
	else
	{
		m_nIniADMAPSectors=GetNbytes(4,&m_pIFO_00[m_VTS_VOBU_ADMAP_00]);
		m_nIniADMAPSectors=m_nIniADMAPSectors/2048+1;
	}

	if (m_VTSM_C_ADT_00!=0)  
		m_nStartCellsTable=m_VTSM_C_ADT_00;
	else if (m_VTSM_VOBU_ADMAP_00!=0)
		m_nStartCellsTable=m_VTSM_VOBU_ADMAP_00;
	else if (nVTS!=0 && m_VTS_C_ADT_00!=0)
		m_nStartCellsTable=m_VTS_C_ADT_00;
	else if (nVTS!=0 && m_VTS_VOBU_ADMAP_00!=0)
		m_nStartCellsTable=m_VTS_VOBU_ADMAP_00;
	else
		m_nStartCellsTable= (int)((m_i64IFOlen_00/2048)*2048);
*/
}

void CVobBlankerApp::ProcessIfoVTSMenu(int nVTS, CWnd* pDlg)
{
	int iACells,iANavs,nVOBIDs;
	int iVideoAttr,iFormat;
	CString csAux;
	int nT, nCell, nCell_00,nC;
	int VID,CID,NVID,NCID;
	int nLU,nLUR,nPGC,nnT;
	int n;
	int k;
	DWORD dwDuration,dwPGCDuration;
	int Maxbyte;
	int myVTSM_C_ADT, myVTSM_VOBU_ADMAP;
	int iRet;
	int nA;
	int nButtons,nSecs;
	int nNext,nPrev;
	bool bAtLeastOneInfinite;
	bool bSTCdisc;
	int iACellsKept,kk;

	if (nVTS==0)
		csAux.Format(_T("VIDEO_TS: Processing IFO (Menu)"));
	else
		csAux.Format(_T("VTS %02d: Processing IFO (Menu)"),nVTS);
	MyLog(csAux);

	ReadIFO_Copy(nVTS);

	iACells=m_MenuCells[nVTS].GetSize();
	iANavs=m_ANavinfo.GetSize();
///////////////////////////////////////////////////////
// Cell Info 
	m_nVOBIDsInProcess = m_nMMaxVOBIDs[nVTS]; //To be used in additional cells

///////////////////////////////////////////////////////
// Cell & Menu PGCs loop
	iVideoAttr=m_pIFO_00[0x100]*256+m_pIFO_00[0x101];
	iFormat=(iVideoAttr & 0x1000) >> 12;

	csAux.Format(_T("     Looping into Menu PGCs and cells"));
	MyLog(csAux);

	for (nT=0;nT<m_nMPGCs[nVTS];nT++)
	{
		if (iFormat==NTSC)
			dwPGCDuration=0xC0;
		else
			dwPGCDuration=0x40;

		nLU=m_nLU_MPGC[nVTS][nT];
		nPGC=nT-m_nIniPGCinLU[nVTS][nLU];
		nnT=nT;
		if (m_iMAction[nVTS][nT]==REUSE )
		{
			nLUR=m_iReuseLU[nVTS][nT];
			nnT=m_nIniPGCinLU[nVTS][nLUR]+nPGC;	
		}
		for (nCell_00=nCell=0;
		     nCell_00<m_nMCells_00[nT] && m_iMAction[nVTS][nT]!=DELPBK;
			 nCell_00++, nCell++)
		{
			bAtLeastOneInfinite=false;
			// Use the same order and algorithm to generate new VOBids...
			if  (m_iMAction[nVTS][nT]==CELLBASED && 
				(m_csMCellBased[nVTS][nT][nCell]=='B' ||
				 m_csMCellBased[nVTS][nT][nCell]=='R' ) &&
				 IsReused(MENUS, nVTS,nT,nCell) )
			{
				m_nVOBIDsInProcess++;
				CID=1;
				VID=m_nVOBIDsInProcess;
				m_pIFO_00[m_M_C_POST_00[nT]+nCell_00*4+3]=CID;
				Put2bytes( VID, &m_pIFO_00[m_M_C_POST_00[nT]+nCell_00*4]);
			}
			CID=m_pIFO_00[m_M_C_POST_00[nnT]+nCell_00*4+3];
			VID=GetNbytes(2,&m_pIFO_00[m_M_C_POST_00[nnT]+nCell_00*4]);

// Change VID/CID to NVID/NCID in POSITION tables
			nC=MenuCellGetPosByVCID(nVTS,VID,CID);
			if (nC<0)
			{
				MyErrorLog_Box("Error: Cell NOT found!!");
				m_bInProcess=false;
				return;
			}
			NVID=m_MenuCells[nVTS][nC].NVID;
			NCID=m_MenuCells[nVTS][nC].NCID;
			m_pIFO_00[m_M_C_POST_00[nT]+nCell_00*4+3]=NCID;
			Put2bytes( NVID, &m_pIFO_00[m_M_C_POST_00[nT]+nCell_00*4]);

// PGC PBKT Cell Headers manipulations: 

// Cell Still Time

			if ((m_MenuCells[nVTS][nC].iMode==CELLBASED && 
				 m_MenuCells[nVTS][nC].chMode=='B') ||  
				 m_MenuCells[nVTS][nC].iMode==BLANK)
			{
			// Reset to Zero Cell still time.
				m_pIFO_00[m_M_C_PBKT_00[nT]+nCell_00*24+2]=0;
			}
// Cell Still Time when changing to still w/o audio
			if ((m_MenuCells[nVTS][nC].iMode==CELLBASED && 
				 m_MenuCells[nVTS][nC].chMode=='Z') ||  
				 m_MenuCells[nVTS][nC].iMode==STILLNA)
			{
				dwDuration=GetNbytes(4, &m_pIFO_00[m_M_C_PBKT_00[nT]+nCell_00*24+4]);
				nSecs=DurationInSecs(dwDuration);
				nButtons=m_MenuCells[nVTS][nC].nButtons;

				if (nButtons>0)
				{
			// Change to 255 still time.
					if (nSecs < (m_iIMinStill+1)) nSecs=(m_iIMinStill+1);
					if (nSecs > 254) nSecs=254;
					if (m_pIFO_00[m_M_C_PBKT_00[nT]+nCell_00*24+2] < (m_iIMinStill+1))
						m_pIFO_00[m_M_C_PBKT_00[nT]+nCell_00*24+2]=nSecs;
				}
				else
				{
					if (m_bCheckBlankNoB &&  m_iMAction[nVTS][nT]!=CELLBASED)
			// Change to 1 sec or 0 sec still time, because it has been blanked
					{
						if (m_bCheckOneSecStill)
							m_pIFO_00[m_M_C_PBKT_00[nT]+nCell_00*24+2]=1;
						else
							m_pIFO_00[m_M_C_PBKT_00[nT]+nCell_00*24+2]=0;
					}
					else
					{
			// Change to 5 still time, cell has not been blanked
						if (nSecs < 1) nSecs=1;
						if (nSecs > (m_iIMaxStill+1)) nSecs=(m_iIMaxStill+1);
						if (m_pIFO_00[m_M_C_PBKT_00[nT]+nCell_00*24+2] < 1)
							m_pIFO_00[m_M_C_PBKT_00[nT]+nCell_00*24+2]=nSecs;
					}
				}
				m_MenuCells[nVTS][nC].dwDuration=0;
			}
// Cell Still Time in no buttons when changing to still with audio
			if ((m_MenuCells[nVTS][nC].iMode==CELLBASED && 
				 m_MenuCells[nVTS][nC].chMode=='S') ||  
				 m_MenuCells[nVTS][nC].iMode==STILLA)
			{
				nButtons=m_MenuCells[nVTS][nC].nButtons;
				if (m_bCheckBlankNoB && nButtons<=0 )
// Change to 1 still time, because it has been blanked
					m_pIFO_00[m_M_C_PBKT_00[nT]+nCell_00*24+2]=1;
			}

			if ( m_pIFO_00[m_M_C_PBKT_00[nT]+nCell_00*24+2]==255 ) bAtLeastOneInfinite=true;
// PGC PBKT Cell Headers manipulations: STC Discontinuity
// Blanking Cells or changing to still w/o audio
			if ((m_MenuCells[nVTS][nC].iMode==CELLBASED && 
				 (m_MenuCells[nVTS][nC].chMode=='B' ||  m_MenuCells[nVTS][nC].chMode=='R' || m_MenuCells[nVTS][nC].chMode=='Z' ))   
				|| m_MenuCells[nVTS][nC].iMode==BLANK ||  m_MenuCells[nVTS][nC].iMode==STILLNA)
			{
			// Mark as STC Discontinuity this and the following cells.
				m_pIFO_00[m_M_C_PBKT_00[nT]+nCell_00*24] = 0x02 ;
				if ( (nCell_00+1) <m_nMCells_00[nT])
					m_pIFO_00[m_M_C_PBKT_00[nT]+(nCell_00+1)*24] = 0x02 ;
			}
// PGC PBKT Cell Headers manipulations: STC Discontinuity
// Motion2Still PGCs (Which also blanks)
// Not Needed, because cells are marked as Blank.
			if  (m_bCheckBlankNoB &&
                 ( m_MenuCells[nVTS][nC].iMode==STILLA || m_MenuCells[nVTS][nC].iMode==STILLNA))
			{
				nButtons=m_MenuCells[nVTS][nC].nButtons;

				if (nButtons <=0) 
				{
// Mark as STC Discontinuity this and the following cells.
					m_pIFO_00[m_M_C_PBKT_00[nT]+nCell_00*24] = 0x02 ;
					if ( (nCell_00+1) <m_nMCells_00[nT])
						m_pIFO_00[m_M_C_PBKT_00[nT]+(nCell_00+1)*24] = 0x02 ;
				}
			}

// PGC PBKT Cell Headers manipulations: STC Discontinuity in Cut Cells
			if  (m_MenuCells[nVTS][nC].iMode==CELLBASED && m_MenuCells[nVTS][nC].chMode=='C' )
			{
				if (m_MenuCells[nVTS][nC].iCutMode==CUT1 || m_MenuCells[nVTS][nC].iCutMode==CUT3)
				{
					 // Mark this cell as non-seamless
					m_pIFO_00[m_M_C_PBKT_00[nT]+nCell_00*24] = 0x02 ;
				}

				if (m_MenuCells[nVTS][nC].iCutMode==CUT2 || m_MenuCells[nVTS][nC].iCutMode==CUT3 ||
					m_MenuCells[nVTS][nC].iCutMode==CUT4 )
				{
					 // Mark next cell as non-seamless
					if ((nCell_00+1) <m_nCells_00[nT])
						m_pIFO_00[m_M_C_PBKT_00[nT]+(nCell_00+1)*24] = 0x02 ;
				}
			}

// Clear ILV Flags
			Put4bytes(0,  &m_pIFO_00[m_M_C_PBKT_00[nT]+nCell_00*24+0x0C]);
			m_pIFO_00[m_M_C_PBKT_00[nT]+nCell_00*24]=m_pIFO_00[m_M_C_PBKT_00[nnT]+nCell_00*24] & 0xFB;
//////////////////////// Copy Cells Info ////////////////////////////////////
			if (m_MenuCells[nVTS][nC].i64FirstLBAFirstVOBU != -1)
				Put4bytes(m_MenuCells[nVTS][nC].i64FirstLBAFirstVOBU,  &m_pIFO_00[m_M_C_PBKT_00[nT]+nCell_00*24+8]);
			if (m_MenuCells[nVTS][nC].i64FirstLBALastVOBU != -1)
				Put4bytes(m_MenuCells[nVTS][nC].i64FirstLBALastVOBU,  &m_pIFO_00[m_M_C_PBKT_00[nT]+nCell_00*24+0x10]);
			if (m_MenuCells[nVTS][nC].i64LastLBALastVOBU != -1)
				Put4bytes(m_MenuCells[nVTS][nC].i64LastLBALastVOBU,  &m_pIFO_00[m_M_C_PBKT_00[nT]+nCell_00*24+0x14]);
			dwDuration=m_MenuCells[nVTS][nC].dwDuration;
			if (dwDuration != -1)
			{
				if (dwDuration==0x40 || (dwDuration==0 && iFormat==PAL))
					dwDuration=0x12+0x40;
				if (dwDuration==0x0c0 || (dwDuration==0 && iFormat==NTSC ) ) 
					dwDuration=0x0c0+0x15;
				Put4bytes(dwDuration,  &m_pIFO_00[m_M_C_PBKT_00[nT]+nCell_00*24+4]);
				dwPGCDuration= AddDuration(dwDuration,dwPGCDuration);
			}
// PGC PBKT Cell Headers manipulations: Change STC Discontinuity according VOB layout
			if  ( m_bCheckClockDisc ) 
			{
				bSTCdisc=false;
				if (nC==0) bSTCdisc=true;
				if (nCell_00==0) bSTCdisc=true;
				else 
				{
				// VID/CID of nnT should be used.
					n=MenuCellGetPos(nVTS,nnT,nCell-1);
					if (n!=(nC-1))  bSTCdisc=true;
					if (m_MenuCells[nVTS][nC].ui64iniscr < m_MenuCells[nVTS][n].ui64lastscr)
						bSTCdisc=true;
					if (m_MenuCells[nVTS][nC].ui64iniscr > (m_MenuCells[nVTS][n].ui64lastscr + MAXSCRDIFF))
						bSTCdisc=true;
				}
				if (bSTCdisc && !(m_pIFO_00[m_M_C_PBKT_00[nT]+nCell_00*24] & 0x02)) 
				{
// Marking STC discontinuity, not reflected in IFO
					csAux.Format(_T("     Setting STC discontinuity flag, not reflected in original IFO: PGC %d, Cell %d"), nT+1, nCell_00+1);
					MyLog(csAux,CIAN15);
					m_pIFO_00[m_M_C_PBKT_00[nT]+nCell*24] |= (uchar)0x02 ;
				}
				if (!bSTCdisc && (m_pIFO_00[m_M_C_PBKT_00[nT]+nCell*24] & 0x02)) 
				{
// Marking STC discontinuity, badly reflected in IFO
					csAux.Format(_T("     Clearing STC discontinuity flag, forced or present in original IFO: PGC %d, Cell %d"), nT+1, nCell+1);
					MyLog(csAux,CIAN15);
					m_pIFO_00[m_M_C_PBKT_00[nT]+nCell_00*24] &= (uchar)0xFD ;
				}
			}
		} /* For Cells */
// If playback has been deleted...
		if (m_iMAction[nVTS][nnT]==DELPBK)
		{
//			m_nMCells[nVTS][nT]=0;
			m_pIFO_00[m_MENU_PGC_00[nT]+3]=0;
			m_pIFO_00[m_MENU_PGC_00[nT]+2]=0; // Programs

			m_pIFO_00[m_MENU_PGC_00[nT]+0xE6]=0; // offset to program map
			m_pIFO_00[m_MENU_PGC_00[nT]+0xE6+1]=0; 
			m_pIFO_00[m_MENU_PGC_00[nT]+0xE8]=0; // offset to playback
			m_pIFO_00[m_MENU_PGC_00[nT]+0xE8+1]=0; 
			m_pIFO_00[m_MENU_PGC_00[nT]+0xEA]=0; // offset to position
			m_pIFO_00[m_MENU_PGC_00[nT]+0xEA+1]=0; 
		
			dwPGCDuration=(m_dwMDuration[nVTS][nT] & 0x000000C0);
		}

		Put4bytes(dwPGCDuration, &m_pIFO_00[m_MENU_PGC_00[nT]+4]);
/*
		m_pIFO_00[m_MENU_PGC_00[nT]+3]=     m_pIFO[nVTS][m_MENU_PGC[nVTS][nT]+3];
		m_pIFO_00[m_MENU_PGC_00[nT]+2]=     m_pIFO[nVTS][m_MENU_PGC[nVTS][nT]+2]; 
		m_pIFO_00[m_MENU_PGC_00[nT]+0xE6]=  m_pIFO[nVTS][m_MENU_PGC[nVTS][nT]+0xE6]; 
		m_pIFO_00[m_MENU_PGC_00[nT]+0xE6+1]=m_pIFO[nVTS][m_MENU_PGC[nVTS][nT]+0xE6+1]; 
		m_pIFO_00[m_MENU_PGC_00[nT]+0xE8]=  m_pIFO[nVTS][m_MENU_PGC[nVTS][nT]+0xE8]; 
		m_pIFO_00[m_MENU_PGC_00[nT]+0xE8+1]=m_pIFO[nVTS][m_MENU_PGC[nVTS][nT]+0xE8+1]; 
		m_pIFO_00[m_MENU_PGC_00[nT]+0xEA]=  m_pIFO[nVTS][m_MENU_PGC[nVTS][nT]+0xEA]; 
		m_pIFO_00[m_MENU_PGC_00[nT]+0xEA+1]=m_pIFO[nVTS][m_MENU_PGC[nVTS][nT]+0xEA+1]; 
*/
// Clear audio status if blanking or motion2still
		if (m_iMAction[nVTS][nnT]==BLANK || m_iMAction[nVTS][nnT]==STILLNA )
		{
			if (m_bCheckAttrMenu)
			{
				for (nA=0;nA<8;nA++)
				{
					m_pIFO_00[m_MENU_PGC_00[nT]+nA*2+0x0c]=0;
					m_pIFO_00[m_MENU_PGC_00[nT]+nA*2+0x0c+1]=0;
				}
			}
		}
// Clear subs status and PGC still time if blanking 
		if (m_iMAction[nVTS][nnT]==BLANK )
		{
			if (m_bCheckAttrMenu)
			{
				for (nA=0;nA<32;nA++)
				{
					m_pIFO_00[m_MENU_PGC_00[nT]+nA*4+0x1c]=0;
					m_pIFO_00[m_MENU_PGC_00[nT]+nA*4+0x1c+1]=0;
					m_pIFO_00[m_MENU_PGC_00[nT]+nA*4+0x1c+2]=0;
					m_pIFO_00[m_MENU_PGC_00[nT]+nA*4+0x1c+3]=0;
				}
			}
			m_pIFO_00[m_MENU_PGC_00[nT]+0xA3]=0;
		}

// Change Post into precommands

		if ( m_bCheckPostPre && m_iMAction[nVTS][nnT]==BLANK && m_M_PGC_COMM[nVTS][nT]!=0 )
// Action is blanking, table exists and checkbox is clicked)
		{
			iRet=ChangePostIntoPre(MENUS,nVTS,nT);
			if (iRet>=0)  {m_nPostPre++; m_nActualPostPre++;}
			if (iRet==-2)  m_nPostPre++;
		}

// Point Next PGC to itself if checked and not empty and no buttons
		if (m_bCheckNextMenu && m_nMCells[nVTS][nT]!=0 && 
			m_iMAction[nVTS][nnT]!=DELPBK  && m_nMButtons[nVTS][nT]==0
			&& !bAtLeastOneInfinite )
		{
			nNext=GetNbytes(2,&m_pIFO_00[m_MENU_PGC_00[nT]+0x09c]);
			if (nNext ==0 && m_i8MPostComm[nVTS][nT]>0 && m_pIFO_00[m_MENU_PGC_00[nT]+0xA3]==0)
			{
// Use nPGC, it points to the PGC number in LU
				csAux.Format(_T("     PGCN Pointer: Pointing Next PGCN to itself in LU %d, PGC %d"),nLU+1,nPGC+1);
				MyLog(csAux);
				Put2bytes(nPGC+1,&m_pIFO_00[m_MENU_PGC_00[nT]+0x09c]);
			}
		}
// Point Prev PGC to itself if checked and is null
		if (m_bCheckPrevMenu && m_nMCells[nVTS][nT]!=0 && 
			m_iMAction[nVTS][nnT]!=DELPBK )
		{
			nPrev=GetNbytes(2,&m_pIFO_00[m_MENU_PGC_00[nT]+0x09E]);
			if (nPrev ==0)
			{
// Use nPGC, it points to the PGC number in LU
				csAux.Format(_T("     PGCN Pointer: Pointing Prev PGCN to itself in LU %d, PGC %d"),nLU+1,nPGC+1);
				MyLog(csAux);
				Put2bytes(nPGC+1,&m_pIFO_00[m_MENU_PGC_00[nT]+0x09E]);
			}
		}
	} /* for PGCs */

/////////////////////////////////////////////////////
// VTSM_C_ADT : Total reconstruction of this table;
	nVOBIDs = GetMenuNVobId(nVTS);

	if (m_VTSM_C_ADT_00==0)
	{
		csAux.Format(_T("     VTSM_C_ADT table did not exist"));
		MyLog(csAux);
		m_nNewMADTSectors= 0; 
	}
	else
	{
		for (k=0, iACellsKept=0;k<iACells;k++)
			if (m_MenuCells[nVTS][k].bToBeDeleted==false) iACellsKept++;

		if (iACellsKept==0)
		{
			csAux.Format(_T("     VTSM_C_ADT table has been deleted"));
			MyLog(csAux);
			Put4bytes(0,&m_pIFO_00[0xD8]);
			m_nNewMADTSectors= 0;
		}
		else
		{
			myVTSM_C_ADT=m_nStartCellsTable;
			Put4bytes(myVTSM_C_ADT/2048,&m_pIFO_00[0xD8]);

			csAux.Format(_T("     Building VTSM_C_ADT table"));
			MyLog(csAux);

			m_nNewMADTSectors= (iACellsKept*12+7)/2048 +1; 
			for (k=0;k<(m_nNewMADTSectors*2048)/4;k++)
				Put4bytes(0, &m_pIFO_00[myVTSM_C_ADT+4*k]);

			m_pIFO_00[myVTSM_C_ADT+0]=nVOBIDs/256;
			m_pIFO_00[myVTSM_C_ADT+1]=nVOBIDs%256;
			m_pIFO_00[myVTSM_C_ADT+2]=0;
			m_pIFO_00[myVTSM_C_ADT+3]=0;
			Put4bytes( iACellsKept*12+7 ,&m_pIFO_00[myVTSM_C_ADT+4]);
			for (k=kk=0;k<iACells;k++)
			{
				if (m_MenuCells[nVTS][k].bToBeDeleted==false)
				{
					m_pIFO_00[myVTSM_C_ADT+8+12*kk  ]=m_MenuCells[nVTS][k].NVID/256;
					m_pIFO_00[myVTSM_C_ADT+8+12*kk+1]=m_MenuCells[nVTS][k].NVID%256;
					m_pIFO_00[myVTSM_C_ADT+8+12*kk+2]=m_MenuCells[nVTS][k].NCID;
					m_pIFO_00[myVTSM_C_ADT+8+12*kk+3]=0;

					if (m_MenuCells[nVTS][k].i64FirstLBAFirstVOBU != -1)
						Put4bytes(m_MenuCells[nVTS][k].i64FirstLBAFirstVOBU, &m_pIFO_00[myVTSM_C_ADT+8+12*kk+4]);
					if (m_MenuCells[nVTS][k].i64LastLBALastVOBU != -1)
						Put4bytes(m_MenuCells[nVTS][k].i64LastLBALastVOBU,&m_pIFO_00[myVTSM_C_ADT+8+12*kk+8]);
					kk++;
				}
			}
		}
	}

///////////////////////////////////////////////////////
// VTSM_VOBU_ADMAP
	
	if (m_VTSM_VOBU_ADMAP_00==0)
	{
		csAux.Format(_T("     VTSM_VOBU_ADMAP table did not exist"));
		MyLog(csAux);
		m_nNewMADMAPSectors=0;
		Maxbyte=-1;
	}
	else
	{
		if (iANavs==0)
		{
			csAux.Format(_T("     VTSM_VOBU_ADMAP table has been deleted"));
			MyLog(csAux);
			Put4bytes(0,&m_pIFO_00[0xDC]);
			m_nNewMADMAPSectors=0;
			Maxbyte=-1;
// Clear stream attributes.....
			csAux.Format(_T("     Clearing MENU streams attributes"));
			MyLog(csAux);
			ProcessIfoClearAttrib(nVTS, MENUS);
		}
		else
		{
			myVTSM_VOBU_ADMAP=m_nStartCellsTable+m_nNewMADTSectors*2048;
			Put4bytes(myVTSM_VOBU_ADMAP/2048,&m_pIFO_00[0xDC]);

			csAux.Format(_T("     Filling VTSM_VOBU_ADMAP table"));
			MyLog(csAux);
			Maxbyte = iANavs*4+3;
			m_nNewMADMAPSectors=Maxbyte/2048+1;

			if ((m_nNewMADTSectors+m_nNewMADMAPSectors-m_nIniMADTSectors-m_nIniMADMAPSectors) > MAX_NEWIFOSECTORS_END)
			{
				MyErrorLog_Box("Error: No enough room for IFO growing...");
				m_bInProcess=false;
				return;
			}

			for (k=0; k< (m_nNewMADMAPSectors*2048)/4;k++)
				Put4bytes(0,&m_pIFO_00[myVTSM_VOBU_ADMAP+4*k]);
		
			for ( k=0 ; k<iANavs ; k++)
				Put4bytes(m_ANavinfo[k].LBA,&m_pIFO_00[myVTSM_VOBU_ADMAP+4+4*k]);

			Put4bytes(Maxbyte,&m_pIFO_00[myVTSM_VOBU_ADMAP]);
		}
	}
	m_i64NewIFOlen[nVTS]=m_nStartCellsTable+(m_nNewMADTSectors+m_nNewMADMAPSectors)*2048;
}


void CVobBlankerApp::ProcessIfoVTSTitle(int nVTS, CWnd* pDlg)
{
	int k;
	int Maxbyte;
	int	iACells,iANavs;
	int nT,nCell,nCell_00;
	int nA,nS;
	CString csAux,csFout;
	int VID,CID,NVID,NCID, nC;
	int VIDa, CIDa, nCa;  // store previous VID/CID;
	DWORD dwDuration, dwPGCDuration;
	int iFormat;
	int  myVTS_C_ADT,myVTS_VOBU_ADMAP;
	CString csAux2;
	int nVOBIDs;
	int iRet;
//	int	iAction,IniCell,EndCell;
	int nNext,nPrev;
	bool bAtLeastOneInfinite;
	int AudioStatus,SubStatus0,SubStatus1;
	uchar uVTSAllAttr[0x300], uPalette[64], uStatus[16+128];
	int nPGCs, nCells;
	bool bSTCdisc, b2ndSplit;
	int nNewSectors,nTotalNewSectors;
	int iACellsKept,kk;

	csAux.Format(_T("VTS %02d: Processing IFO (Titles)"),nVTS);
	MyLog(csAux);

	iACells=m_TitleCells[nVTS].GetSize();
	iANavs=m_ANavinfo.GetSize();

	ReadIFO_Copy(nVTS);

	nTotalNewSectors=0;

	for (nC=0; nC<iACells; nC++)
	{
		if (m_TitleCells[nVTS][nC].iMode ==CELLBASED && 
			m_TitleCells[nVTS][nC].chMode=='P' &&
			m_TitleCells[nVTS][nC].iPart== 0)
		{
			VIDa=m_TitleCells[nVTS][nC].VID;
			CIDa=m_TitleCells[nVTS][nC].CID;
			nC++; // skips next one (part 2)
// Split the cell in all PGCs
			for (nT=0;nT<m_nPGCs[nVTS];nT++)
			{
				for (nCell_00=0;nCell_00<m_nCells_00[nT];nCell_00++)
				{
					CID=m_pIFO_00[m_C_POST_00[nT]+nCell_00*4+3];
					VID=GetNbytes(2,&m_pIFO_00[m_C_POST_00[nT]+nCell_00*4]);
					if (VIDa==VID && CIDa==CID)
					{
						if (nTotalNewSectors > MAX_NEWIFOSECTORS_INITIAL-2 )
						{
							MyErrorLog_Box("Error: No enough room for IFO growing...");
							m_bInProcess=false;
							return;
						}
						nNewSectors=InsertCellInPGC(nT, nCell_00, m_TitleCells[nVTS][nC].iSplitMode );
						nCell_00++; // skip next (the iserted one)
//Update all_pointers(they can be changed)
						m_i64IFOlen_00+=(nNewSectors)*2048;
						nTotalNewSectors+=nNewSectors;
						ReadIFO_Copy(nVTS);
						if( m_TitleCells[nVTS][nC].iSplitMode ==2)
							m_nChaptersAdded[nVTS][nT]++;
					}
				}
			}
		}
	}
///////////////////////////////////////////////////////
// Cell Info 
	m_nVOBIDsInProcess = m_nTMaxVOBIDs[nVTS]; //To be used in additional cells

///////////////////////////////////////////////////////
// Cell & Title PGCs loop
	iFormat=(m_iVideoAttr[nVTS] & 0x1000) >> 12;

	csAux.Format(_T("     Looping into Title PGCs and cells"));
	MyLog(csAux);

	for (nT=0;nT<m_nPGCs[nVTS];nT++)
	{
		if (iFormat==NTSC)
			dwPGCDuration=0xC0;
		else
			dwPGCDuration=0x40;

		nCa=-1;  // stores the index of the previous cell
		VIDa=CIDa=-1; // storesVID/CID of the previous cell (to verify if it is a splitted cell)
		for (nCell_00=nCell=0;nCell_00<m_nCells_00[nT];nCell_00++,nCell++)
		{
			b2ndSplit=false;
			CID=m_pIFO_00[m_C_POST_00[nT]+nCell_00*4+3];
			VID=GetNbytes(2,&m_pIFO_00[m_C_POST_00[nT]+nCell_00*4]);
			if (nCell>0 && VIDa==VID && CIDa==CID )
			{
				nC=TitleCellGetPosByVCID(nVTS,VID,CID);
				if (m_TitleCells[nVTS][nC].iMode==CELLBASED && m_TitleCells[nVTS][nC].chMode=='P' )
				{
// This is a splitted cell, now in the second part, so the original index must be decreased by one
			   	  b2ndSplit=true;
				  nCell--;
				}
			}
			VIDa=VID;
			CIDa=CID;

			bAtLeastOneInfinite=false;
// Use the same order and algorithm to generate new VOBids...
			if  (m_iAction[nVTS][nT]==CELLBASED && 
				(m_csCellBased[nVTS][nT][nCell]=='B' ||
				 m_csCellBased[nVTS][nT][nCell]=='R' ) &&
				 IsReused(TITLES, nVTS,nT,nCell) )
			{
				m_nVOBIDsInProcess++;
				CID=1;
				VID=m_nVOBIDsInProcess;
				m_pIFO_00[m_C_POST_00[nT]+nCell_00*4+3]=CID;
				Put2bytes( VID, &m_pIFO_00[m_C_POST_00[nT]+nCell_00*4]);
			}

			CID=m_pIFO_00[m_C_POST_00[nT]+nCell_00*4+3];
			VID=GetNbytes(2,&m_pIFO_00[m_C_POST_00[nT]+nCell_00*4]);

// Get index (nC) in TitleCells
			nC=TitleCellGetPosByVCID(nVTS,VID,CID);
			if (b2ndSplit) nC++;
// Change VID/CID to NVID/NCID in POSITION tables
			NVID=m_TitleCells[nVTS][nC].NVID;
			NCID=m_TitleCells[nVTS][nC].NCID;
			m_pIFO_00[m_C_POST_00[nT]+nCell_00*4+3]=NCID;
			Put2bytes( NVID, &m_pIFO_00[m_C_POST_00[nT]+nCell_00*4]);

// PGC PBKT Cell Headers manipulations: Cell Still Time
		// Blanking Titles or cells
			if  (  ( m_TitleCells[nVTS][nC].iMode==CELLBASED && 
				     m_TitleCells[nVTS][nC].chMode=='B') ||
				 m_TitleCells[nVTS][nC].iMode==BLANK ) 
			{
			// Reset to Zero Cell still time.
				m_pIFO_00[m_C_PBKT_00[nT]+nCell_00*24+2]=0;
			}
// PGC PBKT Cell Headers manipulations: STC Discontinuity: 
		// Blanking Titles or blanking/Replacing cells
			if  (  ( m_TitleCells[nVTS][nC].iMode==CELLBASED && 
				     (m_TitleCells[nVTS][nC].chMode=='B' || m_TitleCells[nVTS][nC].chMode=='R' ))
				     || m_TitleCells[nVTS][nC].iMode==BLANK ) 
			{
			// Mark as STC Discontinuity this cell and the following one.
				m_pIFO_00[m_C_PBKT_00[nT]+nCell_00*24] = 0x02 ;
				if ((nCell_00+1) <m_nCells_00[nT])
					m_pIFO_00[m_C_PBKT_00[nT]+(nCell_00+1)*24] = 0x02 ;
			}
// PGC PBKT Cell Headers manipulations: Clear STC Discontinuity in PGC replace
			if  ( m_iAction[nVTS][nT]==REPLACE ) 
			{
		// Assuming a continuous PGC is used to replace: 
		// Mark STC Discontinuity in the first cell and clear in all the rest.
				m_pIFO_00[m_C_PBKT_00[nT]+nCell_00*24] = 0x08 ;
				if (nCell_00==0)
					m_pIFO_00[m_C_PBKT_00[nT]+nCell_00*24] = 0x02 ;
			}
			if  ( m_TitleCells[nVTS][nC].iMode==REPLACE && m_iAction[nVTS][nT]!=REPLACE) 
			{
	// This is a reused cell. What to do?. Nothing. Keep the flags as they are... 
	// Mark STC Discontinuity in the first cell and clear in all the rest.
			}

// PGC PBKT Cell Headers manipulations: STC Discontinuity in Cut title/Cells
// Cut Title: iMode of the cells in a Cut PGC are marked as KEEP, BLANK or CUT
			if  ( m_TitleCells[nVTS][nC].iMode==CUT || 
				 (m_TitleCells[nVTS][nC].iMode==CELLBASED && m_TitleCells[nVTS][nC].chMode=='C' ))
			{
				if (m_TitleCells[nVTS][nC].iCutMode==CUT1 || m_TitleCells[nVTS][nC].iCutMode==CUT3)
				{
					 // Mark this cell as non-seamless
					m_pIFO_00[m_C_PBKT_00[nT]+nCell_00*24] = 0x02 ;
				}

				if (m_TitleCells[nVTS][nC].iCutMode==CUT2 || m_TitleCells[nVTS][nC].iCutMode==CUT3 ||
					m_TitleCells[nVTS][nC].iCutMode==CUT4 )
				{
					 // Mark next cell as non-seamless
					if ((nCell_00+1) <m_nCells_00[nT])
						m_pIFO_00[m_C_PBKT_00[nT]+(nCell_00+1)*24] = 0x02 ;
				}
			}

/////////////////////////////////////////////////////////////////////////////////////
			if ( m_pIFO_00[m_C_PBKT_00[nT]+nCell_00*24+2]==255 ) bAtLeastOneInfinite=true;
// Clear ILV Flags
			Put4bytes(0,  &m_pIFO_00[m_C_PBKT_00[nT]+nCell_00*24+0x0C]);
			m_pIFO_00[m_C_PBKT_00[nT]+nCell_00*24]=m_pIFO_00[m_C_PBKT_00[nT]+nCell_00*24] & 0xFB;
//////////////////////////////////// Copy Cells Info///////////////////////////
			if (m_TitleCells[nVTS][nC].i64FirstLBAFirstVOBU != -1)
				Put4bytes(m_TitleCells[nVTS][nC].i64FirstLBAFirstVOBU,  &m_pIFO_00[m_C_PBKT_00[nT]+nCell_00*24+8]);
			if (m_TitleCells[nVTS][nC].i64FirstLBALastVOBU != -1)
				Put4bytes(m_TitleCells[nVTS][nC].i64FirstLBALastVOBU,  &m_pIFO_00[m_C_PBKT_00[nT]+nCell_00*24+0x10]);
			if (m_TitleCells[nVTS][nC].i64LastLBALastVOBU != -1)
				Put4bytes(m_TitleCells[nVTS][nC].i64LastLBALastVOBU,  &m_pIFO_00[m_C_PBKT_00[nT]+nCell_00*24+0x14]);
			dwDuration=m_TitleCells[nVTS][nC].dwDuration;
			if (dwDuration != -1)
			{
				if (dwDuration==0x40 || (dwDuration==0 && iFormat==PAL))
					dwDuration=0x12+0x40;
				if (dwDuration==0x0c0 || (dwDuration==0 && iFormat==NTSC ) ) 
					dwDuration=0x0c0+0x15;
				Put4bytes(dwDuration,  &m_pIFO_00[m_C_PBKT_00[nT]+nCell_00*24+4]);
				dwPGCDuration= AddDuration(dwDuration,dwPGCDuration);
			}
// PGC PBKT Cell Headers manipulations: Change STC Discontinuity according VOB layout
			if  ( m_bCheckClockDisc ) 
			{
				bSTCdisc=false;
				if (nC==0) bSTCdisc=true;
				else if (nCell_00==0) bSTCdisc=true;
				else 
				{
					if (nCa<0) bSTCdisc=true;
					else if (nCa!=(nC-1))  bSTCdisc=true;
					else if (m_TitleCells[nVTS][nC].ui64iniscr < m_TitleCells[nVTS][nCa].ui64lastscr)
						bSTCdisc=true;
					else if (m_TitleCells[nVTS][nC].ui64iniscr > (m_TitleCells[nVTS][nCa].ui64lastscr + MAXSCRDIFF))
						bSTCdisc=true;
				}
				if (bSTCdisc && !(m_pIFO_00[m_C_PBKT_00[nT]+nCell_00*24] & 0x02) ) 
				{
// Marking STC discontinuity, not reflected in IFO
					csAux.Format(_T("     Setting STC discontinuity flag, not reflected in original IFO: PGC %d, Cell %d "), nT+1, nCell_00+1);
					MyLog(csAux,CIAN15);
					m_pIFO_00[m_C_PBKT_00[nT]+nCell_00*24] |= (uchar)0x02 ;
				}
				if (!bSTCdisc && (m_pIFO_00[m_C_PBKT_00[nT]+nCell_00*24] & 0x02) ) 
				{
// Marking STC discontinuity, badly reflected in IFO
					csAux.Format(_T("     Clearing STC discontinuity flag, forced or present in original IFO: PGC %d, Cell %d "), nT+1, nCell_00+1);
					MyLog(csAux,CIAN15);
					m_pIFO_00[m_C_PBKT_00[nT]+nCell_00*24] &= (uchar)0xFD ;
				}
			}
			nCa=nC;
		} /* For Cells */
		Put4bytes(dwPGCDuration, &m_pIFO_00[m_VTS_PGC_00[nT]+4]);

// Clear audio status if audio strip
// Audio: Check if the same stripped stream is used in other track, and deactivate it.
		if (m_iAction[nVTS][nT]==STRIP)
		{
			if (m_bCheckAttrTitle)
			{
				for (nA=0;nA<m_nAudio[nVTS];nA++)
				{
					if ( m_iIdTAudioStrip[nVTS][nA][nT])
					{
						AudioStatus=m_pIFO_00[m_VTS_PGC_00[nT]+nA*2+0x0c];
						if ((AudioStatus & 0x80))
							m_pIFO_00[m_VTS_PGC_00[nT]+nA*2+0x0c]=0;

						for (k=0;k<8;k++)
						{
							AudioStatus=m_pIFO_00[m_VTS_PGC_00[nT]+k*2+0x0c];
							if ( (AudioStatus & 0x80) &&
							   ( m_iIdTAudio[nVTS][nA][nT]+m_iAddIdAudio[nVTS][nA]==
							     m_iIdTAudio[nVTS][k ][nT]+ m_iAddIdAudio[nVTS][k ])) 
								m_pIFO_00[m_VTS_PGC_00[nT]+k*2+0x0c]=0;
						}
					}
				}
				for (nS=0;nS<m_nSubs[nVTS];nS++)
				{
					if ( m_iIdTSubsStrip[nVTS][nS][nT])
					{
						SubStatus0=m_pIFO_00[m_VTS_PGC_00[nT]+nS*4+0x1c+0];
						if ((SubStatus0 & 0x80))
						{
							m_pIFO_00[m_VTS_PGC_00[nT]+nS*4+0x1c+0]=0;
							m_pIFO_00[m_VTS_PGC_00[nT]+nS*4+0x1c+1]=0;
							m_pIFO_00[m_VTS_PGC_00[nT]+nS*4+0x1c+2]=0;
							m_pIFO_00[m_VTS_PGC_00[nT]+nS*4+0x1c+3]=0;
						}
					}
				}
			} // CheckAttrTitle
		} // Action==STRIP
// Clear audio/sub status and PGC still time if blanking
		if (m_iAction[nVTS][nT]==BLANK)
		{
			if (m_bCheckAttrTitle)
			{
				for (nA=0;nA<8;nA++)
				{
					m_pIFO_00[m_VTS_PGC_00[nT]+nA*2+0x0c]=0;
					m_pIFO_00[m_VTS_PGC_00[nT]+nA*2+0x0c+1]=0;
				}
				for (nA=0;nA<32;nA++)
				{
					m_pIFO_00[m_VTS_PGC_00[nT]+nA*4+0x1c]=0;
					m_pIFO_00[m_VTS_PGC_00[nT]+nA*4+0x1c+1]=0;
					m_pIFO_00[m_VTS_PGC_00[nT]+nA*4+0x1c+2]=0;
					m_pIFO_00[m_VTS_PGC_00[nT]+nA*4+0x1c+3]=0;
				}
			}
			m_pIFO_00[m_VTS_PGC_00[nT]+0xA3]=0;
		}
// Copy Audio and sub Attributes
		if (m_iAction[nVTS][nT]==REPLACE && m_bCheckCopyAttrib)
		{
			if (GetInfoReplacingIFO(m_csReplace[nVTS][nT], &nPGCs, &nCells, uVTSAllAttr, uPalette, uStatus))
			{
				csAux.Format(_T("     Copying VTS audio/subs attributes from replacing PGC in PGC %d"),nT+1);
				MyLog(csAux);
				// Copy audio attrib except bytes 0 and 1, already copied/checked by dlg
				for (k=0; k<2+8*8 ;k++)
					if ( ((k-2)%8 )!=0 && ((k-2)%8 )!=1 )
						m_pIFO_00[0x202+k]=uVTSAllAttr[k+0x102];
				// Copy subs attrib 
				for (k=0; k<2+32*6 ;k++)
						m_pIFO_00[0x254+k]=uVTSAllAttr[k+0x154];
			}
			else
			{
				csAux.Format(_T("     WARNING: Unable to copy stream attributes from replacing IFO."));
				MyLog(csAux,ORANGE);
				m_nWarnings++;
			}
		}
// Copy Audio and sub Status
		if (m_iAction[nVTS][nT]==REPLACE && m_bCheckCopyStatus)
		{
			if (GetInfoReplacingIFO(m_csReplace[nVTS][nT], &nPGCs, &nCells, uVTSAllAttr, uPalette, uStatus))
			{
				csAux.Format(_T("     Copying PGC audio/subs stream control from replacing PGC in PGC %d"),nT+1);
				MyLog(csAux);
				// Copy audio status
				for (k=0; k<16 ;k++)
					m_pIFO_00[m_VTS_PGC_00[nT]+0x0C+k]=uStatus[0+k];
				// Copy attrib status
				for (k=0; k<128 ;k++)
					m_pIFO_00[m_VTS_PGC_00[nT]+0x1C+k]=uStatus[0x10+k];
			}
			else
			{
				csAux.Format(_T("     WARNING: Unable to copy stream control from replacing IFO."));
				MyLog(csAux,ORANGE);
				m_nWarnings++;
			}
		}
// Copy Color palette.
		if (m_iAction[nVTS][nT]==REPLACE && m_bCheckCopyPalette)
		{
			if (GetInfoReplacingIFO(m_csReplace[nVTS][nT], &nPGCs, &nCells, uVTSAllAttr, uPalette, uStatus))
			{
				csAux.Format(_T("     Copying PGC color palette from replacing PGC in PGC %d"),nT+1);
				MyLog(csAux);
				for (k=0; k<64 ;k++)
					m_pIFO_00[m_VTS_PGC_00[nT]+0xA4+k]=uPalette[0+k];
			}
			else
			{
				csAux.Format(_T("     WARNING: Unable to copy color palette from replacing IFO."));
				MyLog(csAux,ORANGE);
				m_nWarnings++;
			}
		}

// Check changes in AR and fix sub indexes in this case.
//		if (m_iAction[nVTS][nT]==REPLACE && m_bCheckSubsAR &&
		if ( m_bCheckSubsAR &&
		    (m_iVideoAttr[nVTS] & 0x0400) != (m_iVideoAttrBK[nVTS] & 0x0400)) 
		{
			csAux.Format(_T("     Note: Updating sub stream indexes in PGC %d."),nT+1);
			MyLog(csAux,CIAN);

			for (nS=0;nS<m_nSubs[nVTS];nS++)
			{
				SubStatus0=m_pIFO_00[m_VTS_PGC_00[nT]+nS*4+0x1c+0];
				SubStatus1=m_pIFO_00[m_VTS_PGC_00[nT]+nS*4+0x1c+1];
				if ((SubStatus0 & 0x80))
				{
					if ( m_iVideoAttr[nVTS] & 0x0C00)
					// From 4:3 to 16:9
					{
						m_pIFO_00[m_VTS_PGC_00[nT]+nS*4+0x1c+1]=SubStatus0 & 0x1F;
						m_pIFO_00[m_VTS_PGC_00[nT]+nS*4+0x1c+2]=SubStatus0 & 0x1F;
						m_iVideoAttr[nVTS] &= 0x00feff;  // Forces letterbox.
					}
					else
					// From 16:9 to 4:3
					{
						m_pIFO_00[m_VTS_PGC_00[nT]+nS*4+0x1c+0]= (SubStatus1 + 0x80);
						m_iVideoAttr[nVTS] |= 0x0300;  // Disallowes LB & PS
					}

					m_pIFO_00[0x200]=m_iVideoAttr[nVTS]/256;
				}
			}
		}

// Change Post into precommands
		if ( m_bCheckPostPre && m_iAction[nVTS][nT]==BLANK && m_PGC_COMM[nVTS][nT]!=0 )
// Action is blanking, table exists and checkbox active
		{
			iRet=ChangePostIntoPre(TITLES,nVTS,nT);
			if (iRet>=0)  {m_nPostPre++; m_nActualPostPre++;}
			if (iRet<=-2)  m_nPostPre++;
		}

// Point PGC to itself if checked and not empty 
		if (m_bCheckNextTitle && m_nCells_00[nT]!=0 && !bAtLeastOneInfinite)
		{
			nNext=GetNbytes(2,&m_pIFO_00[m_VTS_PGC_00[nT]+0x09c]);
			if (nNext ==0 && m_i8PostComm[nVTS][nT]>0 && m_pIFO_00[m_VTS_PGC_00[nT]+0xA3]==0)
			{
				Put2bytes(nT+1,&m_pIFO_00[m_VTS_PGC_00[nT]+0x09c]);
				csAux.Format(_T("     PGCN Pointer: Pointing Next PGCN to itself in PGC %d"),nT+1);
				MyLog(csAux);
			}
		}
// Point PGC to itself if checked and null 
		if (m_bCheckPrevTitle && m_nCells_00[nT]!=0)
		{
			nPrev=GetNbytes(2,&m_pIFO_00[m_VTS_PGC_00[nT]+0x09E]);
			if (nPrev ==0)
			{
				Put2bytes(nT+1,&m_pIFO_00[m_VTS_PGC_00[nT]+0x09E]);
				csAux.Format(_T("     PGCN Pointer: Pointing Prev PGCN to itself in PGC %d"),nT+1);
				MyLog(csAux);
			}
		}

	} /* for Titles */

///////////////////////////////////////////////////////
// VTS_TMAPTI
	csAux.Format(_T("     Processing TMPATI table"));
	MyLog(csAux);

	for (nT=0;nT<m_nPGCs[nVTS];nT++)
		ProcessTmapti(nT);


/////////////////////////////////////////////////////
// VTS_C_ADT : Total reconstruction of this table;
	nVOBIDs=GetTitleNVobId(nVTS);


	if (m_VTS_C_ADT_00==0)
	{
		csAux.Format(_T("     VTS_C_ADT table did not exist"));
		MyLog(csAux);
		m_nNewADTSectors= 0; 
	}
	else
	{
		for (k=0, iACellsKept=0;k<iACells;k++)
			if (m_TitleCells[nVTS][k].bToBeDeleted==false) iACellsKept++;

		if (iACellsKept==0)
		{
			csAux.Format(_T("     VTS_C_ADT table has been deleted"));
			MyLog(csAux);
			Put4bytes(0,&m_pIFO_00[0xE0]);
			m_nNewADTSectors= 0;
		}
		else
		{

			myVTS_C_ADT=m_nStartCellsTable+(m_nNewMADTSectors+m_nNewMADMAPSectors)*2048;
			Put4bytes(myVTS_C_ADT/2048,&m_pIFO_00[0xE0]);

			csAux.Format(_T("     Building VTS_C_ADT table"));
			MyLog(csAux);

			m_nNewADTSectors= (iACellsKept*12+7)/2048 +1; 
			for (k=0;k<(m_nNewADTSectors*2048)/4;k++)
				Put4bytes(0, &m_pIFO_00[myVTS_C_ADT+4*k]);

			m_pIFO_00[myVTS_C_ADT+0]=nVOBIDs/256;
			m_pIFO_00[myVTS_C_ADT+1]=nVOBIDs%256;
			m_pIFO_00[myVTS_C_ADT+2]=0;
			m_pIFO_00[myVTS_C_ADT+3]=0;
			Put4bytes( iACellsKept*12+7 ,&m_pIFO_00[myVTS_C_ADT+4]);

			for (k=kk=0;k<iACells;k++)
			{
				if (m_TitleCells[nVTS][k].bToBeDeleted==false)
				{
					m_pIFO_00[myVTS_C_ADT+8+12*kk  ]=m_TitleCells[nVTS][k].NVID/256;
					m_pIFO_00[myVTS_C_ADT+8+12*kk+1]=m_TitleCells[nVTS][k].NVID%256;
					m_pIFO_00[myVTS_C_ADT+8+12*kk+2]=m_TitleCells[nVTS][k].NCID;
					m_pIFO_00[myVTS_C_ADT+8+12*kk+3]=0;

					if (m_TitleCells[nVTS][k].i64FirstLBAFirstVOBU != -1)
						Put4bytes(m_TitleCells[nVTS][k].i64FirstLBAFirstVOBU, &m_pIFO_00[myVTS_C_ADT+8+12*kk+4]);
					if (m_TitleCells[nVTS][k].i64LastLBALastVOBU != -1)
						Put4bytes(m_TitleCells[nVTS][k].i64LastLBALastVOBU,&m_pIFO_00[myVTS_C_ADT+8+12*kk+8]);
					kk++;
				}
			}
		}
	}

///////////////////////////////////////////////////////
// VTS_VOBU_ADMAP

	if (m_VTS_VOBU_ADMAP_00==0)
	{
		csAux.Format(_T("     VTS_VOBU_ADMAP table did not exist"));
		MyLog(csAux);
		m_nNewADMAPSectors=0;
		Maxbyte=-1;
	}
	else
	{
		if (iANavs==0)
		{
			csAux.Format(_T("     VTS_VOBU_ADMAP table has been deleted"));
			MyLog(csAux);
			Put4bytes(0,&m_pIFO_00[0xE4]);
			m_nNewMADMAPSectors=0;
			Maxbyte=-1;
// Clear stream attributes.....
			csAux.Format(_T("     Clearing TITLE streams attributes"));
			MyLog(csAux);
			ProcessIfoClearAttrib(nVTS, TITLES);
		}
		else
		{
			myVTS_VOBU_ADMAP=m_nStartCellsTable+(m_nNewMADTSectors+m_nNewMADMAPSectors+m_nNewADTSectors)*2048;
			Put4bytes(myVTS_VOBU_ADMAP/2048,&m_pIFO_00[0xE4]);

			csAux.Format(_T("     Filling VTS_VOBU_ADMAP table"));
			MyLog(csAux);
			Maxbyte = iANavs*4+3;
			m_nNewADMAPSectors=Maxbyte/2048+1;

			if ((m_nNewMADMAPSectors+m_nNewMADTSectors+m_nNewADMAPSectors+m_nNewADTSectors
				-m_nIniMADMAPSectors-m_nIniMADTSectors-m_nIniADMAPSectors-m_nIniADTSectors) 
				 > MAX_NEWIFOSECTORS_END)
			{
				MyErrorLog_Box("Error: No enough room for IFO growing...");
				m_bInProcess=false;
				return;
			}

			for (k=0; k< (m_nNewADMAPSectors*2048)/4;k++)
				Put4bytes(0,&m_pIFO_00[myVTS_VOBU_ADMAP+4*k]);

			for ( k=0 ; k<iANavs ; k++)
				Put4bytes(m_ANavinfo[k].LBA,&m_pIFO_00[myVTS_VOBU_ADMAP+4+4*k]);

			Put4bytes(Maxbyte,&m_pIFO_00[myVTS_VOBU_ADMAP]);
		}
	}
	m_i64NewIFOlen[nVTS]=m_nStartCellsTable+(m_nNewMADTSectors+m_nNewMADMAPSectors+m_nNewADTSectors+m_nNewADMAPSectors)*2048;
}


void CVobBlankerApp::ProcessIfoVTSCopyTables(int nVTS, int iDomain)
{

	CString csAux;
	int myVTS_C_ADT,myVTS_VOBU_ADMAP;
	int k;


	if (iDomain==MENUS)
	{
/////////////////////////////////////////////////////////////////////////
// VTSM_C_ADT : Not needed to copy none of the tables. They will be in the same sector 
		if (m_VTSM_C_ADT_00==0)
		{
			csAux.Format(_T("     VTSM_C_ADT table did not exist"));
			MyLog(csAux);
			m_nNewMADTSectors= 0; 
		}
		else
		{
			m_nNewMADTSectors=m_nIniMADTSectors;
			csAux.Format(_T("     Copying VTSM_C_ADT table"));
			MyLog(csAux);
		}

///////////////////////////////////////////////////////
// VTSM_VOBU_ADMAP: 
		if (m_VTSM_VOBU_ADMAP_00==0)
		{
			csAux.Format(_T("     VTSM_VOBU_ADMAP table did not exist"));
			MyLog(csAux);
			m_nNewMADMAPSectors=0;
		}
		else
		{
			m_nNewMADMAPSectors=m_nIniMADMAPSectors;
			csAux.Format(_T("     Copying VTSM_VOBU_ADMAP table"));
			MyLog(csAux);
		}
		m_i64NewIFOlen[nVTS]=m_nStartCellsTable+(m_nNewMADTSectors+m_nNewMADMAPSectors)*2048;
	}
	else
	{
///////////////////////////////////////////////////////////////////////////////////
// VTS_C_ADT : It is needed to copy the table. Menu tables can be of different size
		if (m_VTS_C_ADT_00==0)
		{
			csAux.Format(_T("     VTS_C_ADT table did not exist"));
			MyLog(csAux);
			m_nNewADTSectors= 0; 
		}
		else
		{
			m_nNewADTSectors=m_nIniADTSectors;
			csAux.Format(_T("     Copying VTS_C_ADT table"));
			MyLog(csAux);

			myVTS_C_ADT=m_nStartCellsTable+(m_nNewMADTSectors+m_nNewMADMAPSectors)*2048;
			Put4bytes(myVTS_C_ADT/2048,&m_pIFO_00[0xE0]);

			for (k=0;k<m_nIniADTSectors*2048;k++)
				m_pIFO_00[myVTS_C_ADT+k]=m_pIFO[nVTS][m_VTS_C_ADT[nVTS]+k];

		}

///////////////////////////////////////////////////////
// VTS_VOBU_ADMAP
	
		if (m_VTS_VOBU_ADMAP_00==0)
		{
			csAux.Format(_T("     VTS_VOBU_ADMAP table did not exist"));
			MyLog(csAux);
			m_nNewADMAPSectors=0;
		}
		else
		{
			m_nNewADMAPSectors=m_nIniADMAPSectors;
			csAux.Format(_T("     Copying VTS_VOBU_ADMAP table"));
			MyLog(csAux);

			myVTS_VOBU_ADMAP=m_nStartCellsTable+(m_nNewMADTSectors+m_nNewMADMAPSectors+m_nNewADTSectors)*2048;

			Put4bytes(myVTS_VOBU_ADMAP/2048,&m_pIFO_00[0xE4]);

			for (k=0;k<m_nIniADMAPSectors*2048;k++)
				m_pIFO_00[myVTS_VOBU_ADMAP+k]=m_pIFO[nVTS][m_VTS_VOBU_ADMAP[nVTS]+k];

		}
		m_i64NewIFOlen[nVTS]=m_nStartCellsTable+(m_nNewMADTSectors+m_nNewMADMAPSectors+m_nNewADTSectors+m_nNewADMAPSectors)*2048;
	}
}

void CVobBlankerApp::ProcessIfoVTSEnd(int nVTS, CWnd* pDlg)
{

	CString csAux,csFout,csAux2;
	FILE *out;
	int i;
	int nIFOSectors,nMenuSectors,nVOBSectors;
	struct  _stati64 statbuf;
	int nT;

	csAux.Format(_T("VTS %02d: Processing IFO (Ending and writting)"),nVTS);
	MyLog(csAux);

	for (nT=0;nT<m_nPGCs[nVTS];nT++)
		if (m_bCheckIfoPuops)
			Put4bytes(0, &m_pIFO_00[m_VTS_PGC_00[nT]+8]);

	for (nT=0;nT<m_nMPGCs[nVTS];nT++)
		if (m_bCheckIfoPuops)
			Put4bytes(0, &m_pIFO_00[m_MENU_PGC_00[nT]+8]);

//////////////////////////////////////////////////////
// SECTORS

	nIFOSectors= (int) (m_i64NewIFOlen[nVTS]/2048);

// Use output path for menus. May be process menus is not selected,
//	but they should be copied previously..
	csAux2.Format(_T("VTS_%02d_0.VOB"), nVTS);
	csAux=m_csOutputPath+'\\'+csAux2;
	if (_stati64 ( csAux, &statbuf)==0)
		nMenuSectors= (int)(statbuf.st_size/2048);
	else 
		nMenuSectors=-1;

// Use output path for vobs.
	nVOBSectors=0;
	for (i=1; i<10; i++)
	{
		csAux2.Format(_T("VTS_%02d_%d.VOB"), nVTS,i);
		csAux=m_csOutputPath+'\\'+csAux2;
		if (_stati64 ( csAux, &statbuf)==0)
			nVOBSectors+= (int)(statbuf.st_size/2048);
		else 
			if (i!=0) i=20;
	}

	Put4bytes(nIFOSectors-1,&m_pIFO_00[0x1C]);
	if (nMenuSectors>=0)
		Put4bytes(nIFOSectors,&m_pIFO_00[0xC0]);
	else
	{
		// Menu does not exist
		nMenuSectors=0;
		Put4bytes(0,&m_pIFO_00[0xC0]);
	}
	Put4bytes(nIFOSectors+nMenuSectors,&m_pIFO_00[0xC4]);
	Put4bytes(nIFOSectors*2+nMenuSectors+nVOBSectors-1,&m_pIFO_00[0x0C]);

// write IFO & BUP
	csAux.Format(_T("VTS_%02d_0.IFO"), nVTS);
	csAux=m_csOutputPath+ '\\' +csAux;
	out=fopen(csAux,"wb");
	if (out!=NULL)
	{
		for (i=0;i<m_i64NewIFOlen[nVTS];i++)
			fputc (m_pIFO_00[i],out);
		fclose(out);
	}
	else
		MyLog("Error writting IFO");

	csAux.Format(_T("VTS_%02d_0.BUP"), nVTS);
	csAux=m_csOutputPath+ '\\' +csAux;
	out=fopen(csAux,"wb");
	if (out!=NULL)
	{
		for (i=0;i<m_i64NewIFOlen[nVTS];i++)
			fputc (m_pIFO_00[i],out);
		fclose(out);
	}
	else
		MyLog("Error writting BUP");


	delete[] m_pIFO_00;

}

void CVobBlankerApp::ProcessIfoClearAttrib(int nVTS, int iDomain)
{

	int n;
	int iVideoAttr;

	if (iDomain==MENUS)
	{
		// video
		iVideoAttr=GetNbytes(2,&m_pIFO_00[0x100]);
		iVideoAttr&=0x1000;
		Put2bytes(iVideoAttr,&m_pIFO_00[0x100]);

		// audio
		Put2bytes(0,&m_pIFO_00[0x102]);
		for (n=0;n<8;n++)
		{
			Put4bytes(0,&m_pIFO_00[0x104+8*n]);
			Put4bytes(0,&m_pIFO_00[0x104+4+8*n]);
		}
		// subs
		Put4bytes(0,&m_pIFO_00[0x154]);
		Put4bytes(0,&m_pIFO_00[0x154+4]);
	}
	if (iDomain==TITLES)
	{
		// video
		iVideoAttr=GetNbytes(2,&m_pIFO_00[0x200]);
		iVideoAttr&=0x1000;
		Put2bytes(iVideoAttr,&m_pIFO_00[0x200]);

		// audio
		Put2bytes(0,&m_pIFO_00[0x202]);
		for (n=0;n<8;n++)
		{
			Put4bytes(0,&m_pIFO_00[0x204+8*n]);
			Put4bytes(0,&m_pIFO_00[0x204+4+8*n]);
		}
		// subs
		Put2bytes(0,&m_pIFO_00[0x254]);
		for (n=0;n<32;n++)
		{
			Put2bytes(0,&m_pIFO_00[0x256+6*n]);
			Put4bytes(0,&m_pIFO_00[0x256+2+6*n]);
		}
	}


}

void CVobBlankerApp::ProcessIfoMGR(CWnd* pDlg)
{
	int i;
	FILE *out;
	CString csFout,csAux,csAux2, csPath, csIFOVTS;
	int nIFOSectors, nMenuSectors,nVOBSectors,nStart;
	UINT nStartSector[MAX_VTS];
	UINT FirstFreeSector;
	struct  _stati64 statbuf;
	int nVTS, nT, k;
	int TT_SRPT;
	uchar uVTSAllAttr[0x300];
	int pVMG_VTS_ATRT, pVTS_ATRT, pEndAddress;



//	ProcessIfoVTSPrepare(0,pDlg);

//	ProcessIfoVTSMenu(0,pDlg);

// Folder where check sizes
	if (m_bCheckFolder) csPath=m_csInputPath;
	else csPath=m_csOutputPath;

//////////////////////////////////////////////////////
// OWN SECTORS

	nIFOSectors= (int) (m_i64NewIFOlen[0]/2048);

// Use output path for menus. May be process menus is not selected,
//	but they should be copied previously..
	csAux=csPath+'\\'+"VIDEO_TS.VOB";
	if (_stati64 ( csAux, &statbuf)==0)
		nMenuSectors= (int)(statbuf.st_size/2048);
	else 
		nMenuSectors=-1;

	Put4bytes(nIFOSectors-1,&m_pIFO_00[0x1C]);
	if (nMenuSectors>=0)
		Put4bytes(nIFOSectors,&m_pIFO_00[0xC0]);
	else
	{
		// menu does not exist
		nMenuSectors=0;
		Put4bytes(0,&m_pIFO_00[0xC0]);
	}
	Put4bytes(nIFOSectors*2+nMenuSectors-1,&m_pIFO_00[0x0C]);

	FirstFreeSector=nIFOSectors*2+nMenuSectors;
//////////////////////////////////////////////////////
// TT_SRPT: Table of titles

// Calculate start sector of each VTS

	for (nVTS=1 ; nVTS<m_nIFOs+1 ; nVTS++)
	{
		nStartSector[nVTS]=FirstFreeSector;

// Use output path for IFOs. May be their size has changed,
		csAux2.Format(_T("VTS_%02d_0.IFO"), nVTS);
		csAux=csPath+'\\'+csAux2;
		if (_stati64 ( csAux, &statbuf)==0)
			nIFOSectors= (UINT)(statbuf.st_size/2048);
		else 
			nIFOSectors= (UINT) (m_i64IFOlen[nVTS]/2048);

// Use output path for menus. May be process menus is not selected,
//	but they should be copied previously..
		csAux2.Format(_T("VTS_%02d_0.VOB"), nVTS);
		csAux=csPath+'\\'+csAux2;
		if (_stati64 ( csAux, &statbuf)==0)
			nMenuSectors= (UINT)(statbuf.st_size/2048);
		else 
			nMenuSectors=0;
// Use output path for vobs.
		nVOBSectors=0;
		for (k=1; k<10; k++)
		{
			csAux2.Format(_T("VTS_%02d_%d.VOB"), nVTS,k);
			csAux=m_csOutputPath+'\\'+csAux2;
			if (_stati64 ( csAux, &statbuf)==0)
				nVOBSectors+= (UINT)(statbuf.st_size/2048);
			else 
				if (k!=0) k=20;
		}

		FirstFreeSector+= (2*nIFOSectors+nMenuSectors+nVOBSectors);
	}

///////////////////////////////////////////////////////
// VMG_VTS_ATRT
// Copy Audio and sub Attributes
	for (nVTS=1 ; nVTS<m_nIFOs+1 ; nVTS++)
	{
		if (m_iActionVTS[nVTS]==PROCESS)
		{
			csAux2.Format(_T("VTS_%02d_0.IFO"), nVTS);
			csAux=csPath+'\\'+csAux2;

			if (GetIFOVTSAttr(csAux, uVTSAllAttr))
			{
				pVMG_VTS_ATRT=GetNbytes(4,&m_pIFO_00[0xd0])*2048;
				pVTS_ATRT=GetNbytes(4,&m_pIFO_00[pVMG_VTS_ATRT+8+4*(nVTS-1)])+pVMG_VTS_ATRT;
				pEndAddress= GetNbytes(4,&m_pIFO_00[pVTS_ATRT]);
				if (m_bCheckTitle )
				{
					csAux.Format(_T("     Copying Titles video/audio/subs attributes from VTS_%02d.IFO"),nVTS);
					MyLog(csAux);
			// Copy all Title domain attrib 
					for (k=0; k<0x1d8 && k+8 <= pEndAddress;k++)
						m_pIFO_00[pVTS_ATRT+k+8+0x100]=uVTSAllAttr[k+0x100];
				}
				if (m_bCheckMenu )
				{
					csAux.Format(_T("     Copying Menus video/audio/subs attributes from VTS_%02d.IFO"),nVTS);
					MyLog(csAux);
			// Copy all Menu domain attrib 
					for (k=0; k<0x5c && k+8 <= pEndAddress;k++)
						m_pIFO_00[pVTS_ATRT+k+8]=uVTSAllAttr[k+0x000];
				}

			}
			else
			{
				csAux.Format(_T("     WARNING: Unable to copy stream attributes from VTS_%02d.IFO"),nVTS);
				MyLog(csAux,ORANGE);
				m_nWarnings++;
			}
		}
	}

///////////////////////////////////////////////////////
// Titles loop
	TT_SRPT=2048*GetNbytes(4,&m_pIFO_00[0xC4]);
	for (k=0;k< m_nTotalTitles ; k++)
	{
		nStart=GetNbytes(1,&m_pIFO_00[TT_SRPT+8+12*k+6]);
		Put4bytes(nStartSector[nStart],&m_pIFO_00[TT_SRPT+8+12*k+8]);
		if (m_bCheckIfoPuops)
			m_pIFO_00[TT_SRPT+8+12*k]=m_pIFO_00[TT_SRPT+8+12*k] & 0xFC;

//// Chapters & angles
//// Loop PGCs ---> VTS index:"nVTS"; PGC index: "nT"

		for (nVTS=1 ; nVTS<m_nIFOs+1 ; nVTS++)
			for (nT=0 ; nT<m_nPGCs[nVTS] ; nT++)
			{
				if (m_nTitleInVTS[nVTS][nT]== m_pIFO_00[TT_SRPT+8+7+12*k] &&
					nVTS==m_pIFO_00[TT_SRPT+8+6+12*k])
				{
					Put2bytes(GetNbytes(2,&m_pIFO_00[TT_SRPT+10+12*k])+m_nChaptersAdded[nVTS][nT],
						&m_pIFO_00[TT_SRPT+10+12*k]);
					if (m_iActionVTS[nVTS]==PROCESS && m_bCheckTitle)
						m_pIFO_00[TT_SRPT+8+1+12*k]= 1;
//					else m_pIFO_00[TT_SRPT+8+1+12*k]=m_nAngles[nVTS][nT]; 
				}
			}
	}

///////////////////////////////////////////////////////
//  Menu PGCs loop
	for (nT=0;nT<m_nMPGCs[0];nT++)
		if (m_bCheckIfoPuops)
			Put4bytes(0, &m_pIFO_00[m_MENU_PGC_00[nT]+8]);

//  First Play PGC
	if (m_bCheckIfoPuops)
		Put4bytes(0, &m_pIFO_00[GetNbytes(4,&m_pIFO_00[0x84])+8]);

	
	csAux.Format(_T("VIDEO_TS: Processing IFO (Ending and writting)"));
	MyLog(csAux);


// write IFO & BUP
	nIFOSectors= m_nStartCellsTable/2048+ m_nNewMADTSectors+m_nNewMADMAPSectors;
	csFout=m_csOutputPath+ '\\' +"VIDEO_TS.IFO";
	out=fopen(csFout,"wb");
	if (out!=NULL)
	{
		for (i=0;i<m_i64NewIFOlen[0];i++)
			fputc (m_pIFO_00[i],out);
		fclose(out);
	}
	else
		MyLog("Error writting IFO");

	csFout=m_csOutputPath+ '\\' +"VIDEO_TS.BUP";
	out=fopen(csFout,"wb");
	if (out!=NULL)
	{
		for (i=0;i<m_i64NewIFOlen[0];i++)
			fputc (m_pIFO_00[i],out);
		fclose(out);
	}
	else
		MyLog("Error writting BUP");

	delete[] m_pIFO_00;

}

int CVobBlankerApp::AdjustSectors(CString csPath)
{
	int		iIFOSectors[MAX_VTS];
	int		iMenuSectors[MAX_VTS];
	int		iVOBSectors[MAX_VTS];
	int		FirstFreeSector;
	int		iStartSector[MAX_VTS];
	CString csAux,csAux2;
	int		iTT_SRPT;
	int		nVTS,nT;
	struct _stati64	statbuf;
	int		i,nStart;

	FILE * in;


	for (nVTS=1 ; nVTS<m_nIFOs+1 ; nVTS++)
	{
		csAux2.Format(_T("VTS_%02d_0.IFO"), nVTS);
		csAux=csPath+'\\'+csAux2;
		if (_stati64 ( csAux, &statbuf)==0)
			iIFOSectors[nVTS]= (int)(statbuf.st_size/2048);
		else 
			iIFOSectors[nVTS]=-1;

		csAux2.Format(_T("VTS_%02d_0.VOB"), nVTS);
		csAux=csPath+'\\'+csAux2;
		if (_stati64 ( csAux, &statbuf)==0)
			iMenuSectors[nVTS]= (int)(statbuf.st_size/2048);
		else 
			iMenuSectors[nVTS]=-1;

		iVOBSectors[nVTS]=0;
		for (i=1; i<10; i++)
		{
			csAux2.Format(_T("VTS_%02d_%d.VOB"), nVTS,i);
			csAux=csPath+'\\'+csAux2;
			if (_stati64 ( csAux, &statbuf)==0)
				iVOBSectors[nVTS]+= (int)(statbuf.st_size/2048);
			else 
				if (i!=0) i=20;
		}
	}

	csAux=csPath+"\\VIDEO_TS.IFO";
	if (_stati64 ( csAux, &statbuf)==0)
		iIFOSectors[0]= (int)(statbuf.st_size/2048);
	else 
		iIFOSectors[0]=-1;

	csAux=csPath+"\\VIDEO_TS.VOB";
	if (_stati64 ( csAux, &statbuf)==0)
		iMenuSectors[0]= (int)(statbuf.st_size/2048);
	else 
		iMenuSectors[0]=-1;

	iVOBSectors[0]=0;

	for (nVTS=1 ; nVTS<m_nIFOs+1 ; nVTS++)
	{
//////////////////////////////////////////////////////
// SECTORS IN VTS_XX_0.IFO

		csAux.Format(_T("VTS_%02d_0.IFO"), nVTS);
		csAux=csPath+'\\'+csAux;

		csAux2.Format(_T("VTS_%02d_0.BUP"), nVTS);
		csAux2=csPath+'\\'+csAux2;

		if ((in=fopen(csAux,"r+b"))==NULL)
		{
			MyLog ("Unable to open IFO file: " + csAux);
			return -1;
		}

		fseek(in,0x1C,SEEK_SET);
		fput4c(iIFOSectors[nVTS]-1,in);

		fseek(in,0xC0,SEEK_SET);
		if (iMenuSectors[nVTS]>=0)
			fput4c(iIFOSectors[nVTS],in);
		else
		{
		// Menu does not exist
			iMenuSectors[nVTS]=0;
			fput4c(0,in);
		}

		fseek(in,0xC4,SEEK_SET);
		fput4c(iIFOSectors[nVTS]+iMenuSectors[nVTS],in);

		fseek(in,0x0C,SEEK_SET);
		fput4c(2*iIFOSectors[nVTS]+iMenuSectors[nVTS]+iVOBSectors[nVTS]-1,in);

// Remove POUPs in Skipped IFOs: Originakl pointers can be used
// VIDEO_TS.IFO is always processed, so no need to remove PUOPs again
		if (m_bCheckIfoPuops && m_iActionVTS[nVTS]==SKIP )
		{
			for (nT=0;nT<m_nPGCs[nVTS];nT++)
			{
				fseek(in, m_VTS_PGC[nVTS][nT]+8 ,SEEK_SET);
				fput4c( 0 ,in);
			}

			for (nT=0;nT<m_nMPGCs[nVTS];nT++)
			{
				fseek(in, m_MENU_PGC[nVTS][nT]+8 ,SEEK_SET);
				fput4c( 0 ,in);
			}
		}
		fclose(in);
//		MyLog (csAux + " modified. Updating BUP");
		CopyFile(csAux, csAux2,FALSE);
	}

//////////////////////////////////////////////////////
// SECTORS IN VIDEO_TS.IFO

// OWN SECTORS
	csAux=csPath+"\\VIDEO_TS.IFO";
	csAux2=csPath+"\\VIDEO_TS.BUP";
	
	if ((in=fopen(csAux,"r+b"))==NULL)
	{
		MyLog("Unable to open IFO file: " + csAux);
		return -1;
	}

	fseek(in,0x1C,SEEK_SET);
	fput4c(iIFOSectors[0]-1,in);

	fseek(in,0xC0,SEEK_SET);
	if (iMenuSectors[0]>=0)
		fput4c(iIFOSectors[0],in);
	else
	{
	// Menu does not exist
		iMenuSectors[0]=0;
		fput4c(0,in);
	}

	fseek(in,0x0C,SEEK_SET);
	fput4c(2*iIFOSectors[0]+iMenuSectors[0]-1,in);
	

// TT_SRPT: Table of titles
// Calculate start sector of each VTS
	FirstFreeSector=iIFOSectors[0]*2+iMenuSectors[0];
	for (nVTS=1 ; nVTS<m_nIFOs+1 ; nVTS++)
	{
		iStartSector[nVTS]=FirstFreeSector;
		FirstFreeSector+= (2*iIFOSectors[nVTS]+iMenuSectors[nVTS]+iVOBSectors[nVTS]);
	}	
///////////////////////////////////////////////////////
// Titles loop

	fseek(in,0x0C4,SEEK_SET);
	iTT_SRPT=2048*get4c(in);

	for (i=0;i< m_nTotalTitles ; i++)
	{
		if (fseek(in,iTT_SRPT+8+12*i+6,SEEK_SET)==0)
		{
			nStart=getc(in);
			if (nStart !=EOF && nStart < m_nIFOs+1 && nStart >0)
			{
				fseek(in,iTT_SRPT+8+12*i+8,SEEK_SET);
				fput4c(iStartSector[nStart],in);
			}
			else
			{
				MyLog ("Unable to adjust all title sectors");
				fclose(in);
				return -1;
			}
		}
		else
		{
			MyLog ("Unable to get title number in VIDEO_TS.IFO");
			fclose(in);
			return -1;
		}
	}

	fclose(in);
	CopyFile(csAux, csAux2,FALSE);
	return 0;
}

void CVobBlankerApp::ProcessTmapti( int nT)
{

#define PERCDUR 95
#define MAXENTRIESLOST 2

	int duration, nuPGCs, nuPGCs_TMAP;
	int nusecs, i, idx;
	int VTS_TMAP_ini, VTS_TMAP_end, VTS_TMAP_absolute_end;
	int maxentries, entries, entriesok;
	__int64 lba;
	CString csAux;
	FILE *log;
	int discontinuity;
	int VID,CID, VID_old,CID_old;



	if (m_VTS_TMAPTI_00 == 0)
		// No TMAPTI table
		return;

	nuPGCs=GetNbytes(2,&m_pIFO_00[m_VTS_PGCI_00]);
/*
Not needed

	if ( nuPGCs <= nT)
	{
		csAux.Format(_T("     WARNING: Something wrong in number of PGCs: %d"),nT);
		MyLog (csAux,ORANGE);
		m_nWarnings++;
//		MyErrorBox("ERROR: Something wrong in number of PGCs");
		return;
	}
*/

	duration= GetNbytes(4,&m_pIFO_00[m_VTS_PGC_00[nT] + 4]);
	duration= DurationInSecs( GetNbytes(4,&m_pIFO_00[m_VTS_PGC_00[nT] + 4]));

// locate selected TMAP

	nuPGCs_TMAP= GetNbytes( 2, &m_pIFO_00[m_VTS_TMAPTI_00]);

	if ( nT >=  nuPGCs_TMAP)
	{
//		MyErrorBox("ERROR: nuPGCs mismatch between VTS_TMAPTI and VTS_PGCI.");
		csAux.Format(_T("     WARNING: nuPGCs higher than the value stored in VTS_TMAPTI %d"),nT+1);
		MyLog (csAux,ORANGE);
		m_nWarnings++;
		return;
	}

	VTS_TMAP_ini= GetNbytes( 4, &m_pIFO_00[m_VTS_TMAPTI_00 + 8 + nT*4 ]) + m_VTS_TMAPTI_00;


// locate the limits of TMAP table
	VTS_TMAP_absolute_end=GetNbytes( 4, &m_pIFO_00[m_VTS_TMAPTI_00 + 4 ]) + m_VTS_TMAPTI_00 -1;
	if (nuPGCs_TMAP == nT+1)
		// last PGC, so use last available byte
		VTS_TMAP_end= VTS_TMAP_absolute_end;
	else
		// first byte of next PGC
		VTS_TMAP_end=GetNbytes( 4, &m_pIFO_00[m_VTS_TMAPTI_00 + 12 + nT*4 ]) + m_VTS_TMAPTI_00 -1;

// Guarantee to do not go out of the table..
	if (VTS_TMAP_end> VTS_TMAP_absolute_end) VTS_TMAP_end=VTS_TMAP_absolute_end;

    maxentries=(VTS_TMAP_end-VTS_TMAP_ini+1)/4-1 ;
	if (maxentries <0) maxentries=0;

	if ( maxentries !=0)
	{
		nusecs=duration/maxentries;
		if (nusecs == 0)  nusecs=1;
		entries= duration/nusecs;
		if (entries > maxentries+MAXENTRIESLOST)
			nusecs= (duration*PERCDUR/100)/maxentries + 1;
	}
	else
	{
		entries=0;
		nusecs=duration+1;
	}

	// to be sure 
	if (nusecs == 0)  nusecs=1;
	entries= duration/nusecs;

	if (LOGTMAPTI && m_bLog)
	{
		csAux.Format(_T("C:\\tmapti_log.txt"));
		log=fopen(csAux,"a");
		fprintf (log, "pgc:%02d nusecs:%02d entries:%04d maxentries:%04d duration:%06d\n",
		           nT+1, nusecs, entries, maxentries, duration);
	}


	VID_old=CID_old=0;

	for (i=nusecs, entriesok=0; i<duration; i+=nusecs)
	{
		discontinuity=0;

		idx=Findidxlba(i, nT, &discontinuity);
		lba= m_ANavinfo[idx].LBA;
		VID=m_ANavinfo[idx].VID;
		CID=m_ANavinfo[idx].CID;

		if (i!=0 && (VID_old!=VID || CID_old!=CID)) discontinuity=1;
			
		VID_old=VID;
		CID_old=CID;

// entriesok is incremented later, in order to apply discontinuity 
// to the previous index, like IFOEdit does. Not sure if it is ok or not
		if (discontinuity==1)
		{
			discontinuity=0;
			m_pIFO_00[VTS_TMAP_ini+entriesok*4] |= 0x80;
		}

		if (lba!=0xFFFFFFFF  && entriesok <maxentries)
		{
			entriesok++;
			Put4bytes(lba, &m_pIFO_00[VTS_TMAP_ini+entriesok*4]);
			if (LOGTMAPTI && m_bLog)
				fprintf (log, "entry:%04d sec:%06d lba:%08I64X\n",
		                   entriesok, i, lba);
		}

	}
	if (LOGTMAPTI && m_bLog)  fclose (log);

// last entry always discontinuity. Not sure, but it seems... 
	if (entriesok > 0 )
		m_pIFO_00[VTS_TMAP_ini+entriesok*4] |= 0x80;

	m_pIFO_00[VTS_TMAP_ini+2]=entriesok/256;
	m_pIFO_00[VTS_TMAP_ini+3]=entriesok%256;
	m_pIFO_00[VTS_TMAP_ini]=nusecs;
}

int CVobBlankerApp::Findidxlba (int sec,  int nT,int * discontinuity)
{

	int k, match, CellId, VobId,nCell;
	static int framesacum;
	int framesread;
	int nC;
	int idx,idxlast;
	DWORD dwDuration, dwPGCDuration;
	int ifps;


	dwPGCDuration=GetNbytes(4, &m_pIFO_00[m_VTS_PGC_00[nT]+4]);
	if ( ((dwPGCDuration%256) & 0x0c0) == 0x0c0 )
		ifps=30;
	else  
		ifps=25;

// Go cell by cell
	for (nCell=nC=0,framesacum=0, match=0;nCell<m_nCells_00[nT] && match==0 ;nCell++)
	{
		dwDuration=GetNbytes(4,&m_pIFO_00[m_C_PBKT_00[nT]+24*nCell+4]);
		framesacum+=DurationInFrames(dwDuration);

		if (framesacum >= sec*ifps) 
		{
			match=1;
			nC=nCell;
			framesacum-=DurationInFrames(dwDuration);
		}
	}

	nCell=nC;
	CellId=m_pIFO_00[m_C_POST_00[nT]+nCell*4+3];
	VobId=GetNbytes(2,&m_pIFO_00[m_C_POST_00[nT]+nCell*4]);

	idxlast=m_ANavinfo.GetSize()-1;
	for (k=0,match=0 ; k < m_ANavinfo.GetSize() && match==0 ; k++)
	{
		if (VobId==m_ANavinfo[k].VID && CellId==m_ANavinfo[k].CID)
		{
//			framesread=m_ANavinfo[k].seconds*ifps;
			framesread=m_ANavinfo[k].frames;
////////////////// Strange situations ////////////////
/*			if (secread < secold)
			{
				*discontinuity=1;
				secacum+=secold;
			}

			if (secread > secold + MAXVOBUSECSLENGTH)
			{
// Something happens. i.e.: a cut. Now duration are fixed 
//  so it is not really needed, but..., 
				*discontinuity=1;
				secacum-=(secread-secold);
			}
			secold=secread;
//////////////////////////////////////////////////
*/
			if ( (framesread+framesacum) >= (sec*ifps) )
			{
				match=1;
				idx=k;
			}
			idxlast=k;
		}
	}

	if (match)
		return idx;
	else
		return idxlast;
}


int  CVobBlankerApp::InsertCellInPGC(int nT, int nCell, int iChapterMode)
{
// Inserts a Cell in the PGC#: nT, following Cell#: nCell. 
// Uses VID/CID and all values taken from the nCell
// Grows m_pIFO_00 if needed, and return the number of sectors grown.
// iChapterMode meanings are:
//	0 ---> Insert CELL only
//	1 ---> Insert CELL and Program
//	2 ---> Insert CELL, Program and Chapter

	int LastByteIni, LastByte;
//	int nPGC;
	int nTT;
	int i,j;
	int nNewIFOSec;
	int nPrograms;
	int nProgCell,nProgramAdded;
	int nPTT_PRG,nPTT_PGC;
	int VTS_PTT_Ini,VTS_PTT_End,VTS_PTT_This;
	int nTTU;

	nNewIFOSec=0;

	LastByteIni=LastByte=GetNbytes(4,&m_pIFO_00[m_VTS_PGCI_00+4]);
// 28 bytes will be added if original # programs is odd
	LastByte+=28;
	nPrograms=m_pIFO_00[m_VTS_PGC_00[nT]+2];
// If a program has to be added,
// 30 bytes will be added if original # programs is even
	if (iChapterMode > 0)
	{
		if ((nPrograms%2)==0)
			LastByte+=2;
	}

	if (LastByte/2048 > LastByteIni/2048)
	{
//Move one sector all the tables starting from m_VTSM_PGCI_00
// One sector is available for VTS_PGCI_00 growing
		for (i= (int)m_i64IFOlen_00-1; i>=m_VTSM_PGCI_00 ; i--)
		{
			m_pIFO_00[i+2048]=m_pIFO_00[i];
		}
// Clear the created hole
		for (i= m_VTSM_PGCI_00 ; i < m_VTSM_PGCI_00+2048 ; i++)
		{
			m_pIFO_00[i]=0;
		}

		for (i=0xD0 ; i<= 0xE4 ; i+=4)
			if (GetNbytes(4,&m_pIFO_00[i])!=0)
				Put4bytes(GetNbytes(4,&m_pIFO_00[i])+1 , &m_pIFO_00[i]);
//		m_i64IFOlen_00+=2048;
//		ReadIFO_Copy(nVTS);
		nNewIFOSec=1;
	}
	Put4bytes(LastByte,&m_pIFO_00[m_VTS_PGCI_00+4]);

// Number of Cells and programs	
//	nPrograms=m_pIFO_00[m_VTS_PGC_00[nT]+2];
	if (iChapterMode > 0)
		m_pIFO_00[m_VTS_PGC_00[nT]+2]++;
	m_pIFO_00[m_VTS_PGC_00[nT]+3]++;
	m_nCells_00[nT]++;

// Move 2 byte (hole for program) if # prog is even 
	if (iChapterMode > 0)
	{
		if ((nPrograms%2)==0)
		{
			for (i=m_VTS_PGCI_00+(LastByte/2048+1)*2048-1; i>= 	m_C_PBKT_00[nT]+2 ; i--)
				m_pIFO_00[i]=m_pIFO_00[i-2];

			m_C_PBKT_00[nT]+=2;
			m_C_POST_00[nT]+=2;
		}
	}


// Move 24 byte (hole for cell pbk)
	for (i=m_VTS_PGCI_00+(LastByte/2048+1)*2048-1; i>=m_C_POST_00[nT]+24 ; i--)
	{
		m_pIFO_00[i]=m_pIFO_00[i-24];
	}
	m_C_POST_00[nT]+=24;
// Move 4 byte (hole for cell position)
	if (nT !=m_nPGCs_00-1)
	{
		for (i=m_VTS_PGCI_00+(LastByte/2048+1)*2048-1; i>=m_VTS_PGC_00[nT+1]+4+25 ; i--)
		{
			m_pIFO_00[i]=m_pIFO_00[i-4];
		}
	}

// Correct this PGC pointers
	Put2bytes(m_C_PBKT_00[nT]-m_VTS_PGC_00[nT],&m_pIFO_00[m_VTS_PGC_00[nT]+0xE8]);
	Put2bytes(m_C_POST_00[nT]-m_VTS_PGC_00[nT],&m_pIFO_00[m_VTS_PGC_00[nT]+0xEA]);

// Correct next PGCs pointers. nTT indexes next PGCs

	i=28;
	if (iChapterMode > 0)
		if ((nPrograms%2)==0) i+=2;
	for (nTT=nT+1 ; nTT < m_nPGCs_00 ; nTT++)
	{
		m_VTS_PGC_00[nTT]+=i;
		Put4bytes( GetNbytes(4,&m_pIFO_00[m_VTS_PGCI_00+0x04+(nTT+1)*8])+i,
					&m_pIFO_00[m_VTS_PGCI_00+0x04+(nTT+1)*8]);
		m_C_POST_00[nTT]+=i;
		m_C_PBKT_00[nTT]+=i;
		m_C_PROG_00[nTT]+=i;
	}

////////////////////////////////////////////////
// Fill program tables
////////////////////////////////////////////////
// Step A: Renumber current programs
// Note nCell goes from 0 to n-1....
	for (i=0; i<nPrograms;i++)
	{
		nProgCell=m_pIFO_00[m_C_PROG_00[nT]+i];
		if (nProgCell> nCell+1) 
			m_pIFO_00[m_C_PROG_00[nT]+i]++;
	}
// Step B: move Current programs one step: Only if iChapterMode >0
	if (iChapterMode > 0)
	{
		nProgCell=1;
		for (i=nPrograms; i>0;i--)
		{
			nProgCell=m_pIFO_00[m_C_PROG_00[nT]+i-1];
			if (nProgCell > nCell+1)
				m_pIFO_00[m_C_PROG_00[nT]+i]=m_pIFO_00[m_C_PROG_00[nT]+i-1];
			else
			{
				m_pIFO_00[m_C_PROG_00[nT]+i]=nCell+2;
				nProgramAdded=i+1;
				i=0;
			}
		}
//if # prog is even fill with zero the next byte
		if ((nPrograms%2)==0)
			m_pIFO_00[m_C_PROG_00[nT]+nPrograms+1]=0;
	}

////////////////////////////////////////////////
// Fill position tables
////////////////////////////////////////////////
	for (i=m_nCells_00[nT]-1; i> nCell ; i--)
	{
		for (j=0;j<4;j++)
			m_pIFO_00[m_C_POST_00[nT]+i*4+j]=m_pIFO_00[m_C_POST_00[nT]+(i-1)*4+j];
	}

////////////////////////////////////////////////
// Fill playback tables
////////////////////////////////////////////////
	for (i=m_nCells_00[nT]-1; i> nCell ; i--)
	{
		for (j=0;j<24;j++)
			m_pIFO_00[m_C_PBKT_00[nT]+i*24+j]=m_pIFO_00[m_C_PBKT_00[nT]+(i-1)*24+j];
	}
// Seamless linked. Rest of data are cloned from original Cell. Duration and sectors will be automatically corrected
	m_pIFO_00[m_C_PBKT_00[nT]+(nCell+1)*24  ]=  8 ;  

// Return if no programs have been added
	if (iChapterMode==0 || m_VTS_PTT_SRPT_00==0)
		return nNewIFOSec;


//////////////////////////////////////////////////////
//////////////////////////////////////////////////////
// Process VTS_PTT_SRPT
////////////////////////////////////////////////

	LastByteIni=LastByte=GetNbytes(4,&m_pIFO_00[m_VTS_PTT_SRPT_00+4]);

	if (iChapterMode==2)
	{
		LastByte=LastByteIni+4;
		Put4bytes(LastByte,&m_pIFO_00[m_VTS_PTT_SRPT_00+4]);
	}

	if (LastByte/2048 > LastByteIni/2048)
	{
//Move one sector
		for (i= (int)m_i64IFOlen_00-1+2048*nNewIFOSec; i>=m_VTS_PGCI_00 ; i--)
		{
			m_pIFO_00[i+2048]=m_pIFO_00[i];
		}
// Clear the created hole
		for (i= m_VTS_PGCI_00 ; i < m_VTS_PGCI_00+2048 ; i++)
		{
			m_pIFO_00[i]=0;
		}
		for (i=0xCC ; i<= 0xE4 ; i+=4)
			if (GetNbytes(4,&m_pIFO_00[i])!=0)
				Put4bytes(GetNbytes(4,&m_pIFO_00[i])+1 , &m_pIFO_00[i]);
		nNewIFOSec++;
	}
	if (iChapterMode==2)
	{
		Put4bytes(0,&m_pIFO_00[LastByteIni+1+m_VTS_PTT_SRPT_00]);
	}


	if (iChapterMode>0)
	{
		VTS_PTT_End=GetNbytes(4,&m_pIFO_00[m_VTS_PTT_SRPT_00+4])+m_VTS_PTT_SRPT_00;
		VTS_PTT_Ini=GetNbytes(4,&m_pIFO_00[m_VTS_PTT_SRPT_00+8])+m_VTS_PTT_SRPT_00;

		for (i= VTS_PTT_Ini; i< VTS_PTT_End ;i+=4)
		{
			nPTT_PGC=GetNbytes(2,&m_pIFO_00[i]);
			nPTT_PRG=GetNbytes(2,&m_pIFO_00[i+2]);
			if ( (nT+1) == nPTT_PGC && nPTT_PRG >= nProgramAdded )
				Put2bytes(nPTT_PRG+1,&m_pIFO_00[i+2]);
		}
	}
	if (iChapterMode==2)
	{
		VTS_PTT_End=GetNbytes(4,&m_pIFO_00[m_VTS_PTT_SRPT_00+4])+m_VTS_PTT_SRPT_00;
		VTS_PTT_Ini=GetNbytes(4,&m_pIFO_00[m_VTS_PTT_SRPT_00+8])+m_VTS_PTT_SRPT_00;

		for (i= VTS_PTT_End-7; i>= VTS_PTT_Ini ;i-=4)
		{
			nPTT_PGC=GetNbytes(2,&m_pIFO_00[i]);
			nPTT_PRG=GetNbytes(2,&m_pIFO_00[i+2]);
			if ((nT+1) != nPTT_PGC || ((nT+1) == nPTT_PGC && nPTT_PRG != (nProgramAdded-1) ))
			{
				Put2bytes(nPTT_PGC,&m_pIFO_00[i+4]);
				Put2bytes(nPTT_PRG,&m_pIFO_00[i+2+4]);
			}
			else
			{
				Put2bytes(nT+1,&m_pIFO_00[i+4]);
				Put2bytes(nProgramAdded,&m_pIFO_00[i+2+4]);
				VTS_PTT_This=i+4-m_VTS_PTT_SRPT_00;
				i=0;
			}
		}
// Time unit search pointers
		nTTU=GetNbytes(2,&m_pIFO_00[m_VTS_PTT_SRPT_00]);
		for (i=0;i<nTTU;i++)
		{
			VTS_PTT_Ini=GetNbytes(4,&m_pIFO_00[m_VTS_PTT_SRPT_00+8+4*i]);
			if (VTS_PTT_Ini >= VTS_PTT_This)
				Put4bytes(VTS_PTT_Ini+4,&m_pIFO_00[m_VTS_PTT_SRPT_00+8+4*i]);
		}
	}

	return nNewIFOSec;
}


/*Used in preview */

 
__int64 CVobBlankerApp::PR_CellSectors(int iDomain, int nVTS, int nT, int nCell)
{
	__int64 i64AccSec,i64IniSec,i64EndSec;
    
	if (iDomain==TITLES)
	{
		i64IniSec=GetNbytes(4,&m_pIFO[nVTS][m_C_PBKT[nVTS][nT]+24*nCell+8]);
		i64EndSec=GetNbytes(4,&m_pIFO[nVTS][m_C_PBKT[nVTS][nT]+24*nCell+0x14]);
		i64AccSec=(i64EndSec-i64IniSec+1);
	}
	else
	{
		i64IniSec=GetNbytes(4,&m_pIFO[nVTS][m_M_C_PBKT[nVTS][nT]+24*nCell+8]);
		i64EndSec=GetNbytes(4,&m_pIFO[nVTS][m_M_C_PBKT[nVTS][nT]+24*nCell+0x14]);
		i64AccSec=(i64EndSec-i64IniSec+1);
	}
	return i64AccSec;

}

__int64 CVobBlankerApp::PR_CellIniSector(int m_iDomain, int nVTS, int nT, int nCell)
{
	__int64 i64IniSec;
    
	if (m_iDomain==TITLES)
		i64IniSec=GetNbytes(4,&m_pIFO[nVTS][m_C_PBKT[nVTS][nT]+24*nCell+8]);
	else
		i64IniSec=GetNbytes(4,&m_pIFO[nVTS][m_M_C_PBKT[nVTS][nT]+24*nCell+8]);

	return i64IniSec;

}

int CVobBlankerApp::CellVID(int nVTS,int nT,int nCell) 
{
	int iVID;

	iVID=GetNbytes(2,&m_pIFO[nVTS][m_C_POST[nVTS][nT]+4*nCell]);
	return iVID;
}

int CVobBlankerApp::CellCID(int nVTS,int nT,int nCell) 
{
	int iCID;

	iCID=m_pIFO[nVTS][m_C_POST[nVTS][nT]+3+4*nCell];
	return iCID;
}
int CVobBlankerApp::CellMVID(int nVTS,int nT,int nCell) 
{
	int iVID;

	iVID=GetNbytes(2,&m_pIFO[nVTS][m_M_C_POST[nVTS][nT]+4*nCell]);
	return iVID;
}

int CVobBlankerApp::CellMCID(int nVTS,int nT,int nCell) 
{
	int iCID;

	iCID=m_pIFO[nVTS][m_M_C_POST[nVTS][nT]+3+4*nCell];
	return iCID;
}
__int64 CVobBlankerApp::PR_LocateNavSector(int iDomain, int nVTS, int iVID, int iCID, __int64 i64sector, bool iNext)
{
	int k,iSectorsRead;
	__int64 i64AccSec;
	CString csAux,csAux2;
	struct  _stati64 statbuf;
	FILE *in;
	int nSectorsRead;
	int nRead;
	int iSaveSectorsRead;
	bool bfoundNav;

#define MAXREAD 4096

	if ( iDomain==TITLES)
	{
// TODO: Guarantee change of file ...
		i64AccSec=0;
		for (k=1; k<10; k++)
		{
			csAux2.Format(_T("VTS_%02d_%d.VOB"), nVTS,k);
			csAux=m_csInputPath+'\\'+csAux2;
			if (_stati64 ( csAux, &statbuf)==0)
			{
				i64AccSec+= (statbuf.st_size/2048);
				if (i64AccSec > i64sector)
				{
					k=10;
					i64AccSec-= (statbuf.st_size/2048);
				}
			}
			else 
				k=20;
		}

		if (k==11)
		{
			in=fopen (csAux,"rb");
			fseek(in, (int)( (i64sector-i64AccSec )*2048) ,SEEK_SET);

			bfoundNav=false;
			iSectorsRead=nSectorsRead=0;
			while ( ( nRead=readbuffer(m_buffer,in) )== 2048  && nSectorsRead < MAXREAD)
			{
				nSectorsRead++;
				if (IsNav(m_buffer))
				{
					// This piece of code guarantee the CellID in a ILV Cell
					if (  (m_buffer[0x41f]*256 + m_buffer[0x420]) == iVID &&
							m_buffer[0x422]== iCID) 
					{
						bfoundNav=true;
						iSaveSectorsRead=iSectorsRead;
						if ( iNext==false ) break;
					}
					else bfoundNav=false;
				}
				if (IsVideo(m_buffer))
				{
					if (iNext && bfoundNav)
					{
						iSectorsRead=iSaveSectorsRead;
						break;
					}
				}

				if ( iNext) iSectorsRead++;
				else iSectorsRead--;
				fseek(in, (int)( (i64sector-i64AccSec+iSectorsRead )*2048) ,SEEK_SET);
			}

			if (in !=NULL) fclose(in);
	
			if (!bfoundNav || nRead!= 2048 || nSectorsRead==MAXREAD) return -1;
	
			return iSectorsRead+i64sector;
		}

	return 0;
	}

	else  //Menus
	{
		if (nVTS==0)
			csAux2="VIDEO_TS.VOB";
		else
			csAux2.Format(_T("VTS_%02d_0.VOB"), nVTS);
		csAux=m_csInputPath+'\\'+csAux2;
		i64AccSec=0;
		in=fopen (csAux,"rb");
		fseek(in, (int)( (i64sector-i64AccSec )*2048) ,SEEK_SET);


		iSectorsRead=nSectorsRead=0;
		bfoundNav=false;
		while ((nRead=readbuffer(m_buffer,in))== 2048  && nSectorsRead < MAXREAD)
		{
			nSectorsRead++;
			if (IsNav(m_buffer))
			{
				// This piece of code guarantee the CellID in a ILV Cell and a VOBU with video
				if (  (m_buffer[0x41f]*256 + m_buffer[0x420]) == iVID &&
						m_buffer[0x422]== iCID)
				{
					bfoundNav=true;
					iSaveSectorsRead=iSectorsRead;
					if ( iNext==false ) break;
				}
				else bfoundNav=false;
			}
			if (IsVideo(m_buffer))
			{
				if (iNext && bfoundNav)
				{
					iSectorsRead=iSaveSectorsRead;
					break;
				}
			}

			if ( iNext) iSectorsRead++;
			else iSectorsRead--;
			if (iSectorsRead==0 && iNext==false) break;
			fseek(in, (int)( (i64sector-i64AccSec+iSectorsRead )*2048) ,SEEK_SET);
		}

		if (in !=NULL) fclose(in);

		if (!bfoundNav || nRead!= 2048 || nSectorsRead==MAXREAD) return -1;

		return iSectorsRead+i64sector;
	}
}

int CVobBlankerApp::PR_IsClosedGOP(int iDomain,int nVTS,int nT, int nCell, int iSector)
{
// Returns 0 if it is an OpenGOP and not self-contained (starting with IP) 
// Returns 1 it it is a ClosedGOP
// Returns 2 if it is a self-contained
// Returns 3 if it is unknown	
	int i,j;
	int k,kk;
	__int64 i64IniSec, i64AccSec;
	CString csAux,csAux2;
	struct  _stati64 statbuf;
	FILE *in;
	int iEndPack,iEndFrame,iNextFrame;
	int start;

  
	if (iDomain==TITLES)
	{
		i64IniSec=GetNbytes(4,&m_pIFO[nVTS][m_C_PBKT[nVTS][nT]+24*nCell+8]) + iSector ;
		i64AccSec=0;
		for (k=1; k<10; k++)
		{
			csAux2.Format(_T("VTS_%02d_%d.VOB"), nVTS,k);
			kk=k;
			csAux=m_csInputPath+'\\'+csAux2;
			if (_stati64 ( csAux, &statbuf)==0)
			{
				i64AccSec+= (statbuf.st_size/2048);
				if (i64AccSec > i64IniSec)
				{
					k=10;
					i64AccSec-= (statbuf.st_size/2048);
				}
			}
			else 
				k=20;
		}

		if (k!=11) return 3;

		in=fopen (csAux,"rb");
		fseek(in, (int)( (i64IniSec-i64AccSec )*2048) ,SEEK_SET);

		iEndPack=2;
// Read the whole VOBU...
		for (i=0;i<iEndPack ; i++ )
		{
			if (readbuffer(&m_buffer[i*2048],in)!=2048)
			{
				fclose (in);
				kk++;
				csAux2.Format(_T("VTS_%02d_%d.VOB"), nVTS, kk);
				csAux=m_csInputPath+ '\\' +csAux2;
				in=fopen(csAux,"rb");
				if (readbuffer(&m_buffer[i*2048],m_Fin)!=2048)
				{
//					MyErrorBox("Error: Reached end of VOB too early");
					if (in !=NULL) fclose(in);
					return 3;
				}
			}
			if (i==0 && IsNav(m_buffer)) 
			{
				iEndPack=GetNbytes(4,&m_buffer[0x40f]);
				if (iEndPack > MAXPACKSPERVOBU)
				{
// Something has been wrong. Return silently....
					if (in !=NULL) fclose(in);
						return 3;
				}
			}
		}
		if (in !=NULL) fclose(in);
	}
	else
// MENUS
	{
		i64IniSec=GetNbytes(4,&m_pIFO[nVTS][m_M_C_PBKT[nVTS][nT]+24*nCell+8]) + iSector ;

		if (nVTS==0)
			csAux2.Format(_T("VIDEO_TS.VOB"));
		else
			csAux2.Format(_T("VTS_%02d_0.VOB"), nVTS);

		csAux=m_csInputPath+ '\\' +csAux2;

		in=fopen (csAux,"rb");
		fseek(in, (int)(i64IniSec*2048) ,SEEK_SET);

		iEndPack=2;
// Read the whole VOBU...
		for (i=0;i<iEndPack ; i++ )
		{
			if (readbuffer(&m_buffer[i*2048],in)!=2048)
			{
//				MyErrorBox("Error: Reached end of VOB too early");
				if (in !=NULL) fclose(in);
				return 3;
			}
		
			if (i==0 && IsNav(m_buffer)) 
			{
				iEndPack=GetNbytes(4,&m_buffer[0x40f]);
				if (iEndPack > MAXPACKSPERVOBU)
				{
// Something has been wrong. Return silently....
					if (in !=NULL) fclose(in);
						return 3;
				}
			}
		}
		if (in !=NULL) fclose(in);
	}


// Now, we have the whole VOBU in m_buffer;
// First pack after Nav must be the first Video pack and must be a GOP.
// If not, return silently
	if (!IsVideo(&m_buffer[2048]) || !IsGOP(&m_buffer[2048]) )	return 3;

// If IsClosed return true
	if (IsClosedGOP (&m_buffer[2048]))		return 1;

// look for Next frame
	iEndFrame=GetNbytes(4,&m_buffer[0x413]);
	start=0x17+m_buffer[2048*iEndFrame+0x16];
//	nbytes=m_buffer[0x12]*256+m_buffer[0x13]+0x14-start;

// look for End 
	for (j=2048*iEndFrame+start; j<(iEndFrame+1)*2048-3-2; j++)
	{
		if (m_buffer[j]   == 0 && m_buffer[j+1] == 0 &&
		m_buffer[j+2] == 1 &&  m_buffer[j+3] == 0 )
		{
			iNextFrame=(GetNbytes(2,&m_buffer[j+4])>>3) & 0x7;
			if (iNextFrame==1 ||iNextFrame==2)
// It is an I frame or a P frame. So it is a self-contained GOP
				return 2;
			else
				return 0;
		}
	}
// End of I Frame not found..Return silently..
	return 3;
}

int CVobBlankerApp::PR_AreOrphanSubsInVOBU()
{
	int iEndPack;
	int iRet;
	bool bSubs[32];
	int i, nSubId;

	iRet=0;

	for (i=0;i<32;i++)
		bSubs[i]=false;

	if (!IsNav(m_buffer)) 
	return 0;
	
	iEndPack=GetNbytes(4,&m_buffer[0x40f]);

	for (i=0;i<iEndPack && iRet==0; i++)
	{
		if (IsSubs(&m_buffer[2048*i]))
		{
			nSubId=getSubId (&m_buffer[2048*i]) & 0x31;
			if (bSubs[nSubId]==false)
			{
				bSubs[nSubId]=true;
				if (!(m_buffer[0x15+2048*i]&0x80))
				{
					iRet=1;
				}
			}
		}
	}
	return iRet;
}

void CVobBlankerApp::CalculateCutSize(int nVTS, int nT)
{
	int l,j,k,kk,ll;
	int same;
	int VIDa,VIDb,CIDa,CIDb;
	__int64 i64IniSec, i64EndSec;
	__int64 i64IniSecADT, i64EndSecADT;
	int nADTCells;
	int IniLba,EndLba,IniCell,EndCell,iAction;

	j=nVTS;
	k=nT;
	m_i64Rsize[j][k]=0;

	iAction=m_CutInfo[j][k].iAction;
	IniCell=m_CutInfo[j][k].iIniCell;
	IniLba= m_CutInfo[j][k].iIniLba;
	EndCell=m_CutInfo[j][k].iEndCell;
	EndLba= m_CutInfo[j][k].iEndLba;
	if (IniCell <0) IniCell=1;
	if (EndCell <0) EndCell=m_nCells[j][k];
	if (IniLba <0)  IniLba=0;
	if (EndLba <0) 
	{
		i64IniSec=GetNbytes(4,&m_pIFO[j][m_C_PBKT[j][k]+24*m_nCells[j][k]+8]);
		i64EndSec=GetNbytes(4,&m_pIFO[j][m_C_PBKT[j][k]+24*m_nCells[j][k]+0x14]);
		EndLba= (int)(i64EndSec-i64IniSec+1) ;

	}

	nADTCells=	(GetNbytes(4,&m_pIFO[j][m_VTS_C_ADT[j]+4])-7)/12;

	for ( l=0; l< m_nCells[j][k]; l++)
	{
		VIDa=GetNbytes(2,&m_pIFO[j][m_C_POST[j][k]+4*l]);
		CIDa=m_pIFO[j][m_C_POST[j][k]+3+4*l];
		i64IniSec=GetNbytes(4,&m_pIFO[j][m_C_PBKT[j][k]+24*l+8]);
		i64EndSec=GetNbytes(4,&m_pIFO[j][m_C_PBKT[j][k]+24*l+0x14]);

				// check if this cell has been already used
		same=0;
		for (kk=0; kk<k ;kk++)
			for (ll=0; ll< m_nCells[j][kk]; ll++)
			{
				VIDb=GetNbytes(2,&m_pIFO[j][m_C_POST[j][kk]+4*ll]);
				CIDb=m_pIFO[j][m_C_POST[j][kk]+3+4*ll];
				if (VIDa==VIDb && CIDa==CIDb)
					same=1;
			}

		if (same==0)
		{
			if (iAction==0)
			{
				if (l >= IniCell && l <= EndCell )
				{
					for (kk=0;kk<nADTCells;kk++)
					{
						if (VIDa==(int)GetNbytes(2, &m_pIFO[j][m_VTS_C_ADT[j]+8+12*kk]) &&
							CIDa==m_pIFO[j][m_VTS_C_ADT[j]+8+12*kk+2])
						{
							i64IniSecADT=GetNbytes(4,&m_pIFO[j][m_VTS_C_ADT[j]+8+12*kk+4]);
							i64EndSecADT=GetNbytes(4,&m_pIFO[j][m_VTS_C_ADT[j]+8+12*kk+8]);
							m_i64Rsize[j][k]+=((i64EndSecADT-i64IniSecADT+1)*2048);
						}
					}
				}
				if (IniCell==l )
					m_i64Rsize[j][k]-=(IniLba*2048);

				if (EndCell==l )
					m_i64Rsize[j][k]-=((i64EndSec-i64IniSec+1-EndLba)*2048);

				if (l > EndCell || l < IniCell )
					m_i64Rsize[j][k]+=(5*2048);
			}
			else
			{
				if (l > EndCell || l < IniCell )
				{
					for (kk=0;kk<nADTCells;kk++)
					{
						if (VIDa==(int)GetNbytes(2, &m_pIFO[j][m_VTS_C_ADT[j]+8+12*kk]) &&
							CIDa==m_pIFO[j][m_VTS_C_ADT[j]+8+12*kk+2])
						{
							i64IniSecADT=GetNbytes(4,&m_pIFO[j][m_VTS_C_ADT[j]+8+12*kk+4]);
							i64EndSecADT=GetNbytes(4,&m_pIFO[j][m_VTS_C_ADT[j]+8+12*kk+8]);
							m_i64Rsize[j][k]+=((i64EndSecADT-i64IniSecADT+1)*2048);
						}
					}
				}
				if (IniCell==l )
					m_i64Rsize[j][k]+=(IniLba*2048);
				
				if (EndCell==l )
					m_i64Rsize[j][k]+=((i64EndSec-i64IniSec+1-EndLba)*2048);

				if (l > IniCell && l < EndCell )
					m_i64Rsize[j][k]+=(5*2048);
			}
		}
	}
}

__int64 CVobBlankerApp::CalculateMenuCellBasedSize(int nVTS, int nT)
{
	int l,n;
	int same;
	int nACell;
	__int64 i64size;
	__int64 i64Cellsize;
	int iIniSector, iEndSector;
	CString csFile;
	struct  _stati64 statbuf;


	i64size=0;
	for ( l=0; l< m_nMCells[nVTS][nT]; l++)
	{

		nACell=MenuCellGetPos( nVTS, nT, l);
		if (nACell >= 0) 
		{
			same=0;
			if (IsReused(MENUS,nVTS,nT,l)) same=1;

// If replace or blank, count the size.
			if (m_csMCellBased[nVTS][nT][l] != 'K') same=0;

			if (same==0)
			{
				m_MenuCells[nVTS][nACell].bAlreadySize=true;

				if (m_csMCellBased[nVTS][nT][l] == 'K' )
					i64size+=m_MenuCells[nVTS][nACell].i64size;
				else if (m_csMCellBased[nVTS][nT][l] == 'B' )
					i64size+=(5*2048);
				else if (m_csMCellBased[nVTS][nT][l] == 'R' )
				{
					for(n=0,csFile=""; n< m_ACell_replace.GetSize(); n++)
					{
						if (m_ACell_replace[n].nT== nT &&
						     m_ACell_replace[n].nCell== l &&
							 m_ACell_replace[n].nVTS==nVTS &&
							 m_ACell_replace[n].iDomain==MENUS )
							 csFile= m_ACell_replace[n].csPath;
					}
					if (_stati64 ( csFile, &statbuf)==0)
						i64size+= statbuf.st_size;
				}
				else if (m_csMCellBased[nVTS][nT][l] == 'S' )
				{
					i64size+=2048*(CalculateStillMenuCellSize(nVTS,nT,l,true,0));
				}
				else if (m_csMCellBased[nVTS][nT][l] == 'Z' )
				{
					i64size+=2048*(CalculateStillMenuCellSize(nVTS,nT,l,false,0));
				}
				else if (m_csMCellBased[nVTS][nT][l] == 'C' )
				{
					i64Cellsize=m_MenuCells[nVTS][nACell].i64size;
					for(n=0; n< m_ACellCutinfo.GetSize(); n++)
					{
						if ( m_ACellCutinfo[n].nT== nT &&
						     m_ACellCutinfo[n].nCell== l &&
							 m_ACellCutinfo[n].nVTS== nVTS &&
							 m_ACellCutinfo[n].iDomain==MENUS )
						{
							iIniSector=m_ACellCutinfo[n].iIniSector;
							iEndSector=m_ACellCutinfo[n].iEndSector;
							if (iEndSector<0)
								iEndSector=(int)(m_MenuCells[nVTS][nACell].i64EndSecCell-m_MenuCells[nVTS][nACell].i64IniSecCell);
							if (iIniSector<0) iIniSector=0;

							i64Cellsize=(iEndSector-iIniSector+1)*2048;
							if (m_ACellCutinfo[n].iAction!=KEEP)
								i64Cellsize=m_MenuCells[nVTS][nACell].i64size-i64Cellsize;
						}
					}
					i64size+= i64Cellsize;
				}
			}
		}
	} /* for l Cells*/
	return i64size;
}



__int64 CVobBlankerApp::CalculateCellBasedSize(int nVTS, int nT)
{
	int l,n;
	int nACell;
	int same;
	__int64 i64size;
	CString csFile;
	struct  _stati64 statbuf;
	__int64 i64Cellsize;
	int iIniSector,iEndSector;


	i64size=0;

	for ( l=0; l< m_nCells[nVTS][nT]; l++)
	{
		nACell=TitleCellGetPos( nVTS, nT, l);
		if (nACell >= 0) 
		{
				// check if this cell has been already used
			same=0;
			if (IsReused(TITLES,nVTS,nT,l)) same=1;

// If replace or blank, count the size.
			if (m_csCellBased[nVTS][nT][l] != 'K') same=0;

			if (same==0)
			{
				if (m_csCellBased[nVTS][nT][l] == 'K' )
					i64size+=m_TitleCells[nVTS][nACell].i64size;
				else if (m_csCellBased[nVTS][nT][l] == 'P' )
					i64size+=m_TitleCells[nVTS][nACell].i64size;
				else if (m_csCellBased[nVTS][nT][l] == 'B' )
					i64size+=(5*2048);
				else if (m_csCellBased[nVTS][nT][l] == 'R' )
				{
					for(n=0,csFile=""; n< m_ACell_replace.GetSize(); n++)
					{
						if (m_ACell_replace[n].nT== nT &&
						     m_ACell_replace[n].nCell== l &&
							 m_ACell_replace[n].nVTS== nVTS &&
							 m_ACell_replace[n].iDomain==TITLES )
							 csFile= m_ACell_replace[n].csPath;
					}
					if (_stati64 ( csFile, &statbuf)==0)
						i64size+= statbuf.st_size;
				}
				else if (m_csCellBased[nVTS][nT][l] == 'S' )
				{
					i64size+=2048*(CalculateStillTitleCellSize(nVTS,nT,l,true,0));
				}
				else if (m_csCellBased[nVTS][nT][l] == 'C' )
				{
					i64Cellsize=m_TitleCells[nVTS][nACell].i64size;
					for(n=0; n< m_ACellCutinfo.GetSize(); n++)
					{
						if ( m_ACellCutinfo[n].nT== nT &&
						     m_ACellCutinfo[n].nCell== l &&
							 m_ACellCutinfo[n].nVTS== nVTS &&
							 m_ACellCutinfo[n].iDomain==TITLES )
						{
							iIniSector=m_ACellCutinfo[n].iIniSector;
							iEndSector=m_ACellCutinfo[n].iEndSector;
							if (iEndSector<0)
								iEndSector=(int)(m_TitleCells[nVTS][nACell].i64EndSecCell-m_TitleCells[nVTS][nACell].i64IniSecCell);
							if (iIniSector<0) iIniSector=0;

							i64Cellsize=(iEndSector-iIniSector+1)*2048;
							if (m_ACellCutinfo[n].iAction!=0)  // iAction=0 means Keep
								i64Cellsize=m_TitleCells[nVTS][nACell].i64size-i64Cellsize;
						}
					}
					i64size+= i64Cellsize;
				}

			}
		}
	} /* for l Cells*/
	return i64size;
}

void CVobBlankerApp::UpdateAudioAttr(int nVTS, int nA)
{
	int pVMG_VTS_ATRT, pVTS_ATRT;

	if (nVTS==0) return;
	if (m_iAudioAttr[nVTS][nA]==-1) return;

	m_pIFO[nVTS][0x204+8*nA]=m_iAudioAttr[nVTS][nA]/256;
	m_pIFO[nVTS][0x205+8*nA]=m_iAudioAttr[nVTS][nA]%256;

	pVMG_VTS_ATRT=GetNbytes(4,&m_pIFO[0][0xd0])*2048;

	pVTS_ATRT=GetNbytes(4,&m_pIFO[0][pVMG_VTS_ATRT+8+4*(nVTS-1)])+pVMG_VTS_ATRT;

	m_pIFO[0][pVTS_ATRT+0x104+8+8*nA]=m_iAudioAttr[nVTS][nA]/256;
	m_pIFO[0][pVTS_ATRT+0x105+8+8*nA]=m_iAudioAttr[nVTS][nA]%256;
}

void CVobBlankerApp::UpdateVideoAttr(int nVTS)
{
	int pVMG_VTS_ATRT, pVTS_ATRT;

	if (nVTS==0) return;

	m_pIFO[nVTS][0x200]=m_iVideoAttr[nVTS]/256;
	m_pIFO[nVTS][0x201]=m_iVideoAttr[nVTS]%256;

	pVMG_VTS_ATRT=GetNbytes(4,&m_pIFO[0][0xd0])*2048;

	pVTS_ATRT=GetNbytes(4,&m_pIFO[0][pVMG_VTS_ATRT+8+4*(nVTS-1)])+pVMG_VTS_ATRT;

	m_pIFO[0][pVTS_ATRT+0x108]=m_iVideoAttr[nVTS]/256;
	m_pIFO[0][pVTS_ATRT+0x109]=m_iVideoAttr[nVTS]%256;

}


bool CVobBlankerApp::IsReused(int iDomain,int nVTS,int nT,int nCell)
{
	bool bReused;
	int kk,ll;
	int VIDb,CIDb;
	int VobId,CellId;


	if (iDomain==TITLES)
	{
		VobId=GetNbytes(2,&m_pIFO[nVTS][m_C_POST[nVTS][nT]+4*nCell]);
		CellId=m_pIFO[nVTS][m_C_POST[nVTS][nT]+3+4*nCell];

		bReused=false;

		for (kk=0; kk<nT && bReused==false ;kk++)
			for (ll=0; ll< m_nCells[nVTS][kk]; ll++)
			{
				VIDb=GetNbytes(2,&m_pIFO[nVTS][m_C_POST[nVTS][kk]+4*ll]);
				CIDb=m_pIFO[nVTS][m_C_POST[nVTS][kk]+3+4*ll];
				if (VobId==VIDb && CellId==CIDb)
					bReused=true;
			}

		for (ll=0; ll<nCell &&  bReused==false ;ll++)
		{
			VIDb=GetNbytes(2,&m_pIFO[nVTS][m_C_POST[nVTS][nT]+4*ll]);
			CIDb=m_pIFO[nVTS][m_C_POST[nVTS][nT]+3+4*ll];
			if (VobId==VIDb && CellId==CIDb)
				bReused=true;
		}
		return bReused;
	}
	else
	{
		VobId=GetNbytes(2,&m_pIFO[nVTS][m_M_C_POST[nVTS][nT]+4*nCell]);
		CellId=m_pIFO[nVTS][m_M_C_POST[nVTS][nT]+3+4*nCell];

		bReused=false;

		for (kk=0; kk<nT && bReused==false ;kk++)
			for (ll=0; ll< m_nMCells[nVTS][kk]; ll++)
			{
				VIDb=GetNbytes(2,&m_pIFO[nVTS][m_M_C_POST[nVTS][kk]+4*ll]);
				CIDb=m_pIFO[nVTS][m_M_C_POST[nVTS][kk]+3+4*ll];
				if (VobId==VIDb && CellId==CIDb)
					bReused=true;
			}

		for (ll=0; ll<nCell &&  bReused==false ;ll++)
		{
			VIDb=GetNbytes(2,&m_pIFO[nVTS][m_M_C_POST[nVTS][nT]+4*ll]);
			CIDb=m_pIFO[nVTS][m_M_C_POST[nVTS][nT]+3+4*ll];
			if (VobId==VIDb && CellId==CIDb)
				bReused=true;
		}
		return bReused;

	}
}


void CVobBlankerApp::GetCellInfo(int iDomain, int nVTS,int nT,int nCell, 
			int * VobId, int * CellId, DWORD * dwDuration, __int64 * i64Size, bool * bReused, uchar * CellCat0, int * nButtons )
{

	__int64 i64IniSec,i64EndSec;
	int nADTCells,kk;

	*bReused=false;
	*dwDuration=0;
	*VobId= 1;
	*CellId=1;

	if (iDomain==TITLES)
	{
		*VobId=GetNbytes(2,&m_pIFO[nVTS][m_C_POST[nVTS][nT]+4*nCell]);
		*CellId=m_pIFO[nVTS][m_C_POST[nVTS][nT]+3+4*nCell];
		*dwDuration=GetNbytes(4,&m_pIFO[nVTS][m_C_PBKT[nVTS][nT]+24*nCell+4]);
		*CellCat0=m_pIFO[nVTS][m_C_PBKT[nVTS][nT]+24*nCell];
	}
	else
	{
		*VobId=GetNbytes(2,&m_pIFO[nVTS][m_M_C_POST[nVTS][nT]+4*nCell]);
		*CellId=m_pIFO[nVTS][m_M_C_POST[nVTS][nT]+3+4*nCell];
		*dwDuration=GetNbytes(4,&m_pIFO[nVTS][m_M_C_PBKT[nVTS][nT]+24*nCell+4]);
		*CellCat0=m_pIFO[nVTS][m_M_C_PBKT[nVTS][nT]+24*nCell];
	}
	// check if this cell has been already used
				
	*bReused=IsReused(iDomain, nVTS, nT, nCell);

	*i64Size=0;
	
	if (iDomain==TITLES)
	{
		nADTCells=	(GetNbytes(4,&m_pIFO[nVTS][m_VTS_C_ADT[nVTS]+4])-7)/12;

		for (kk=0;kk<nADTCells;kk++)
		{
			if (*VobId==(int)GetNbytes(2, &m_pIFO[nVTS][m_VTS_C_ADT[nVTS]+8+12*kk]) &&
				*CellId==m_pIFO[nVTS][m_VTS_C_ADT[nVTS]+8+12*kk+2])
			{
				i64IniSec=GetNbytes(4,&m_pIFO[nVTS][m_VTS_C_ADT[nVTS]+8+12*kk+4]);
				i64EndSec=GetNbytes(4,&m_pIFO[nVTS][m_VTS_C_ADT[nVTS]+8+12*kk+8]);
				*i64Size+=((i64EndSec-i64IniSec+1)*2048);
			}
		}
	}
	else
	{
		if (m_VTSM_C_ADT[nVTS]==0)
			nADTCells=0;
		else
			nADTCells=	(GetNbytes(4,&m_pIFO[nVTS][m_VTSM_C_ADT[nVTS]+4])-7)/12;

		for (kk=0;kk<nADTCells;kk++)
		{
			if (*VobId==(int)GetNbytes(2, &m_pIFO[nVTS][m_VTSM_C_ADT[nVTS]+8+12*kk]) &&
				*CellId==m_pIFO[nVTS][m_VTSM_C_ADT[nVTS]+8+12*kk+2])
			{
				i64IniSec=GetNbytes(4,&m_pIFO[nVTS][m_VTSM_C_ADT[nVTS]+8+12*kk+4]);
				i64EndSec=GetNbytes(4,&m_pIFO[nVTS][m_VTSM_C_ADT[nVTS]+8+12*kk+8]);
				*i64Size+=((i64EndSec-i64IniSec+1)*2048);
			}
		}
	}

	*nButtons=0;

	if (iDomain==MENUS)
	{
		for (kk=0;kk < m_MenuCells[nVTS].GetSize();kk++)
		{
			if (m_MenuCells[nVTS][kk].VID==*VobId &&
				m_MenuCells[nVTS][kk].CID==*CellId )
				*nButtons=m_MenuCells[nVTS][kk].nButtons;
		}
	}
	else
	{
		for (kk=0;kk < m_TitleCells[nVTS].GetSize();kk++)
		{
			if (m_TitleCells[nVTS][kk].VID==*VobId &&
				m_TitleCells[nVTS][kk].CID==*CellId )
				*nButtons=m_TitleCells[nVTS][kk].nButtons;
		}
	}
}

void CVobBlankerApp::LogEnd()
{
	CString csAux;

	MyLog ("");

	csAux.Format(_T("PostCommands changed into Precommands in %d PGCs of a total of %d"),
			m_nActualPostPre,m_nPostPre);
	if (m_nActualPostPre==m_nPostPre)
		MyLog(csAux);
	else
		MyLog(csAux, ORANGE);

	MyLog ("");

	if (theApp.m_bAborted)
	{
		csAux.Format(_T("Process Aborted and not completed"));
		MyLog(csAux,RED);
	}
	else if (m_nErrors==0)
	{
		csAux.Format(_T("Finished. No Errors, %d Warnings"), m_nWarnings);
		if (m_nWarnings==0)
			MyLog(csAux);
		else
			MyLog(csAux,ORANGE);
	}
	else
	{
		csAux.Format(_T("Finished with ERROR. Process Aborted and not completed"));
		MyLog(csAux,RED);
	}
}

void CVobBlankerApp::ExtractCell(int iDomain, int nVTS,int nT, int nCell, CWnd* pDlg)
{
	int k;
	int CellId, VobId;
	__int64 i64sectors, i64IniSec,i64EndSec,i64;
	CString csAux,csAuxIn;
	bool bMyCell;
//	struct  _stati64 statbuf;
	int nVobin;
	int nPads;

	if (iDomain==MENUS)
	{
		CellId=m_pIFO[nVTS][m_M_C_POST[nVTS][nT]+nCell*4+3];
		VobId=GetNbytes(2,&m_pIFO[nVTS][m_M_C_POST[nVTS][nT]+nCell*4]);
//  Locate the cell
		i64sectors=0;
		i64IniSec=GetNbytes(4,&m_pIFO[nVTS][m_M_C_PBKT[nVTS][nT]+nCell*24+8]);
		i64EndSec=GetNbytes(4,&m_pIFO[nVTS][m_M_C_PBKT[nVTS][nT]+nCell*24+0x14]);

		if (nVTS==0)
			csAux.Format(_T("VIDEO_TS.VOB"));
		else
			csAux.Format(_T("VTS_%02d_0.VOB"), nVTS);
	}
	else
	{
		nVobin=1;
		CellId=m_pIFO[nVTS][m_C_POST[nVTS][nT]+nCell*4+3];
		VobId=GetNbytes(2,&m_pIFO[nVTS][m_C_POST[nVTS][nT]+nCell*4]);

//  Locate the cell
		i64sectors=0;
		i64IniSec=GetNbytes(4,&m_pIFO[nVTS][m_C_PBKT[nVTS][nT]+nCell*24+8]);
		i64EndSec=GetNbytes(4,&m_pIFO[nVTS][m_C_PBKT[nVTS][nT]+nCell*24+0x14]);
		for (k=1;k<10;k++)
		{
			i64sectors+=(m_i64VOBsize[nVTS][k]/2048);
			if (i64IniSec<i64sectors)
			{
				i64sectors-=(m_i64VOBsize[nVTS][k]/2048);
				nVobin=k;
				k=20;
			}
		}
		csAux.Format(_T("VTS_%02d_%d.VOB"), nVTS, nVobin);
	}

	m_csFin=m_csInputPath+ '\\' +csAux;
	m_Fin=fopen(m_csFin,"rb");
	if (m_Fin ==NULL)
	{
		MyErrorLog_Box("Error opening input VOB: "+m_csFin);
		m_bInProcess=false;
		return;
	}

	fseek(m_Fin, (long) ((i64IniSec-i64sectors)*2048), SEEK_SET);

	m_bInProcess=true;
	nPads=0;
	for (i64=0,bMyCell=true;i64< (i64EndSec-i64IniSec+1) && m_bInProcess==true; i64++)
	{
	//readpack
		if ((i64%MODUPDATE) == 0) UpdateProgressCell(pDlg, (int)((100*i64)/(i64EndSec-i64IniSec)));
		if (readbuffer(m_buffer,m_Fin)!=2048)
		{
			if (iDomain==TITLES)
			{
				fclose (m_Fin);
				nVobin++;
				csAux.Format(_T("VTS_%02d_%d.VOB"), nVTS, nVobin);
				m_csFin=m_csInputPath+ '\\' +csAux;
				m_Fin=fopen(m_csFin,"rb");
			}
			if (readbuffer(m_buffer,m_Fin)!=2048)
			{
				if (m_Fin) fclose (m_Fin);
				MyErrorLog_Box("Input error: Reached end of VOB too early");
				m_bInProcess=false;
				return;
			}
		}
		if (IsSynch(m_buffer) != true)
		{
			if (nPads==0)
				MyInfoBox("WARNING: Packs unsynchronized. Skipping packs..."); 
			nPads++;
		}
		else if (m_bInProcess==true)
		{
			if (IsNav(m_buffer))
			{
				if (m_buffer[0x420]==(uchar)(VobId%256) &&
					m_buffer[0x41F]==(uchar)(VobId/256) &&
					m_buffer[0x422]== (uchar) CellId)
					bMyCell=true;
				else
					bMyCell=false;
				CleanILV(m_buffer);
			}
			if (bMyCell)
			{
				if ( writebuffer(m_buffer,m_Fout) != 2048)
				{
					MyErrorBox("Error writting output file. Check disk space");
					m_bInProcess=false;
				}
			}
		}
	}
	if (m_bInProcess)
		UpdateProgressCell(pDlg, 100);
	else
		UpdateProgressCell(pDlg, 0);
	m_bInProcess=false;
	if (m_Fin!=NULL) fclose (m_Fin);
	m_Fin=NULL;

}

int CVobBlankerApp::FillTitleCellInfo(int nVTS)
{
	int iACells,iANavs;
	int i,k;
	int nIniNav,nEndNav;
	__int64 i64FirstLBAFirstVOBU, i64FirstLBALastVOBU, i64LastLBALastVOBU;
	DWORD dwDuration,dwVOBUDuration;
	int NCID,NVID;
	int nNavs;
	int same;
	int iFormat;
	int nVOBIDs;

	iACells=m_TitleCells[nVTS].GetSize();
	iANavs=m_ANavinfo.GetSize();
	iFormat=(m_iVideoAttr[nVTS] & 0x1000) >> 12;


///////////////////////////////////////////////////////
// Cell Info 
	nVOBIDs=0;
	for( i=0; i< iACells ; i++)
	{
		i64FirstLBAFirstVOBU=-1;
		i64FirstLBALastVOBU=0;
		i64LastLBALastVOBU=0;
		dwDuration=0x40;
		if (iFormat==NTSC) dwDuration=0xC0;
		NCID=m_TitleCells[nVTS][i].NCID;
		NVID=m_TitleCells[nVTS][i].NVID;
		for (k=0,same=0; k< i; k++)
		{
			if (NVID==m_TitleCells[nVTS][k].NVID )
				same=1;
		}

		if (same==0) nVOBIDs++;

		for (k=0,nNavs=0,nIniNav=nEndNav=-1; k< iANavs; k++)
		{
			if (NVID==m_ANavinfo[k].VID && NCID==m_ANavinfo[k].CID)
			{
				nNavs++;
				if (i64FirstLBAFirstVOBU<0) i64FirstLBAFirstVOBU=m_ANavinfo[k].LBA;
				if (i64FirstLBALastVOBU<m_ANavinfo[k].LBA) i64FirstLBALastVOBU=m_ANavinfo[k].LBA;
				if (i64LastLBALastVOBU<m_ANavinfo[k].LastLBA) i64LastLBALastVOBU=m_ANavinfo[k].LastLBA;
				if (nIniNav <0) nIniNav=k;
				nEndNav=k;
			}
		}
		if (i64FirstLBAFirstVOBU<0) i64FirstLBAFirstVOBU=0;
		if (nEndNav >=0)
		{
			dwDuration=m_ANavinfo[nEndNav].dwDuration;
			dwVOBUDuration=(m_ANavinfo[nEndNav].iPTS1-m_ANavinfo[nEndNav].iPTS0)/(m_ticsperframe);
			dwVOBUDuration=Dec2BCD(dwVOBUDuration);
			dwVOBUDuration=dwVOBUDuration|(dwDuration & 0xc0);
			dwDuration=AddDuration(dwDuration,dwVOBUDuration);
		}

		m_TitleCells[nVTS][i].i64FirstLBAFirstVOBU=i64FirstLBAFirstVOBU;
		m_TitleCells[nVTS][i].i64FirstLBALastVOBU=i64FirstLBALastVOBU;
		m_TitleCells[nVTS][i].i64LastLBALastVOBU=i64LastLBALastVOBU;
		m_TitleCells[nVTS][i].dwDuration=dwDuration;
		m_TitleCells[nVTS][i].nNavs=nNavs;

		m_TitleCells[nVTS][i].ui64iniscr=0;
		m_TitleCells[nVTS][i].ui64lastscr=0;
		if (nIniNav >=0)
		{
			m_TitleCells[nVTS][i].ui64iniscr=m_ANavinfo[nIniNav].ui64iniscr;
			m_TitleCells[nVTS][i].ui64lastscr=m_ANavinfo[nEndNav].ui64lastscr;
		}
	}
	return nVOBIDs;
}
int CVobBlankerApp::FillMenuCellInfo(int nVTS)
{
	int iACells,iANavs;
	int i,k;
	int nIniNav,nEndNav;
	__int64 i64FirstLBAFirstVOBU, i64FirstLBALastVOBU, i64LastLBALastVOBU;
	DWORD dwDuration,dwVOBUDuration;
	int NCID,NVID;
	int nNavs;
	int same;
	int iFormat;
	int nVOBIDs;

	iACells=m_MenuCells[nVTS].GetSize();
	iANavs=m_ANavinfo.GetSize();
	iFormat=(m_iVideoAttr[nVTS] & 0x1000) >> 12;


///////////////////////////////////////////////////////
// Cell Info 
	nVOBIDs=0;
	for( i=0; i< iACells ; i++)
	{
		i64FirstLBAFirstVOBU=-1;
		i64FirstLBALastVOBU=0;
		i64LastLBALastVOBU=0;
		dwDuration=0x40;
		if (iFormat==NTSC) dwDuration=0xC0;
		NCID=m_MenuCells[nVTS][i].NCID;
		NVID=m_MenuCells[nVTS][i].NVID;
		for (k=0,same=0; k< i; k++)
		{
			if (NVID==m_MenuCells[nVTS][k].NVID )
				same=1;
		}

		if (same==0) nVOBIDs++;

		for (k=0,nNavs=0,nIniNav=nEndNav=-1; k< iANavs; k++)
		{
			if (NVID==m_ANavinfo[k].VID && NCID==m_ANavinfo[k].CID)
			{
				nNavs++;
				if (i64FirstLBAFirstVOBU<0) i64FirstLBAFirstVOBU=m_ANavinfo[k].LBA;
				if (i64FirstLBALastVOBU<m_ANavinfo[k].LBA) i64FirstLBALastVOBU=m_ANavinfo[k].LBA;
				if (i64LastLBALastVOBU<m_ANavinfo[k].LastLBA) i64LastLBALastVOBU=m_ANavinfo[k].LastLBA;
				if (nIniNav <0 )nIniNav=k;
				nEndNav=k;
			}
		}
		if (i64FirstLBAFirstVOBU<0) i64FirstLBAFirstVOBU=0;
		if (nEndNav >=0)
		{
			dwDuration=m_ANavinfo[nEndNav].dwDuration;
			dwVOBUDuration=(m_ANavinfo[nEndNav].iPTS1-m_ANavinfo[nEndNav].iPTS0)/(m_ticsperframe);
			dwVOBUDuration=Dec2BCD(dwVOBUDuration);
			dwVOBUDuration=dwVOBUDuration|(dwDuration & 0xc0);
			dwDuration=AddDuration(dwDuration,dwVOBUDuration);
		}

		m_MenuCells[nVTS][i].i64FirstLBAFirstVOBU=i64FirstLBAFirstVOBU;
		m_MenuCells[nVTS][i].i64FirstLBALastVOBU=i64FirstLBALastVOBU;
		m_MenuCells[nVTS][i].i64LastLBALastVOBU=i64LastLBALastVOBU;
		m_MenuCells[nVTS][i].dwDuration=dwDuration;
		m_MenuCells[nVTS][i].nNavs=nNavs;
		if (nIniNav >=0)
		{
			m_MenuCells[nVTS][i].ui64iniscr=m_ANavinfo[nIniNav].ui64iniscr;
			m_MenuCells[nVTS][i].ui64lastscr=m_ANavinfo[nEndNav].ui64lastscr;
		}

	}
	return nVOBIDs;
}

int CVobBlankerApp::GetMenuMaxVobId(int nVTS)
{
	int iACells,i;
	int VobId;
	int nVOBIDs;

	iACells=m_MenuCells[nVTS].GetSize();

///////////////////////////////////////////////////////
// Cell Info 
	nVOBIDs=0;
	for( i=0; i< iACells ; i++)
	{
		if (m_MenuCells[nVTS][i].bToBeDeleted == false)
		{
			VobId=m_MenuCells[nVTS][i].VID;
			if (VobId>nVOBIDs )
				nVOBIDs=VobId;
		}
	}
	return nVOBIDs;
}

int CVobBlankerApp::GetMenuNVobId(int nVTS)
{
	int iACells,i,k;
	int VobId;
	int iSame;
	int nVOBIDs;

	iACells=m_MenuCells[nVTS].GetSize();

///////////////////////////////////////////////////////
// Cell Info 
	nVOBIDs=0;
	for( i=0; i< iACells ; i++)
	{
		if (m_MenuCells[nVTS][i].bToBeDeleted==false)
		{
			VobId=m_MenuCells[nVTS][i].VID;
			for (k=0,iSame=0; k< i; k++)
			{
				if (VobId==m_MenuCells[nVTS][k].VID )
					iSame=1;
			}
		if (iSame==0) nVOBIDs++;
		}
	}
	return nVOBIDs;
}

int CVobBlankerApp::GetTitleMaxVobId(int nVTS)
{
	int iACells,i;
	int VobId;
	int nVOBIDs;

	iACells=m_TitleCells[nVTS].GetSize();

///////////////////////////////////////////////////////
// Cell Info 
	nVOBIDs=0;
	for( i=0; i< iACells ; i++)
	{
		if (m_TitleCells[nVTS][i].bToBeDeleted==false)
		{
			VobId=m_TitleCells[nVTS][i].VID;
			if (VobId>nVOBIDs)
				nVOBIDs=VobId;
		}
	}
	return nVOBIDs;
}

int CVobBlankerApp::GetTitleNVobId(int nVTS)
{
	int iACells,i,k;
	int VobId;
	int iSame;
	int nVOBIDs;

	iACells=m_TitleCells[nVTS].GetSize();

///////////////////////////////////////////////////////
// Cell Info 
	nVOBIDs=0;
	for( i=0; i< iACells ; i++)
	{
		if (m_TitleCells[nVTS][i].bToBeDeleted==false)
		{
			VobId=m_TitleCells[nVTS][i].VID;
			for (k=0,iSame=0; k< i; k++)
			{
				if (VobId==m_TitleCells[nVTS][k].VID )
					iSame=1;
			}
			if (iSame==0) nVOBIDs++;
		}
	}
	return nVOBIDs;
}

int CVobBlankerApp::ChangePostIntoPre(int iDomain, int nVTS, int nT)
{
// returns -1: No needs to change
// returns -2: No change. There are Cell Commands 
// returns -3: No change. Post Commands have Links/Jumps/Calls to programs of this PGC 
// returns >=0: Change Post into pre. Number of commands modified

	int nCellComm, nPost, nPre, nCom;
	int iAction,PGC_COMM;
	CString csAux;
	int nCommModified;
	int nPGC,nLU,nTTN;
	bool bCommDanger;
	uchar *pCommand;


	if (iDomain==MENUS)
	{
		iAction=m_iMAction[nVTS][nT];
		PGC_COMM=m_M_PGC_COMM_00[nT];
		nLU=m_nLU_MPGC[nVTS][nT];
		nPGC=nT-m_nIniPGCinLU[nVTS][nLU];
		nTTN=-1; // No sense Title number in MENUS domain
	}
	else
	{
		iAction=m_iAction[nVTS][nT];
		PGC_COMM=m_PGC_COMM_00[nT];
		nPGC=nT;
		nTTN=m_nTitleInVTS[nVTS][nT];
	}

	nCellComm=	m_pIFO_00[PGC_COMM+5];
	nPre=		m_pIFO_00[PGC_COMM+1];		
	nPost=		m_pIFO_00[PGC_COMM+3];
	nCommModified=0;

	if ( iAction!=BLANK || PGC_COMM==0  ) return -1;

	if ( nPost ==0 ) return -1;


	if (iDomain==MENUS)
		csAux.Format(_T("     Changing Post into precommands: VTS %d, LU %d, PGC %d"),nVTS,nLU+1,nPGC+1);
	else
		csAux.Format(_T("     Changing Post into precommands: VTS %d, PGC %d"),nVTS,nT+1);
	MyLog(csAux);

// Explore CellCommands

	for (nCom=0,bCommDanger=false; nCom<nCellComm ; nCom++)
	{
		pCommand=&m_pIFO_00[PGC_COMM+8+8*(nCom+nPre+nPost)];
// If command different to a solid link group to the same PGC or solid link to TTN PGN or CN, abort
		if  ( (!( (pCommand[0] & 0xF0)==0x20 && (pCommand[1] == 0x81 || pCommand[1] == 01))) &&
			  (!( (pCommand[0] & 0xF0)==0x20 && (pCommand[1] & 0x7C) == 0x04 && (pCommand[1] & 0x7)!=4) ) ) 
			bCommDanger=true;
	}

	if ( nCellComm!=0 && bCommDanger && !m_bCheckPostPreForced) 
	{
		MyLog("     Quitting: There are Cell Commands in this PGC and Change always is not checked" );
		return -2;
	}

// Explore PostCommands
	for (nCom=0,bCommDanger=false; nCom<nPost ; nCom++)
	{
		pCommand=&m_pIFO_00[PGC_COMM+8+8*(nCom+nPre)];
// Look for Solid/Conditional LinkPGCN (to this PGC).
		if ( (pCommand[0] & 0xF0)==0x20 && (pCommand[1] & 0xF) == 0x04 && pCommand[7] ==(nPGC+1))
			bCommDanger=true;
// Look for JumpVTS_TT/PTT (to this Title).
		if (iDomain==TITLES && (pCommand[0] & 0xF0)==0x30 &&
			(pCommand[1] & 0x7F) >= 0x02 && (pCommand[1] & 0x7F) <= 0x05 &&
			 pCommand[5] == nTTN)
			 bCommDanger=true;
// Look for Solid/Conditional Lnk Group and Solid/Conditional LnkPGN PTTN CN
		if ( (pCommand[0] & 0xF0) == 0x20 && 
			 (  (pCommand[1] & 0x0f) == 0x01 ||
			    ((pCommand[1] & 0x0f) >= 5 && (pCommand[1] & 0x0f) <= 7) )	) 
			 bCommDanger=true;
	}
	if (bCommDanger)
	{
		MyLog("     Quitting: Post Commands with Links/Jumps/Calls to programs of this PGC");
		return -3;
	}

	m_pIFO_00[PGC_COMM + 3]=0;
	m_pIFO_00[PGC_COMM + 1]=nPost+nPre;

//	Explore precommands
	for (nCom=0;nCom<nPre;nCom++)
	{
		pCommand=&m_pIFO_00[PGC_COMM+8+8*nCom];
// Look for Solid Break
		if ((pCommand[0] & 0xE0)==0 && (pCommand[1] == 0x82 || pCommand[1] == 02))
		{
			pCommand[1]--;
			pCommand[7]=nPre+1;
			csAux.Format(_T("     Found a Solid Break. Changed into Goto command"));
			MyLog(csAux);
			nCommModified++;
		}
// Look for Conditional Break
		else if ( (pCommand[0] & 0xE0) == 0  &&
			 (pCommand[1] & 0x0f) == 02 && (pCommand[1] & 0x70) != 0 )
		{
			pCommand[1]--;
			pCommand[7]=nPre+1;
			csAux.Format(_T("     Found a Conditional Break. Changed into Goto command"));
			MyLog(csAux);
			nCommModified++;
		}
// Look for Solid Lnk Group.
		else if ( (pCommand[0] & 0xF0)==0x20 && (pCommand[1] == 0x81 || pCommand[1] == 01))
		{
			pCommand[0]=0;
			pCommand[1]=(pCommand[1]&0x80)+1;
			pCommand[6]=0;
			pCommand[7]=nPre+1;
			csAux.Format(_T("     Found a Solid Lnk. Changed into Goto command"));
			MyLog(csAux);
			nCommModified++;
		}
// Look for Conditional Lnk Group.
		else if ( (pCommand[0] & 0xF0) == 0x20 && 
			 (pCommand[1] & 0x0f) == 0x01 && (pCommand[1] & 0x70) != 0 )
		{
			pCommand[0]=0;
			pCommand[1]=(pCommand[1]&0xF0)+1;
			pCommand[6]=0;
			pCommand[7]=nPre+1;
			csAux.Format(_T("     Found a Conditional Lnk. Changed into a conditional Goto command"));
			MyLog(csAux);
			nCommModified++;
		}
// LinkPGCN, with this PGC has no sense in precommands, so I'm not going to look for it
// Look for Solid LnkPTTN LinkPGN LinkCN.
		else if ( (pCommand[0] & 0xF0)==0x20 && (pCommand[1] & 0x7C) == 0x04 && (pCommand[1] & 0x7)!=4)
		{
			pCommand[0]=0;
			pCommand[1]=(pCommand[1]&0x80)+1;
			pCommand[6]=0;
			pCommand[7]=nPre+1;
			csAux.Format(_T("     Found a Solid LnkPTTN/PGN/CN. Changed into Goto command"));
			MyLog(csAux);
			nCommModified++;
		}
// Look for ConditionalLnkPTTN LinkPGN LinkCN.
		else if ( (pCommand[0] & 0xF0) == 0x20 && 
			 (pCommand[1] & 0x0C) == 0x04  && (pCommand[1] & 0x70) != 0 && (pCommand[1] & 0x7)!=4 )
		{
			pCommand[0]=0;
			pCommand[1]=(pCommand[1]&0xF0)+1;
			pCommand[6]=0;
			pCommand[7]=nPre+1;
			csAux.Format(_T("     Found a Conditional LnkPTTN/PGN/CN. Changed into Conditional Goto"));
			MyLog(csAux);
			nCommModified++;
		}

	}

// Explore PostCommands for Goto modifications
	for (nCom=0; nCom<nPost ; nCom++)
	{
		pCommand=&m_pIFO_00[PGC_COMM+8+8*(nCom+nPre)];
// Look for Solid Goto
		if ((pCommand[0] & 0xE0)==0 && (pCommand[1] == 0x81 || pCommand[1] == 01))
		{
			pCommand[7]+=nPre;
			csAux.Format(_T("     Found a Solid Goto in postcommand area. Fixed"));
			MyLog(csAux);
			nCommModified++;
		}
// Look for Conditional Goto
		else if ( (pCommand[0] & 0xE0) == 0  &&
			 (pCommand[1] & 0x0f) == 01 && (pCommand[1] & 0x70) != 0 )
		{
			pCommand[7]+=nPre;
			csAux.Format(_T("     Found a Conditional Goto in postcommand area. Fixed"));
			MyLog(csAux);
			nCommModified++;
		}
	}
	return nCommModified;
}

int CVobBlankerApp::GetProgram(int iDomain, int nVTS, int nT, int nCell)
{
	int nProgram,nP,nTotalProg;
	int C_PROG;

	nProgram=-1;

	if (iDomain==TITLES)
	{
		C_PROG=GetNbytes(2,&m_pIFO[nVTS][m_VTS_PGC[nVTS][nT]+0xE6]);
		if (C_PROG!=0  ) C_PROG+=m_VTS_PGC[nVTS][nT];

	}
	else
	{
		C_PROG=GetNbytes(2,&m_pIFO[nVTS][m_MENU_PGC[nVTS][nT]+0xE6]);
		if (C_PROG!=0  ) C_PROG+=m_MENU_PGC[nVTS][nT];
	}
	
	if (C_PROG==0) return -1;
	
	if (iDomain==TITLES)
		nTotalProg= m_pIFO[nVTS][m_VTS_PGC[nVTS][nT]+2];
	else
		nTotalProg= m_pIFO[nVTS][m_MENU_PGC[nVTS][nT]+2];

	for (nP=0; nP<nTotalProg ; nP++)
	{
		if ( m_pIFO[nVTS][ C_PROG+nP ] == (nCell+1))
		{
			nProgram=nP+1;
			nP=nTotalProg;
		}
	}

	return nProgram;
}

int CVobBlankerApp::GetChapter(int nVTS, int nT, int nCell)
{
	int nChapter,nProgram;
	int n,nTotalTitles,nPgr;
	int iOffStart,iOffEnd;
	int nChap,nTotalPgr;

//m_nTitleInVTS

	nProgram=GetProgram(TITLES, nVTS, nT, nCell);

	if ( nProgram == -1 || m_VTS_PTT_SRPT[nVTS]==0) return -1;

	nChapter=-1;
	
	nChap=0;

	nTotalTitles=GetNbytes(2,&m_pIFO[nVTS][m_VTS_PTT_SRPT[nVTS]]);

	n= m_nTitleInVTS[nVTS][nT]-1;
	iOffStart=GetNbytes(4,&m_pIFO[nVTS][m_VTS_PTT_SRPT[nVTS]+8+4*n]);
	if (n == (nTotalTitles-1)) 
		iOffEnd=GetNbytes(4,&m_pIFO[nVTS][m_VTS_PTT_SRPT[nVTS]+4]);
	else
		iOffEnd=GetNbytes(4,&m_pIFO[nVTS][m_VTS_PTT_SRPT[nVTS]+8+4*(n+1)])-1;

	nTotalPgr=((iOffEnd-iOffStart)+1)/4;
	for (nPgr=0; nPgr < nTotalPgr ; nPgr++)
	{
		nChap++;
		if ( (nT+1)== (int)GetNbytes(2,&m_pIFO[nVTS][m_VTS_PTT_SRPT[nVTS]+iOffStart+nPgr*4]))
		{
			if (nProgram== (int)GetNbytes(2,&m_pIFO[nVTS][m_VTS_PTT_SRPT[nVTS]+iOffStart+nPgr*4+2]) )
			{
				nChapter=nChap;
				nPgr=nTotalPgr;
				n=nTotalTitles;
			}
		}
	}

	return nChapter;
}

BOOL CVobBlankerApp::GetInfoReplacingIFO(CString csPath, int * nPGCs, int * nCells, uchar * uVTSAttr, uchar * uPalette, uchar * uStatus)
{
	int i;

	CString csAux;
	struct  _stati64 statbuf;
	uchar* p_myIFO;
	__int64 i64IFOsize,i64IFOlen;
	FILE *in;
	
	
	int REP_VTS_PGCI,REP_VTS_PGC,REP_C_PBKT,REP_C_POST;



/// Open the IFO and read the sector values
	if (_stati64 ( csPath, &statbuf)==0)
		i64IFOsize= statbuf.st_size;
	else
	{
		MyErrorLog_Box("Error: Unable to stat " + csPath);
		return false;
	}

	// Fill VTS data
	if (i64IFOsize > MAXLENGTH)	
	{
		MyErrorBox ("ERROR: Ifo file too big: "+csPath);
		return false;
	}

	i64IFOsize=i64IFOsize+2048; // Allow One additional sector

	p_myIFO= new uchar[(int)i64IFOsize];

	if (p_myIFO == NULL )
	{
		MyErrorBox ("Unable to allocate memory for IFO file");
		return false;
	}
	if ((in=fopen(csPath,"rb"))==NULL)
	{
		MyErrorBox ("Unable to open input IFO file: "+csPath);
		delete [] p_myIFO;
		return false;
	}
	for (i=0;!feof(in) && i< i64IFOsize ;i++)
		p_myIFO[i]=fgetc(in);
	i64IFOlen=i-1;
	
	if (in!=NULL) fclose(in);

	// Fill VTS data

	REP_VTS_PGCI=2048*GetNbytes(4,&p_myIFO[0xCC]);
	*nPGCs=GetNbytes(2,&p_myIFO[REP_VTS_PGCI]);

	REP_VTS_PGC=GetNbytes(4,&p_myIFO[REP_VTS_PGCI+0x04+8])+REP_VTS_PGCI;
	REP_C_PBKT=GetNbytes(2,&p_myIFO[REP_VTS_PGC+0xE8]);
	if (REP_C_PBKT!=0 ) REP_C_PBKT+=REP_VTS_PGC;
	REP_C_POST=GetNbytes(2,&p_myIFO[REP_VTS_PGC+0xEA]);
	if (REP_C_POST!=0  ) REP_C_POST+=REP_VTS_PGC;
	
	*nCells=p_myIFO[REP_VTS_PGC+3];

	if (REP_C_POST==0 || REP_C_PBKT==0  ||  nCells==0)
		// Seems something is wrong so quit.....
	{
		MyErrorBox ("ERROR: There is something wrong in number of cells in "+csPath);
		delete [] p_myIFO;
		return false;
	}

	for (i=0;i<0x300; i++)
		uVTSAttr[i]=p_myIFO[0x100+i];
	for (i=0;i<64; i++)
		uPalette[i]=p_myIFO[REP_VTS_PGC+0xA4+i];
	for (i=0;i<(16+128); i++)
		uStatus[i]=p_myIFO[REP_VTS_PGC+0x0C+i];

	delete [] p_myIFO;

	return true;
}

BOOL CVobBlankerApp::GetIFOVTSAttr(CString csPath, uchar * uVTSAttr)
{
	int i;

//	CString csAux;
	struct  _stati64 statbuf;
	uchar* p_myIFO;
	__int64 i64IFOsize,i64IFOlen;
	FILE *in;
	
	

/// Open the IFO and read the sector values
	if (_stati64 ( csPath, &statbuf)==0)
		i64IFOsize= statbuf.st_size;
	else
	{
		MyErrorLog_Box("Error: Unable to stat " + csPath);
		return false;
	}

	// Fill VTS data
	if (i64IFOsize > MAXLENGTH)	
	{
		MyErrorBox ("ERROR: Ifo file too big: "+csPath);
		return false;
	}

	i64IFOsize=i64IFOsize+2048; // Allow One additional sector

	p_myIFO= new uchar[(int)i64IFOsize];

	if (p_myIFO == NULL )
	{
		MyErrorBox ("Unable to allocate memory for IFO file");
		return false;
	}
	if ((in=fopen(csPath,"rb"))==NULL)
	{
		MyErrorBox ("Unable to open input IFO file: "+csPath);
		delete [] p_myIFO;
		return false;
	}
	for (i=0;!feof(in) && i< i64IFOsize ;i++)
		p_myIFO[i]=fgetc(in);
	i64IFOlen=i-1;
	
	if (in!=NULL) fclose(in);

	// Fill VTS data

	for (i=0;i<0x300; i++)
		uVTSAttr[i]=p_myIFO[0x100+i];

	delete [] p_myIFO;

	return true;
}

__int64 CVobBlankerApp::CalculateStillMenuCellSize(int nVTS,int nT, int nCell,  bool bAudio, __int64 i64Sector)
{
// returns number of sectors
	__int64 i64sectors, i64IniSec,i64EndSec, i64Size, i64AudSize;
//	__int64 VOBUSize, VOBUSector, VOBUSector0, VOBUSector1,EndADMAPSector;
//	int nVOBUs;
	int VobId,CellId;
	int nSecs, iRate;
	int i, nA;
	DWORD dwDuration;
	uchar AudStatus;
	int nButtons,nC;
	int nCode,nChannels;


	//  Locate the cell
	i64sectors=0;
	i64IniSec=GetNbytes(4,&m_pIFO[nVTS][m_M_C_PBKT[nVTS][nT]+nCell*24+8]);
	i64EndSec=GetNbytes(4,&m_pIFO[nVTS][m_M_C_PBKT[nVTS][nT]+nCell*24+0x14]);
	VobId=GetNbytes(2,&m_pIFO[nVTS][m_M_C_POST[nVTS][nT]+4*nCell]);
	CellId=m_pIFO[nVTS][m_M_C_POST[nVTS][nT]+3+4*nCell];

	if (m_VTSM_VOBU_ADMAP[nVTS]==0) return (__int64)0;

	nC=-1;

	for (i=0,nButtons=-1;i < m_MenuCells[nVTS].GetSize();i++)
	{
		if (m_MenuCells[nVTS][i].VID==VobId &&
			m_MenuCells[nVTS][i].CID==CellId )
		{
			nC=i;
			nButtons=m_MenuCells[nVTS][i].nButtons;
		}
	}

	if (nC<0) return 0;

	if (m_bCheckBlankNoB && nButtons==0) return (__int64)5;
	

/*
	EndADMAPSector=GetNbytes(4,&m_pIFO[nVTS][m_VTSM_VOBU_ADMAP[nVTS]]);
	EndADMAPSector=((EndADMAPSector+1)/4)-1;


	for (i=0,nVOBUs=0,VOBUSize=0; i<EndADMAPSector;i++)
	{
		VOBUSector=GetNbytes(4,&m_pIFO[nVTS][m_VTSM_VOBU_ADMAP[nVTS] + 4 +4*i]);
		if (VOBUSector==(i64Sector+i64IniSec))
		{
			VOBUSector0=VOBUSector;
			if ((i+1)==EndADMAPSector)
				VOBUSector1=(m_i64Misize[nVTS])/2048;
			else
				VOBUSector1=GetNbytes(4,&m_pIFO[nVTS][m_VTSM_VOBU_ADMAP[nVTS] + 8 +4*i]);
			VOBUSize=VOBUSector1-VOBUSector0;
			if (VOBUSize <0) VOBUSize=1;
		}

		if ( VOBUSector >= i64IniSec && VOBUSector < i64EndSec ) nVOBUs++;
	}
*/
// Nav size
	if (bAudio)
		i64Size=m_MenuCells[nVTS][nC].nVOBUS;
	else
		i64Size=1;


// First aproximation: Video Size
	if (m_iIFrameMode==0)
		i64Size+=(m_MenuCells[nVTS][nC].i64IniIFSize/2048);
	if (m_iIFrameMode==1)
	{
		if (m_MenuCells[nVTS][nC].i64MidIFSize != 0)
			i64Size+=(m_MenuCells[nVTS][nC].i64MidIFSize/2048);
		else
			i64Size+=(m_MenuCells[nVTS][nC].i64IniIFSize/2048);
	}
	if (m_iIFrameMode==2)
	{
		if (m_MenuCells[nVTS][nC].i64EndIFSize != 0)
			i64Size+=(m_MenuCells[nVTS][nC].i64EndIFSize/2048);
		else
			i64Size+=(m_MenuCells[nVTS][nC].i64IniIFSize/2048);
	}

	if (m_iIFrameMode==3)
	{
		if (m_MenuCells[nVTS][nC].i64EndIFSize > m_MenuCells[nVTS][nC].i64IniIFSize )
			i64Size+=(m_MenuCells[nVTS][nC].i64EndIFSize/2048);
		else
			i64Size+=(m_MenuCells[nVTS][nC].i64IniIFSize/2048);
	}

//Audio aproximation
	if (bAudio)
	{
		dwDuration=GetNbytes(4,&m_pIFO[nVTS][m_M_C_PBKT[nVTS][nT]+24*nCell+4]);
		nSecs=DurationInSecs(dwDuration);

		i64AudSize=0;
		for (nA=0;nA<m_nMenuAudio[nVTS];nA++)
		{
		
			AudStatus=m_pIFO[nVTS][m_MENU_PGC[nVTS][nT]+nA*2+0x0c];
			if (AudStatus & 0x80)
			{
//				iRate=m_iMenuBRAudio[nVTS][AudStatus & 0x07];
				iRate=0;
				nCode=theApp.m_pIFO[nVTS][0x104+8*nA] >> 5;
				nChannels=(theApp.m_pIFO[nVTS][0x104+8*nA+1] & 0x7)+1;
				if (nCode==4) // LPCM
					iRate=nChannels*16*48;  // Assuming 16 bits at 48 kbit/s
				else if (nCode==6) // DTS;
					iRate= 768;
				else // ac3, ??,Mpeg1 & Mpeg2
				{
					if (nChannels <=2)
						iRate =192;
					else
						iRate=nChannels*64;
				}
				if (iRate<=0) iRate=256;
				i64AudSize+=(1+(nSecs*iRate*1000/8/(2048-40)));
			}
		}
	
		i64Size+=i64AudSize;
	}

//Subs are not computed...

	if (i64Size > (i64EndSec-i64IniSec+1) ) i64Size= (i64EndSec-i64IniSec+1) ;
	return i64Size;

}

__int64 CVobBlankerApp::CalculateStillTitleCellSize(int nVTS,int nT, int nCell,  bool bAudio, __int64 i64Sector)
{

// returns number of sectors
	__int64 i64sectors, i64IniSec,i64EndSec, i64Size, i64AudSize;
	int VobId,CellId;
	int nSecs, iRate;
	int i, nA;
	DWORD dwDuration;
	uchar AudStatus;
	int nC;
	int nCode, nChannels;

	//  Locate the cell
	i64sectors=0;
	i64IniSec=GetNbytes(4,&m_pIFO[nVTS][m_C_PBKT[nVTS][nT]+nCell*24+8]);
	i64EndSec=GetNbytes(4,&m_pIFO[nVTS][m_C_PBKT[nVTS][nT]+nCell*24+0x14]);
	VobId=GetNbytes(2,&m_pIFO[nVTS][m_C_POST[nVTS][nT]+4*nCell]);
	CellId=m_pIFO[nVTS][m_C_POST[nVTS][nT]+3+4*nCell];

	if (m_VTS_VOBU_ADMAP[nVTS]==0) return (__int64)0;

	nC=-1;

	for (i=0;i < m_TitleCells[nVTS].GetSize();i++)
	{
		if (m_TitleCells[nVTS][i].VID==VobId &&
			m_TitleCells[nVTS][i].CID==CellId )
			nC=i;
	}

	if (nC<0) return 0;


// Nav size
	if (bAudio)
		i64Size=m_TitleCells[nVTS][nC].nVOBUS;
	else
		i64Size=1;

// First aproximation: Video Size
	i64Size+=60;

//Audio aproximation
	if (bAudio)
	{
		dwDuration=GetNbytes(4,&m_pIFO[nVTS][m_C_PBKT[nVTS][nT]+24*nCell+4]);
		nSecs=DurationInSecs(dwDuration);
		i64AudSize=0;
		for (nA=0;nA<8;nA++)
		{
			AudStatus=m_pIFO[nVTS][m_VTS_PGC[nVTS][nT]+nA*2+0x0c];
			if (AudStatus & 0x80)
			{
//				iRate=m_iBRAudio[nVTS][AudStatus & 0x07];
//				Assume bitrate
				iRate=0;
				nCode=theApp.m_pIFO[nVTS][0x204+8*nA] >> 5;
				nChannels=(theApp.m_pIFO[nVTS][0x204+8*nA+1] & 0x7)+1;
				if (nCode==4) // LPCM
					iRate=nChannels*16*48;  // Assuming 16 bits at 48 kbit/s
				else if (nCode==6) // DTS;
					iRate= 768;
				else // ac3, ??,Mpeg1 & Mpeg2
				{
					if (nChannels <=2)
						iRate =192;
					else
						iRate=nChannels*64;
				}
				if (iRate<=0) iRate=256;
				i64AudSize+=(1+(nSecs*iRate*1000/8/(2048-40)));
			}
		}
		i64Size+=i64AudSize;
	}

//Subs are not computed...

	if (i64Size > (i64EndSec-i64IniSec+1) ) i64Size= (i64EndSec-i64IniSec+1) ;
	return i64Size;

}
////////////////LOAD  /  SAVE////////////////////////

void CVobBlankerApp::SettingsSave() 
{
	WriteProfileInt("General", "CheckMenu" ,			m_bCheckMenu);
	WriteProfileInt("General", "CheckVobPuops" ,		m_bCheckVobPuops);
	WriteProfileInt("General", "CheckTitle" ,		m_bCheckTitle);
	WriteProfileInt("General", "CheckIfoPuops" ,		m_bCheckIfoPuops);
	WriteProfileInt("General", "CheckFolder" ,		m_bCheckFolder);

	WriteProfileInt("FixVOBPointers", "CheckFixTitlePointers" ,	m_bCheckFixTitlePointers);
	WriteProfileInt("FixVOBPointers", "CheckFixMenuPointers" ,	m_bCheckFixMenuPointers);

	WriteProfileInt("PGC options", "CheckPostPre" ,		m_bCheckPostPre);
	WriteProfileInt("PGC options", "CheckPostPreForced" ,m_bCheckPostPreForced);
	WriteProfileInt("PGC options", "CheckAttrMenu" ,		m_bCheckAttrMenu);
	WriteProfileInt("PGC options", "CheckAttrTitle" ,	m_bCheckAttrTitle);
	WriteProfileInt("PGC options", "CheckNextMenu" ,		m_bCheckNextMenu);
	WriteProfileInt("PGC options", "CheckNextTitle" ,	m_bCheckNextTitle);
	WriteProfileInt("PGC options", "CheckPrevMenu" ,		m_bCheckPrevMenu);
	WriteProfileInt("PGC options", "CheckPrevTitle" ,	m_bCheckPrevTitle);

	WriteProfileInt("Replace",	  "CheckElapsed" ,		m_bCheckElapsed);
	WriteProfileInt("Replace",	  "CheckFixVobsReplacing" ,		m_bCheckFixVobsReplacing);
	WriteProfileInt("Replace",	  "CheckCopyPalette" ,	m_bCheckCopyPalette);
	WriteProfileInt("Replace",	  "CheckCopyAttrib" ,	m_bCheckCopyAttrib);
	WriteProfileInt("Replace",	  "CheckCopyStatus" ,	m_bCheckCopyStatus);
	WriteProfileInt("Replace",	  "CheckSubsAR" ,	m_bCheckSubsAR);

	WriteProfileInt("ScanVOBUs", "CheckAutoScan" ,	m_bCheckAutoScan);
	WriteProfileInt("ScanVOBUs", "ScanNVOBUs" ,		m_iScanNVOBUs);

	WriteProfileInt("Preview",    "CheckDisTinyPrev",m_bCheckDisTinyPrev);
	WriteProfileInt("Preview",    "CheckNoOverlay",  m_bCheckNoOverlay);
	WriteProfileInt("Preview",    "CheckAutoPlay", 	 m_bCheckAutoPlay);
	WriteProfileInt("Preview",    "CheckAutoPlayTiny",m_bCheckAutoPlayTiny);
	WriteProfileInt("Preview",    "CheckTinyGoto10", m_bCheckTinyGoto10);
	WriteProfileInt("Preview",    "CheckTinyMenus",  m_bCheckTinyMenus);

	WriteProfileInt("VobLayout", "CheckVobFill" ,	m_bCheckVobFill);
	WriteProfileInt("VobLayout", "CheckVobOrder" ,	m_bCheckVobOrder);
	WriteProfileInt("VobLayout", "CheckVobMUnref" ,	m_bCheckVobMUnref);
	WriteProfileInt("VobLayout", "CheckVobLUnref" ,	m_bCheckVobLUnref);
	WriteProfileInt("VobLayout", "CheckVobRenumber" ,	m_bCheckVobRenumber);
	WriteProfileInt("VobLayout", "CheckClockDisc" ,	m_bCheckClockDisc);

	WriteProfileInt("Backup",	  "CheckBckMul" ,	m_bCheckBckMul);
	WriteProfileInt("Backup",	  "CheckBckVts" ,	m_bCheckBckVts);

	WriteProfileString("Paths",   "OutputFolder" ,		m_csOutputPath);

	WriteProfileInt("Motion2Still", "CheckBlankNoB" ,	m_bCheckBlankNoB);
	WriteProfileInt("Motion2Still", "IFrameMode" ,		m_iIFrameMode);
	WriteProfileInt("Motion2Still", "MinStillTime" ,	m_iIMinStill);
	WriteProfileInt("Motion2Still", "MaxStillTime" ,	m_iIMaxStill);
	WriteProfileInt("Motion2Still", "CheckOneSecStill" ,m_bCheckOneSecStill);
}

void CVobBlankerApp::SettingsClear() 
{
	m_bCheckFolder=		FALSE;
	m_bCheckMenu=		TRUE;
	m_bCheckVobPuops=	TRUE;
	m_bCheckTitle=		TRUE;
	m_bCheckIfoPuops=	TRUE;

	m_bCheckBlankNoB=	TRUE;
	m_bCheckOneSecStill=TRUE;
	m_bCheckNextMenu=	TRUE;
	m_bCheckNextTitle=	TRUE;
	m_bCheckPrevMenu=	TRUE;
	m_bCheckPrevTitle=	TRUE;
	m_bCheckAttrMenu=	TRUE;
	m_bCheckAttrTitle=	FALSE;

	m_bCheckDisTinyPrev=FALSE;
	m_bCheckNoOverlay=	FALSE;
	m_bCheckAutoPlay=	FALSE;
	m_bCheckAutoPlayTiny=FALSE;
	m_bCheckTinyGoto10=	TRUE;
	m_bCheckTinyMenus=	TRUE;

	m_bCheckVobFill=	FALSE;
	m_bCheckVobOrder=	FALSE;
	m_bCheckVobMUnref=	FALSE;
	m_bCheckVobLUnref=	FALSE;
	m_bCheckVobRenumber=TRUE;
	m_bCheckClockDisc=	TRUE;
	
	m_bCheckBckMul=		FALSE;
	m_bCheckBckVts=		FALSE;

	m_bCheckElapsed=	FALSE;
	m_bCheckFixVobsReplacing=	FALSE;
	m_bCheckCopyPalette=	FALSE;
	m_bCheckCopyAttrib=	FALSE;
	m_bCheckCopyStatus=	FALSE;
	m_bCheckSubsAR=		TRUE;

	m_bCheckAutoScan=	FALSE;
	m_iIFrameMode=		1;
	m_iIMinStill=		9;
	m_iIMaxStill=		4;
	m_iScanNVOBUs=		4;

	m_bCheckFixTitlePointers=FALSE;
	m_bCheckFixMenuPointers=FALSE;

	m_bCheckPostPre=	TRUE;
	m_bCheckPostPreForced=FALSE;

	WriteProfileInt("General", "CheckMenu" ,		m_bCheckMenu);
	WriteProfileInt("General", "CheckTitle" ,		m_bCheckTitle);
	WriteProfileInt("General", "CheckFolder" ,		m_bCheckFolder);
	WriteProfileInt("General", "CheckVobPuops" ,	m_bCheckVobPuops);
	WriteProfileInt("General", "CheckIfoPuops" ,	m_bCheckIfoPuops);

	WriteProfileInt("PGC options", "CheckPostPre" ,		m_bCheckPostPre);
	WriteProfileInt("PGC options", "CheckPostPreForced", m_bCheckPostPreForced);
	WriteProfileInt("PGC options", "CheckNextMenu" ,		m_bCheckNextMenu);
	WriteProfileInt("PGC options", "CheckNextTitle" ,	m_bCheckNextTitle);
	WriteProfileInt("PGC options", "CheckPrevMenu" ,		m_bCheckPrevMenu);
	WriteProfileInt("PGC options", "CheckPrevTitle" ,	m_bCheckPrevTitle);
	WriteProfileInt("PGC options", "CheckAttrMenu" ,		m_bCheckAttrMenu);
	WriteProfileInt("PGC options", "CheckAttrTitle" ,	m_bCheckAttrTitle);

	WriteProfileInt("FixVOBPointers", "CheckFixTitlePointers" ,	m_bCheckFixTitlePointers);
	WriteProfileInt("FixVOBPointers", "CheckFixMenuPointers" ,	m_bCheckFixMenuPointers);

	WriteProfileString("Paths",   "OutputFolder" ,		"");

	WriteProfileInt("Motion2Still", "CheckBlankNoB" ,	m_bCheckBlankNoB);
	WriteProfileInt("Motion2Still", "CheckOneSecStill",	m_bCheckOneSecStill);
	WriteProfileInt("Motion2Still", "IFrameMode" ,		m_iIFrameMode);
	WriteProfileInt("Motion2Still", "MaxStillTime" ,	m_iIMaxStill);
	WriteProfileInt("Motion2Still", "MinStillTime" ,	m_iIMinStill);

	WriteProfileInt("Preview", "CheckDisTinyPrev" ,		m_bCheckDisTinyPrev);
	WriteProfileInt("Preview", "CheckNoOverlay" ,		m_bCheckNoOverlay);
	WriteProfileInt("Preview", "CheckAutoPlay", 		m_bCheckAutoPlay);
	WriteProfileInt("Preview",    "CheckAutoPlayTiny",m_bCheckAutoPlayTiny);
	WriteProfileInt("Preview",    "CheckTinyGoto10", m_bCheckTinyGoto10);
	WriteProfileInt("Preview",    "CheckTinyMenus",  m_bCheckTinyMenus);


	WriteProfileInt("Replace",	 "CheckAutoPlay" ,		m_bCheckAutoPlay);
	WriteProfileInt("Replace",	 "CheckFixVobsReplacing",m_bCheckFixVobsReplacing);
	WriteProfileInt("Replace",	 "CheckCopyPalette" ,	m_bCheckCopyPalette);
	WriteProfileInt("Replace",	 "CheckCopyAttrib" ,	m_bCheckCopyAttrib);
	WriteProfileInt("Replace",	 "CheckCopyStatus" ,	m_bCheckCopyStatus);

	WriteProfileInt("ScanVOBUs", "CheckAutoScan" ,		m_bCheckAutoScan);
	WriteProfileInt("ScanVOBUs", "ScanNVOBUs",			m_iScanNVOBUs);

	WriteProfileInt("VobLayout", "CheckVobFill" ,	m_bCheckVobFill);
	WriteProfileInt("VobLayout", "CheckVobOrder" ,	m_bCheckVobOrder);
	WriteProfileInt("VobLayout", "CheckVobMUnref" ,	m_bCheckVobMUnref);
	WriteProfileInt("VobLayout", "CheckVobLUnref" ,	m_bCheckVobLUnref);
	WriteProfileInt("VobLayout", "CheckVobRenumber",m_bCheckVobRenumber);
	WriteProfileInt("VobLayout", "CheckClockDisc" ,	m_bCheckClockDisc);

	WriteProfileInt("Backup", "CheckBckMul" ,	m_bCheckBckMul);
	WriteProfileInt("Backup", "CheckBckVts" ,	m_bCheckBckVts);

}

bool CVobBlankerApp::LoadProject(CString FilePath)
{
	char szbuffer[1024];
//	char szPath[1024];
	int nIFOs,nTitles;
	int nVTS,nT,nPGCs,nCell;
	int iAux;
	CString csSection,csKey,csAux,csDef;
	int n, nReplacedCells,nStillCells,nSplitCells,nCutCells;
	CELL_REPLACE myCell_replace;
	CELLSTILLINFO myCell_still;
	CELLSPLITINFO myCell_split;
	CELLCUTINFO myCell_Cut;

	m_csLoadedProject="";

	GetPrivateProfileString("General", "InputPath","",szbuffer , 1024 , FilePath);
	m_csInputPath.Format(_T("%s"),szbuffer);
	GetPrivateProfileString("General", "OutputPath","",szbuffer , 1024 , FilePath);
	m_csOutputPath.Format(_T("%s"),szbuffer);


	if (m_csInputPath=="") 
	{
		MyErrorBox("No input path in project file");
		return false;
	}

	csDef.Format(_T("%d"),m_bCheckVobFill);
	GetPrivateProfileString("VobLayout", "CheckVobFill",csDef,szbuffer , 32 , FilePath);
	sscanf (szbuffer, "%d", &m_bCheckVobFill);

	csDef.Format(_T("%d"),m_bCheckVobOrder);
	GetPrivateProfileString("VobLayout", "CheckVobOrder",csDef,szbuffer , 32 , FilePath);
	sscanf (szbuffer, "%d", &m_bCheckVobOrder);

	csDef.Format(_T("%d"),m_bCheckVobMUnref);
	GetPrivateProfileString("VobLayout", "CheckVobMUnref",csDef,szbuffer , 32 , FilePath);
	sscanf (szbuffer, "%d", &m_bCheckVobMUnref);

	csDef.Format(_T("%d"),m_bCheckVobLUnref);
	GetPrivateProfileString("VobLayout", "CheckVobLUnref",csDef,szbuffer , 32 , FilePath);
	sscanf (szbuffer, "%d", &m_bCheckVobLUnref);

	csDef.Format(_T("%d"),m_bCheckVobRenumber);
	GetPrivateProfileString("VobLayout", "CheckVobRenumber",csDef,szbuffer , 32 , FilePath);
	sscanf (szbuffer, "%d", &m_bCheckVobRenumber);

	csDef.Format(_T("%d"),m_bCheckClockDisc);
	GetPrivateProfileString("VobLayout", "CheckClockDisc",csDef,szbuffer , 32 , FilePath);
	sscanf (szbuffer, "%d", &m_bCheckClockDisc);

	if (ReadIFOs(m_csInputPath+"\\"+"VIDEO_TS.IFO") <=0)
	{
		MyErrorBox("Error reading IFOs. Aborting.");
		return false;
	}
	csAux.Format(_T("%d"),m_nIFOs);

	GetPrivateProfileString("General", "nIFOs",csAux, szbuffer , 32 , FilePath);
	sscanf (szbuffer, "%d", &nIFOs);
	GetPrivateProfileString("General", "nTitles","0",szbuffer , 32 , FilePath);
	sscanf (szbuffer, "%d", &nTitles);

	if (nIFOs != m_nIFOs )
	{
		MyErrorBox("Number of IFOs does not match. Aborting.");
		return false;
	}

	csDef.Format(_T("%d"),m_bCheckFolder);
	GetPrivateProfileString("General", "CheckFolder",csDef,szbuffer , 32 , FilePath);
	sscanf (szbuffer, "%d", &m_bCheckFolder);
	csDef.Format(_T("%d"),m_bCheckMenu);
	GetPrivateProfileString("General", "CheckMenu", csDef ,szbuffer , 32 , FilePath);
	sscanf (szbuffer, "%d", &m_bCheckMenu);
	csDef.Format(_T("%d"),m_bCheckTitle);
	GetPrivateProfileString("General", "CheckTitle",csDef,szbuffer , 32 , FilePath);
	sscanf (szbuffer, "%d", &m_bCheckTitle);
	csDef.Format(_T("%d"),m_bCheckVobPuops);
	GetPrivateProfileString("General", "CheckVobPuops",csDef,szbuffer , 32 , FilePath);
	sscanf (szbuffer, "%d", &m_bCheckVobPuops);
	csDef.Format(_T("%d"),m_bCheckIfoPuops);
	GetPrivateProfileString("General", "CheckIfoPuops",csDef,szbuffer , 32 , FilePath);
	sscanf (szbuffer, "%d", &m_bCheckIfoPuops);

	csDef.Format(_T("%d"),m_bCheckFixTitlePointers);
	GetPrivateProfileString("FixVOBPointers", "CheckFixTitlePointers",csDef,szbuffer , 32 , FilePath);
	sscanf (szbuffer, "%d", &m_bCheckFixTitlePointers);
	csDef.Format(_T("%d"),m_bCheckFixMenuPointers);
	GetPrivateProfileString("FixVOBPointers", "CheckFixMenuPointers",csDef,szbuffer , 32 , FilePath);
	sscanf (szbuffer, "%d", &m_bCheckFixMenuPointers);
	csDef.Format(_T("%d"),m_bCheckPostPre);

	GetPrivateProfileString("PGC options", "CheckPostPre",csDef,szbuffer , 32 , FilePath);
	sscanf (szbuffer, "%d", &m_bCheckPostPre);
	csDef.Format(_T("%d"),m_bCheckPostPreForced);
	GetPrivateProfileString("PGC options", "CheckPostPreForced",csDef,szbuffer , 32 , FilePath);
	sscanf (szbuffer, "%d", &m_bCheckPostPreForced);
	csDef.Format(_T("%d"),m_bCheckNextMenu);
	GetPrivateProfileString("PGC options", "CheckNextMenu",csDef,szbuffer , 32 , FilePath);
	sscanf (szbuffer, "%d", &m_bCheckNextMenu);
	csDef.Format(_T("%d"),m_bCheckNextTitle);
	GetPrivateProfileString("PGC options", "CheckNextTitle",csDef,szbuffer , 32 , FilePath);
	sscanf (szbuffer, "%d", &m_bCheckNextTitle);
	csDef.Format(_T("%d"),m_bCheckPrevMenu);
	GetPrivateProfileString("PGC options", "CheckPrevMenu",csDef,szbuffer , 32 , FilePath);
	sscanf (szbuffer, "%d", &m_bCheckPrevMenu);
	csDef.Format(_T("%d"),m_bCheckPrevTitle);
	GetPrivateProfileString("PGC options", "CheckPrevTitle",csDef,szbuffer , 32 , FilePath);
	sscanf (szbuffer, "%d", &m_bCheckPrevTitle);
	csDef.Format(_T("%d"),m_bCheckAttrMenu);
	GetPrivateProfileString("PGC options", "CheckAttrMenu",csDef,szbuffer , 32 , FilePath);
	sscanf (szbuffer, "%d", &m_bCheckAttrMenu);
	csDef.Format(_T("%d"),m_bCheckAttrTitle);
	GetPrivateProfileString("PGC options", "CheckAttrTitle",csDef,szbuffer , 32 , FilePath);
	sscanf (szbuffer, "%d", &m_bCheckAttrTitle);

	csDef.Format(_T("%d"),m_bCheckElapsed);
	GetPrivateProfileString("Replace", "CheckElapsed",csDef,szbuffer , 32 , FilePath);
	sscanf (szbuffer, "%d", &m_bCheckElapsed);
	csDef.Format(_T("%d"),m_bCheckFixVobsReplacing);
	GetPrivateProfileString("Replace", "CheckFixVobsReplacing",csDef,szbuffer , 32 , FilePath);
	sscanf (szbuffer, "%d", &m_bCheckFixVobsReplacing);
	csDef.Format(_T("%d"),m_bCheckCopyPalette);
	GetPrivateProfileString("Replace", "CheckCopyPalette",csDef,szbuffer , 32 , FilePath);
	sscanf (szbuffer, "%d", &m_bCheckCopyPalette);
	csDef.Format(_T("%d"),m_bCheckCopyAttrib);
	GetPrivateProfileString("Replace", "CheckCopyAttrib",csDef,szbuffer , 32 , FilePath);
	sscanf (szbuffer, "%d", &m_bCheckCopyAttrib);
	csDef.Format(_T("%d"),m_bCheckCopyStatus);
	GetPrivateProfileString("Replace", "CheckCopyStatus",csDef,szbuffer , 32 , FilePath);
	sscanf (szbuffer, "%d", &m_bCheckCopyStatus);
	csDef.Format(_T("%d"),m_bCheckSubsAR);
	GetPrivateProfileString("Replace", "CheckSubsAR",csDef,szbuffer , 32 , FilePath);
	sscanf (szbuffer, "%d", &m_bCheckSubsAR);

	csDef.Format(_T("%d"),m_bCheckAutoScan);
	GetPrivateProfileString("ScanVOBUs", "CheckAutoScan",csDef,szbuffer , 32 , FilePath);
	sscanf (szbuffer, "%d", &m_bCheckAutoScan);
	csDef.Format(_T("%d"),m_iScanNVOBUs);
	GetPrivateProfileString("ScanVOBUs", "ScanNVOBUs",csDef,szbuffer , 32 , FilePath);
	sscanf (szbuffer, "%d", &m_iScanNVOBUs);

/*	csDef.Format(_T("%d"),m_bCheckNoOverlay);
	GetPrivateProfileString("Preview", "CheckNoOverlay",csDef,szbuffer , 32 , FilePath);
	sscanf (szbuffer, "%d", &m_bCheckNoOverlay);
	csDef.Format(_T("%d"),m_bCheckAutoPlay);
	GetPrivateProfileString("Preview", "CheckAutoPlay",csDef,szbuffer , 32 , FilePath);
	sscanf (szbuffer, "%d", &m_bCheckAutoPlay);
	csDef.Format(_T("%d"),m_bCheckDisTinyPrev);
	GetPrivateProfileString("Preview", "CheckDisTinyPrev",csDef,szbuffer , 32 , FilePath);
	sscanf (szbuffer, "%d", &m_bCheckDisTinyPrev);

    m_bCheckAutoPlayTiny=TRUE;
	m_bCheckTinyGoto10=	TRUE;
	m_bCheckTinyMenus=	TRUE;

*/


	csDef.Format(_T("%d"),m_bCheckBlankNoB);
	GetPrivateProfileString("Motion2Still", "CheckBlankNoB",csDef,szbuffer , 32 , FilePath);
	sscanf (szbuffer, "%d", &m_bCheckBlankNoB);
	csDef.Format(_T("%d"),m_bCheckOneSecStill);
	GetPrivateProfileString("Motion2Still", "CheckOneSecStill",csDef,szbuffer , 32 , FilePath);
	sscanf (szbuffer, "%d", &m_bCheckOneSecStill);
	csDef.Format(_T("%d"),m_iIFrameMode);
	GetPrivateProfileString("Motion2Still", "IFrameMode",csDef,szbuffer , 32 , FilePath);
	sscanf (szbuffer, "%d", &m_iIFrameMode);
	csDef.Format(_T("%d"),m_iIMaxStill);
	GetPrivateProfileString("Motion2Still", "MaxStillTime",csDef,szbuffer , 32 , FilePath);
	sscanf (szbuffer, "%d", &m_iIMaxStill);
	csDef.Format(_T("%d"),m_iIMinStill);
	GetPrivateProfileString("Motion2Still", "MinStillTime",csDef,szbuffer , 32 , FilePath);
	sscanf (szbuffer, "%d", &m_iIMinStill);

	csDef.Format(_T("%d"),m_bCheckBckMul);
	GetPrivateProfileString("Backup", "CheckBckMul",csDef,szbuffer , 32 , FilePath);
	sscanf (szbuffer, "%d", &m_bCheckBckMul);
	csDef.Format(_T("%d"),m_bCheckBckVts);
	GetPrivateProfileString("Backup", "CheckBckVts",csDef,szbuffer , 32 , FilePath);
	sscanf (szbuffer, "%d", &m_bCheckBckVts);

	if (m_bCheckFolder)
		m_csOutputPath=m_csInputPath;

	m_ACell_replace.RemoveAll();

	GetPrivateProfileString("Replacing Cells", "nReplacedCells","0",szbuffer , 32 , FilePath);
	sscanf (szbuffer, "%d", &nReplacedCells);

	for (n=0;n<nReplacedCells;n++)
	{
		csKey.Format(_T("Replacing_Cell_%03d"),n);
		GetPrivateProfileString("Replacing Cells", csKey,"-1 -1 0 0",szbuffer , 32 , FilePath);
		sscanf (szbuffer, "%d %d %d %d", &myCell_replace.iDomain, &myCell_replace.nVTS,
			&myCell_replace.nT, &myCell_replace.nCell);

		csKey.Format(_T("Replacing_Cell_Path_%03d"),n);
		GetPrivateProfileString("Replacing Cells", csKey,"",szbuffer , 1024 , FilePath);
		myCell_replace.csPath= szbuffer;

		m_ACell_replace.SetAtGrow(n,myCell_replace);
	}

	for (n=nReplacedCells-1;n>=0;n--)
	{
		if ( m_ACell_replace[n].nT==-1 || m_ACell_replace[n].nCell==-1 || 
			 m_ACell_replace[n].nVTS==-1 || m_ACell_replace[n].csPath.IsEmpty() ) 
			 m_ACell_replace.RemoveAt(n,1);
		else if (m_ACell_replace[n].csPath.IsEmpty()) 
			 m_ACell_replace.RemoveAt(n,1);
	}

	m_ACellStillinfo.RemoveAll();
	GetPrivateProfileString( "Cells to Still", "nStillCells","0",szbuffer , 32 , FilePath);
	sscanf (szbuffer, "%d", &nStillCells);

	for (n=0;n<nStillCells;n++)
	{
		csKey.Format(_T("Cell_to_Still_%03d"),n);
		GetPrivateProfileString("Cells to Still", csKey,"-1 -1 -1 -1 -7",szbuffer , 64 , FilePath);
		sscanf (szbuffer, "%d %d %d %d %I64d", &myCell_still.iDomain, &myCell_still.nVTS,
			&myCell_still.nT, &myCell_still.nCell, &myCell_still.i64IFrame);

		csKey.Format(_T("Cell_to_Still_Path_%03d"),n);
		GetPrivateProfileString("Cells to Still", csKey,"",szbuffer , 1024 , FilePath);
		myCell_still.csFileStill= szbuffer;

		m_ACellStillinfo.SetAtGrow(n,myCell_still);
	}

	for (n=nStillCells-1;n>=0;n--)
	{
		if ( m_ACellStillinfo[n].nT==-1 || m_ACellStillinfo[n].nCell==-1 || 
			 m_ACellStillinfo[n].nVTS==-1 || m_ACellStillinfo[n].iDomain ==-1 || 
			 m_ACellStillinfo[n].i64IFrame < -6 ) 
			 m_ACellStillinfo.RemoveAt(n,1);
		else if (m_ACellStillinfo[n].i64IFrame == -6  && m_ACellStillinfo[n].csFileStill.IsEmpty()) 
			 m_ACellStillinfo.RemoveAt(n,1);
	}

	m_ACellSplitinfo.RemoveAll();
	GetPrivateProfileString( "Cells to Split", "nSplitCells","0",szbuffer , 32 , FilePath);
	sscanf (szbuffer, "%d", &nSplitCells);

	for (n=0;n<nSplitCells;n++)
	{
		csKey.Format(_T("Cell_to_Split_%03d"),n);
		GetPrivateProfileString("Cells to Split", csKey,"-1 -1 -1 -1 0 3 0",szbuffer , 64 , FilePath);
		sscanf (szbuffer, "%d %d %d %d %d %d %I64d", &myCell_split.iDomain, &myCell_split.nVTS,
			&myCell_split.nT, &myCell_split.nCell, &myCell_split.iSplitMode, 
			&myCell_split.iIniIsClosed, &myCell_split.i64IFrame);

		m_ACellSplitinfo.SetAtGrow(n,myCell_split);
	}

	for (n=nSplitCells-1;n>=0;n--)
	{
		if ( m_ACellSplitinfo[n].nT==-1 || m_ACellSplitinfo[n].nCell==-1 || 
			 m_ACellSplitinfo[n].nVTS==-1 || m_ACellSplitinfo[n].iDomain ==-1 || 
			 m_ACellSplitinfo[n].i64IFrame < 0  ||
			 m_ACellSplitinfo[n].iSplitMode < 0 ||  m_ACellSplitinfo[n].iSplitMode > 2 ||
			 m_ACellSplitinfo[n].iIniIsClosed < -1 ||  m_ACellSplitinfo[n].iIniIsClosed > 3 )
			 m_ACellSplitinfo.RemoveAt(n,1);
	}

	m_ACellCutinfo.RemoveAll();
	GetPrivateProfileString( "Cells to Cut", "nCutCells","0",szbuffer , 32 , FilePath);
	sscanf (szbuffer, "%d", &nCutCells);

	for (n=0;n<nCutCells;n++)
	{
		csKey.Format(_T("Cell_to_Cut_%03d"),n);
		GetPrivateProfileString("Cells to Cut", csKey,"-1 -1 -1 -1 -1 -1 0 0 0",szbuffer , 64 , FilePath);
		sscanf (szbuffer, "%d %d %d %d %d %d %d %d %d", &myCell_Cut.iDomain, &myCell_Cut.nVTS,
			&myCell_Cut.nT, &myCell_Cut.nCell,
			&myCell_Cut.iIniSector, &myCell_Cut.iEndSector,
			&myCell_Cut.iIniIsClosed, &myCell_Cut.iEndIsClosed,
			&myCell_Cut.iAction);

		m_ACellCutinfo.SetAtGrow(n,myCell_Cut);
	}

	for (n=nCutCells-1;n>=0;n--)
	{
		if ( m_ACellCutinfo[n].nT==-1 || m_ACellCutinfo[n].nCell==-1 || 
			 m_ACellCutinfo[n].nVTS==-1 || m_ACellCutinfo[n].iDomain ==-1 || 
			 (m_ACellCutinfo[n].iIniSector >  m_ACellCutinfo[n].iEndSector && m_ACellCutinfo[n].iEndSector!=-1) )
			 m_ACellCutinfo.RemoveAt(n,1);
	}

	csSection="VIDEO_TS";

	GetPrivateProfileString(csSection, "ActionVTS","PROCESS",szbuffer , 1024 , FilePath);
	m_iActionVTS[0]=PROCESS;
	if (strcmp(szbuffer,"SKIP")==0)
	{
		m_iActionVTS[0]=SKIP;
		for (nT=0;nT<m_nMPGCs[0];nT++)
			if (m_iMAction[0][nT]!=ZERO)
				m_iMAction[0][nT]=KEEP;
	}

	else
	{
		for (nT=0;nT<m_nMPGCs[0];nT++)
		{
			if (m_iMAction[0][nT]!=ZERO)
			{
				csKey.Format(_T("ActionM%02d_%02d"),0,nT+1);
					GetPrivateProfileString(csSection, csKey,"KEEP",szbuffer , 1024 , FilePath);
				m_iMAction[0][nT]=KEEP;
				if (strcmp(szbuffer,"BLANK")==0) m_iMAction[0][nT]=BLANK;
				if (strcmp(szbuffer,"DELPBK")==0) m_iMAction[0][nT]=DELPBK;
				if (strcmp(szbuffer,"STILLNA")==0) m_iMAction[0][nT]=STILLNA;
				if (strcmp(szbuffer,"STILLA")==0) m_iMAction[0][nT]=STILLA;
				if (strcmp(szbuffer,"CELLBASED")==0) m_iMAction[0][nT]=CELLBASED;
				if (strstr(szbuffer,"REUSE")!=NULL)
				{
					m_iMAction[0][nT]=REUSE;
					if ( sscanf(szbuffer+5,"%d", &m_iReuseLU[0][nT]) !=1)
						m_iMAction[0][nT]=KEEP;
					else
						m_iReuseLU[0][nT]--;
					if (m_iReuseLU[0][nT]<0 || m_iReuseLU[0][nT] > m_nLUs[0])
					{
						m_iMAction[0][nT]=KEEP;
					}
				}
				csKey.Format(_T("CellBased_String_Menu_%02d_%02d"),0,nT+1);
				GetPrivateProfileString(csSection, csKey,"",szbuffer , 1024 , FilePath);
				if ((int)strlen(szbuffer)<= m_csMCellBased[0][nT].GetLength() ) 
				{
					for (nCell=0; nCell < (int)strlen(szbuffer) ; nCell++)
							m_csMCellBased[0][nT].SetAt(nCell,szbuffer[nCell]);
				}
				else if (strlen(szbuffer)>0 && strlen(szbuffer)< 256)
					m_csMCellBased[0][nT]=szbuffer;
			}
		}
	}
	for (nVTS=1; nVTS<m_nIFOs+1;nVTS++)
	{
		csSection.Format(_T("VTS%02d"),nVTS);

		GetPrivateProfileString(csSection, "nPGCs","0",szbuffer , 32 , FilePath);
		sscanf (szbuffer, "%d", &nPGCs);
//		if (nPGCs != m_nPGCs[nVTS] )
//		{
//			MyErrorBox("Number of PGCs does not match. Aborting.");
//			return false;
//		}
		GetPrivateProfileString(csSection, "ActionVTS","PROCESS",szbuffer , 1024 , FilePath);
		m_iActionVTS[nVTS]=PROCESS;
		if (strcmp(szbuffer,"SKIP")==0)
		{
			m_iActionVTS[nVTS]=SKIP;
			for (nT=0;nT<m_nPGCs[nVTS];nT++)
			{
				m_iAction[nVTS][nT]=SKIP;
				m_csReplace[nVTS][nT]="";
				m_i64Rsize[nVTS][nT]=0;
			}
			for (nT=0;nT<m_nMPGCs[nVTS];nT++)
				m_iMAction[nVTS][nT]=KEEP;

		}

		GetPrivateProfileString(csSection, "VideoAttr","",szbuffer , 1024 , FilePath);
		if (sscanf (szbuffer, "%X", &iAux) ==1 )
		{
			m_iVideoAttr[nVTS]=iAux;	
			theApp.UpdateVideoAttr(nVTS);
		}

		for (n=0;n<8;n++)
		{
			csKey.Format(_T("AudioAttr%d"),n);
			GetPrivateProfileString(csSection, csKey,"",szbuffer , 1024 , FilePath);
			if (sscanf (szbuffer, "%X", &iAux) ==1 )
			{
				m_iAudioAttr[nVTS][n]=iAux;	
				theApp.UpdateAudioAttr(nVTS,n);
			}
		}

		csKey.Format(_T("VOBAlreadyScan_%02d"),nVTS);
		GetPrivateProfileString(csSection, csKey, "0",szbuffer , 32 , FilePath);
		sscanf (szbuffer, "%d", &m_bAlreadyScan[nVTS]);
		if (m_bAlreadyScan[nVTS]) 
		{
			csKey.Format(_T("AudSizeInfo_%02d"),nVTS);
			GetPrivateProfileString(csSection, csKey,"0 0 0 0 0 0 0 0",szbuffer , 1024 , FilePath);
			sscanf(szbuffer,"%d %d %d %d %d %d %d %d",
				&m_iAudioSectors[nVTS][0],&m_iAudioSectors[nVTS][1],
				&m_iAudioSectors[nVTS][2],&m_iAudioSectors[nVTS][3],
				&m_iAudioSectors[nVTS][4],&m_iAudioSectors[nVTS][5],
				&m_iAudioSectors[nVTS][6],&m_iAudioSectors[nVTS][7]);

			csKey.Format(_T("SubSizeInfo_%02d"),nVTS);
			GetPrivateProfileString(csSection, csKey,"0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0",szbuffer , 1024 , FilePath);
			sscanf(szbuffer,"%d %d %d %d %d %d %d %d %d %d %d %d %d %d %d %d %d %d %d %d %d %d %d %d %d %d %d %d %d %d %d %d",
				&m_iSubsSectors[nVTS][0],&m_iSubsSectors[nVTS][1],
				&m_iSubsSectors[nVTS][2],&m_iSubsSectors[nVTS][3],
				&m_iSubsSectors[nVTS][4],&m_iSubsSectors[nVTS][5],
				&m_iSubsSectors[nVTS][6],&m_iSubsSectors[nVTS][7],
				&m_iSubsSectors[nVTS][8],&m_iSubsSectors[nVTS][9],
				&m_iSubsSectors[nVTS][10],&m_iSubsSectors[nVTS][11],
				&m_iSubsSectors[nVTS][12],&m_iSubsSectors[nVTS][13],
				&m_iSubsSectors[nVTS][14],&m_iSubsSectors[nVTS][15],
				&m_iSubsSectors[nVTS][16],&m_iSubsSectors[nVTS][17],
				&m_iSubsSectors[nVTS][18],&m_iSubsSectors[nVTS][19],
				&m_iSubsSectors[nVTS][20],&m_iSubsSectors[nVTS][21],
				&m_iSubsSectors[nVTS][22],&m_iSubsSectors[nVTS][23],
				&m_iSubsSectors[nVTS][24],&m_iSubsSectors[nVTS][25],
				&m_iSubsSectors[nVTS][26],&m_iSubsSectors[nVTS][27],
				&m_iSubsSectors[nVTS][28],&m_iSubsSectors[nVTS][29],
				&m_iSubsSectors[nVTS][30],&m_iSubsSectors[nVTS][31]);
		}

		if 	(m_iActionVTS[nVTS]!=SKIP)
		{
			for (nT=0;nT<m_nPGCs[nVTS];nT++)
			{
				csKey.Format(_T("ActionT%02d_%02d"),nVTS,nT+1);
				GetPrivateProfileString(csSection, csKey,"KEEP",szbuffer , 1024 , FilePath);
				m_iAction[nVTS][nT]=KEEP;
				if (strcmp(szbuffer,"BLANK")==0) m_iAction[nVTS][nT]=BLANK;
				if (strcmp(szbuffer,"REPLACE")==0) m_iAction[nVTS][nT]=REPLACE;
				if (strcmp(szbuffer,"STRIP")==0) m_iAction[nVTS][nT]=STRIP;
				if (strcmp(szbuffer,"CUT")==0) m_iAction[nVTS][nT]=CUT;
				if (strcmp(szbuffer,"SKIP")==0) m_iAction[nVTS][nT]=SKIP;
				if (strcmp(szbuffer,"CELLBASED")==0) m_iAction[nVTS][nT]=CELLBASED;

				csKey.Format(_T("Replacing Title_%02d_%02d"),nVTS,nT+1);
				GetPrivateProfileString(csSection, csKey,"",szbuffer , 1024 , FilePath);
				m_csReplace[nVTS][nT]=szbuffer;

				csKey.Format(_T("Replacing Size_%02d_%02d"),nVTS,nT+1);
				GetPrivateProfileString(csSection, csKey,"0",szbuffer , 32 , FilePath);
				if (sscanf (szbuffer, "%I64d", &m_i64Rsize[nVTS][nT]) !=1 ) m_i64Rsize[nVTS][nT]=0;

				csKey.Format(_T("CutInfo_%02d_%02d"),nVTS,nT+1);
				GetPrivateProfileString(csSection, csKey,"0 -1 -1 -1 -1 -1 -1",szbuffer , 1024 , FilePath);
				sscanf(szbuffer,"%d %d %d %d %d %d %d", &m_CutInfo[nVTS][nT].iAction,
					&m_CutInfo[nVTS][nT].iIniCell,&m_CutInfo[nVTS][nT].iIniLba,
					&m_CutInfo[nVTS][nT].iEndCell,&m_CutInfo[nVTS][nT].iEndLba,
					&m_CutInfo[nVTS][nT].iIniIsClosed,&m_CutInfo[nVTS][nT].iEndIsClosed);

				csKey.Format(_T("AudStripInfo_%02d_%02d"),nVTS,nT+1);
				GetPrivateProfileString(csSection, csKey,"0 0 0 0 0 0 0 0",szbuffer , 1024 , FilePath);
				sscanf(szbuffer,"%d %d %d %d %d %d %d %d",
					&m_iIdTAudioStrip[nVTS][0][nT],&m_iIdTAudioStrip[nVTS][1][nT],
					&m_iIdTAudioStrip[nVTS][2][nT],&m_iIdTAudioStrip[nVTS][3][nT],
					&m_iIdTAudioStrip[nVTS][4][nT],&m_iIdTAudioStrip[nVTS][5][nT],
					&m_iIdTAudioStrip[nVTS][6][nT],&m_iIdTAudioStrip[nVTS][7][nT]);

				csKey.Format(_T("SubStripInfo_%02d_%02d"),nVTS,nT+1);
				GetPrivateProfileString(csSection, csKey,"0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0",szbuffer , 1024 , FilePath);
				sscanf(szbuffer,"%d %d %d %d %d %d %d %d %d %d %d %d %d %d %d %d %d %d %d %d %d %d %d %d %d %d %d %d %d %d %d %d",
					&m_iIdTSubsStrip[nVTS][0][nT],&m_iIdTSubsStrip[nVTS][1][nT],
					&m_iIdTSubsStrip[nVTS][2][nT],&m_iIdTSubsStrip[nVTS][3][nT],
					&m_iIdTSubsStrip[nVTS][4][nT],&m_iIdTSubsStrip[nVTS][5][nT],
					&m_iIdTSubsStrip[nVTS][6][nT],&m_iIdTSubsStrip[nVTS][7][nT],
					&m_iIdTSubsStrip[nVTS][8][nT],&m_iIdTSubsStrip[nVTS][9][nT],
					&m_iIdTSubsStrip[nVTS][10][nT],&m_iIdTSubsStrip[nVTS][11][nT],
					&m_iIdTSubsStrip[nVTS][12][nT],&m_iIdTSubsStrip[nVTS][13][nT],
					&m_iIdTSubsStrip[nVTS][14][nT],&m_iIdTSubsStrip[nVTS][15][nT],
					&m_iIdTSubsStrip[nVTS][16][nT],&m_iIdTSubsStrip[nVTS][17][nT],
					&m_iIdTSubsStrip[nVTS][18][nT],&m_iIdTSubsStrip[nVTS][19][nT],
					&m_iIdTSubsStrip[nVTS][20][nT],&m_iIdTSubsStrip[nVTS][21][nT],
					&m_iIdTSubsStrip[nVTS][22][nT],&m_iIdTSubsStrip[nVTS][23][nT],
					&m_iIdTSubsStrip[nVTS][24][nT],&m_iIdTSubsStrip[nVTS][25][nT],
					&m_iIdTSubsStrip[nVTS][26][nT],&m_iIdTSubsStrip[nVTS][27][nT],
					&m_iIdTSubsStrip[nVTS][28][nT],&m_iIdTSubsStrip[nVTS][29][nT],
					&m_iIdTSubsStrip[nVTS][30][nT],&m_iIdTSubsStrip[nVTS][31][nT]);

				csKey.Format(_T("CellBased_String_Title_%02d_%02d"),nVTS,nT+1);
				GetPrivateProfileString(csSection, csKey,"",szbuffer , 1024 , FilePath);
				if ((int)strlen(szbuffer)<= m_csCellBased[nVTS][nT].GetLength() ) 
				{
					for (nCell=0; nCell < (int)strlen(szbuffer) ; nCell++)
						m_csCellBased[nVTS][nT].SetAt(nCell,szbuffer[nCell]);
				}
				else if (strlen(szbuffer)>0 && strlen(szbuffer)< 256)
					m_csCellBased[nVTS][nT]=szbuffer;
			}

			for (nT=0;nT<m_nMPGCs[nVTS];nT++)
			{
				if (m_iMAction[nVTS][nT]!=ZERO)
				{
					csKey.Format(_T("ActionM%02d_%02d"),nVTS,nT+1);
						GetPrivateProfileString(csSection, csKey,"KEEP",szbuffer , 1024 , FilePath);
					m_iMAction[nVTS][nT]=KEEP;
					if (strcmp(szbuffer,"BLANK")==0) m_iMAction[nVTS][nT]=BLANK;
					if (strcmp(szbuffer,"DELPBK")==0) m_iMAction[nVTS][nT]=DELPBK;
					if (strcmp(szbuffer,"STILLA")==0) m_iMAction[nVTS][nT]=STILLA;
					if (strcmp(szbuffer,"STILLNA")==0) m_iMAction[nVTS][nT]=STILLNA;
					if (strcmp(szbuffer,"CELLBASED")==0) m_iMAction[nVTS][nT]=CELLBASED;
					if (strstr(szbuffer,"REUSE")!=NULL)
					{
						m_iMAction[nVTS][nT]=REUSE;
						if ( sscanf(szbuffer+5,"%d", &m_iReuseLU[nVTS][nT]) !=1)
							m_iMAction[nVTS][nT]=KEEP;
						else
							m_iReuseLU[nVTS][nT]--;
						if (m_iReuseLU[nVTS][nT]<0 || m_iReuseLU[nVTS][nT] > m_nLUs[nVTS])
						{
							m_iMAction[nVTS][nT]=KEEP;
						}
					}
					csKey.Format(_T("CellBased_String_Menu_%02d_%02d"),nVTS,nT+1);
					GetPrivateProfileString(csSection, csKey,"",szbuffer , 1024 , FilePath);
					if ((int)strlen(szbuffer)<= m_csMCellBased[nVTS][nT].GetLength() ) 
					{
						for (nCell=0; nCell < (int)strlen(szbuffer) ; nCell++)
							m_csMCellBased[nVTS][nT].SetAt(nCell,szbuffer[nCell]);
					}
					else if (strlen(szbuffer)>0 && strlen(szbuffer)< 256)
						m_csMCellBased[nVTS][nT]=szbuffer;
				}
			}
		}
	}

	GetMenuEndSize();
	m_csLoadedProject=FilePath;
	return true;
}

bool CVobBlankerApp::SaveProject(CString FilePath)
{
	CString csAux,csSection,csKey;
	int nVTS,nT;
	int n, nReplacedCells, nStillCells, nSplitCells,nCutCells;
	bool bWrite;

	DeleteFile(FilePath);

	//		WritePrivateProfileString("section","key","string",ininame);
	WritePrivateProfileString("General", "Version", VB_VERSION, FilePath);

	WritePrivateProfileString("General", "InputPath", m_csInputPath, FilePath);
	WritePrivateProfileString("General", "OutputPath", m_csOutputPath, FilePath);

	csAux.Format(_T("%d"),m_nIFOs);
	WritePrivateProfileString("General", "nIFOs", csAux, FilePath);

	csAux.Format(_T("%d"),m_nTotalTitles);
	WritePrivateProfileString("General", "nTitles", csAux, FilePath);

	csAux.Format(_T("%d"),m_bCheckFolder);
	WritePrivateProfileString("General", "CheckFolder", csAux, FilePath);

	csAux.Format(_T("%d"),m_bCheckMenu);
	WritePrivateProfileString("General", "CheckMenu", csAux, FilePath);

	csAux.Format(_T("%d"),m_bCheckTitle);
	WritePrivateProfileString("General", "CheckTitle", csAux, FilePath);

	csAux.Format(_T("%d"),m_bCheckVobPuops);
	WritePrivateProfileString("General", "CheckVobPuops", csAux, FilePath);

	csAux.Format(_T("%d"),m_bCheckIfoPuops);
	WritePrivateProfileString("General", "CheckIfoPuops", csAux, FilePath);

	csAux.Format(_T("%d"),m_bCheckFixTitlePointers);
	WritePrivateProfileString("FixVOBPointers", "CheckFixTitlePointers", csAux, FilePath);

	csAux.Format(_T("%d"),m_bCheckFixMenuPointers);
	WritePrivateProfileString("FixVOBPointers", "CheckFixMenuPointers", csAux, FilePath);

	csAux.Format(_T("%d"),m_bCheckElapsed);
	WritePrivateProfileString("Replace", "CheckElapsed", csAux, FilePath);
	csAux.Format(_T("%d"),m_bCheckFixVobsReplacing);
	WritePrivateProfileString("Replace", "CheckFixVobsReplacing", csAux, FilePath);
	csAux.Format(_T("%d"),m_bCheckCopyPalette);
	WritePrivateProfileString("Replace", "CheckCopyPalette", csAux, FilePath);
	csAux.Format(_T("%d"),m_bCheckCopyAttrib);
	WritePrivateProfileString("Replace", "CheckCopyAttrib", csAux, FilePath);
	csAux.Format(_T("%d"),m_bCheckCopyStatus);
	WritePrivateProfileString("Replace", "CheckCopyStatus", csAux, FilePath);
	csAux.Format(_T("%d"),m_bCheckSubsAR);
	WritePrivateProfileString("Replace", "CheckSubsAR", csAux, FilePath);

	csAux.Format(_T("%d"),m_bCheckAutoScan);
	WritePrivateProfileString("ScanVOBUs", "CheckAutoScan", csAux, FilePath);
	csAux.Format(_T("%d"),m_iScanNVOBUs);
	WritePrivateProfileString("ScanVOBUs", "ScanNVOBUs", csAux, FilePath);

/*
	csAux.Format(_T("%d"),m_bCheckNoOverlay);
	WritePrivateProfileString("Preview", "CheckNoOverlay", csAux, FilePath);
	csAux.Format(_T("%d"),m_bCheckAutoPlay);
	WritePrivateProfileString("Preview", "CheckAutoPlay", csAux, FilePath);
	csAux.Format(_T("%d"),m_bCheckDisTinyPrev);
	WritePrivateProfileString("Preview", "CheckDisTinyPrev", csAux, FilePath);
	m_bCheckAutoPlayTiny=TRUE;
	m_bCheckTinyGoto10=	TRUE;
	m_bCheckTinyMenus=	TRUE;
*/
	csAux.Format(_T("%d"),m_bCheckPostPre);
	WritePrivateProfileString("PGC options", "CheckPostPre", csAux, FilePath);
	csAux.Format(_T("%d"),m_bCheckPostPreForced);
	WritePrivateProfileString("PGC options", "CheckPostPreForced", csAux, FilePath);
	csAux.Format(_T("%d"),m_bCheckNextMenu);
	WritePrivateProfileString("PGC options", "CheckNextMenu", csAux, FilePath);
	csAux.Format(_T("%d"),m_bCheckNextTitle);
	WritePrivateProfileString("PGC options", "CheckNextTitle", csAux, FilePath);
	csAux.Format(_T("%d"),m_bCheckPrevMenu);
	WritePrivateProfileString("PGC options", "CheckPrevMenu", csAux, FilePath);
	csAux.Format(_T("%d"),m_bCheckPrevTitle);
	WritePrivateProfileString("PGC options", "CheckPrevTitle", csAux, FilePath);
	csAux.Format(_T("%d"),m_bCheckAttrMenu);
	WritePrivateProfileString("PGC options", "CheckAttrMenu", csAux, FilePath);
	csAux.Format(_T("%d"),m_bCheckAttrTitle);
	WritePrivateProfileString("PGC options", "CheckAttrTitle", csAux, FilePath);

	
	csAux.Format(_T("%d"),m_bCheckBlankNoB);
	WritePrivateProfileString("Motion2Still", "CheckBlankNoB", csAux, FilePath);
	csAux.Format(_T("%d"),m_bCheckOneSecStill);
	WritePrivateProfileString("Motion2Still", "CheckOneSecStill", csAux, FilePath);
	csAux.Format(_T("%d"),m_iIMaxStill);
	WritePrivateProfileString("Motion2Still", "MaxStillTime", csAux, FilePath);
	csAux.Format(_T("%d"),m_iIMinStill);
	WritePrivateProfileString("Motion2Still", "MinStillTime", csAux, FilePath);
	csAux.Format(_T("%d"),m_iIFrameMode);
	WritePrivateProfileString("Motion2Still", "IFrameMode", csAux, FilePath);

	csAux.Format(_T("%d"),m_bCheckVobFill);
	WritePrivateProfileString("VobLayout", "CheckVobFill", csAux, FilePath);
	csAux.Format(_T("%d"),m_bCheckVobOrder);
	WritePrivateProfileString("VobLayout", "CheckVobOrder", csAux, FilePath);
	csAux.Format(_T("%d"),m_bCheckVobMUnref);
	WritePrivateProfileString("VobLayout", "CheckVobMUnref", csAux, FilePath);
	csAux.Format(_T("%d"),m_bCheckVobLUnref);
	WritePrivateProfileString("VobLayout", "CheckVobLUnref", csAux, FilePath);
	csAux.Format(_T("%d"),m_bCheckVobRenumber);
	WritePrivateProfileString("VobLayout", "CheckVobRenumber", csAux, FilePath);
	csAux.Format(_T("%d"),m_bCheckClockDisc);
	WritePrivateProfileString("VobLayout", "CheckClockDisc", csAux, FilePath);

	csAux.Format(_T("%d"),m_bCheckBckMul);
	WritePrivateProfileString("Backup", "CheckBckMul", csAux, FilePath);
	csAux.Format(_T("%d"),m_bCheckBckVts);
	WritePrivateProfileString("Backup", "CheckBckVts", csAux, FilePath);

	nReplacedCells=m_ACell_replace.GetSize();
	csAux.Format(_T("%d"),nReplacedCells);
	WritePrivateProfileString("Replacing Cells", "nReplacedCells", csAux, FilePath);

	for (n=0;n<nReplacedCells;n++)
	{
		csAux.Format(_T("%d %d %d %d"),m_ACell_replace[n].iDomain,m_ACell_replace[n].nVTS,
			 m_ACell_replace[n].nT, m_ACell_replace[n].nCell);
		csKey.Format(_T("Replacing_Cell_%03d"),n);
		WritePrivateProfileString("Replacing Cells", csKey, csAux, FilePath);

		csAux.Format(_T("%s"), m_ACell_replace[n].csPath);
		csKey.Format(_T("Replacing_Cell_Path_%03d"),n);
		WritePrivateProfileString("Replacing Cells", csKey, csAux, FilePath);

	}

	nStillCells=m_ACellStillinfo.GetSize();
	csAux.Format(_T("%d"),nStillCells);
	WritePrivateProfileString("Cells to Still", "nStillCells", csAux, FilePath);

	for (n=0;n<nStillCells;n++)
	{
		csAux.Format(_T("%d %d %d %d %I64d"),m_ACellStillinfo[n].iDomain,m_ACellStillinfo[n].nVTS,
			 m_ACellStillinfo[n].nT,m_ACellStillinfo[n].nCell, m_ACellStillinfo[n].i64IFrame);
		csKey.Format(_T("Cell_to_Still_%03d"),n);
		WritePrivateProfileString("Cells to Still", csKey, csAux, FilePath);

		csAux.Format(_T("%s"), m_ACellStillinfo[n].csFileStill);
		csKey.Format(_T("Cell_to_Still_Path_%03d"),n);
		WritePrivateProfileString("Cells to Still", csKey, csAux, FilePath);

	}

	nSplitCells=m_ACellSplitinfo.GetSize();
	csAux.Format(_T("%d"),nSplitCells);
	WritePrivateProfileString("Cells to Split", "nSplitCells", csAux, FilePath);

	for (n=0;n<nSplitCells;n++)
	{
		csAux.Format(_T("%d %d %d %d %d %d %I64d"),m_ACellSplitinfo[n].iDomain,m_ACellSplitinfo[n].nVTS,
			 m_ACellSplitinfo[n].nT,m_ACellSplitinfo[n].nCell,m_ACellSplitinfo[n].iSplitMode, 
			 m_ACellSplitinfo[n].iIniIsClosed,m_ACellSplitinfo[n].i64IFrame);
		csKey.Format(_T("Cell_to_Split_%03d"),n);
		WritePrivateProfileString("Cells to Split", csKey, csAux, FilePath);
	}

	nCutCells=m_ACellCutinfo.GetSize();
	csAux.Format(_T("%d"),nCutCells);
	WritePrivateProfileString("Cells to Cut", "nCutCells", csAux, FilePath);

	for (n=0;n<nCutCells;n++)
	{
		csAux.Format(_T("%d %d %d %d %d %d %d %d %d"),m_ACellCutinfo[n].iDomain,
			 m_ACellCutinfo[n].nVTS,m_ACellCutinfo[n].nT,m_ACellCutinfo[n].nCell,
			 m_ACellCutinfo[n].iIniSector, m_ACellCutinfo[n].iEndSector,
			 m_ACellCutinfo[n].iIniIsClosed, m_ACellCutinfo[n].iEndIsClosed,
			 m_ACellCutinfo[n].iAction);
		csKey.Format(_T("Cell_to_Cut_%03d"),n);
		WritePrivateProfileString("Cells to Cut", csKey, csAux, FilePath);
	}


	csSection="VIDEO_TS";
	csAux.Format(_T("%d"),m_nMPGCs[0]);
	WritePrivateProfileString(csSection, "nMPGCs", csAux, FilePath);

	if (m_iActionVTS[0]==PROCESS) csAux="PROCESS";
	if (m_iActionVTS[0]==SKIP) csAux="SKIP";
	WritePrivateProfileString(csSection, "ActionVTS", csAux, FilePath);	

	if ( m_iActionVTS[0]!=SKIP)
	{
		for (nT=0;nT<m_nMPGCs[0];nT++)
		{
			bWrite=false;
			csKey.Format(_T("ActionM%02d_%02d"),0,nT+1);
			if (m_iMAction[0][nT]==KEEP)   {csAux="KEEP";   bWrite=false;}
			if (m_iMAction[0][nT]==BLANK)  {csAux="BLANK";  bWrite=true;}
			if (m_iMAction[0][nT]==DELPBK) {csAux="DELPBK"; bWrite=true;}
			if (m_iMAction[0][nT]==STILLA)  {csAux="STILLA"; bWrite=true;}
			if (m_iMAction[0][nT]==STILLNA) {csAux="STILLNA"; bWrite=true;}
			if (m_iMAction[0][nT]==CELLBASED) {csAux="CELLBASED"; bWrite=true;}
			if (m_iMAction[0][nT]==REUSE)
				{csAux.Format(_T("REUSE %02d"),m_iReuseLU[0][nT]+1);  bWrite=true;}
			if (bWrite)
			{
				WritePrivateProfileString(csSection, csKey, csAux, FilePath);
				if (m_iMAction[0][nT]==CELLBASED)
				{
					csKey.Format(_T("CellBased_String_Menu_%02d_%02d"),0,nT+1);
					WritePrivateProfileString(csSection, csKey, m_csMCellBased[0][nT], FilePath);
				}
			}
		}
	}
	for (nVTS=1; nVTS<m_nIFOs+1;nVTS++)
	{
		csSection.Format(_T("VTS%02d"),nVTS);

		csAux.Format(_T("%d"),m_nPGCs[nVTS]);
		WritePrivateProfileString(csSection, "nPGCs", csAux, FilePath);
		csAux.Format(_T("%d"),m_nMPGCs[nVTS]);
		WritePrivateProfileString(csSection, "nMPGCs", csAux, FilePath);

		if (m_iActionVTS[nVTS]==PROCESS) csAux="PROCESS";
		if (m_iActionVTS[nVTS]==SKIP) csAux="SKIP";
		WritePrivateProfileString(csSection, "ActionVTS", csAux, FilePath);

		csAux.Format(_T("%X"),m_iVideoAttr[nVTS]);
		WritePrivateProfileString(csSection, "VideoAttr", csAux, FilePath);

		for (n=0; n<8; n++)
		{
			csAux.Format(_T("%X"),m_iAudioAttr[nVTS][n]);
			csKey.Format(_T("AudioAttr%d"),n);
			WritePrivateProfileString(csSection, csKey, csAux, FilePath);
		}
		if (m_bAlreadyScan[nVTS]) 
		{
			csKey.Format(_T("VOBAlreadyScan_%02d"),nVTS);
			WritePrivateProfileString(csSection, csKey, "1", FilePath);

			csAux.Format(_T("%d %d %d %d %d %d %d %d"),
				m_iAudioSectors[nVTS][0],m_iAudioSectors[nVTS][1],
				m_iAudioSectors[nVTS][2],m_iAudioSectors[nVTS][3],
				m_iAudioSectors[nVTS][4],m_iAudioSectors[nVTS][5],
				m_iAudioSectors[nVTS][6],m_iAudioSectors[nVTS][7]);
			csKey.Format(_T("AudSizeInfo_%02d"),nVTS);
			WritePrivateProfileString(csSection, csKey, csAux, FilePath);

			csAux.Format(_T("%d %d %d %d %d %d %d %d %d %d %d %d %d %d %d %d %d %d %d %d %d %d %d %d %d %d %d %d %d %d %d %d"),
				m_iSubsSectors[nVTS][0],m_iSubsSectors[nVTS][1],
				m_iSubsSectors[nVTS][2],m_iSubsSectors[nVTS][3],
				m_iSubsSectors[nVTS][4],m_iSubsSectors[nVTS][5],
				m_iSubsSectors[nVTS][6],m_iSubsSectors[nVTS][7],
				m_iSubsSectors[nVTS][8],m_iSubsSectors[nVTS][9],
				m_iSubsSectors[nVTS][10],m_iSubsSectors[nVTS][11],
				m_iSubsSectors[nVTS][12],m_iSubsSectors[nVTS][13],
				m_iSubsSectors[nVTS][14],m_iSubsSectors[nVTS][15],
				m_iSubsSectors[nVTS][16],m_iSubsSectors[nVTS][17],
				m_iSubsSectors[nVTS][18],m_iSubsSectors[nVTS][19],
				m_iSubsSectors[nVTS][20],m_iSubsSectors[nVTS][21],
				m_iSubsSectors[nVTS][22],m_iSubsSectors[nVTS][23],
				m_iSubsSectors[nVTS][24],m_iSubsSectors[nVTS][25],
				m_iSubsSectors[nVTS][26],m_iSubsSectors[nVTS][27],
				m_iSubsSectors[nVTS][28],m_iSubsSectors[nVTS][29],
				m_iSubsSectors[nVTS][30],m_iSubsSectors[nVTS][31]);
			csKey.Format(_T("SubSizeInfo_%02d"),nVTS);
			WritePrivateProfileString(csSection, csKey, csAux, FilePath);
		}
		else
		{
			csKey.Format(_T("VOBAlreadyScan_%02d"),nVTS);
			WritePrivateProfileString(csSection, csKey, "0", FilePath);
		}

		if (m_iActionVTS[nVTS]!=SKIP)
		{
			for (nT=0;nT<m_nPGCs[nVTS];nT++)
			{
				bWrite=false;
				csKey.Format(_T("ActionT%02d_%02d"),nVTS,nT+1);
				if (m_iAction[nVTS][nT]==KEEP)    {csAux="KEEP";    bWrite=false;}
				if (m_iAction[nVTS][nT]==BLANK)   {csAux="BLANK";   bWrite=true;}
				if (m_iAction[nVTS][nT]==REPLACE) {csAux="REPLACE"; bWrite=true;}
				if (m_iAction[nVTS][nT]==STRIP)   {csAux="STRIP";   bWrite=true;}
				if (m_iAction[nVTS][nT]==CUT)     {csAux="CUT";     bWrite=true;}
				if (m_iAction[nVTS][nT]==SKIP)    {csAux="SKIP";    bWrite=true;}
				if (m_iAction[nVTS][nT]==CELLBASED) {csAux="CELLBASED"; bWrite=true;}
				if (bWrite)
					WritePrivateProfileString(csSection, csKey, csAux, FilePath);

				if (m_iAction[nVTS][nT]!=KEEP && m_iAction[nVTS][nT]!=BLANK) 
				{
					csKey.Format(_T("Replacing Title_%02d_%02d"),nVTS,nT+1);
					WritePrivateProfileString(csSection, csKey, m_csReplace[nVTS][nT], FilePath);

					csAux.Format(_T("%I64d"),m_i64Rsize[nVTS][nT]);
					csKey.Format(_T("Replacing Size_%02d_%02d"),nVTS,nT+1);
					WritePrivateProfileString(csSection, csKey, csAux, FilePath);
				}
				if (m_iAction[nVTS][nT]==CUT) 
				{

					csAux.Format(_T("%d %d %d %d %d %d %d"),m_CutInfo[nVTS][nT].iAction,
						m_CutInfo[nVTS][nT].iIniCell,m_CutInfo[nVTS][nT].iIniLba,
						m_CutInfo[nVTS][nT].iEndCell,m_CutInfo[nVTS][nT].iEndLba,
						m_CutInfo[nVTS][nT].iIniIsClosed,m_CutInfo[nVTS][nT].iEndIsClosed);
					csKey.Format(_T("CutInfo_%02d_%02d"),nVTS,nT+1);
					WritePrivateProfileString(csSection,csKey, csAux, FilePath);
				}

				if (m_iAction[nVTS][nT]==STRIP) 
				{
					csAux.Format(_T("%d %d %d %d %d %d %d %d"),
						m_iIdTAudioStrip[nVTS][0][nT],m_iIdTAudioStrip[nVTS][1][nT],
						m_iIdTAudioStrip[nVTS][2][nT],m_iIdTAudioStrip[nVTS][3][nT],
						m_iIdTAudioStrip[nVTS][4][nT],m_iIdTAudioStrip[nVTS][5][nT],
						m_iIdTAudioStrip[nVTS][6][nT],m_iIdTAudioStrip[nVTS][7][nT]);
					csKey.Format(_T("AudStripInfo_%02d_%02d"),nVTS,nT+1);
					WritePrivateProfileString(csSection, csKey, csAux, FilePath);

					csAux.Format(_T("%d %d %d %d %d %d %d %d %d %d %d %d %d %d %d %d %d %d %d %d %d %d %d %d %d %d %d %d %d %d %d %d"),
						m_iIdTSubsStrip[nVTS][0][nT],m_iIdTSubsStrip[nVTS][1][nT],
						m_iIdTSubsStrip[nVTS][2][nT],m_iIdTSubsStrip[nVTS][3][nT],
						m_iIdTSubsStrip[nVTS][4][nT],m_iIdTSubsStrip[nVTS][5][nT],
						m_iIdTSubsStrip[nVTS][6][nT],m_iIdTSubsStrip[nVTS][7][nT],
						m_iIdTSubsStrip[nVTS][8][nT],m_iIdTSubsStrip[nVTS][9][nT],
						m_iIdTSubsStrip[nVTS][10][nT],m_iIdTSubsStrip[nVTS][11][nT],
						m_iIdTSubsStrip[nVTS][12][nT],m_iIdTSubsStrip[nVTS][13][nT],
						m_iIdTSubsStrip[nVTS][14][nT],m_iIdTSubsStrip[nVTS][15][nT],
						m_iIdTSubsStrip[nVTS][16][nT],m_iIdTSubsStrip[nVTS][17][nT],
						m_iIdTSubsStrip[nVTS][18][nT],m_iIdTSubsStrip[nVTS][19][nT],
						m_iIdTSubsStrip[nVTS][20][nT],m_iIdTSubsStrip[nVTS][21][nT],
						m_iIdTSubsStrip[nVTS][22][nT],m_iIdTSubsStrip[nVTS][23][nT],
						m_iIdTSubsStrip[nVTS][24][nT],m_iIdTSubsStrip[nVTS][25][nT],
						m_iIdTSubsStrip[nVTS][26][nT],m_iIdTSubsStrip[nVTS][27][nT],
						m_iIdTSubsStrip[nVTS][28][nT],m_iIdTSubsStrip[nVTS][29][nT],
						m_iIdTSubsStrip[nVTS][30][nT],m_iIdTSubsStrip[nVTS][31][nT]);
					csKey.Format(_T("SubStripInfo_%02d_%02d"),nVTS,nT+1);
					WritePrivateProfileString(csSection, csKey, csAux, FilePath);

				}

				if (m_iAction[nVTS][nT]==CELLBASED)
				{
					csKey.Format(_T("CellBased_String_Title_%02d_%02d"),nVTS,nT+1);
					WritePrivateProfileString(csSection, csKey, m_csCellBased[nVTS][nT], FilePath);
				}
			}

			for (nT=0;nT<m_nMPGCs[nVTS];nT++)
			{
				bWrite=false;
				csKey.Format(_T("ActionM%02d_%02d"),nVTS,nT+1);
				if (m_iMAction[nVTS][nT]==KEEP)   {csAux="KEEP";   bWrite=false;}
				if (m_iMAction[nVTS][nT]==BLANK)  {csAux="BLANK";  bWrite=true;}
				if (m_iMAction[nVTS][nT]==DELPBK) {csAux="DELPBK"; bWrite=true;}
				if (m_iMAction[nVTS][nT]==STILLA) {csAux="STILLA";  bWrite=true;}
				if (m_iMAction[nVTS][nT]==STILLNA) {csAux="STILLNA";  bWrite=true;}
				if (m_iMAction[nVTS][nT]==CELLBASED) {csAux="CELLBASED"; bWrite=true;}
				if (m_iMAction[nVTS][nT]==REUSE)
					{csAux.Format(_T("REUSE %02d"),m_iReuseLU[nVTS][nT]+1);  bWrite=true;}
				if (bWrite)
				{
					WritePrivateProfileString(csSection, csKey, csAux, FilePath);
					if (m_iMAction[nVTS][nT]==CELLBASED)
					{
						csKey.Format(_T("CellBased_String_Menu_%02d_%02d"),nVTS,nT+1);
						WritePrivateProfileString(csSection, csKey, m_csMCellBased[nVTS][nT], FilePath);
					}
				}
			}
		}
	}
	return true;
}

///////////////////////////////////////////////////////////////
/////////////////////////// NEW: MEMORY ALLOCATION ////////////
///////////////////////////////////////////////////////////////
int CVobBlankerApp::MemoryNewVTSTitle_00( int nPGCs)
{

	m_VTS_PGC_00=		new int [nPGCs]; if (m_VTS_PGC_00== NULL ) return 0;
	m_C_PBKT_00=		new int [nPGCs]; if (m_C_PBKT_00== NULL ) return 0;
	m_C_POST_00=		new int [nPGCs]; if (m_C_POST_00== NULL ) return 0;
	m_C_PROG_00=		new int [nPGCs]; if (m_C_PROG_00== NULL ) return 0;
	m_PGC_COMM_00=		new int [nPGCs]; if (m_PGC_COMM_00== NULL ) return 0;
	m_nCells_00=		new int [nPGCs]; if (m_nCells_00== NULL ) return 0;

	return 1;
}

void CVobBlankerApp::MemoryDeleteVTSTitle_00()
{
	delete[] m_VTS_PGC_00;
	delete[] m_C_PBKT_00;
	delete[] m_C_POST_00;
	delete[] m_C_PROG_00;
	delete[] m_PGC_COMM_00;
	delete[] m_nCells_00;
}

int CVobBlankerApp::MemoryNewVTSMenu_00(int nPGCs)
{

	m_nLU_MPGC_00=		new int [nPGCs]; if (m_nLU_MPGC_00== NULL ) return 0;
	m_MENU_PGC_00=		new int [nPGCs]; if (m_MENU_PGC_00== NULL ) return 0;
	m_M_C_PBKT_00=		new int [nPGCs]; if (m_M_C_PBKT_00== NULL ) return 0;
	m_M_C_POST_00=		new int [nPGCs]; if (m_M_C_POST_00== NULL ) return 0;
	m_M_PGC_COMM_00=	new int [nPGCs]; if (m_M_PGC_COMM_00== NULL ) return 0;
	m_nMCells_00=		new int [nPGCs]; if (m_nMCells_00== NULL ) return 0;

	return 1;
}
void CVobBlankerApp::MemoryDeleteVTSMenu_00()
{
	delete[] m_nLU_MPGC_00;
	delete[] m_MENU_PGC_00;
	delete[] m_M_C_PBKT_00;
	delete[] m_M_C_POST_00;
	delete[] m_M_PGC_COMM_00;
	delete[] m_nMCells_00;
}


int CVobBlankerApp::MemoryNewVTSTitle(int nVTS, int nPGCs)
{
	int i;

	m_nTitle[nVTS] =		new int [nPGCs];	if (m_nTitle[nVTS] == NULL ) return 0;
	m_bEntry[nVTS] =		new bool [nPGCs];	if (m_bEntry[nVTS] == NULL ) return 0;
	m_nTitleInVTS[nVTS] =	new int [nPGCs];	if (m_nTitleInVTS[nVTS] == NULL ) return 0;
	m_bILVU[nVTS] =			new bool [nPGCs];	if (m_bILVU[nVTS] == NULL ) return 0;
	m_nAngles[nVTS] =		new int [nPGCs];	if (m_nAngles[nVTS] == NULL ) return 0;
	m_nChaptersAdded[nVTS]=	new int [nPGCs];	if (m_nChaptersAdded[nVTS] == NULL ) return 0;
	m_bCellReUsed[nVTS] =	new bool [nPGCs];	if (m_bCellReUsed[nVTS] == NULL ) return 0;
	m_nCells[nVTS] =		new int [nPGCs];	if (m_nCells[nVTS] == NULL ) return 0;
	m_nFirstVID[nVTS] =		new int [nPGCs];	if (m_nFirstVID[nVTS] == NULL ) return 0;
	m_dwDuration[nVTS] =	new DWORD [nPGCs];	if (m_dwDuration[nVTS] == NULL ) return 0;
	m_dwDurationOwn[nVTS] =	new DWORD [nPGCs];	if (m_dwDurationOwn[nVTS] == NULL ) return 0;
	m_i64Tisize[nVTS] =		new __int64 [nPGCs];if (m_i64Tisize[nVTS] == NULL ) return 0;
	m_i64Rsize[nVTS] =		new __int64 [nPGCs];if (m_i64Rsize[nVTS] == NULL ) return 0;
	m_iAction[nVTS] =		new int [nPGCs];	if (m_iAction[nVTS] == NULL ) return 0;
	m_VTS_PGC[nVTS] =		new int [nPGCs];	if (m_VTS_PGC[nVTS] == NULL ) return 0;
	m_C_PBKT[nVTS] =		new int [nPGCs];	if (m_C_PBKT[nVTS] == NULL ) return 0;
	m_C_POST[nVTS] =		new int [nPGCs];	if (m_C_POST[nVTS] == NULL ) return 0;
	m_PGC_COMM[nVTS] =		new int [nPGCs];	if (m_PGC_COMM[nVTS] == NULL ) return 0;
	m_i8CellComm[nVTS] =	new uchar [nPGCs];	if (m_i8CellComm[nVTS] == NULL ) return 0;
	m_i8PreComm[nVTS] =		new uchar [nPGCs];	if (m_i8PreComm[nVTS] == NULL ) return 0;
	m_i8PostComm[nVTS] =	new uchar [nPGCs];	if (m_i8PostComm[nVTS] == NULL ) return 0;
	m_CutInfo[nVTS] =	new CUTINFO [nPGCs];	if (m_CutInfo[nVTS] == NULL ) return 0;
	m_csCellBased[nVTS] =	new CString [nPGCs];if (m_csCellBased[nVTS] == NULL ) return 0;
	m_csReplace[nVTS] =		new CString [nPGCs];if (m_csReplace[nVTS] == NULL ) return 0;
	m_nTButtons[nVTS] =		new int [nPGCs];	if (m_nTButtons[nVTS] == NULL ) return 0;

	for (i=0;i<8; i++)
	{
		m_iIdTAudio[nVTS][i] =		new int [nPGCs];	if (m_iIdTAudio[nVTS][i] == NULL ) return 0;
		m_iIdTAudioStrip[nVTS][i] =	new int [nPGCs];	if (m_iIdTAudioStrip[nVTS][i] == NULL ) return 0;
//		m_iBRTAudio[nVTS][i] =		new int [nPGCs];	if (m_iBRTAudio[nVTS][i] == NULL ) return 0;
	}
	for (i=0;i<32; i++)
	{
		m_iIdTSubsStrip[nVTS][i] =	new int [nPGCs];	if (m_iIdTSubsStrip[nVTS][i] == NULL ) return 0;
	}

	// Inicialize CStrings to empty (not sure if needed)
	for (i=0;i<nPGCs;i++)
	{
		m_csReplace[nVTS][i].Empty();
		m_csCellBased[nVTS][i].Empty();
	}
	return 1;
}

int CVobBlankerApp::MemoryNewVTSMenu(int nVTS, int nPGCs)
{
// IFO index
	m_MENU_PGC[nVTS] =		new int [nPGCs];	if (m_MENU_PGC[nVTS] == NULL ) return 0;
	m_M_C_PBKT[nVTS] =		new int [nPGCs];	if (m_M_C_PBKT[nVTS] == NULL ) return 0;
	m_M_C_POST[nVTS] =		new int [nPGCs];	if (m_M_C_POST[nVTS] == NULL ) return 0;
	m_M_PGC_COMM[nVTS] =	new int [nPGCs];	if (m_M_PGC_COMM[nVTS] == NULL ) return 0;
// Others (Menu PGCs)
	m_nLU_MPGC[nVTS] =		new int [nPGCs];	if (m_nLU_MPGC[nVTS] == NULL ) return 0;
	m_iMAction[nVTS] =		new int [nPGCs];	if (m_iMAction[nVTS] == NULL ) return 0;
	m_i64MPGCisize[nVTS] =	new __int64 [nPGCs];if (m_i64MPGCisize[nVTS] == NULL ) return 0;
	m_i64MPGCfsize[nVTS] =	new __int64 [nPGCs];if (m_i64MPGCfsize[nVTS] == NULL ) return 0;
	m_nMCells[nVTS] =		new int [nPGCs];	if (m_nMCells[nVTS] == NULL ) return 0;
	m_nMFirstVID[nVTS] =	new int [nPGCs];	if (m_nMFirstVID[nVTS] == NULL ) return 0;
	m_dwMDuration[nVTS] =	new DWORD [nPGCs];	if (m_dwMDuration[nVTS] == NULL ) return 0;
	m_bMCellReUsed[nVTS] =	new bool [nPGCs];	if (m_bMCellReUsed[nVTS] == NULL ) return 0;
	m_b8MCellComm[nVTS] =	new bool [nPGCs];	if (m_b8MCellComm[nVTS] == NULL ) return 0;
	m_i8MCellComm[nVTS] =	new uchar [nPGCs];	if (m_i8MCellComm[nVTS] == NULL ) return 0;
	m_i8MPreComm[nVTS] =	new uchar [nPGCs];	if (m_i8MPreComm[nVTS] == NULL ) return 0;
	m_i8MPostComm[nVTS] =	new uchar [nPGCs];	if (m_i8MPostComm[nVTS] == NULL ) return 0;
	m_iReuseLU[nVTS] =		new int [nPGCs];	if (m_iReuseLU[nVTS] == NULL ) return 0;
	m_nMButtons[nVTS] =		new int [nPGCs];	if (m_nMButtons[nVTS] == NULL ) return 0;
	m_csMCellBased[nVTS] =	new CString [nPGCs];if (m_csMCellBased[nVTS] == NULL ) return 0;

	return 1;
}

void CVobBlankerApp::MemoryDeleteVTSTitle(int nVTS)
{
	int i;

	delete[] m_nTitle[nVTS];
	delete[] m_bEntry[nVTS];
	delete[] m_nTitleInVTS[nVTS];
	delete[] m_bILVU[nVTS]; 
	delete[] m_nAngles[nVTS]; 
	delete[] m_nChaptersAdded[nVTS];
	delete[] m_bCellReUsed[nVTS];
	delete[] m_nCells[nVTS]; 
	delete[] m_nFirstVID[nVTS]; 
	delete[] m_dwDuration[nVTS]; 
	delete[] m_dwDurationOwn[nVTS]; 
	delete[] m_i64Tisize[nVTS];
	delete[] m_i64Rsize[nVTS];
	delete[] m_iAction[nVTS];
	delete[] m_VTS_PGC[nVTS]; 
	delete[] m_C_PBKT[nVTS]; 
	delete[] m_C_POST[nVTS]; 
	delete[] m_PGC_COMM[nVTS];
	delete[] m_i8CellComm[nVTS];
	delete[] m_i8PreComm[nVTS]; 
	delete[] m_i8PostComm[nVTS]; 
	delete[] m_CutInfo[nVTS];
	delete[] m_csReplace[nVTS]; 
	delete[] m_csCellBased[nVTS];
	delete[] m_nTButtons[nVTS];

	for (i=0;i<8; i++)
	{
		delete[] m_iIdTAudio[nVTS][i];
		delete[] m_iIdTAudioStrip[nVTS][i];
//		delete[] m_iBRTAudio[nVTS][i];
	}
	for (i=0;i<32; i++)
		delete[] m_iIdTSubsStrip[nVTS][i];

}

void CVobBlankerApp::MemoryDeleteVTSMenu(int nVTS)
{

	delete[] m_MENU_PGC[nVTS];
	delete[] m_M_C_PBKT[nVTS];
	delete[] m_M_C_POST[nVTS]; 
	delete[] m_M_PGC_COMM[nVTS]; 
	delete[] m_nLU_MPGC[nVTS]; 
	delete[] m_iMAction[nVTS]; 
	delete[] m_i64MPGCisize[nVTS];
	delete[] m_i64MPGCfsize[nVTS]; 
	delete[] m_nMCells[nVTS]; 
	delete[] m_nMFirstVID[nVTS];
	delete[] m_dwMDuration[nVTS]; 
	delete[] m_bMCellReUsed[nVTS]; 
	delete[] m_b8MCellComm[nVTS]; 
	delete[] m_i8MCellComm[nVTS]; 
	delete[] m_i8MPreComm[nVTS]; 
	delete[] m_i8MPostComm[nVTS]; 
	delete[] m_iReuseLU[nVTS];
	delete[] m_nMButtons[nVTS];
	delete[] m_csMCellBased[nVTS];
}

void CVobBlankerApp::MemoryDeleteAll()
{
	int i;

	for (i=0; i<MAX_VTS; i++) 
	{
		if (m_pIFO[i]!=NULL) delete[] m_pIFO[i]; m_pIFO[i]=NULL;
		if (m_nPGCs[i]) MemoryDeleteVTSTitle (i); m_nPGCs[i]=0;
		if (m_nMPGCs[i]) MemoryDeleteVTSMenu (i); m_nMPGCs[i]=0;
	}
}


// CODE for subpictures (Not used)
/*
struct colorremap {
    int newcolors[16];
    int state,curoffs,maxlen,nextoffs,skip;
    struct colorinfo *origmap;
};
// the following code scans subtitle code in order to
// remap the colors and update the end pts
          if( buf[0] == 0 &&
                buf[1] == 0 &&
                buf[2] == 1 &&
                buf[3] == 0xba &&
                buf[14] == 0 &&
                buf[15] == 0 &&
                buf[16] == 1 &&
                buf[17] == 0xbd) 
				{
                int dptr=buf[22]+23,ml=read2(buf+18)+20;
                int st=buf[dptr];
                dptr++;
                if( (st&0xf8)==0x20 ) { // subtitle
       procremap(&crs[st&31],buf+dptr,ml-dptr,&s->audch[st].audpts[s->audch[st].numaudpts-1].pts[1]);

}

static void procremap(struct colorremap *cr,unsigned char *b,int l,int *timespan)
{
    while(l) {
        // fprintf(stderr,"INFO: state=%d, byte=%02x (%d)\n",cr->state,*b,*b);
        switch(cr->state) {
        case CR_BEGIN0: cr->curoffs=0; cr->skip=0; cr->maxlen=b[0]*256; cr->state=CR_BEGIN1; break;
        case CR_BEGIN1: cr->maxlen+=b[0]; cr->state=CR_BEGIN2; break;
        case CR_BEGIN2: cr->nextoffs=b[0]*256; cr->state=CR_BEGIN3; break;
        case CR_BEGIN3: cr->nextoffs+=b[0]; cr->state=CR_WAIT; break;

        case CR_WAIT:
            if( cr->curoffs==cr->maxlen ) {
                cr->state=CR_BEGIN0;
                continue; // execute BEGIN0 right away
            }
            if( cr->curoffs!=cr->nextoffs )
                break;
            cr->state=CR_SKIP0;
            // fall through to CR_SKIP0
        case CR_SKIP0: *timespan+=1024*b[0]*256; cr->state=CR_SKIP1; break;
        case CR_SKIP1: *timespan+=1024*b[0]; cr->state=CR_NEXTOFFS0; break;
        case CR_NEXTOFFS0: cr->nextoffs=b[0]*256; cr->state=CR_NEXTOFFS1; break;
        case CR_NEXTOFFS1: cr->nextoffs+=b[0]; cr->state=CR_CMD; break;
        case CR_SKIPWAIT:
            if( cr->skip ) {
                cr->skip--;
                break;
            }
            cr->state=CR_CMD;
            // fall through to CR_CMD
        case CR_CMD:
            switch(*b) {
            case 0: break;
            case 1: break;
            case 2: break;
            case 3: cr->state=CR_COL0; break;
            case 4: cr->skip=2; cr->state=CR_SKIPWAIT; break;
            case 5: cr->skip=6; cr->state=CR_SKIPWAIT; break;
            case 6: cr->skip=4; cr->state=CR_SKIPWAIT; break;
            case 255: cr->state=CR_WAIT; break;
            default:
                fprintf(stderr,"ERR: procremap encountered unknown subtitle command: %d\n",*b);
                exit(1);
            }
            break;

        case CR_COL0:
            remapbyte(cr,b);
            cr->state=CR_COL1;
            break;

        case CR_COL1:
            remapbyte(cr,b);
            cr->state=CR_CMD;
            break;
           
        default:
            assert(0);
        }
        cr->curoffs++;
        b++;
        l--;
    }
}
enum { CR_BEGIN0,   CR_BEGIN1,    CR_BEGIN2,    CR_BEGIN3, CR_SKIP0,
       CR_SKIP1,    CR_NEXTOFFS0, CR_NEXTOFFS1, CR_WAIT,   CR_CMD,
       CR_SKIPWAIT, CR_COL0,      CR_COL1};


static void initremap(struct colorremap *cr)
{
    int i;

    for( i=0; i<16; i++ )
        cr->newcolors[i]=i;
    cr->state=CR_BEGIN0;
    cr->origmap=0;
}

static int remapcolor(struct colorremap *cr,int idx)
{
    int i,nc;
    
    if( cr->newcolors[idx] < 16 )
        return cr->newcolors[idx];
    
    nc=cr->newcolors[idx]&0xffffff;
    for( i=0; i<16; i++ )
        if( cr->origmap->colors[i]==nc ) {
            cr->newcolors[idx]=i;
            return i;
        }
    for( i=0; i<16; i++ )
        if( cr->origmap->colors[i]==0x1000000 ) {
            cr->origmap->colors[i]=nc;
            cr->newcolors[idx]=i;
            return i;
        }
    fprintf(stderr,"ERR: color map full, unable to allocate new colors.\n");
    exit(1);
}

static void remapbyte(struct colorremap *cr,unsigned char *b)
{
    b[0]=remapcolor(cr,b[0]&15)|(remapcolor(cr,b[0]>>4)<<4);
}




int CVobBlankerApp::findspuidx(int sind,int pts0)
{
    int l,h,m;

	l=0;
	h=m_nSubsInCell[sind]-1;

	if( h<l )
		return -1;
	while(h>l)
	{
		m=(l+h+1)/2;
		if( pts0<  m_CellAudioinfo[sind][m].iPTS  )
			h=m-1;
		else
		l=m;
	}
	return l;
}

int CVobBlankerApp::FV_FindVobubysect(__int64 sect)
{
	int l,h,m;

	l=0;

    h=m_nNavsInCell-1;

	if( h<0 )
		return -1;
	if( sect<m_CellNavinfo[0].LBA )
		return -1;
    while(l<h)
	{
		m=(l+h+1)/2;
		if( sect < m_CellNavinfo[m].LBA )
			h=m-1;
		else
			l=m;
	}
	return l;
}



*/